/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AglAttribut.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:05 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.agl;
import com.memoire.agl.*;



public class AglAttribut extends AglDeclaration
{
  public AglVisibilite visibilite;
  public String        nom;
  public AglType       type;
  public AglExpression initiale;

  public AglAttribut() // yapod
  {
    this(AglLib.genereNom("attribut"),AglTypePrimitif.tvoid);
  }

  public AglAttribut(String _nom, AglType _type)
  {
    /*
    if(inom.endsWith("[]"))
    {
      inom=inom.substring(0,inom.length()-2);
      itype=AglClasse.cherche(itype+"[]");
    }
    */

    visibilite=new AglVisibilite();
    nom       =_nom;
    type      =_type;
    initiale  =null;
  }

  public String signature()
  {
    String r="";

    if(proprietaire instanceof AglType)
      r+=AglNom.signature(((AglType)proprietaire).nom)+"/";

    r+=nom+" "+AglType.signature(type);
    return r;
  }

  public String toString()
  {
    return "ATTRIBUT("+nom+")";
  }
}
