/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AglCodeDjaPaquets.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:05 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.agl;
import com.memoire.agl.*;
import com.memoire.dja.*;
import java.awt.*;
import java.io.*;
import java.util.*;

public class AglCodeDjaPaquets extends AglCodeDependance
{
  public final static boolean DIAGONALE=
    AglPreferences.AGL.getBooleanProperty("djapaquets.code.diagonale",true);

  private DjaGridInteractive grille_;
  private Hashtable          formes_;
  //private final Hashtable groupes_=new Hashtable();
  //private final Hashtable fleches_=new Hashtable();

  public AglCodeDjaPaquets()
  {
    grille_ =new DjaGridInteractive();
    formes_ =new Hashtable();
  }

  public String extension()
  {
    return "dja";
  }

  public String[] extensions()
  {
    return new String[] { "dja", "DJA" };
  }

  public String syntaxe()
  {
    return "Dja";
  }

  protected String dependanceUnite (AglUnite  o) { return ""; }
  protected String dependanceType  (AglType   o) { return ""; }
  protected String dependancePaquet(AglPaquet o) { return ""; }

  public AglSortie[] code(AglProjet o)
  {
    projet_=true;
    superCode(o);
    projet_=false;
    dependances();
    fleches();
    //ajuste();

    new DjaLayoutTree().layout(grille_);
    grille_.recenter();

    for(Enumeration e=grille_.enumerate(DjaLink.class);
	e.hasMoreElements(); )
      grille_.putToBack((DjaLink)e.nextElement());

    StringBuffer sb=new StringBuffer();
    DjaSaver.saveAsText(grille_.getObjects(),sb);

    return new AglSortie[]
    {
      new AglSortie("application/x-dja-grid",null,o.nom+".dja",grille_),
      new AglSortie("text/dja",syntaxe()         ,o.nom+".dja",sb.toString())
    };
  }

  private void fleches()
  {
    for(Enumeration f=paquets_.keys(); f.hasMoreElements(); )
    {
      AglPaquet  a=(AglPaquet)f.nextElement();
      AglVecteur v=(AglVecteur)paquets_.get(a);
      if(v!=null)
      {
        AglTableTriee t=new AglTableTriee();

        for(Enumeration e=v.elements(); e.hasMoreElements(); )
        {
          AglNom   an=(AglNom)e.nextElement();
	  AglType  at=AglType.cherche(an);
	  if(at!=null)
	  {
	    AglNom ap=at.nom.parent();
	    if((ap!=null)&&!ap.equals(a.nom))
	    {
	      AglPaquet b=AglPaquet.cherche(ap);
	      if(b!=null)
	      {
		/*
		AglNom    agp;
		AglPaquet c;
		while(  ((agp=ap.parent())!=null)
			&&!a.nom.formeJava().startsWith(agp.formeJava())
			&&((c=(AglPaquet)AglPaquet.table.get(agp))!=null)
			&&(formes_.get(c)!=null))
		{
		  System.err.println("GP: "+a.nom.formeJava()+" "+
				     ap.dernier()+" "+agp.formeJava());
		  ap=agp;
		  b=c;
		}
		*/
		t.put(b,Boolean.TRUE);
	      }
	    }
	  }
        }

	for(Enumeration e=t.keys(); e.hasMoreElements(); )
	  fleche(a,(AglPaquet)e.nextElement());
      }
    }
  }

  private void fleche(AglPaquet _a, AglPaquet _b)
  {
    DjaObject fa=(DjaObject)formes_.get(_a);
    DjaObject fb=(DjaObject)formes_.get(_b);

    /*
    AglNom npb=_b.nom.parent();
    if(npb!=null)
    {
      if(groupes_.get(npb)!=null)
	fb=(DjaObject)groupes_.get(npb);
      else
      {
	AglPaquet c=AglPaquet.cherche(npb);
	if((c!=null)&&(formes_.get(c)!=null))
	  fb=(DjaObject)formes_.get(c);
      }
    }
    */

    int ax0=fa.getX();
    int ay0=fa.getY();
    int bx0=fb.getX();
    int by0=fb.getY();

    /*
    int ax=ax0+(bx0-ax0)/10;
    int ay=ay0+(by0-ay0)/10;
    int bx=bx0+(ax0-bx0)/10;
    int by=by0+(ay0-by0)/10;

    int tmp;
    if(by>ay+30) { tmp=ay; ay=by; by=tmp; }

    fa.setX(ax);
    fa.setY(ay);
    fb.setX(bx);
    fb.setY(by);
    */

    DjaLink l;

    if(DIAGONALE)
    {
      l=new DjaBrokenArrow();
      l.setBegin(fa,(ay0<=by0 ? 3 : 1),0);
      l.setEnd  (fb,(ax0<=bx0 ? 5 : 6),5);
      l.putProperty("arrondi","6");
    }
    else
    {
      l=new DjaDirectArrow();
      l.setBegin(fa,0,0);
      l.setEnd  (fb,3,5);
      l.putProperty("trace","3.1");
    }

    grille_.add(l);

    /*
    AglVecteur v=(AglVecteur)fleches_.get(fa);
    if(v==null) { v=new AglVecteur(); fleches_.put(fa,v); }
    v.addElement(l);
    */
  }

  /*
  public void ajuste()
  {
    for(int j=500;j>0;j--)
    //for(int i=0;i<10;i++) 
    {
      for(Enumeration e=grille_.enumerate(DjaUmlSmallPackage.class);
          e.hasMoreElements(); )
      {
	DjaObject o=(DjaObject)e.nextElement();
	ajuste(o,j  );
	ajuste(o,j/2);
	ajuste(o,j/4);
	System.err.println("J="+j);
      }
    }
  }

  public void ajuste(DjaObject _o, int _f)
  {
    final int[] DX=new int[] {  1, -1, 1, 0,-1, 1, 0,-1 };
    final int[] DY=new int[] {  0,  0, 1, 1, 1,-1,-1,-1 };

    int    ox=_o.getX();
    int    oy=_o.getY();
    double t0=tension(_o);

    int j=-1;
    for(int i=0;i<8;i++)
    {
      _o.setX(ox+_f*DX[i]);
      _o.setY(oy+_f*DY[i]);
      double ti=tension(_o);
      if(ti<t0) { j=i; t0=ti; }
    }

    _o.setX(ox);
    _o.setY(oy);

    if(j>=0)
    {
      _o.setX(ox+DX[j]);
      _o.setY(oy+DY[j]);
    }
  }

  public double tension(DjaObject _o)
  {
    double     r=0.;
    AglVecteur v=(AglVecteur)fleches_.get(_o);

    if(v!=null)
    {
      for(int i=0;i<v.size();i++)
      {
        DjaLink l=(DjaLink)v.elementAt(i);
	l.getX();
	int ax=l.getBeginX();
	int ay=l.getBeginY();
        int bx=l.getEndX();
        int by=l.getEndY();
	double d=Math.abs(200.-Math.sqrt
			  ((ax-bx)*(ax-bx)+(ay-by)*(ay-by)));
	r+=d;
      }
    }  

    return r;
  }
  */

  public String code(AglUnite o)
  {
    // Ajoute les representants des imports
    if(o!=null)
    for(Enumeration e=o.imports.elements(); e.hasMoreElements(); )
    {
      AglNom ni=((AglImport)e.nextElement()).nom.parent();
      if(ni==null) continue;
      AglPaquet pi=AglPaquet.cherche(ni);
      if((pi!=null)&&(paquets_.get(pi)==null))
	paquets_.put(pi,new AglVecteur());
    }

    /*
    // Ajout super-paquets
    for(Enumeration e=AglPaquet.table.keys(); e.hasMoreElements(); )
    {
      AglNom na=(AglNom)e.nextElement();
      AglNom np=na.parent();
      if((np!=null)&&(AglPaquet.table.get(np)==null))
	paquets_.put(new AglPaquet(np),new AglVecteur());
    }    
    */

    return super.code(o);
  }

  protected AglSortie[] dependances()
  {
    int    n=paquets_.size();
    double r=20.+10.*n;
    int    x=0;
    int    y=0;
    int    i=0;

    for(Enumeration e=paquets_.keys(); e.hasMoreElements(); i++)
    {
      AglPaquet          p=(AglPaquet)e.nextElement();
      DjaUmlSmallPackage f=new DjaUmlSmallPackage();
      f.setFont(new Font("SansSerif",Font.PLAIN,10));
      f.setText(p.nom.formeJava(),0);
      //f.setWidth (80);
      //f.setHeight(30);

      if(!DIAGONALE)
      {
	double a=Math.PI*2.*(double)i/(double)n;
	x=10+40+(int)Math.round(1.2*r+1.2*r*Math.sin(a));
	y=10+20+(int)Math.round(0.8*r-0.8*r*Math.cos(a));
      }

      f.setX(x);
      f.setY(y);

      if(DIAGONALE)
      {
	x+=f.getWidth ()-15;
	y+=f.getHeight()+5;
	x+=10-x%10;
	y+=10-y%10;
      }

      formes_.put(p,f);
      grille_.add(f);

      /*
      AglNom np=p.nom.parent();
      if(  (np!=null)
	 &&(groupes_.get(np)==null))
      {
	AglPaquet pp=AglPaquet.cherche(np);
	if(pp==null)
        {
	  DjaBox g=new DjaBox(np.formeJava());
	  groupes_.put(np,f);

	  g.setFont(new Font("SansSerif",Font.PLAIN,10));
	  g.setX(10+40+(int)Math.round(r+r/2.*Math.sin(a)));
	  g.setY(10+20+(int)Math.round(r-r/2.*Math.cos(a)));
	  g.setWidth (80);
	  g.setHeight(30);
	  grille_.add(g);
	}
	else
	{
	  DjaObject o=(DjaObject)formes_.get(pp);
	  if(o!=null)
	  {
	    o.setX((o.getX()+10+40+(int)Math.round(r+r/2.*Math.sin(a)))/2);
	    o.setY((o.getY()+10+20+(int)Math.round(r-r/2.*Math.cos(a)))/2);
	  }
	}
      }
      */
    }

    return super.dependances();
  }
}
