/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AglCodeJniC.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:05 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.agl;
import com.memoire.agl.*;


import java.util.*;

public class AglCodeJniC extends AglCodeJniH
{
  public String extension()
  {
    return "c";
  }

  public String[] extensions()
  {
    return new String[] { "c", "C" };
  }

  public String syntaxe()
  {
    return "C";
  }

  public String code(AglMethode o)
  {
    String r="";

    r+=debutCM()+"\n";
    r+=milieuCM()+"Class:     "+classe_.nom.dernier()+"\n";
    r+=milieuCM()+"Method:    "+o.nom+"\n";

    String s=o.signature();
    int    i=s.indexOf(':');
    if(i>=0) s=s.substring(i+1);
    r+=milieuCM()+"Signature: "+s+"\n";
    r+=finCM()+"\n";

    r+="JNIEXPORT "+code(o.type)+" JNICALL ";
    r+=" Java_"+code(classe_.nom)+"_"+o.nom+"\n";
    r+="  (JNIEnv *env";

    if(o.visibilite.vstatic) r+=", jclass _class";
    else                     r+=", jobject _this";

    for(Enumeration e=o.parametres.elements(); e.hasMoreElements(); )
    {
      AglParametre ap=(AglParametre)e.nextElement();
      r+=", ";
      r+=code(ap);
    }

    r+=")\n";
    r+="{\n";
    r+="  /* add your code here */\n";
    r+="}";

    return r;
  }

  public String code(AglParametre o)
  {
    return code(o.type)+" "+o.nom;
  }

  public String code(AglVisibilite o)
  {
    return "";
  }

// Expressions

  public String code(AglExpressionGenerique o)
  { return ""; }
  
  public String code(AglExpressionAffectation o)
  { return ""; }
  
  public String code(AglExpressionAttribut o)
  { return ""; }
  
  public String code(AglExpressionBinaire o)
  { return ""; }
  
  public String code(AglExpressionDefVar o)
  { return ""; }
  
  public String code(AglExpressionEstUn o)
  { return ""; }
  
  public String code(AglExpressionFonction o)
  { return ""; }
  
  public String code(AglExpressionIndice o)
  { return ""; }
  
  public String code(AglExpressionInitArray o)
  { return ""; }
  
  public String code(AglExpressionMethode o)
  { return ""; }
  
  public String code(AglExpressionMultiple o)
  { return ""; }
  
  public String code(AglExpressionNew o)
  { return ""; }
  
  public String code(AglExpressionNewArray o)
  { return ""; }
  
  public String code(AglExpressionParenthesee o)
  { return ""; }
  
  public String code(AglExpressionTernaire o)
  { return ""; }
  
  public String code(AglExpressionTypage o)
  { return ""; }
  
  public String code(AglExpressionUnaireDroite o)
  { return ""; }
  
  public String code(AglExpressionUnaireGauche o)
  { return ""; }
  

// Instructions

  public String code(AglInstructionGenerique o)
  { return ""; }
  
  public String code(AglInstructionVide o)
  { return ""; }
  
  public String code(AglInstructionAffectation o)
  { return ""; }
  
  public String code(AglInstructionBloc o)
  { return ""; }
  
  public String code(AglInstructionBreak o)
  { return ""; }
    
  public String code(AglInstructionCatch o)
  { return ""; }
  
  public String code(AglInstructionContinue o)
  { return ""; }
  
  public String code(AglInstructionDefVar o)
  { return ""; }
  
  public String code(AglInstructionDoWhile o)
  { return ""; }
  
  public String code(AglInstructionExpression o)
  { return ""; }
  
  public String code(AglInstructionFinally o)
  { return ""; }
  
  public String code(AglInstructionGoto o)
  { return ""; }
  
  public String code(AglInstructionFor o)
  { return ""; }
  
  public String code(AglInstructionIf o)
  { return ""; }
  
  public String code(AglInstructionLabel o)
  { return ""; }

  public String code(AglInstructionProcedure o)
  { return ""; }
  
  public String code(AglInstructionReturn o)
  { return ""; }

  public String code(AglInstructionSwitch o)
  { return ""; }

  public String code(AglInstructionThrow o)
  { return ""; }

  public String code(AglInstructionTry o)
  { return ""; }

  public String code(AglInstructionWhile o)
  { return ""; }

// Unite

  public String code(AglUnite o)
  {
    String r="";
    indentation=0;

    r+=entete(o.fichier);
    r+="\n";

    for(Enumeration e=AglType.table.elements(); e.hasMoreElements(); )
    {
      AglType at=(AglType)e.nextElement();
      if(at instanceof AglClasse)
      {
        AglClasse ac=(AglClasse)at;
        if(!ac.elementaire)
        {
	  String nc=code(ac.nom);
	  r+="/* Body for class "+nc+" */\n";
          r+=code(ac);
        }
      }
    }

    return r;
  }
}
