/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AglCodeJtkCpp.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:05 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.agl;
import com.memoire.agl.*;


import java.util.*;

public class AglCodeJtkCpp extends AglCodeCpp
{
  public AglCodeJtkCpp()
  {
    MAIN           =false;
    GC             =true;
    STL            =false;
    SINGLECLASSROOT=true;
    JAVALIKE       =true;
    SPACEAFTER     ="";
    RETURNAFTER    =true;
    NAMESPACE      =false;
    SHORTNAME      =false;
    BOOLEANTYPE    ="boolean";
  }

  public String code(AglType o)
  {
    String r="";

    if(o instanceof AglTypePrimitif)
      r="java_"+super.code(o);
    else
      r=super.code(o);

    return r;
  }

  public String avantClasse(AglClasse o)
  {
    String r="#include \"jtk_impl.hpp\"\n\n";

    r+="java_lang_Class* "+code(o.nom);
    r+="_class=new java_lang_Class\n";
    r+="  (\""+code(o.nom).replace('_','.')+"\"";

    if(o.meres.noms.size()>0)
      r+=","+code(o.meres.noms.elementAt(0))+"_class";

    r+=");\n";
    return r;
  }

  public String avantMethodes(AglClasse o)
  {
    String r="\njava_lang_Class* ";
    r+=code(o.nom)+"::getClass()\n";
    r+="{\n";
    r+="  return "+code(o.nom)+"_class;\n";
    r+="}\n";
    return r;
  }
}
