/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AglCodeJtkHpp.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:05 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.agl;
import com.memoire.agl.*;


import java.util.*;

public class AglCodeJtkHpp extends AglCodeHpp
{
  public AglCodeJtkHpp()
  {
    MAIN           =false;
    GC             =true;
    STL            =false;
    SINGLECLASSROOT=true;
    JAVALIKE       =true;
    SPACEAFTER     ="";
    RETURNAFTER    =true;
    NAMESPACE      =false;
    SHORTNAME      =false;
    BOOLEANTYPE    ="boolean";
  }

  public String code(AglType o)
  {
    String r="";

    if(o instanceof AglTypePrimitif)
      r="java_"+super.code(o);
    else
      r=super.code(o);

    return r;
  }

  public String avantClasse(AglClasse o)
  {
    String r="";

    r+="#include \"jtk_decl.hpp\"\n";

    for(int i=0; i<o.meres.noms.size(); i++)
      r+="#include \""+code(o.meres.noms.elementAt(i))+".hpp\"\n";

    for(int i=0; i<o.interfaces.noms.size(); i++)
      r+="#include \""+code(o.interfaces.noms.elementAt(i))+".hpp\"\n";

    r+="\nextern java_lang_Class* "+code(o.nom);
    r+="_class;\n\n";

    return r;
  }

  public String avantMethodes(AglClasse o)
  {
    return "  virtual java_lang_Class* getClass();\n";
  }
}




