/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AglCodeSrcHtml.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.agl;
import com.memoire.agl.*;
import com.memoire.fu.*;
import com.memoire.re.*;
import com.memoire.bu.*;
//import com.memoire.syntax.*;

import javax.swing.text.*;

import java.awt.*;
import java.util.*;

public class AglCodeSrcHtml extends AglCode
{
  protected final boolean LINKS=
    AglPreferences.AGL.getBooleanProperty("srchtml.code.links",false);

  protected final boolean TYPES=
    AglPreferences.AGL.getBooleanProperty("srchtml.code.types",false);

  protected final boolean NUMBERS=
    AglPreferences.AGL.getBooleanProperty("srchtml.code.numbers",true);

  protected final String LANGUAGE=
    AglPreferences.AGL.getStringProperty("srchtml.code.language","");

  public AglCodeSrcHtml()
  {
  }

  public String extension()
  {
    return "html";
  }

  public String[] extensions()
  {
    return new String[] { "html", "HTML", "htm", "HTM" };
  }

  private final static char LT=0xFC; //"CSH_LT";
  private final static char GT=0xFD; //"CSH_GT";

  private static String btag(String _s)
  {
    return LT+_s+GT;
  }

  private static String etag(String _s)
  {
    return LT+"/"+_s+GT;
  }

  public String code(AglNom          o) { return ""; }
  public String code(AglListeNoms    o) { return ""; }

  public String code(AglAttribut     o) { return ""; }
  public String code(AglBloc         o) { return ""; }
  public String code(AglClasse       o) { return ""; }
  public String code(AglConstructeur o) { return ""; }
  public String code(AglImport       o) { return ""; }
  public String code(AglMethode      o) { return ""; }
  public String code(AglParametre    o) { return ""; }
  public String code(AglStruct       o) { return ""; }
  public String code(AglType         o) { return ""; }
  //public String code(AglUnite        o) { return ""; }
  public String code(AglVisibilite   o) { return ""; }

  public String code(AglExpressionGenerique    o) { return ""; }
  public String code(AglExpressionAffectation  o) { return ""; }
  public String code(AglExpressionAttribut     o) { return ""; }
  public String code(AglExpressionBinaire      o) { return ""; }
  public String code(AglExpressionDefVar       o) { return ""; }
  public String code(AglExpressionEstUn        o) { return ""; }
  public String code(AglExpressionFonction     o) { return ""; }
  public String code(AglExpressionIndice       o) { return ""; }
  public String code(AglExpressionInitArray    o) { return ""; }
  public String code(AglExpressionMethode      o) { return ""; }
  public String code(AglExpressionMultiple     o) { return ""; }
  public String code(AglExpressionNew          o) { return ""; }
  public String code(AglExpressionNewArray     o) { return ""; }
  public String code(AglExpressionParenthesee  o) { return ""; }
  public String code(AglExpressionTernaire     o) { return ""; }
  public String code(AglExpressionTypage       o) { return ""; }
  public String code(AglExpressionUnaireDroite o) { return ""; }
  public String code(AglExpressionUnaireGauche o) { return ""; }

  public String code(AglInstructionGenerique    o) { return ""; }
  public String code(AglInstructionVide         o) { return ""; }
  public String code(AglInstructionAffectation  o) { return ""; }
  public String code(AglInstructionBloc         o) { return ""; }
  public String code(AglInstructionBreak        o) { return ""; }
  public String code(AglInstructionCatch        o) { return ""; }
  public String code(AglInstructionContinue     o) { return ""; }
  public String code(AglInstructionDefVar       o) { return ""; }
  public String code(AglInstructionDoWhile      o) { return ""; }
  public String code(AglInstructionExpression   o) { return ""; }
  public String code(AglInstructionFinally      o) { return ""; }
  public String code(AglInstructionFor          o) { return ""; }
  public String code(AglInstructionGoto         o) { return ""; }
  public String code(AglInstructionIf           o) { return ""; }
  public String code(AglInstructionLabel        o) { return ""; }
  public String code(AglInstructionProcedure    o) { return ""; }
  public String code(AglInstructionReturn       o) { return ""; }
  public String code(AglInstructionSwitch       o) { return ""; }
  public String code(AglInstructionSynchronized o) { return ""; }
  public String code(AglInstructionThrow        o) { return ""; }
  public String code(AglInstructionTry          o) { return ""; }
  public String code(AglInstructionWhile        o) { return ""; }

  /*
  public String code(AglCommentaireSimple o)
  {
    String r=btag("FONT COLOR=#000080");
    r+=transcode(super.code(o));
    return r+etag("FONT");
  }

  public String code(AglCommentaireMulti o)
  {
    String r=btag("FONT COLOR=#000080");
    r+=transcode(super.code(o));
    return r+etag("FONT");
  }
  */

  /*
  public String code(AglNom o)
  {
    String r=btag("B");
    r+=transcode(super.code(o));
    return r+etag("B");
  }
  */

  /*
  public String code(AglListeNoms o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }
  */

  /*
  public String code(AglType o)
  {
    String r="";

    if(o instanceof AglTypePrimitif) ; //r+=btag("FONT COLOR=#800000");
    else if(o instanceof AglTypeTableau)  ;
    else r+=btag("A HREF=\""+o.nom.formeJava()+".html\"");

    r+=transcode(super.code(o));

    if(o instanceof AglTypePrimitif) ; //r+=etag("FONT");
    else if(o instanceof AglTypeTableau)  ;
    else r+=etag("A");

    return r;
  }
  */

  /*
  public String code(AglMoule o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglAttribut o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglBloc o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglStruct o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglClasse o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglConstructeur o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }
  */

  /*
  public String code(AglPaquet o)
  {
    String r=btag("FONT COLOR=#008000");
    r+=transcode(super.code(o));
    return r+etag("FONT");
  }

  public String code(AglImport o)
  {
    String r=btag("FONT COLOR=#008000");
    r+=transcode(super.code(o));
    return r+etag("FONT");
  }
  */

  /*
  public String code(AglMethode o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglParametre o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }
  */

  /*
  public String code(AglVisibilite o)
  {
    String r=btag("FONT COLOR=#800080");
    r+=transcode(super.code(o));
    return r+etag("FONT");
  }
  */

// Expressions

  /*
  public String code(AglExpression o)
  {
    String r=btag("FONT COLOR=#404000");
    r+=transcode(super.code(o));
    return r+etag("FONT");
  }
  */

  /*
  public String code(AglExpressionGenerique o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglExpressionAffectation o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglExpressionAttribut o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglExpressionBinaire o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglExpressionDefVar o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglExpressionEstUn o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglExpressionFonction o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglExpressionIndice o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglExpressionInitArray o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglExpressionMethode o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglExpressionMultiple o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglExpressionNew o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglExpressionNewArray o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglExpressionParenthesee o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglExpressionTernaire o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglExpressionTypage o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglExpressionUnaireDroite o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglExpressionUnaireGauche o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }
  */

// Instructions

  /*
  public String code(AglInstruction o)
  {
    String r=btag("FONT COLOR=#004040");
    r+=transcode(super.code(o));
    return r+etag("FONT");
  }
  */

  /*
  public String code(AglInstructionGenerique o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglInstructionVide o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglInstructionAffectation o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglInstructionBloc o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglInstructionCatch o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglInstructionCondition o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglInstructionContinue o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglInstructionDefVar o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglInstructionDoWhile o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglInstructionExpression o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglInstructionFinally o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglInstructionFor o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglInstructionGoto o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglInstructionIf o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglInstructionLabel o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglInstructionProcedure o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglInstructionReturn o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglInstructionSwitch o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglInstructionThrow o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglInstructionTry o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }

  public String code(AglInstructionWhile o)
  {
    String r="";
    r+=transcode(super.code(o));
    return r;
  }
  */

// Unite

  public String code(AglUnite o)
  {
    String fichier=o.fichier;
    int i;
    i=fichier.lastIndexOf('/');
    if(i>=0) fichier=fichier.substring(i+1,fichier.length());
    i=fichier.lastIndexOf('\\');
    if(i>=0) fichier=fichier.substring(i+1,fichier.length());

    String langage=LANGUAGE;
    if("".equals(langage)) langage=o.langage;
    AglCode code=AglCode.langage(langage);

    suivi("Code");
    boolean e=AglOptions.entete;
    AglOptions.entete=false;
    String r=code.code(o);
    AglOptions.entete=e;

    return coloration(r,code.syntaxe(),fichier,TYPES,LINKS,NUMBERS);
  }

  public static String coloration
    (String _source, String _syntaxe, String _titre,
     boolean _types, boolean _links, boolean _numbers)
  {
    String r="";
    String s=_source;

    /*
    String fichier=o.fichier;
    int i;
    i=fichier.lastIndexOf('/');
    if(i>=0) fichier=fichier.substring(i+1,fichier.length());
    i=fichier.lastIndexOf('\\');
    if(i>=0) fichier=fichier.substring(i+1,fichier.length());
    */

    r ="<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2//EN\">\n<HTML>\n";
    r+="<HEAD>\n";
    /*
      r+="  <META HTTP-EQUIV=\"Content-Type\"";
      r+=" CONTENT=\"text/html; charset=iso-8859-1\">\n";
    */
    r+="  <TITLE>"+_titre+"</TITLE>\n";
    /*
    r+="  <LINK REL=\"StyleSheet\" HREF=\""+
	AglOptions.styleHtml+"\" TITLE=\"Style\">\n";
    */
    r+="  <STYLE>A { text-decoration: none; }</STYLE>\n";
    r+="</HEAD>\n";

    r+="<BODY BGCOLOR=#FFF0F0 TEXT=#000000 LINK=#008000 VLINK=#008000 ALINK=#00FF00>\n";
    //r+=entete(o.fichier);
    r+="<PRE>\n";

    suivi("Coloration");
    BuAutoStyledDocument doc=new BuAutoStyledDocument(s);
    doc.setSyntax(_syntaxe);

    suivi("Html");
    s=toHtml(doc);

    suivi("Replace");
    //s=FuLib.replace(s,"&" ,"&amp;" );
    //s=FuLib.replace(s,"\"","&quot;");
    s=FuLib.replace(s,"<","&lt;");
    s=FuLib.replace(s,">","&gt;");

    suivi("Link/Type");
    s=link(s,_types,_links);

    if(_numbers)
    {
      suivi("Numbers");
      s=number(s);
    }

    suivi("Replace");
    s=s.replace(LT,'<');
    s=s.replace(GT,'>');

    r+=s;
    r+="</PRE>\n</BODY>\n</HTML>\n";
    return r;
  }

  private static String number(String _s)
  {
    String r="";
    int    n=1;

    String t;
    int    i;
    while((i=_s.indexOf('\n'))>=0)
    {
      t="      "+n;
      t=t.substring(t.length()-5);
      if(n%5==0) r+=btag("FONT COLOR=#505050")+t+" "+etag("FONT");
      else       r+=btag("FONT COLOR=#A0A0A0")+t+" "+etag("FONT");
      r+=_s.substring(0,i+1);
      _s=_s.substring(i+1);
      n++;
    }

    return r;
  }

  private static String toHtml(BuAutoStyledDocument _doc)
  {
    String r="";

    Element root=_doc.getDefaultRootElement();
    int     nbl =root.getElementCount();

    for(int i=0;i<nbl;i++)
    {
      Element line=root.getElement(i);
      int     nbw =line.getElementCount();
      int     hl  =0;

      for(int j=0;j<nbw;j++)
      {	
	Element word=line.getElement(j);
	String t="";
	try
	{
	  int start=word.getStartOffset();
	  int end  =word.getEndOffset();
	  t=_doc.getText(start,end-start);
	  t=FuLib.replace(t,"\t","        ");
	}
	catch(BadLocationException ex) { }
	//System.err.println(word+" ["+replace(t,"\n","")+"]");

	AttributeSet attributes=word.getAttributes();
	Color fg=_doc.getForeground(attributes);
	Font  ft=_doc.getFont(attributes);

	String h="000000"+Integer.toHexString(fg.getRGB());
	h=h.substring(h.length()-6);

	if(!"000000".equals(h)           ) r+=btag("FONT COLOR=#"+h);
	if((ft.getStyle()&Font.ITALIC)!=0) r+=btag("I");
	if((ft.getStyle()&Font.BOLD  )!=0) r+=btag("B");
	r+=t;
	if((ft.getStyle()&Font.BOLD  )!=0) r+=etag("B");
	if((ft.getStyle()&Font.ITALIC)!=0) r+=etag("I");
	if(!"000000".equals(h)           ) r+=etag("FONT");
      }
    }

    return r;
  }

  public static String link(String _s, boolean _t, boolean _l)
  {
    String r=_s;

    if(_t||_l)
    for(Enumeration e=AglType.table.elements(); e.hasMoreElements(); )
    {
      AglType at=(AglType)e.nextElement();
      if(  (at instanceof AglClasse)
	 ||(at instanceof AglStruct))
      {
	String  fn=at.nom.formeJava();
	String  sn=at.nom.dernier();

	try
	{
	  RE regexp_match  =new RE("(^|[^a-zA-Z0-9_])"+sn+"($|[^a-zA-Z0-9_])");
	  RE regexp_replace=new RE(sn);
	  REMatch mm;
	  int     p=0;
	  int     q=0;

	  while((mm=regexp_match.getMatch(r,p))!=null)
	  {
	    String oldtext=r.substring(mm.getStartIndex(),
				       mm.getEndIndex  ());

	    REMatch mr=regexp_replace.getMatch(oldtext);

	    /*
	    q++;
	    if(q==500)
	    {
	      System.err.println("MAYBE LOOP : SRCHTML");
	      System.err.println("ERROR LINK    : SN "+sn);
	      System.err.println("              : "+oldtext);
	      break;
	    }
	    */

	    if(mr==null)
	    {
	      System.err.println("MR=NULL : SRCHTML");
	      System.err.println("ERROR LINK    : SN "+sn);
	      System.err.println("              : "+oldtext);
	      break;
	    }

	    String newtext=oldtext.substring(mr.getStartIndex(),
					     mr.getEndIndex  ());

	    /*
	    if(oldtext.equals(newtext))
	    {
	      System.err.println("SAMETEXT : SRCHTML");
	      System.err.println("ERROR LINK    : SN "+sn);
	      System.err.println("              : "+oldtext);
	      break;
	    }
	    */

	    int si=mm.getStartIndex()+mr.getStartIndex();
	    int ei=mm.getStartIndex()+mr.getEndIndex  ();

	         if(_l) newtext=btag("A HREF="+fn+".html")+sn+etag("A");
	    else if(_t) newtext=btag("FONT COLOR=#008000")+sn+etag("FONT");
	    r=r.substring(0,si)+newtext+r.substring(ei);

	    p=mm.getStartIndex()+mr.getStartIndex()+newtext.length();
	  }
	}
	catch(REException ex)
	    { System.err.println("AglCodeSrcHtml: link"); }
	catch(Error ex)
	    { System.err.println(""+ex); }
      }
    }

    return r;
  }

  /*
  private String colorize(String _s)
  {
    SyntaxKey[] keys=new SyntaxBase("Java").keys();

    Hashtable btags=new Hashtable();
    Hashtable etags=new Hashtable();

    btags.put(SyntaxBase.KEYWORD ,"B");
    etags.put(SyntaxBase.KEYWORD ,"B");
    btags.put(SyntaxBase.TYPE    ,"FONT COLOR=#008000");
    etags.put(SyntaxBase.TYPE    ,"FONT");
    btags.put(SyntaxBase.MODIFIER,"FONT COLOR=#008080");
    etags.put(SyntaxBase.MODIFIER,"FONT");
    btags.put(SyntaxBase.SPECIAL ,"FONT COLOR=#808000");
    etags.put(SyntaxBase.SPECIAL ,"FONT");
    btags.put(SyntaxBase.OPERATOR,"FONT COLOR=#C06000");
    etags.put(SyntaxBase.OPERATOR,"FONT");
    btags.put(SyntaxBase.NUMBER  ,"FONT COLOR=#0000FF");
    etags.put(SyntaxBase.NUMBER  ,"FONT");
    btags.put(SyntaxBase.COMMENT ,"FONT COLOR=#008000");
    etags.put(SyntaxBase.COMMENT ,"FONT");
    btags.put(SyntaxBase.STRING  ,"FONT COLOR=#8000FF");
    etags.put(SyntaxBase.STRING  ,"FONT");

    for(int i=0;i<keys.length;i++)
	_s=colorize1(keys[i],_s,
		     (String)btags.get(keys[i].style),
		     (String)etags.get(keys[i].style));

    for(int i=0;i<keys.length;i++)
      if(SyntaxBase.COMMENT.equals(keys[i].style))
	_s=colorize1(keys[i],_s,"FONT COLOR=#008000","FONT");

    for(int i=0;i<keys.length;i++)
      if(SyntaxBase.NUMBER.equals(keys[i].style))
	_s=colorize1(keys[i],_s,"FONT COLOR=#0000FF","FONT");

    for(int i=0;i<keys.length;i++)
      if(SyntaxBase.KEYWORD.equals(keys[i].style))
	_s=colorize1(keys[i],_s,"B","B");

    for(int i=0;i<keys.length;i++)
      if(SyntaxBase.MODIFIER.equals(keys[i].style))
	_s=colorize1(keys[i],_s,"FONT COLOR=#800080","FONT");

    return _s;
  }

  private String colorize1
    (SyntaxKey key, String _s, String _btag, String _etag)
  {
      if(_btag==null) _btag="";
      if(_etag==null) _etag="";

      String  r=_s;

      REMatch mm;
      int     p=0;
      int     q=0;

      while((mm=key.regexp_match.getMatch(r,p))!=null)
      {
	String newtext=r.substring(mm.getStartIndex(),
				   mm.getEndIndex  ());
	if(  (newtext.indexOf(LT)>=0)
	   ||(newtext.indexOf(GT)>=0))
	    { p=mm.getEndIndex(); continue; }

	int bti=r.lastIndexOf(LT,mm.getStartIndex());
	int eti=r.lastIndexOf(GT,mm.getStartIndex());
	if((bti>=0)&&(bti>eti))
	    { p=mm.getEndIndex(); continue; }

	REMatch mr=key.regexp_replace.getMatch(newtext);

	q++;
	if((q==500)||(mr==null))
	{
	  System.err.println("LOOP");
	  System.err.println
	    ("ERROR COLORIZE: MATCH "+key.match);
	  System.err.println
	    ("              : REPL. "+key.replace);
	  System.err.println
	    ("              : "+newtext);
	  break;
	}

	newtext=newtext.substring(mr.getStartIndex(),
				  mr.getEndIndex  ());

	if(  (newtext.indexOf(LT)>=0)
	   ||(newtext.indexOf(GT)>=0))
	    { p=mm.getEndIndex(); continue; }

	bti=r.lastIndexOf(LT,mm.getStartIndex());
	eti=r.lastIndexOf(GT,mm.getStartIndex());
	if((bti>=0)&&(bti>eti))
	    { p=mm.getEndIndex(); continue; }

	newtext=btag(_btag)+clean(newtext)+etag(_etag);

	int si=mm.getStartIndex()+mr.getStartIndex();
	int ei=mm.getStartIndex()+mr.getEndIndex  ();
	
	r=r.substring(0,si)+newtext+r.substring(ei);
	
	p=mm.getStartIndex()+mr.getStartIndex()+newtext.length();
      }

      return r;
  }

  private String clean(String _s)
  {
    String  r="";
    boolean p=true;
    for(int i=0;i<_s.length();i++)
    {
	char c=_s.charAt(i);
	   if(c==LT) p=false;
      else if(c==GT) p=true;
      else if(p) r+=c;
    }
    return r;
  }	
  */
}
