/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AglCodeUmlHierarchie.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.agl;
import com.memoire.acme.*;
import com.memoire.agl.*;
//import com.memoire.alma.*;

import java.util.*;
import java.awt.*;
import java.awt.image.*;
import java.io.*;
import java.lang.reflect.*;

import javax.swing.*;
import javax.swing.border.*;

class AglCodeUmlHierarchieXY
{
  AglClasse classe;
  int       x,y,w,h;
  boolean   in;

  AglCodeUmlHierarchieXY(AglClasse _c, int _x, int _y, boolean _in)
  {
    classe=_c;
    x=_x;
    y=_y;
    in=_in;
  }
}

class AglCodeUmlHierarchieFrame extends JFrame implements Runnable
{
  //Thread blinker;
  AglCodeUmlHierarchie       a;
  AglCodeUmlHierarchieCanvas c;

  private JComponent    content;
  private BorderLayout  layout;
  private JScrollPane   spGraphe;

  public AglCodeUmlHierarchieFrame(AglCodeUmlHierarchie _a)
  {
    a=_a;
    if(!"".equals(AglOptions.module))
      setTitle("UmlHierarchie: "+AglOptions.module);
    else
      setTitle("UmlHierarchie: "+a.projet.nom);

    content=(JComponent)getContentPane();
    layout=new BorderLayout();
    content.setLayout(layout);
    content.setBorder(new EmptyBorder(0,0,0,0));

    setSize(200,200);

    c=new AglCodeUmlHierarchieCanvas(a);
    c.setBorder(new EmptyBorder(0,0,0,0));
    spGraphe=new JScrollPane(c);
    content.add("Center",spGraphe);

    // addNotify();
    setVisible(true);
    start();
  }

  public void start()
  {
    setLocation(0,128);
    new Thread(this,"Agl code uml hierarchie").start();
  }
  
  /*
  public void stop()
  {
    blinker.stop();
    blinker=null;
    // System.exit(0);
  }
  */
  
  public void run()
  {
    if(AglOptions.application==null)
    {
      repaint(0);

      while(!a.done)
      {
	System.err.println("WAITING...");
	try { Thread.sleep(1500); }
	catch(Exception ex) { }
      }

      save();

      if(AglOptions.application==null)
      {
	dispose();
	System.exit(0);
      }
    }
  }
  
  void save()
  {
    System.err.println("SAVING "+a.xmax+","+a.ymax);

    Image img=a.createImage(c);

    /*
    Image    img=createImage(a.xmax,a.ymax);
    Graphics g  =img.getGraphics();

    g.setColor(Color.white);
    g.fillRect(0,0,a.xmax,a.ymax);

    synchronized (a)
    {
      a.g=g;
      a.paintImage();
    }
    */

    // c.update(g);

    System.err.println("ACME -- "+a.xmax+","+a.ymax);
    AglImageEncoder.save(img,"UmlHierarchie",AglOptions.formatImage);
  }
}

public class AglCodeUmlHierarchie extends AglCodeUmlAbstract
{
  protected boolean NAMESPACE=
    AglPreferences.AGL.getBooleanProperty("uml.code.namespace",false);

  protected boolean SHORTNAME=
    AglPreferences.AGL.getBooleanProperty("uml.code.shortname",true);

  protected boolean ATTRIBUTETYPE=
    AglPreferences.AGL.getBooleanProperty("uml.code.attribute.type",false);

  protected boolean METHODTYPE=
    AglPreferences.AGL.getBooleanProperty("uml.code.method.type",false);

  protected boolean PARAMETERNAME=
    AglPreferences.AGL.getBooleanProperty("uml.code.parameter.name",false);

  protected boolean PARAMETERTYPE=
    AglPreferences.AGL.getBooleanProperty("uml.code.parameter.type",false);

  protected int WCO=
    AglPreferences.AGL.getIntegerProperty("uml.code.width",180);

  protected int WCI=
    AglPreferences.AGL.getIntegerProperty("uml.code.width",180);

  // protected final static int WCO=180;
  // protected final static int WCI=180;

  protected final static int HCO=14;
  protected final static int HCI=20;

  protected final static Color[] couleurs=
  {
    new Color(240,240,240),
    new Color(224,224,224),
    new Color(208,208,208),

    new Color(240,224,224),
    new Color(224,208,208),
    new Color(208,192,192),

    new Color(240,240,224),
    new Color(224,224,208),
    new Color(208,208,192),

    new Color(240,224,240),
    new Color(224,208,224),
    new Color(208,192,208),

    new Color(224,240,224),
    new Color(208,224,208),
    new Color(192,208,192),

    new Color(224,240,240),
    new Color(208,224,224),
    new Color(192,208,208)
  };

  public AglProjet projet;

  Graphics  g;

  Hashtable classes=new Hashtable();
  Hashtable table  =new Hashtable();
  Hashtable meres  =new Hashtable();

  int       x,y;
  int       xmax,ymax;
  boolean   done;

  public String extension()
  {
    return "html";
  }

  public String[] extensions()
  {
    return new String[] { "html", "htm" };
  }

  public String syntaxe()
  {
    return "Html";
  }

  public boolean optionFormatImage()
    { return true; }

  public boolean optionStyleHtml()
    { return true; }

  public synchronized Image createImage(JComponent _c)
  {
    Image img;

    /*
    img=_c.createImage(xmax,ymax);
    g=img.getGraphics();
    g.setColor(Color.red);
    g.fillRect(0,0,xmax,ymax);
    paintImage();
    */

    done=false;

    img=_c.createImage(xmax+10,ymax+10);
    g=img.getGraphics();
    g.setColor(Color.white);
    g.fillRect(0,0,xmax+10,ymax+10);
    paintImage();

    return img;
  }

  public synchronized void paintImage() // Graphics g
  {
    table.clear();
    x=10;
    y=10;
    xmax=Math.max(xmax,20);
    ymax=Math.max(ymax,20);

    if(AglOptions.module.equals(""))
    {
      for(Enumeration e=AglType.table.elements(); e.hasMoreElements(); )
      {
	AglType at=(AglType)e.nextElement();
	if(at instanceof AglClasse)
	{
	  AglClasse ac=(AglClasse)at;
	  if(!ac.elementaire)
	    // if(ac.meres.noms.size()==0)
	    {
	      AglOptions.terminal.trace(""+ac);
	      if(!table.contains(ac))
		code(ac);
	    }
	}
      }
    }
    else
    {
      String m=AglOptions.module;
      AglOptions.terminal.suivi("Module : "+m);

      AglClasse ac;
      String r;
      r=m; ac=null; // (AglClasse)AglType.cherche(r);

      /*
	if(ac==null)
	  {
	    r="I"+m.substring(0,1).toUpperCase()+m.substring(1);
	    ac=(AglClasse)AglType.cherche(r);
	  }
	if(ac==null)
	  {
	    r="ICalcul"+m.substring(0,1).toUpperCase()+m.substring(1);
	    ac=(AglClasse)AglType.cherche(r);
	    if(ac!=null) ac=(AglClasse)AglType.cherche("IService");
	  }
      */

      /*
      if((ac==null)&&!"".equals(AglOptions.classe))
      {
	r=AglOptions.classe;
	ac=(AglClasse)AglType.cherche(r);
      }
      */

      if(ac==null)
      {
	r="IObjet";
	ac=(AglClasse)AglType.cherche(r);
      }

      if(ac==null)
      {
	r="Object";
	ac=(AglClasse)AglType.cherche(r);
      }

      AglOptions.terminal.suivi("Racine : "+r);
      if(ac!=null) code(ac);
    }

    //if(!AglOptions.module.equals(""))
    {
      for(Enumeration e=AglType.table.elements(); e.hasMoreElements(); )
      {
	AglType at=(AglType)e.nextElement();
	if(at instanceof AglStruct)
	{
	  AglStruct as=(AglStruct)at;
	  //if(!as.elementaire)
	  // if(ac.meres.noms.size()==0)
	  {
	    AglOptions.terminal.trace(""+as);
	    System.err.println(""+as.nom.formeJava());
	    //if(!table.contains(as))
	    code(as);
	  }
	}
      }
    }

    done=true;
  }

  protected boolean isInside(AglStruct o)
  {
    return filtre(o.nom);

    /*
    boolean inside=false;

    if(AglOptions.module.equals(""))
      inside=true;
    else
    if(o.nom.formeJava().startsWith(AglOptions.module))
      inside=true;

    return inside;
    */
  }

  protected boolean isInside(AglClasse o)
  {
    return filtre(o.nom);

    /*
    boolean inside=false;

    if(AglOptions.module.equals(""))
      inside=true;
    else
    if(o.nom.formeJava().startsWith(AglOptions.module))
      inside=true;
    */

    /*
      for(Enumeration e=o.nom.identificateurs.elements();
          e.hasMoreElements(); )
	if(((String)e.nextElement()).equals(AglOptions.module)) inside=true;
    */

    /*
    System.err.println("INSIDE: "+o.nom.formeJava()+"="+
    inside+" ("+AglOptions.module+")");
    */

    //return inside;
  }

  void marqueMeres(AglClasse o)
  {
    meres.put(o,o);

    for(Enumeration e=o.meres.noms.elements(); e.hasMoreElements(); )
    {
      AglNom  an=(AglNom)e.nextElement();
      AglType at=(AglType)AglType.cherche(an);
      if((at!=null)&&(at instanceof AglClasse))
      {
	AglClasse ac=(AglClasse)at;
	marqueMeres(ac);
      }
    }
  }

  static void degrade(Graphics g, Color c, int x, int y, int w, int h)
  {

    /*
    int   r1=c.getRed();
    int   v1=c.getGreen();
    int   b1=c.getBlue();

    int   r2=r1*8/10;
    int   v2=v1*8/10;
    int   b2=b1*9/10;

    for(int j=0;j<h;j++)
    {
      Color d=c;
      if(j<=6)     d=new Color(r2+(r1-r2)*j/6,
			       v2+(v1-v2)*j/6,
			       b2+(b1-b2)*j/6);
      if(h-j-1<=6) d=new Color(r2+(r1-r2)*(h-j-1)/6,
			       v2+(v1-v2)*(h-j-1)/6,
			       b2+(b1-b2)*(h-j-1)/6);
      g.setColor(d);
      g.drawLine(x,y+j,x+w-1,y+j);
    }
    */

  }

  public String code(AglStruct o)
  {
    // if(meres.get(o)==null) return "";
    if(!isInside(o))       return "";

    /*
    table.put(o,new AglCodeUmlHierarchieXY(o,x,y,true));
    classes.put(o.toString()+x+y,new AglCodeUmlHierarchieXY(o,x,y,inside));
    */

    g.setFont(new Font("SansSerif",Font.PLAIN,10));
    g.setColor(Color.black);
    //g.drawLine(x-11,y+HCI/2,x,y+HCI/2);
    //g.drawLine(x-11,y+5,x-11,y+HCI/2);

    int c=0;

    /*
    if(!inside)
      c=0;
    else
    if((o.methodes.size()>0)&&(o.attributs.size()>0))
      c=3;
    else
    if(o.methodes.size()>0)
      c=6;
    else
    if(o.attributs.size()>0)
      c=9;
    else
      c=12;
    */

    degrade(g,couleurs[c],x,y,WCI,HCI);

    g.setColor(Color.black);
    g.drawString(o.nom.dernier(),x+4,y+HCI/2+4);
    g.drawRect(x,y,WCI,HCI);

    int ybg;
    ybg=y+HCI/2;
    y+=HCI;

    if(!AglOptions.module.equals(""))
    {
      degrade(g,couleurs[c+1],x,y,WCI,o.attributs.size()*HCO);

      g.setColor(Color.black);
      g.drawRect(x,y,WCI,o.attributs.size()*HCO);

      for(Enumeration e=o.attributs.elements(); e.hasMoreElements(); )
      {
	AglAttribut aa=(AglAttribut)e.nextElement();
	g.drawString(code(aa.visibilite),x+4,y+HCO-4);
	g.drawString(code(aa),x+14,y+HCO-4);
	if(aa.visibilite.vstatic)
	{
	  FontMetrics fm=g.getFontMetrics(g.getFont());
	  int ws=Math.min(WCI-18,fm.stringWidth(aa.nom));
	  g.drawLine(x+14,y+HCO-3,x+14+ws,y+HCO-3);
	}
	y+=HCO;
      }

      /*
      degrade(g,couleurs[c+2],x,y,WCI,o.methodes.size()*HCO);

      g.setColor(Color.black);
      g.drawRect(x,y,WCI,o.methodes.size()*HCO);

      for(Enumeration e=o.methodes.elements(); e.hasMoreElements(); )
      {
	AglMethode am=(AglMethode)e.nextElement();
	g.drawString(code(am.visibilite),x+4,y+HCO-4);
	String s=am.nom;
	if(am.parametres.size()>0) s+=" ("+am.parametres.size()+")";
        else s+=" ( )";
	g.drawString(s,x+14,y+HCO-4);
	if(am.visibilite.vstatic)
	{
	  FontMetrics fm=g.getFontMetrics(g.getFont());
	  int ws=Math.min(WCI-18,fm.stringWidth(s));
	  g.drawLine(x+14,y+HCO-3,x+14+ws,y+HCO-3);
	}
	y+=HCO;
      }
      */
    }

    xmax=Math.max(xmax,x+WCI+10);
    ymax=Math.max(ymax,y+10);
    System.err.println("XMAX="+xmax);
    System.err.println("YMAX="+ymax);

    y+=5;
    return "";
  }

  public String code(AglClasse o)
  {
    if(meres.get(o)==null) return "";

    boolean inside=isInside(o);
    table.put(o,new AglCodeUmlHierarchieXY(o,x,y,inside));
    classes.put(o.toString()+x+y,new AglCodeUmlHierarchieXY(o,x,y,inside));

    g.setFont(new Font("SansSerif",Font.PLAIN,10));
    g.setColor(Color.black);
    if(inside)
    {
      g.drawLine(x-11,y+HCI/2,x,y+HCI/2);
      g.drawLine(x-11,y+5,x-11,y+HCI/2);
    }
    else
      g.drawLine(x-11,y+5,x,y+5);

    int c=0;

    if(!inside)
      c=0;
    else
    if((o.methodes.size()>0)&&(o.attributs.size()>0))
      c=3;
    else
    if(o.methodes.size()>0)
      c=6;
    else
    if(o.attributs.size()>0)
      c=9;
    else
      c=12;

    if(inside)
      {
	// g.setColor(couleurs[c]);
	// g.fillRect(x,y,WCI,HCI);
	degrade(g,couleurs[c],x,y,WCI,HCI);

	g.setColor(Color.black);
	g.drawString(o.nom.dernier(),x+4,y+HCI/2+4);
	g.drawRect(x,y,WCI,HCI);
      }
    else
      {
	// g.setColor(couleurs[c]);
	// g.fillRect(x,y,WCO,HCO);
	degrade(g,couleurs[c],x,y,WCO,HCO);

	g.setColor(Color.black);
	g.drawString(o.nom.dernier(),x+4,y+HCO/2+4);
	g.drawRect(x,y,WCO,HCO);
      }

    int ybg;
    if(inside) ybg=y+HCI/2;
    else       ybg=y+HCO/2;

    if(inside) y+=HCI;
    else       y+=HCO;

    if(inside&&(!AglOptions.module.equals("")))
    {
      // g.setColor(couleurs[c+1]);
      // g.fillRect(x,y,WCI,o.attributs.size()*12);
      degrade(g,couleurs[c+1],x,y,WCI,o.attributs.size()*HCO);

      g.setColor(Color.black);
      g.drawRect(x,y,WCI,o.attributs.size()*HCO);

      for(Enumeration e=o.attributs.elements(); e.hasMoreElements(); )
      {
	AglAttribut aa=(AglAttribut)e.nextElement();
	g.drawString(code(aa.visibilite),x+4,y+HCO-4);

	g.drawString(code(aa),x+14,y+HCO-4);
	if(aa.visibilite.vstatic)
	{
	  FontMetrics fm=g.getFontMetrics(g.getFont());
	  int ws=Math.min(WCI-18,fm.stringWidth(aa.nom));
	  g.drawLine(x+14,y+HCO-3,x+14+ws,y+HCO-3);
	}
	y+=HCO;
      }

      // g.setColor(couleurs[c+2]);
      // g.fillRect(x,y,WCI,o.methodes.size()*12);
      degrade(g,couleurs[c+2],x,y,WCI,o.methodes.size()*HCO);

      g.setColor(Color.black);
      g.drawRect(x,y,WCI,o.methodes.size()*HCO);

      for(Enumeration e=o.methodes.elements(); e.hasMoreElements(); )
      {
	AglMethode am=(AglMethode)e.nextElement();
	g.drawString(code(am.visibilite),x+4,y+HCO-4);
	g.drawString(code(am),x+14,y+HCO-4);
	if(am.visibilite.vstatic)
	{
	  FontMetrics fm=g.getFontMetrics(g.getFont());
	  int ws=Math.min(WCI-18,fm.stringWidth(am.nom));
	  g.drawLine(x+14,y+HCO-3,x+14+ws,y+HCO-3);
	}
	y+=HCO;
      }
    }

    xmax=Math.max(xmax,x+WCI+10);
    ymax=Math.max(ymax,y+10);
    System.err.println("XMAX="+xmax);
    System.err.println("YMAX="+ymax);

    int ybi=y;

    y+=5;
    x+=30;

    for(Enumeration et=AglType.table.elements(); et.hasMoreElements(); )
    {
      AglType at=(AglType)et.nextElement();
      if(at instanceof AglClasse)
      {
        AglClasse ac=(AglClasse)at;
        if((!ac.elementaire)&&(ac.meres.noms.size()>0))
	{
	  boolean fille=false;
          for(Enumeration en=ac.meres.noms.elements(); en.hasMoreElements(); )
	  {
	    AglNom an=(AglNom)en.nextElement();
	    if(an.dernier().equals(o.nom.dernier()))
	    {
	      if(table.get(ac)==null)
	      {
		// g.setColor(Color.blue);

		if(meres.get(ac)!=null)
		{
		  int[] px=new int[] { x-11, x-6, x-16 };
		  int[] py=new int[] { ybi+1, ybi+6, ybi+6 };

		  // g.fillPolygon(px,py,3);
		  g.drawPolygon(px,py,3);
		  g.drawLine(x-11,ybi+6,x-11,y+5);
		}
		code(ac);
	      }
	      else
	      {
		// g.setColor(Color.red);

		AglCodeUmlHierarchieXY xy=(AglCodeUmlHierarchieXY)table.get(ac);

		int[] px=new int[] { x+WCI-30+1, x+WCI-30+6, x+WCI-30+6 };
		int[] py=new int[] { ybg       , ybg-5     , ybg+5      };

		g.drawPolygon(px,py,3);
		g.drawLine(xy.x+WCI,xy.y+HCI/2,xmax-5,xy.y+HCI/2);
		g.drawLine(xmax-5,xy.y+HCI/2,xmax-5,ybg);
		g.drawLine(x+WCI-30+7,ybg,xmax-5,ybg);
		xmax+=5;
	      }
	    }
	  }
        }
      }
    }

    x-=30;

    /*
    String r="";
    r+=code(o.visibilite);
    r+="class "+code(o.nom);

    if(o.meres.noms.size()>0)
      r+=" : "+code(o.meres);

    r+="\n{\n";
    for(Enumeration e=o.attributs.elements(); e.hasMoreElements(); )
    {
      AglAttribut aa=(AglAttribut)e.nextElement();
      r+="  "+code(aa);
    }
    for(Enumeration e=o.methodes.elements(); e.hasMoreElements(); )
    {
      AglMethode am=(AglMethode)e.nextElement();
      r+="\n"+code(am);
    }
    return r+"\n};\n";
    */

    return "";
  }

  public AglSortie[] code(AglProjet o)
  {
    projet=o;

    indentation=0;
    String r="";

    r+="<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2//EN\">\n";
    r+="<HTML>\n";

    if(AglOptions.entete)
    {
      r+="<!--\n";
      r+="  Entte : Alma\n";
      r+="  Projet : "+projet.nom+"\n";
      r+="  Module : "+AglOptions.module+"\n";
      r+="  Date   : "+(new Date())+"\n";
      r+="  Cible  : UmlHierarchie ("+extension()+")\n";
      r+="  Auteur : Guillaume Desnoix\n";
      r+="  Mel    : guillaume@desnoix.com\n";
      r+="  Produit: "+AglOptions.PRODUIT+"\n";
      r+="  Version: "+AglOptions.VERSION+"\n";
      r+="  Site   : "+AglOptions.SITE+"\n";
      r+="-->\n";
    }

    classes.clear();
    meres.clear();

    for(Enumeration ec=AglType.table.elements(); ec.hasMoreElements(); )
    {
      AglType at=(AglType)ec.nextElement();
      if(at instanceof AglClasse)
      {
	AglClasse ac=(AglClasse)at;
	if(isInside(ac))
          marqueMeres(ac);
      }
    }

    if(AglOptions.application==null)
    {
      AglCodeUmlHierarchieFrame f=new AglCodeUmlHierarchieFrame(this);
      try { Thread.sleep(2000); }
      catch (InterruptedException ex) { }
    }
    else
    {
      //AlmaCodeUmlHierarchieFrame f=new AlmaCodeUmlHierarchieFrame(this);
      //((AlmaImplementation)AglOptions.application).addInternalFrame(f);

      ((AglTransfert)AglOptions.application).transfert(this);
    }

    r+="<HEAD>\n";
    //r+="  <META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=iso-8859-1\">\n";
    r+="  <TITLE>"+AglOptions.module+" (Hierarchie)</TITLE>\n";
    r+="  <LINK REL=\"StyleSheet\" HREF=\""+AglOptions.styleHtml+"\" TITLE=\"Style\">\n";
    r+="</HEAD>\n";
    r+="<BODY>\n";

    r+="<MAP NAME=\""+AglOptions.module+"_map\">\n";
    for(Enumeration e=classes.elements(); e.hasMoreElements(); )
    {
      AglCodeUmlHierarchieXY pc=(AglCodeUmlHierarchieXY)e.nextElement();

      AglOptions.terminal.trace("$$$ "+pc.classe.nom.dernier());

      if((pc!=null)&&(!pc.classe.elementaire))
      {
        r+="  <AREA SHAPE=\"rect\" ";
	r+="COORDS=\""+pc.x+","+pc.y+",";
	r+=(pc.x+(pc.in ? WCI : WCO))+",";
	r+=(pc.y+(pc.in ? HCI : HCO))+"\" ";
        r+="HREF=\"_R_"+pc.classe.nom.dernier()+".html\">\n";
      }
    }
    r+="</MAP>\n";

    r+="<IMG SRC=\"_H_"+AglOptions.module+".gif\" ";
    r+="BORDER=0 USEMAP=\"#"+AglOptions.module+"_map\">\n";

    r+="</BODY>\n";
    r+="</HTML>\n";

    return new AglSortie[]
    { new AglSortie("text/html","Html","_H_"+AglOptions.module+".html",r) };
  }
}
