/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AglCodeUmlRelationsCanvas.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.agl;
import com.memoire.agl.*;


import java.util.*;
import java.awt.*;
import java.awt.image.*;
import java.io.*;

import javax.swing.*;
import javax.swing.border.*;

public class AglCodeUmlRelationsCanvas extends JComponent
{
  AglCodeUmlRelations a;
  Image               image;

  public AglCodeUmlRelationsCanvas(AglCodeUmlRelations _a)
  {
    a=_a;
    image=null;
  }

  public Image getImage()
    { return image; }

  public synchronized void paint(Graphics g)
  {
    if(image==null)
    {
      a.g=g;
      a.paintImage();

      AglOptions.terminal.trace("Cration de l'image...");
      image=a.createImage(this);

      Dimension d=new Dimension(image.getWidth(this),image.getHeight(this));
      AglOptions.terminal.trace("DI="+d);
      setPreferredSize(d);
      setSize(d);

      AglOptions.terminal.trace("Validation...");
      getParent().validate();
      getParent().doLayout();
      getParent().getParent().validate();
      getParent().getParent().doLayout();
    }
    g.drawImage(image,0,0,this);
  }
}

