/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AglCodeXmlProto.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.agl;
import com.memoire.agl.*;


import java.util.*;

public  class AglCodeXmlProto extends AglCode
{
  int X0=5, Y0=5;
  int W0=200, H0=22;

  int x,y;

  public String extension()
  {
    return "xml";
  }

  public String[] extensions()
  {
    return new String[] { "xml", "XML" };
  }

  public String syntaxe()
  {
    return "Xml";
  }

  protected String debutCS  () { return indente()+"<!--";  }
  protected String finCS    () { return "-->";             }
  protected String debutCM  () { return indente()+"<!--";  }
  protected String specialCM() { return "-";               }
  protected String milieuCM () { return indente()+"  ---"; }
  protected String finCM    () { return indente()+"  -->"; }

  public String code(AglNom o)
  {
    String r="";
    String s="";
    boolean p=true;

    for(Enumeration e=o.identificateurs.elements(); e.hasMoreElements(); )
    {
      if(p) p=false; else r+=".";
      s=(String)e.nextElement();

      if(s.equals("association"))    s="fr.stcpmvn.dodico.corba.association";
      if(s.equals("base"))           s="fr.stcpmvn.dodico.corba.base";
      if(s.equals("calcul"))         s="fr.stcpmvn.dodico.corba.calcul";
      if(s.equals("collection"))     s="fr.stcpmvn.dodico.corba.collection";
      if(s.equals("courant"))        s="fr.stcpmvn.dodico.corba.courant";
      if(s.equals("curvi"))          s="fr.stcpmvn.dodico.corba.curvi";
      if(s.equals("ef"))             s="fr.stcpmvn.dodico.corba.ef";
      if(s.equals("geometrie"))      s="fr.stcpmvn.dodico.corba.geometrie";
      if(s.equals("hiswa"))          s="fr.stcpmvn.dodico.corba.hiswa";
      if(s.equals("houle"))          s="fr.stcpmvn.dodico.corba.houle";
      if(s.equals("hydraulique"))    s="fr.stcpmvn.dodico.corba.hydraulique";
      if(s.equals("hydro1d"))        s="fr.stcpmvn.dodico.corba.hydro1d";
      if(s.equals("interpolateur"))  s="fr.stcpmvn.dodico.corba.interpolateur";
      if(s.equals("mathematiques"))  s="fr.stcpmvn.dodico.corba.mathematiques";
      if(s.equals("mesure"))         s="fr.stcpmvn.dodico.corba.mesure";
      if(s.equals("oasis"))          s="fr.stcpmvn.dodico.corba.oasis";
      if(s.equals("objet"))          s="fr.stcpmvn.dodico.corba.objet";
      if(s.equals("olb"))            s="fr.stcpmvn.dodico.corba.olb";
      if(s.equals("planification"))  s="fr.stcpmvn.dodico.corba.planification";
      if(s.equals("reflux"))         s="fr.stcpmvn.dodico.corba.reflux";
      if(s.equals("refonde"))        s="fr.stcpmvn.dodico.corba.refonde";
      if(s.equals("sedimentologie")) s="fr.stcpmvn.dodico.corba.sedimentologie";
      if(s.equals("transport"))      s="fr.stcpmvn.dodico.corba.transport";
      if(s.equals("vag"))            s="fr.stcpmvn.dodico.corba.vag";

      r+=s;
    }

    return r;
  }

  public String dernier(String s)
  {
    int i=s.lastIndexOf('.');
    if(i>=0) s=s.substring(i+1);
    return s;
  }

  public String code(AglListeNoms o)
  {
    String r="";
    boolean p=true;

    for(Enumeration e=o.noms.elements(); e.hasMoreElements(); )
    {
      if(p) p=false; else r+=", ";
      r+=code((AglNom)e.nextElement());
    }

    return r;
  }

  public String code(AglType o)
  {
    String r="";
         if(o instanceof AglTypeAlias)   r+=code(((AglTypeAlias)o).type);
    else if(o instanceof AglTypeTableau) r+=code(((AglTypeTableau)o).type)+"[]";
    else if(o==AglTypePrimitif.tlong)    r+=code(AglTypePrimitif.tinteger);
    else r+=code(o.nom);
    return r;
  }

  public String code(AglBloc o)
  {
    String r=indente()+"{\n";
    indentation++;

    int n=1;
    for(Enumeration e=o.instructions.elements(); e.hasMoreElements(); )
    {
      AglInstruction ai=(AglInstruction)e.nextElement();
      r+=code(ai);
      n++;
    }

    indentation--;
    r+=indente()+"}\n";
    return r;
  }

  public String code(AglAttribut aa)
  {
    String r="<Label Pos=\""+x+","+y+
      ","+W0+","+H0+"\" Caption=\""+aa.nom+"\"></Label>";

    x+=W0+X0;

    boolean bouton=false;
    boolean texte =false;
    boolean coche =false;

    AglType at=aa.type;
    while(at instanceof AglTypeAlias)
      at=((AglTypeAlias)at).type;

    // System.err.println(":::"+at+" "+at.getClass());

    if(at==AglTypePrimitif.tvoid)
    {
      ;
    }
    else
    if(at==AglTypePrimitif.tboolean)
    {
      r+="<CheckBox Pos=\""+x+","+y+","+W0+","+H0+"\"></CheckBox>";
      coche=true;
    }
    else
    if(at instanceof AglTypePrimitif)
    {
      r+="<Text Pos=\""+x+","+y+","+W0+","+H0+"\"></Text>";
      texte=true;
    }
    else
    if(at==AglType.cherche("String"))
    {
      r+="<Text Pos=\""+x+","+y+","+W0+","+H0+"\"></Text>";
      texte=true;
    }
    else
    if(at instanceof AglTypeTableau)
    {
      r+="<Button Pos=\""+x+","+y+","+W0+","+H0+"\" Caption=\"[   ]\"></Button>";
      bouton=true;
    }
    else
    if(at instanceof AglStruct)
    {
      r+="<Button Pos=\""+x+","+y+","+W0+","+H0+"\" Caption=\"Editer...\"></Button>";
      bouton=true;
    }
    else
    if(at instanceof AglClasse)
    {
      r+="<Button Pos=\""+x+","+y+","+W0+","+H0+"\" Caption=\"Editer...\"></Button>";
      bouton=true;
    }
    else
    {
      r+="<Label Pos=\""+x+","+y+","+W0+","+H0+"\" Caption=\"???\" Justification=\"center\"></Label>";
    }

    x=X0;
    y+=H0+3;

    return r;
  }

  public String code(AglStruct o)
  {
    String r="";
    y=Y0;

    r+="  <Label Pos=\""+x+","+y+","+(2*W0)+","+H0+"\" Caption=\"Structure "+o.nom.dernier()+"\"></Label>\n";

    x=X0;
    y+=H0+3;

    for(Enumeration e=o.attributs.elements(); e.hasMoreElements(); )
    {
      AglAttribut aa=(AglAttribut)e.nextElement();
      r+="  "+code(aa)+"\n";
    }

    return r;
  }

  public String code(AglClasse o)
  {
    String r="";
    y=Y0;

    r+="  <Label Pos=\""+x+","+y+","+(2*W0)+","+H0+"\" Caption=\"Classe "+o.nom.dernier()+"\"></Label>\n";

    x=X0;
    y+=H0+3;

    AglClasse classe=null; 
     
    // Attributs 
     
    AglVecteur attributs=new AglVecteur(11,11);

    classe=o;
    while(classe!=null)
    {
      for(Enumeration e=classe.attributs.elements(); e.hasMoreElements(); )
      {
	AglAttribut aa=(AglAttribut)e.nextElement();
	// if(aa.visibilite.vpublic)
	  attributs.addElement(aa);
      }
      if(classe.meres.noms.size()>0)
	classe=(AglClasse)AglType.cherche((AglNom)classe.meres.noms.elementAt(0));
      else classe=null;
    }

    r+="\n";
    for(Enumeration e=attributs.elements(); e.hasMoreElements(); )
    {
      AglAttribut aa=(AglAttribut)e.nextElement();
      r+="  "+code(aa)+"\n";
    }

    // Methodes

    AglVecteur methodes=new AglVecteur(11,11);

    classe=o;
    while(classe!=null)
    {
      for(Enumeration e=classe.methodes.elements(); e.hasMoreElements(); )
      {
	AglMethode aa=(AglMethode)e.nextElement();

	// if((aa.visibilite.vpublic)&&(aa.parametres.size()==0))
	// aa.nom.egals(classe)

	if(aa.parametres.size()==0)
	{
	  AglType et=aa.type;
	  while(et instanceof AglTypeAlias)
	    et=((AglTypeAlias)et).type;

	  methodes.addElement(aa);
	}
      }
      if(classe.meres.noms.size()>0)
	classe=(AglClasse)AglType.cherche((AglNom)classe.meres.noms.elementAt(0));
      else classe=null;
    }

    r+="\n";
    for(Enumeration e=methodes.elements(); e.hasMoreElements(); )
    {
      AglMethode aa=(AglMethode)e.nextElement();
      r+="  <Button Pos=\""+x+","+y+","+W0+","+H0+"\" Caption=\""+aa.nom+"\"></Button>\n";
      x=X0; y+=H0+3;
    }

    return r;
  }

  public String code(AglConstructeur o)
  {
    indentation=1;
    String r=indente();
    r+=code(o.visibilite);
    r+=code(o.nom)+"(";

    boolean p=true;
    for(Enumeration e=o.parametres.elements(); e.hasMoreElements(); )
    {
      AglParametre ap=(AglParametre)e.nextElement();
      if(!p) r+=", ";
      r+=code(ap);
      p=false;
    }

    r+=")";

    if(o.visibilite.vabstract&&o.corps.instructions.isEmpty()) r+=";";
    r+=" /* "+o.ligne+" */\n";
    if(!o.corps.instructions.isEmpty()) r+=code(o.corps);

    r+="\n";
    return r;
  }

  public String code(AglImport o)
  {
    indentation=0;
    String r="import "+code(o.nom)+";\n";
    return r;
  }

  public String code(AglMethode o)
  {
    indentation=1;
    String r=indente();
    r+=code(o.visibilite);
    r+=code(o.type)+" "+o.nom+"(";

    boolean p=true;
    for(Enumeration e=o.parametres.elements(); e.hasMoreElements(); )
    {
      AglParametre ap=(AglParametre)e.nextElement();
      if(!p) r+=", ";
      r+=code(ap);
      p=false;
    }

    r+=")";

    if(o.visibilite.vabstract&&o.corps.instructions.isEmpty()) r+=";";
    r+=" /* "+o.ligne+" */\n";
    if(!o.corps.instructions.isEmpty()) r+=code(o.corps);

    r+="\n";
    return r;
  }

  public String code(AglParametre o)
  {
    String r="";
    r+=code(o.type)+" "+o.nom;
    // if(o.defaut!="") r+=" ="+o.defaut;
    return r;
  }

  public String code(AglVisibilite o)
  {
    String r="";

    if(o.vpublic)       r+="public ";
    if(o.vprivate)      r+="private ";
    if(o.vprotected)    r+="protected ";
    // if(o.vinline)       r+="inline ";
    if(o.vabstract)     r+="abtract ";
    if(o.vstatic)       r+="static ";
    if(o.vfinal)        r+="final ";
    if(o.vnative)       r+="native ";
    if(o.vtransient)    r+="transient ";
    if(o.vsynchronized) r+="synchronized ";

    return r;
  }

// Expressions

  public String code(AglExpressionGenerique o)
  {
    String r=o.body;
    return r;
  }

  public String code(AglExpressionAffectation o)
  {
    String r="("+code(o.gauche)+"="+code(o.droite)+")";
    r+=" /* Affectation "+o.ligne+" */ ";
    return r;
  }

  public String code(AglExpressionAttribut o)
  {
    String r="";
    if(o.objet!=null) r+=code(o.objet)+".";
    r+=" /* Attribut "+o.ligne+" */ ";
    r+=o.attribut;
    return r;
  }

  public String code(AglExpressionBinaire o)
  {
    String r=code(o.gauche)+o.operateur+code(o.droite);
    r+=" /* Binaire "+o.ligne+" */ ";
    return r;
  }

  public String code(AglExpressionDefVar o)
  {
    String r=code(o.type)+" "+o.nom;
    if(o.initiale!=null) r+="="+code(o.initiale);
    r+=" /* Var "+o.ligne+" */ ";
    return r;
  }

  public String code(AglExpressionEstUn o)
  {
    String r=code(o.expression)+" instanceof "+code(o.type);
    r+=" /* EstUn "+o.ligne+" */ ";
    return r;
  }

  public String code(AglExpressionFonction o)
  {
    String r=o.nom+"(";

    boolean p=true;
    for(Enumeration e=o.arguments.elements(); e.hasMoreElements(); )
    {
      AglExpression ae=(AglExpression)e.nextElement();
      if(!p) r+=", ";
      r+=code(ae);
      p=false;
    }

    r+=") /* Fonction "+o.ligne+" */ ";
    return r;
  }

  public String code(AglExpressionIndice o)
  {
    String r=code(o.objet)+"["+code(o.indice)+"] /* Indice "+o.ligne+" */ ";
    return r;
  }

  public String code(AglExpressionInitArray o)
  {
    String r="{ ";

    boolean p=true;
    for(Enumeration e=o.initiales.elements(); e.hasMoreElements(); )
    {
      AglExpression ae=(AglExpression)e.nextElement();
      if(!p) r+=", ";
      r+=code(ae);
      p=false;
    }

    r+=" }";
    return r;
  }

  public String code(AglExpressionMethode o)
  {
    String r="";
    if(o.objet!=null) r+=code(o.objet)+".";
    r+=" /* Methode "+o.ligne+" */ ";
    r+=o.fonction;
    return r;
  }

  public String code(AglExpressionMultiple o)
  {
    String r="";
    r+=" /* Multiple "+o.ligne+" */ ";

    boolean p=true;
    for(Enumeration e=o.expressions.elements(); e.hasMoreElements(); )
    {
      AglExpression ae=(AglExpression)e.nextElement();
      if(!p) r+=", ";
      r+=code(ae);
      p=false;
    }

    return r;
  }

  public String code(AglExpressionNew o)
  {
    String r="new "+code(o.type)+"(";

    boolean p=true;
    for(Enumeration e=o.arguments.elements(); e.hasMoreElements(); )
    {
      AglExpression ae=(AglExpression)e.nextElement();
      if(!p) r+=", ";
      r+=code(ae);
      p=false;
    }

    r+=") /* New "+o.ligne+" */ ";
    return r;
  }

  public String code(AglExpressionNewArray o)
  {
    String r="new "+code(o.type)+"[";
    r+=code(o.nombre);
    r+="] /* New "+o.ligne+" */ ";
    return r;
  }

  public String code(AglExpressionParenthesee o)
  {
    String r="( "+code(o.expression)+" )";
    r+=" /* Parenthesee "+o.ligne+" */ ";
    return r;
  }

  public String code(AglExpressionTernaire o)
  {
    String r=code(o.gauche)
      +" "+o.operateur1+" "+code(o.milieu)
      +" "+o.operateur2+" "+code(o.droite);
    r+=" /* Ternaire "+o.ligne+" */ ";
    return r;
  }

  public String code(AglExpressionTypage o)
  {
    String r="("+code(o.type)+")"+code(o.expression);
    r+=" /* Typage "+o.ligne+" */ ";
    return r;
  }

  public String code(AglExpressionUnaireDroite o)
  {
    String r=o.operateur+code(o.droite);
    r+=" /* UnaireDroite "+o.ligne+" */ ";
    return r;
  }

  public String code(AglExpressionUnaireGauche o)
  {
    String r=code(o.gauche)+o.operateur;
    r+=" /* UnaireGauche "+o.ligne+" */ ";
    return r;
  }

// Instructions

  public String code(AglInstructionGenerique o)
  {
    String r=indente();
    r+=o.body;
    if(r.charAt(r.length()-1)!='\n') r+="\n";
    r=r.substring(0,r.length()-1)+" /* Instruction "+o.ligne+" */\n";
    return r;
  }

  public String code(AglInstructionVide o)
  {
    String r=indente()+"; /* Vide "+o.ligne+" */\n";
    return r;
  }

  public String code(AglInstructionAffectation o)
  {
    String r=indente()+code(o.gauche)+"="+code(o.droite);
    r+="; /* Affectation "+o.ligne+" */\n";
    return r;
  }

  public String code(AglInstructionBloc o)
  {
    String r=indente();
    r+="/* Bloc "+o.ligne+" */\n";
    r+=code(o.corps);
    return r;
  }

  public String code(AglInstructionBreak o)
  {
    String r=indente()+"break";
    if(o.nom!=null) r+=" "+o.nom;
    r+="; /* Break "+o.ligne+" */\n";
    return r;
  }

  public String code(AglInstructionCatch o)
  {
    String r=indente()+"catch("+code(o.signal)+") /* Catch "+o.ligne+" */\n";
    r+=code(o.reprise);
    return r;
  }

  public String code(AglInstructionContinue o)
  {
    String r=indente()+"continue";
    if(o.nom!=null) r+=" "+o.nom;
    r+="; /* Continue "+o.ligne+" */\n";
    return r;
  }

  public String code(AglInstructionDefVar o)
  {
    String r=indente()+code(o.type)+" "+o.nom;
    if(o.initiale!=null) r+="="+code(o.initiale);
    r+="; /* DefVar "+o.ligne+" */\n";
    return r;
  }

  public String code(AglInstructionDoWhile o)
  {
    String r=indente()+"do /* DoWhile "+o.ligne+" */\n";
    r+=code(o.corps);
    r+=indente()+"while("+code(o.condition)+"); /* DoWhile "+o.ligne+" */\n";
    return r;
  }

  public String code(AglInstructionExpression o)
  {
    String r=indente()+code(o.expression)+"; /* InsExpr "+o.ligne+" */\n";
    return r;
  }

  public String code(AglInstructionFinally o)
  {
    String r=indente()+"finally /* Finally "+o.ligne+" */\n";
    r+=code(o.corps);
    return r;
  }

  public String code(AglInstructionFor o)
  {
    String r=indente()+"for(";
    r+=code(o.debut);
    r+=indente()+"    "+code(o.test)+"; ";
    r+=code(o.fin);
    r+=") /* For "+o.ligne+" */\n";
    r+=code(o.corps);
    return r;
  }

  public String code(AglInstructionGoto o)
  {
    String r=indente()+"continue "+o.nom;
    r+="; /* Goto "+o.ligne+" */\n";
    return r;
  }

  public String code(AglInstructionIf o)
  {
    String r=indente()+"if("+code(o.condition)+") /* If "+o.ligne+" */\n";
    r+=code(o.sioui);
    if(o.sinon!=null)
    {
      r+=indente()+"else /* Else "+o.ligne+" */\n";
      r+=code(o.sinon);
    }

    return r;
  }

  public String code(AglInstructionLabel o)
  {
    String r=" "+o.nom+":";
    r+=" /* Label "+o.ligne+" */\n";
    return r;
  }

  public String code(AglInstructionProcedure o)
  {
    String r=indente()+o.nom+"(";

    boolean p=true;
    for(Enumeration e=o.arguments.elements(); e.hasMoreElements(); )
    {
      AglExpression ae=(AglExpression)e.nextElement();
      if(!p) r+=", ";
      r+=code(ae);
      p=false;
    }

    r+="); /* Procedure "+o.ligne+" */\n";
    return r;
  }

  public String code(AglInstructionReturn o)
  {
    String r=indente()+"return "+code(o.valeur);
    r+="; /* Return "+o.ligne+" */\n";
    return r;
  }

  public String code(AglInstructionSwitch o)
  {
    String r=indente()+"switch("+code(o.condition)+") /* Switch "+o.ligne+" */\n";
    r+=indente()+"{\n";
    indentation++;

    for(Enumeration e=o.cas.keys(); e.hasMoreElements(); )
    {
      AglExpression ce=(AglExpression)e.nextElement();
      r+=indente()+"case "+code(ce)+":\n";
      AglBloc cb=(AglBloc)(o.cas.get(ce));
      r+=code(cb);
      r+=indente()+"break;\n";
    }

    r+=indente()+"default:\n";
    r+=code(o.defaut);
    // r+=indente()+"break;\n";

    indentation--;
    r+=indente()+"}\n";

    return r;
  }

  public String code(AglInstructionSynchronized o)
  {
    String r=code(o.commentaires)+indente()+"synchronized("+code(o.objet)+")";
    r+="\n";
    r+=code(o.corps);
    return r;
  }

  public String code(AglInstructionThrow o)
  {
    String r=indente()+"throw "+code(o.valeur);
    r+="; /* Throw "+o.ligne+" */\n";
    return r;
  }

  public String code(AglInstructionTry o)
  {
    String r=indente()+"try /* Try "+o.ligne+" */\n";
    r+=code(o.corps);
    return r;
  }

  public String code(AglInstructionWhile o)
  {
    String r=indente()+"while("+code(o.condition)+") /* While "+o.ligne+" */\n";
    r+=code(o.corps);
    return r;
  }


// module ebli

  public String module_ebli()
  {
    String r="";

    r+="class Constantes\n";
    r+="{\n";

    r+="  final static public String[] classes=\n";
    r+="  {\n";

    boolean p=true;
    for(Enumeration e=AglType.table.elements(); e.hasMoreElements(); )
    {
      AglType at=(AglType)e.nextElement();
      if(at instanceof AglClasse)
      {
        AglClasse ac=(AglClasse)at;
        if(!ac.elementaire)
          r+="    \""+code(ac.nom)+"\",\n";
      }
      if(at instanceof AglStruct)
      {
        AglStruct ac=(AglStruct)at;
	r+="    \""+code(ac.nom)+"\",\n";
      }
    }
    r+="  };\n\n";
    r+="}\n\n";

/*
    r+="abstract class Basic_Edt\n";
    r+="         extends JPanel\n";
    r+="         implements ActionListener\n";
    r+="{\n";
    r+="  public abstract void objet(Object o);\n";
    r+="  public abstract void actionPerformed(ActionEvent ev);\n";
    r+="}\n";
*/

    r+="\n";

  // Arrays
/*
    r+="class double_Array_Edt\n";
    r+="      extends Basic_Edt\n";
    r+="{\n";
    r+="  double[]     o;\n";
    r+="\n";

    r+="  JTextField[] tf;\n";
    r+="  GridLayout   layout;\n";
    r+="\n";

    r+="  public double_Array_Edt()\n";
    r+="  {\n";
    r+="    objet(null);\n";
    r+="  }\n";

    r+="  public double_Array_Edt(Object _o)\n";
    r+="  {\n";
    r+="    objet(_o);\n";
    r+="  }\n";

    r+="  public void objet(Object _o)\n";
    r+="  {\n";
    r+="    o=(double[])_o;\n";
    r+="    if(o==null) return;\n";
    r+="\n";

    r+="    layout=new GridLayout(o.length,2);\n";
    r+="    setLayout(layout);\n";

    r+="\n";
    r+="    tf=new JTextField[o.length];\n";
    r+="    for(int i=0;i<o.length;i++)\n";
    r+="    {\n";
    r+="      add(new JLabel(\"\"+i+\" : \",JLabel.RIGHT),2*i);\n";
    r+="      tf[i]=new JTextField(\"\"+o[i]);\n";
    r+="      tf[i].addActionListener(this);\n";
    r+="      add(tf[i],2*i+1);\n";
    r+="    }\n";

    r+="  }\n";

    r+="\n";
    r+="  public void actionPerformed(ActionEvent ev)\n";
    r+="  {\n";
    r+="    JComponent source=(JComponent)ev.getSource();\n";
    // r+="    System.err.println(\"Source : \"+source);\n";

    
    r+="    for(int i=0;i<o.length;i++)\n";
    r+="      if(source==tf[i])\n";
    r+="        o[i]=(new Double(tf[i].getText())).doubleValue();\n";

    r+="  }\n";

    r+="}\n";

    r+="\n";
*/

  // AglVecteur
/*
    r+="class AglVecteur_Edt\n";
    r+="         extends Basic_Edt\n";
    r+="{\n";
    r+="  Object[]     o;\n";
    r+="\n";
    r+="  BorderLayout layout;\n";
    r+="\n";
    r+="  JList        ltValeurs;\n";
    r+="  JScrollPane  spValeurs;\n";
    r+="  JButton      btEditer;\n";
    r+="\n";

    r+="  public AglVecteur_Edt()\n";
    r+="  {\n";
    r+="    objet(null);\n";
    r+="  }\n";

    r+="  public AglVecteur_Edt(Object _o)\n";
    r+="  {\n";
    r+="    objet(_o);\n";
    r+="  }\n";

    r+="  public void objet(Object _o)\n";
    r+="  {\n";
    r+="    o=(Object[])_o;\n";
    r+="    layout=new BorderLayout();\n";
    r+="    setLayout(layout);\n";
    r+="\n";
    r+="    if(o==null) return;\n";
    r+="\n";

    r+="    ltValeurs=new JList(o);\n";
    r+="    spValeurs=new JScrollPane(ltValeurs);\n";
    r+="    add(\"Center\",spValeurs);\n";

    r+="    btEditer=new JButton(\"Editer...\");\n";
    r+="    btEditer.addActionListener(this);\n";
    r+="    btEditer.setToolTipText(\"Edite l'objet selectionne\");\n";
    r+="    add(\"South\",btEditer);\n";
    r+="  }\n";

    r+="\n";
    r+="  public void actionPerformed(ActionEvent ev)\n";
    r+="  {\n";
    r+="    JComponent source=(JComponent)ev.getSource();\n";
    // r+="    System.err.println(\"Source : \"+source);\n";

    r+="    if(source==btEditer)\n";
    r+="    {\n";
    r+="      Object o=ltValeurs.getSelectedValue();\n";
    r+="      System.err.println(\"Selection : \"+o);\n";
    r+="      CEbli.editeInstance(o);\n";
    r+="    }\n";

    r+="  }\n";

    r+="}\n";

    r+="\n";
*/

  // Inspecteur

/*
    r+="class Inspecteur\n";
    r+="      extends JFrame\n";
    // r+="      implements ActionListener\n";
    r+="{\n";
    r+="  JComponent   content;\n";
    r+="  GridLayout   layout;\n";

    r+="\n";
    r+="  public Inspecteur(String s, Basic_Edt f)\n";
    r+="  {\n";

    r+="    layout=new GridLayout(1,1);\n";
    r+="    layout.setHgap(5);\n";
    r+="    layout.setVgap(5);\n";

    r+="    content=(JComponent)getContentPane();\n";
    r+="    content.setLayout(layout);\n";
    r+="    content.setBorder(new EmptyBorder(10,10,10,10));\n";
    r+="    content.add(f,0);\n";

    r+="    setTitle(\"Ebli: \"+s.substring(s.lastIndexOf('.')+1));\n";
    r+="  }\n";

    r+="}\n\n";
*/

  // CEbli

/*
    r+="class CEbli\n";
    r+="      extends JFrame\n";
    r+="      implements ActionListener\n";
    r+="{\n";

    r+="  static CEbli THIS;\n";
    r+="\n";

    r+="  String[] classes=\n";
    r+="  {\n";

    boolean p=true;
    for(Enumeration e=AglType.table.elements(); e.hasMoreElements(); )
    {
      AglType at=(AglType)e.nextElement();
      if(at instanceof AglClasse)
      {
        AglClasse ac=(AglClasse)at;
        if(!ac.elementaire)
          r+="    \""+code(ac.nom)+"\",\n";
      }
      if(at instanceof AglStruct)
      {
        AglStruct ac=(AglStruct)at;
	r+="    \""+code(ac.nom)+"\",\n";
      }
    }
    r+="  };\n\n";

    r+="  java.util.Vector objets=new java.util.Vector();\n";

    r+="  JList        ltClasses;\n";
    r+="  JScrollPane  spClasses;\n";
    r+="  JList        ltObjets;\n";
    r+="  JScrollPane  spObjets;\n";

    r+="  JButton      btCreer;\n";
    r+="  JButton      btEditer;\n";

    r+="  JComponent   content;\n";
    r+="  BorderLayout layout;\n";

    r+="\n";
    r+="  public CEbli()\n";
    r+="  {\n";
    r+="    THIS=this;\n";
    r+="\n";
    r+="    layout=new BorderLayout();\n";

    r+="    content=(JComponent)getContentPane();\n";
    r+="    content.setBorder(new EmptyBorder(5,5,5,5));\n";
    r+="    content.setLayout(layout);\n";
    r+="\n";

    r+="    trieChaines(classes);\n";
    r+="    ltClasses=new JList(classes);\n";
    r+="    spClasses=new JScrollPane(ltClasses);\n";
    r+="    ltObjets =new JList();\n";
    r+="    spObjets =new JScrollPane(ltObjets);\n";

    r+="    JPanel p=new JPanel(new GridLayout(1,2));\n";
    r+="    p.add(spClasses,0);\n";
    r+="    p.add(spObjets,1);\n";
    r+="    content.add(\"Center\",p);\n";

    r+="    btCreer=new JButton(\"Creer...\");\n";
    r+="    btCreer.addActionListener(this);\n";
    r+="    btCreer.setToolTipText(\"Cree un nouvel objet du type selectionne\");\n";

    r+="    btEditer=new JButton(\"Editer...\");\n";
    r+="    btEditer.addActionListener(this);\n";
    r+="    btEditer.setToolTipText(\"Edite l'objet selectionne\");\n";

    r+="    JPanel q=new JPanel(new GridLayout(1,2));\n";
    r+="    q.add(btCreer,0);\n";
    r+="    q.add(btEditer,1);\n";
    r+="    content.add(\"South\",q);\n";

    r+="    setTitle(\"Ebli: CEbli\");\n";
    r+="    setSize(800,400);\n";
    r+="  }\n";

    r+="\n";
    r+="  public void actionPerformed(ActionEvent ev)\n";
    r+="  {\n";
    r+="    JComponent source=(JComponent)ev.getSource();\n";
    // r+="    System.err.println(\"Source : \"+source);\n";

    r+="    if(source==btCreer)\n";
    r+="    {\n";
    r+="      String s=(String)ltClasses.getSelectedValue();\n";
    r+="      System.err.println(\"Selection : \"+s);\n";
    r+="      editeInstance(s,creeInstance(s));\n";
    r+="    }\n";

    r+="    if(source==btEditer)\n";
    r+="    {\n";
    r+="      Object o=ltObjets.getSelectedValue();\n";
    r+="      System.err.println(\"Selection : \"+o);\n";

    r+="      String s=\"\"+o.getClass();\n";
    r+="      int i1,i2;\n";
    r+="      \n";
    r+="      i1=s.indexOf(\".dodico.\");\n";
    r+="      i2=s.indexOf(\".C\");\n";
    r+="      if((i1>=0)&&(i2>=0))\n";
    r+="      s=s.substring(0,i1+7)+\"corba.\"+s.substring(i1+7,i2)+\".I\"+s.substring(i2+2);\n";
    r+="      System.err.println(\"Constructeur : \"+s+\"()\");\n";
    r+="      editeInstance(s,o);\n";
    r+="    }\n";

    r+="  }\n";

    r+="  final public static void ajouteObjet(Object _o)\n";
    r+="  {\n";
    r+="    if(THIS!=null)\n";
    r+="    {\n";
    r+="      THIS.objets.addElement(_o);\n";
    r+="      THIS.ltObjets=new JList(THIS.objets);\n";
    r+="      THIS.spObjets.setViewportView(THIS.ltObjets);\n";
    r+="      THIS.spObjets.doLayout();\n";
    r+="      THIS.spObjets.validate();\n";
    r+="    }\n";
    r+="  }\n";

    r+="  final public static Object creeInstance(String s)\n";
    r+="  {\n";
    r+="    int i1,i2;\n";
    r+="    \n";
    r+="    i1=s.indexOf(\".corba.\");\n";
    r+="    i2=s.indexOf(\".I\");\n";
    r+="    if((i1>=0)&&(i2>=0))\n";
    r+="      s=s.substring(0,i1)+s.substring(i1+6,i2)+\".C\"+s.substring(i2+2);\n";
    r+="    System.err.println(\"Constructeur : \"+s+\"()\");\n";

    r+="    Object o=null;\n";
    r+="    try\n";
    r+="    {\n";
    r+="      Class c=Class.forName(s);\n";
    r+="      o=c.newInstance();\n";
    r+="      System.err.println(\"Objet : \"+o);\n";
    r+="      ajouteObjet(o);\n";
    r+="    }\n";
    r+="    catch(Exception ex) { ex.printStackTrace(); }\n";
    r+="    return o;\n";
    r+="  }\n";

    r+="  final public static Basic_Edt creeDialogue(String s)\n";
    r+="  {\n";
    r+="    Basic_Edt f=null;\n";
    r+="    \n";
    r+="    try\n";
    r+="    {\n";
    r+="      s=s.substring(s.lastIndexOf('.')+1)+\"_Edt\";\n";
    r+="      Class c=Class.forName(s);\n";
    r+="      f=(Basic_Edt)c.newInstance();\n";
    r+="      System.err.println(\"Dialogue : \"+s);\n";
    r+="    }\n";
    r+="    catch(Exception ex) { ex.printStackTrace(); }\n";
    r+="    return f;\n";
    r+="  }\n";

    r+="  final public static void editeInstance(Object o)\n";
    r+="  {\n";
    r+="    if(o!=null)\n";
    r+="    {\n";
    r+="      String s=\"\"+o.getClass();\n";
    r+="      int i1,i2;\n";
    r+="      \n";
    r+="      i1=s.indexOf(\".dodico.\");\n";
    r+="      i2=s.indexOf(\".C\");\n";
    r+="      if((i1>=0)&&(i2>=0))\n";
    r+="      s=s.substring(0,i1+7)+\"corba.\"+s.substring(i1+7,i2)+\".I\"+s.substring(i2+2);\n";
    r+="      System.err.println(\"Constructeur : \"+s+\"()\");\n";
    r+="      editeInstance(s,o);\n";
    r+="    }\n";
    r+="  }\n";

    r+="  final public static void editeInstance(String s, Object o)\n";
    r+="  {\n";
    r+="    if(o!=null)\n";
    r+="    {\n";
    r+="      Basic_Edt f=creeDialogue(s);\n";
    r+="      if(f!=null)\n";
    r+="      {\n";
    r+="        f.objet(o);\n";
    r+="        afficheInspecteur(s,f,true);\n";
    r+="      }\n";
    r+="    }\n";
    r+="  }\n";

    r+="  final public static void editeTableau(String s, Object o, boolean e)\n";
    r+="  {\n";
    r+="    if(o!=null)\n";
    r+="    {\n";
    r+="      Basic_Edt f=null;\n";

    r+="      if(o instanceof Object[]) f=new AglVecteur_Edt();\n";
    r+="      if(o instanceof double[]) f=new double_Array_Edt();\n";

    r+="      if(f!=null)\n";
    r+="      {\n";
    r+="        f.objet(o);\n";
    r+="        afficheInspecteur(s,f,e);\n";
    r+="      }\n";
    r+="    }\n";
    r+="  }\n";

    r+="  final public static void afficheInspecteur(String s, Basic_Edt f, boolean e)\n";
    r+="  {\n";
    r+="    Inspecteur i=new Inspecteur(s,f);\n";
    r+="    i.pack();\n";
    r+="    i.setEnabled(e);\n";
    r+="    if(!e) i.setBackground(Color.gray);\n";
    r+="    i.setVisible(true);\n";
    r+="  }\n";

    r+="  final public static void trieChaines(String[] s)\n";
    r+="  {\n";
    r+="    int i=0;\n";
    r+="    while(i+1<s.length)\n";
    r+="    {\n";
    r+="      if(s[i].compareTo(s[i+1])>0)\n";
    r+="      {\n";
    r+="        String t=s[i];\n";
    r+="        s[i]=s[i+1];\n";
    r+="        s[i+1]=t;\n";
    r+="        if(i>0) i--;\n";
    r+="      }\n";
    r+="      else i++;\n";
    r+="    }\n";
    r+="  }\n";

    r+="}\n\n";
*/

    return r;
  }


// Unite

  public String code(AglUnite o)
  {
    String r="";
    indentation=0;

    x=X0; y=Y0;

    r+="<?xml version=\"1.0\"  encoding=\"ISO-8859-1\"?>\n";
    r+="<!DOCTYPE Window SYSTEM \"proto.dtd\">\n";

    r+=entete(o.fichier,"Prototype de Pierre Morel (http://www.pierlou.com/)");

    r+="<Window Left=\"100\" Top=\"100\" Width=\"500\" Height=\"500\">\n";
    r+="<Panel>\n";
    r+="<TabPane>\n";

    for(Enumeration e=AglType.table.elements(); e.hasMoreElements(); )
    {
      AglType at=(AglType)e.nextElement();
      if(at instanceof AglStruct)
      {
        AglStruct ac=(AglStruct)at;
	r+="<Tab Caption=\""+code(ac.nom.dernier())+"\">\n";
	r+=code(ac);
	r+="</Tab>\n";
      }
    }

    for(Enumeration e=AglType.table.elements(); e.hasMoreElements(); )
    {
      AglType at=(AglType)e.nextElement();
      if(at instanceof AglClasse)
      {
        AglClasse ac=(AglClasse)at;
        if(!ac.elementaire)
        {
	  r+="<Tab Caption=\""+code(ac.nom.dernier())+"\">\n";
	  r+=code(ac);
	  r+="</Tab>\n";
        }
      }
    }

    r+="</TabPane>\n";
    r+="</Panel>\n";
    r+="</Window>\n";

    // r+=module_ebli();
    return r;
  }
}
