/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AglConstructeur.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.agl;
import com.memoire.agl.*;


import java.util.*;

public class AglConstructeur extends AglDeclaration
{
  public AglVisibilite visibilite;
  public AglNom        nom;
  public AglVecteur    parametres;
  public AglListeNoms  exceptions;
  public AglBloc       corps;
  public boolean       destructeur;

  public AglConstructeur() // yapod
  {
    this(new AglNom(AglLib.genereNom("constructeur")));
  }

  public AglConstructeur(AglNom _nom)
  {
    visibilite =new AglVisibilite();
    nom        =_nom;
    parametres =new AglVecteur();
    exceptions =new AglListeNoms();
    corps      =new AglBloc();
    destructeur=false;
  }

  public final String signature()
  {
    String r="";

    if(proprietaire instanceof AglType)
      r+=AglNom.signature(((AglType)proprietaire).nom)+"/";

    r+="<init>(";
    for(Enumeration e=parametres.elements(); e.hasMoreElements(); )
    {
      AglParametre p=(AglParametre)e.nextElement();
      r+=AglType.signature(p.type);
    }
    r+=")V";
    return r;
  }

  public String toString()
  {
    return "CONSTRUCTEUR("+nom+")";
  }
}
