/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AglExpressionAttribut.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.agl;
import com.memoire.agl.*;
import java.util.*;

public class AglExpressionAttribut extends AglExpression
{
  public AglExpression      objet;
  public String             attribut; // expression
  public boolean            statique; // marque

  // yapod
  public AglExpressionAttribut()
  {
    this(null,"<<attribut>>",false);
  }

  public AglExpressionAttribut(AglExpression _objet, String _attribut)
  {
    this(_objet,_attribut,false);
  }

  public AglExpressionAttribut
  (AglExpression _objet, String _attribut, boolean _statique)
  {
    objet   =_objet;
    attribut=_attribut;
    statique=_statique;

    /*
    System.err.println("### OBJET="+_objet+" "+
    (_objet!=null ? _objet.getClass().getName() : ""));

    if(_objet instanceof AglExpressionAttribut)
    {
      AglExpressionAttribut o=(AglExpressionAttribut)_objet;
      if(o.objet==null)
      {
	//System.err.println("### E="+attribut);
	if(AglType.cherche(o.attribut)!=null) statique=true;
	//System.err.println("### STATIQUE="+statique);
      }
    }
    */
  }

  public AglType guessType()
  {
    AglType r=null;
    if(objet!=null)
    {
      AglType t=objet.guessType();
      if(t instanceof AglClasse)
      {
	AglClasse c=(AglClasse)t;
	for(Enumeration e=c.attributs.elements(); e.hasMoreElements(); )
	{
	  AglAttribut aa=(AglAttribut)e.nextElement();
	  if(aa.nom.equals(attribut)) r=aa.type;
	}
      }
    }
    return r;
  }
}

