/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AglExpressionBinaire.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.agl;
import com.memoire.agl.*;


public class AglExpressionBinaire extends AglExpression
{
  public String        operateur;
  public AglExpression gauche;
  public AglExpression droite;

  // yapod
  public AglExpressionBinaire()
  {
    this("<<operateur>>",null,null);
  }

  public AglExpressionBinaire
  (String _operateur, AglExpression _gauche, AglExpression _droite)
  {
    operateur=_operateur;
    gauche   =_gauche;
    droite   =_droite;
  }

  public AglType guessType()
  {
    AglType r=null;
    if(  "==".equals(operateur)
       ||"!=".equals(operateur)
       ||"<" .equals(operateur)
       ||"<=".equals(operateur)
       ||">" .equals(operateur)
       ||">=".equals(operateur)) r=AglTypePrimitif.tboolean;
    else
    {
      AglType g=gauche.guessType();
      AglType d=droite.guessType();

      AglType tstring =AglType.cherche("java.lang.String");
      AglType tdouble =AglTypePrimitif.tdouble;
      AglType tfloat  =AglTypePrimitif.tfloat;
      AglType tlong   =AglTypePrimitif.tlong;
      AglType tinteger=AglTypePrimitif.tinteger;

           if((g==tstring)||(d==tstring)) r=tstring;
      else if((g==tdouble)||(d==tdouble)) r=tdouble;
      else if((g==tfloat )||(d==tfloat )) r=tfloat;
      else if((g==tlong  )||(d==tlong  )) r=tlong;
      else r=tinteger;
    }

    return r;
  }
}

