/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AglExpressionMethode.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.agl;
import com.memoire.agl.*;
import java.util.*;

public class AglExpressionMethode extends AglExpression
{
  public AglExpression         objet;
  public AglExpressionFonction fonction;
  public boolean               statique;

  // yapod
  public AglExpressionMethode()
  {
    this(null,null,false);
  }

  public AglExpressionMethode
  (AglExpression _objet, AglExpressionFonction _fonction)
  {
    this(_objet,_fonction,false);
  }

  public AglExpressionMethode
  (AglExpression _objet, AglExpressionFonction _fonction, boolean _statique)
  {
    objet   =_objet;
    fonction=_fonction;
    statique=_statique;

    /*
      System.err.println("### OBJET="+_objet+" "+
		       (_objet!=null ? _objet.getClass().getName() : ""));

    if(_objet instanceof AglExpressionAttribut)
    {
      AglExpressionAttribut o=(AglExpressionAttribut)_objet;
      if(o.objet==null)
      {
	System.err.println("### E="+fonction);
	if(AglType.cherche(o.fonction)!=null) statique=true;
	System.err.println("### STATIQUE="+statique);
      }
    }
    */
  }

  public AglType guessType()
  {
    AglType r=null;
    if(objet!=null)
    {
      AglType t=objet.guessType();
      if(t instanceof AglClasse)
      {
	AglClasse c=(AglClasse)t;
	for(Enumeration e=c.methodes.elements(); e.hasMoreElements(); )
	{
	  AglMethode am=(AglMethode)e.nextElement();
	  if(am.nom.equals(fonction.nom)) r=am.type;
	}
      }
    }
    return r;
  }
}
