/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AglImageEncoder.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.agl;
import com.memoire.acme.*;
import com.memoire.agl.*;

import java.io.*;
import java.awt.*;

public class AglImageEncoder
{
  public static void save(Image _image, String _fichier, String _format)
  {
    try
    {
      _format=_format.toLowerCase();
      if(_format.equals("jpeg")) _format="jpg";

      if(!_fichier.endsWith("."+_format))
	_fichier+="."+_format;

      if(AglOptions.terminal!=null)
	AglOptions.terminal.trace("Sauvegarde de "
				  /*
				  +AglOptions.module
				  +" dans "
				  */
				  +_fichier+" ...");
      OutputStream     out=new FileOutputStream(_fichier);
      AcmeImageEncoder ie =null;

           if(_format.equals("gif")) ie=new AcmeGifEncoder (_image,out);
      else if(_format.equals("jpg")) ie=new AcmeJpegEncoder(_image,out);
      else if(_format.equals("ppm")) ie=new AcmePpmEncoder (_image,out);
      else throw new Exception("Format d'image inconnu.");

      ie.encode();
      out.close();

      if(AglOptions.terminal!=null)
	AglOptions.terminal.trace("Fini");
    }
    catch(Exception ex)
    {
      if(AglOptions.terminal!=null)
	AglOptions.terminal.erreur("Encodeur "+_format+": "+ex);
    }
  }
}
