/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AglMethode.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.agl;
import com.memoire.agl.*;


import java.util.*;

public class AglMethode extends AglDeclaration
{
  public AglVisibilite visibilite;
  public AglType       type;
  public String        nom;
  public AglVecteur    parametres;
  public AglListeNoms  exceptions;
  //public boolean       requete;

  public AglBloc       corps;
  public AglVecteur    preconditions;
  public AglVecteur    postconditions;

  public AglMethode() // yapod
  {
    this(AglLib.genereNom("methode"),AglTypePrimitif.tvoid);
  }

  public AglMethode(String _nom, AglType _type)
  {
    visibilite=new AglVisibilite();
    type          =_type;
    nom           =_nom;
    parametres    =new AglVecteur();
    exceptions    =new AglListeNoms();
    //requete       =false;

    corps         =new AglBloc();
    preconditions =new AglVecteur();
    postconditions=new AglVecteur();
  }

  public final String signature()
  {
    String r="";

    if(proprietaire instanceof AglType)
      r+=AglNom.signature(((AglType)proprietaire).nom)+"/";

    r+=nom+"(";
    for(Enumeration e=parametres.elements(); e.hasMoreElements(); )
    {
      AglParametre p=(AglParametre)e.nextElement();
      r+=AglType.signature(p.type);
    }
    r+=")";
    r+=AglType.signature(type);
    return r;
  }

  public String toString()
  {
    return "METHODE("+nom+","+type.nom.dernier()+")";
  }
}
