/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AglOutil.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.agl;
import com.memoire.agl.*;
import com.memoire.fu.*;

import java.util.*;
import java.io.*;
import java.net.*;

public abstract class AglOutil
{
  public final static String analyseur(String _ext)
  {
    String r=null;
    String e=_ext.toLowerCase();

    if(e.equals("c"    )||e.equals("h"  )) r="Cpp";
    if(e.equals("cc"   )||e.equals("hh" )) r="Cpp";
    if(e.equals("cpp"  )||e.equals("hpp")) r="Cpp";
    if(e.equals("cxx"  )||e.equals("hxx")) r="Cpp";
    if(e.equals("class")                 ) r="Class";
    if(e.equals("f"    )||e.equals("for")) r="Fortran";
    if(e.equals("idl"  )                 ) r="Idl";
    if(e.equals("java" )||e.equals("jav")) r="Java";
    if(e.equals("javap")                 ) r="JavaP";
    if(e.equals("jsp"  )                 ) r="Jsp";
    if(e.equals("mdl"  )                 ) r="Mdl";
    if(e.equals("pas"  )                 ) r="Pascal";
    if(e.equals("tld"  )                 ) r="Taglib";
    if(e.equals("xmi"  )                 ) r="Xmi";
    if(e.equals("xsd"  )                 ) r="Xsd";

    return r;
  }

  public final static String generateur(String _ext)
  {
    String r=null;
    String e=_ext.toLowerCase();

    if(e.equals("c"    )                 ) r="C";
    if(e.equals("cc"   )                 ) r="Cpp";
    if(e.equals("cpp"  )                 ) r="Cpp";
    if(e.equals("cxx"  )                 ) r="Cpp";
    if(e.equals("h"    )                 ) r="H";
    if(e.equals("hh"   )                 ) r="Hpp";
    if(e.equals("hpp"  )                 ) r="Hpp";
    if(e.equals("hxx"  )                 ) r="Hpp";
    //if(e.equals("class")                 ) r="Class";
    if(e.equals("e"    )                 ) r="Eiffel";
    //if(e.equals("f"    )||e.equals("for")) r="Fortran";
    if(e.equals("idl"  )                 ) r="Idl";
    //if(e.equals("j"  )                 ) r="Jasmin";
    if(e.equals("java" )||e.equals("jav")) r="Java";
    //if(e.equals("javap")                 ) r="JavaP";
    //if(e.equals("jsp"  )                 ) r="Jsp";
    //if(e.equals("mdl"  )                 ) r="Mdl";
    //if(e.equals("pas"  )                 ) r="Pascal";
    //if(e.equals("tld"  )                 ) r="Taglib";
    if(e.equals("xmi"  )                 ) r="Xmi";
    //if(e.equals("xsd"  )                 ) r="Xsd";

    return r;
  }

  public final static String syntaxeur(String _ext)
  {
    String r=null;
    String e=_ext.toLowerCase();

    if(e.equals("class")                 ) r=null;
    if(e.equals("mdl"  )                 ) r=null;
    if(e.equals("txt"  )                 ) r=null;
    if(e.equals("gif"  )                 ) r=null;
    if(e.equals("jpeg" )||e.equals("jpg")) r=null;
    if(e.equals("ppm"  )                 ) r=null;

    if(e.equals("c"    )||e.equals("h"  )) r="Cpp";
    if(e.equals("cc"   )||e.equals("hh" )) r="Cpp";
    if(e.equals("cpp"  )||e.equals("hpp")) r="Cpp";
    if(e.equals("cxx"  )||e.equals("hxx")) r="Cpp";
    if(e.equals("dja"  )                 ) r="Dja";
    if(e.equals("e"    )                 ) r="Eiffel";
    if(e.equals("f"    )||e.equals("for")) r="Fortran";
    if(e.equals("html" )||e.equals("htm")) r="Html";
    if(e.equals("idl"  )                 ) r="Idl";
    if(e.equals("java" )||e.equals("jav")) r="Java";
    if(e.equals("javap")                 ) r="JavaP";
    if(e.equals("jsp"  )                 ) r="Jsp";
    if(e.equals("pas"  )                 ) r="Pascal";
    if(e.equals("tld"  )                 ) r="Xml";
    if(e.equals("xmi"  )                 ) r="Xml";
    if(e.equals("xsd"  )                 ) r="Xml";

    return r;
  }
}
