/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AglOutilReformatage.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.agl;
import com.memoire.agl.*;
import com.memoire.fu.*;

import java.util.*;
import java.io.*;
import java.net.*;

public class AglOutilReformatage
   extends AglOutil
{
  public static void main(String _args[]) throws Exception
  {
    if(_args.length==0)
    {
      System.err.println("-------------------------------------------------------------------------------");
      System.err.println("Alma version "+AglOptions.VERSION+" ["+AglOptions.DATE+"]");
      System.err.println("Outil driv de reformatage");
      System.err.println("Distribu sous les termes de la GNU Public License v2");
      System.err.println("Guillaume Desnoix (c)1998-2001 <guillaume@desnoix.com>");
      System.err.println("Tous droits rservs par l'auteur et les contributeurs");
      System.err.println("http://www.memoire.com/guillaume-desnoix/alma/");
      System.err.println("--------------------------------------------------------------------------------");
      System.err.println("Syntaxe: java com.memoire.agl.AglOutilReformatage <fichier-entree>");
      return;
    }

    if((_args.length>1)||_args[0].startsWith("-"))
    {
      System.err.println("Syntaxe: java com.memoire.agl.AglOutilReformatage <fichier-entree>");
      return;
    }

    String f=_args[0];
    String e="";
    int    i=f.lastIndexOf('.');
    if(i>=0) e=f.substring(i+1);

    String p=analyseur(e);
    if(p==null)
    {
      System.err.println("Erreur: Impossible de trouver un analyseur pour l'extension ."+e);
      return;
    }

    String g=generateur(e);
    if(g==null)
    {
      System.err.println("Erreur: Impossible de trouver un gnrateur pour l'extension ."+e);
      return;
    }

    String[] a=new String[]
    { "--no-header", "--comments", "-p", p, "-g", g, f };
    Agl.main(a);
  }
}
