/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AglPaquet.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.agl;
import com.memoire.agl.*;


public class AglPaquet extends AglDeclaration
{
  public static AglTableTriee table;

  public static void reinit(boolean _nouveau)
  {
    if(_nouveau||(table==null))
    {
      AglOptions.terminal.trace("$$$ AglPaquet");
      table=new AglTableTriee();
    }
  }

  public AglNom  nom;
  public boolean elementaire;

  public AglPaquet() // yapod
  {
    this(new AglNom(AglLib.genereNom("paquet")));
  }

  public AglPaquet(AglNom _nom)
  {
    elementaire=true;
    setNom(_nom);
  }

  public final void setNom(AglNom _nom)
  {
    if((_nom!=null)&&_nom.equals(nom)) return;

    reinit(false);

    if(nom!=null)
    {
      AglOptions.terminal.trace("Destroy package: "+nom);
      table.remove(nom);
    }

    nom=_nom;

    if(nom!=null)
    {
      AglOptions.terminal.trace("Create package: "+nom);

      if(table.get(nom)!=null)
	AglOptions.terminal.trace("Conflict   : "+nom);

      table.put(nom,this);
    }
  }

  public String toString()
  {
    return "PAQUET("+nom+")";
  }

  public static AglPaquet cherche(String _nom)
  {
    return cherche(new AglNom(_nom));
  }

  public static AglPaquet cherche(AglNom _nom)
  {
    AglPaquet p=(AglPaquet)table.get(_nom);
    if(p==null) AglOptions.terminal.trace("Unknown package: "+_nom);
    return p;
  }
}
