/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AglParseClass.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.agl;
import com.memoire.agl.*;


import java.io.*;

/**
 * Simple parser for class files.
 * Only classes compiled with Jikes can be parsed because this compiler
 * saves the class name at the beginning. Later a full class parser
 * will be added using gnu.bytecode.
 */
public class AglParseClass extends AglParseJavaP
{
  public AglParseClass()
  {
  }

  public String extension()
  {
    return "class";
  }

  public String[] extensions()
  {
    return new String[] { "class" };
  }

  public void initStream(InputStream _input, String _fichier) throws Exception
  {
    FileInputStream fin=new FileInputStream(_fichier);
    for(int i=0;i<16;i++) fin.read();
    String name="";
    int c;
    while(((c=fin.read())!=7)&&(c!=-1)) name+=(char)c;

    String path=new File(_fichier).getCanonicalPath();
    if(path.endsWith(".class")) path=path.substring(0,path.length()-6);
    if(path.endsWith(name))
      path=path.substring(0,path.length()-name.length());
    else
    {
      String s=_fichier;
      int    i=s.lastIndexOf(File.separator);
      if(i>=0) s=s.substring(i+1);
      erreur(s+" was not compiled with Jikes");
    }

    name=name.replace('/','.');
    trace("NAME="+name);
    trace("PATH="+path);

    String cp=System.getProperty("java.class.path");
    if(!"".equals(cp)) cp+=System.getProperty("path.separator");
    cp+=path;

    String[] cmd=new String[]
    {
      AglPreferences.AGL.getStringProperty
	("source.javap.command","/usr/local/jdk/bin/javap"),
      "-classpath", cp,
      "-c",
      "-private",
      name
    };

    Process p=Runtime.getRuntime().exec(cmd);

    InputStream  in=new BufferedInputStream(p.getInputStream());
    StringBuffer sb=new StringBuffer();
    int          ch;
    while((ch=in.read())!=-1)
      sb.append((char)ch);

    //System.err.println("JAVAP="+sb);
    p.waitFor();
    super.initStream(new ByteArrayInputStream
		     (sb.toString().getBytes()),_fichier);
  }

  /*
  public String fichier()
  {
    return "-";
  }
  */

  public int ligne()
  {
    return -1;
  }
}


