/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AglParseXmi.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.agl;
import com.memoire.agl.*;
import com.memoire.mst.*;

import java.util.*;
import java.io.*;

public class AglParseXmi extends AglParse
{
  private MstXmlParser parser_;

  //AglParseXmiHandler handler_;

  public AglParseXmi()
  {
    // considere Xmi long as Java int
    /*
    new AglTypeAlias("long",AglTypePrimitif.tinteger,"Xmi");

    if(AglType.cherche("String")==null)
      (new AglClasse(new AglNom("java.lang.String"))).elementaire=true;

    if(AglType.cherche("string")==null)
      new AglTypeAlias("string",AglType.cherche("String"),"Xmi");
    if(AglType.cherche("wstring")==null)
      new AglTypeAlias("wstring",AglType.cherche("String"),"Xmi");
    */
  }

  public String extension()
  {
    return "xmi";
  }

  public String[] extensions()
  {
    return new String[] { "xmi", "XMI" };
  }

  public String syntaxe()
  {
    return "Xml";
  }

  /*
  private int _lineno_=1;
  public int st_lineno()
  {
    return _lineno_++;
  }
  */

  public void initStream(InputStream _input, String _fichier) throws Exception
  {
    fichier=_fichier;
  }

  public String get()
  {
    return "";
  }

  public void put(String _s)
  {
  }

  private int pp=0;
  public int ligne()
  {
    int r=-1;
    if(parser_!=null) r=parser_.getLineNumber();

    if(MaxLines!=0)
    {
      int p=100*r/MaxLines;
      if(p!=pp) progres(p);
      pp=p;
    }
    return r;
  }

  private String fichier="";
  public String fichier()
  {
    int i=fichier.lastIndexOf(File.separator);
    return fichier.substring(i+1);
  }

  // Parsing

  public void parseFichier() throws Exception
  {
    AglParseXmiHandler handler=new AglParseXmiHandler(this,fichier);
    parser_=new MstXmlParser();
    parser_.setHandler(handler);

    String url=fichier;
    if(url.indexOf(':')<0) url="file://"+new File(url).getAbsolutePath();
    try { parser_.parse(url,null,null,null); }
    catch(FileNotFoundException ex)
    {
      erreur("Fichier "+ex.getMessage()+" introuvable");
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
      erreur(ex.getClass().getName()+" "+ex.getMessage());
    }
  }

  public AglUnite parseUnite() throws Exception
  {
    return null;
  }

  public AglVisibilite parseVisibilite() throws Exception
  {
    return null;
  }

  public AglNom parseNom() throws Exception
  {
    return null;
  }

  public AglListeNoms parseListeNoms() throws Exception
  {
    return null;
  }

  public AglType parseType() throws Exception
  {
    return null;
  }

  public AglPaquet parsePaquet() throws Exception
  {
    return null;
  }
  
  public AglImport parseImport() throws Exception
  {
    return null;
  }

  public AglTypeAlias parseTypeDef() throws Exception
  {
    return null;
  }

  public AglStruct parseStruct() throws Exception
  {
    return null;
  }

  public AglClasse parseClasse() throws Exception
  {
    return null;
  }

  public AglListeNoms parseMothers() throws Exception
  {
    return null;
  }

  public AglListeNoms parseInterfaces() throws Exception
  {
    return null;
  }

  public AglListeNoms parseExceptions() throws Exception
  {
    return null;
  }

  public AglConstructeur parseConstructeur() throws Exception
  {
    return null;
  }

  public AglMethode parseMethode() throws Exception
  {
    return null;
  }

  public AglVecteur parseAttribut() throws Exception
  {
    return null;
  }

  public AglVecteur parseParametres() throws Exception
  {
    return null;
  }

  public AglVecteur parseArgs() throws Exception
  {
    return null;
  }

  public AglBloc parseBloc() throws Exception
  {
    erreur("Il n'y a pas de bloc en Xmi ("+get()+")");
    return null;
  }

  public AglBloc parseBlocMultiple() throws Exception
  {
    erreur("Il n'y a pas de bloc-multiple en Xmi ("+get()+")");
    return null;
  }

  public AglBloc parseBlocSimple() throws Exception
  {
    erreur("Il n'y a pas de bloc-simple en Xmi ("+get()+")");
    return null;
  }

  public AglBloc parseBlocVirgule() throws Exception
  {
    erreur("Il n'y a pas de bloc-virgule en Xmi ("+get()+")");
    return null;
  }

// Expressions

  public AglExpression parseExpression() throws Exception
  {
    erreur("Il n'y a pas d'expression en Xmi ("+get()+")");
    return null;
  }

  public AglExpressionGenerique parseExpressionGenerique() throws Exception
  {
    erreur("Il n'y a pas d'expression generique en Xmi ("+get()+")");
    return null;
  }

  public AglExpressionUnaireDroite parseExpressionUnaireDroite() throws Exception
  {
    erreur("Il n'y a pas d'expression unaire droite en Xmi ("+get()+")");
    return null;
  }

  public AglExpressionBinaire parseExpressionBinaire() throws Exception
  {
    erreur("Il n'y a pas d'expression binaire en Xmi ("+get()+")");
    return null;
  }

  public AglExpressionFonction parseExpressionFonction() throws Exception
  {
    erreur("Il n'y a pas d'expression de fonction en Xmi ("+get()+")");
    return null;
  }

  public AglExpression parseExpressionNew() throws Exception
  {
    erreur("Il n'y a pas d'expression new en Xmi ("+get()+")");
    return null;
  }

  public AglExpressionParenthesee parseExpressionParenthesee() throws Exception
  {
    erreur("Il n'y a pas d'expression parenthse en Xmi ("+get()+")");
    return null;
  }

  public AglExpression parseExpressionTypage() throws Exception
  {
    erreur("Il n'y a pas d'expression de typage en Xmi ("+get()+")");
    return null;
  }

// Instructions

  public AglInstructionGenerique parseInstructionGenerique() throws Exception
  {
    erreur("Il n'y a pas d'instruction gnrique en Xmi ("+get()+")");
    return null;
  }

  public AglInstructionAffectation parseInstructionAffectation(AglExpression eg) throws Exception
  {
    erreur("Il n'y a pas d'instruction d'affectation en Xmi ("+get()+")");
    return null;
  }

  public AglInstructionBloc parseInstructionBloc() throws Exception
  {
    erreur("Il n'y a pas d'instruction de bloc en Xmi ("+get()+")");
    return null;
  }

  public AglInstructionCatch parseInstructionCatch() throws Exception
  {
    erreur("Il n'y a pas d'instruction catch en Xmi ("+get()+")");
    return null;
  }

  public AglVecteur parseInstructionDefVar() throws Exception
  {
    erreur("Il n'y a pas d'instruction de dfinition de variable en Xmi ("+get()+")");
    return null;
  }

  public AglInstructionDoWhile parseInstructionDoWhile() throws Exception
  {
    erreur("Il n'y a pas d'instruction do/while en Xmi ("+get()+")");
    return null;
  }

  public AglInstructionExpression parseInstructionExpression(AglExpression eg) throws Exception
  {
    erreur("Il n'y a pas d'instruction expressive en Xmi ("+get()+")");
    return null;
  }

  public AglInstructionIf parseInstructionIf() throws Exception
  {
    erreur("Il n'y a pas d'instruction if en Xmi ("+get()+")");
    return null;
  }

  public AglInstructionProcedure parseInstructionProcedure() throws Exception
  {
    erreur("Il n'y a pas de procedure en Java ("+get()+")");
    return null;
  }  

  public AglInstructionReturn parseInstructionReturn() throws Exception
  {
    erreur("Il n'y a pas d'instruction return en Xmi ("+get()+")");
    return null;
  }

  public AglInstructionSwitch parseInstructionSwitch() throws Exception
  {
    erreur("Il n'y a pas d'instruction switch en Xmi ("+get()+")");
    return null;
  }  

  public AglInstructionThrow parseInstructionThrow() throws Exception
  {
    erreur("Il n'y a pas d'instruction throw en Xmi ("+get()+")");
    return null;
  }

  public AglInstructionTry parseInstructionTry() throws Exception
  {
    erreur("Il n'y a pas d'instruction try en Xmi ("+get()+")");
    return null;
  }

  public AglInstructionWhile parseInstructionWhile() throws Exception
  {
    erreur("Il n'y a pas d'instruction while en Xmi ("+get()+")");
    return null;
  }
}
