/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AglLiteralEntier.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.agl;
import com.memoire.agl.*;

public class AglPileChamps
{
  private AglTableTriee table=new AglTableTriee();

  public void ajoute(String _id, AglObjet _value)
  {
    if(table.get(_id)==null)
      table.put(_id,new AglVecteur(1,1));
    AglVecteur v=(AglVecteur)table.get(_id);
    v.insertElementAt(_value,0);
  }

  public void enleve(String _id, AglObjet _value)
  {
    AglVecteur v=(AglVecteur)table.get(_id);
    if((v==null)||(v.size()==0))
       throw new NullPointerException("id "+_id+" not found");
    AglObjet o=(AglObjet)v.elementAt(0);
    if(o!=_value)
       throw new IllegalArgumentException("id "+_id+" not correct");

    v.removeElementAt(0);
  }

  public AglObjet objet(String _id)
  {
    AglObjet r=null;

    AglVecteur v=(AglVecteur)table.get(_id);
    if(v!=null) r=(AglObjet)v.elementAt(0);

    return r;
  }
}
