/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AglPreferences.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.agl;
import com.memoire.agl.*;
import com.memoire.fu.*;

import java.io.*;
import java.util.*;

/**
 * La classe de preferences pour Agl.
 */

public class AglPreferences
       extends FuPreferences
{
  public final static AglPreferences AGL=new AglPreferences();

  protected AglPreferences() { }

  private Properties defaultValues_=null;

  protected void loadDefaultValues()
  {
    if(defaultValues_==null)
    {
      defaultValues_=new Properties();
      try
      {
	defaultValues_.load(getClass().getResourceAsStream("aglrc.txt"));
      }
      catch(Exception ex1)
      {
	try
	{
	  defaultValues_.load(new FileInputStream
			      (System.getProperty("user.dir")+
			       File.separator+
			       "aglrc.txt"));
	}
	catch(Exception ex2)
	{
	  System.err.println("Can not find aglrc.txt");
	}
      }
    }
  }

  protected void addDefaultValues()
  {
    loadDefaultValues();

    Enumeration e=defaultValues_.keys();
    while(e.hasMoreElements())
    {
      String k=(String)e.nextElement();
      if(values_.get(k)==null)
	values_.put(k,defaultValues_.get(k));
    }
  }

  protected void removeDefaultValues()
  {
    loadDefaultValues();

    Enumeration e=defaultValues_.keys();
    while(e.hasMoreElements())
    {
      String k=(String)e.nextElement();
      if(defaultValues_.get(k).equals(values_.get(k)))
	values_.remove(k);
    }
  }
}
