/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AglRelationBiOrientee.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.agl;
import com.memoire.agl.*;


import java.util.*;

public class AglRelationBiOrientee extends AglRelation
{
  public String verbe;
  public String debut,fin;
  public String roleDebut,roleFin;
  public String cardinaliteDebut,cardinaliteFin;

  public AglRelationBiOrientee() // yapod
  {
    this("<<verbe>>",AglTypePrimitif.tvoid,AglTypePrimitif.tvoid);
  }

  public AglRelationBiOrientee
    (String _verbe, AglType _debut, AglType _fin)
  {
    this(_verbe,_debut.nom.dernier(),_fin.nom.dernier());
  }

  public AglRelationBiOrientee(String _verbe, String _debut, String _fin)
  {
    verbe=_verbe;
    debut=_debut;
    fin  =_fin;

    roleDebut="";
    roleFin="";
    cardinaliteDebut="1";
    cardinaliteFin="1";
  }

  public String getIntituleCourt()
  {
    String r="";
         if(!"1".equals(cardinaliteFin  )) r+=cardinaliteFin  +" ";
    else if(!"1".equals(cardinaliteDebut)) r+=cardinaliteDebut+" ";
    r+=fin;
         if(!"".equals(roleFin  )) r+=" ("+roleFin  +")";
    else if(!"".equals(roleDebut)) r+=" ("+roleDebut+")";
    return r;
  }

  public String getIntituleLong()
  {
    String r="";
    // if(!"1".equals(cardinaliteDebut))
    r+=cardinaliteDebut+" ";
    r+=debut;
    if(!"".equals(roleDebut)) r+=" ("+roleDebut+")";
    r+=" "+verbe+" ";
    // if(!"1".equals(cardinaliteFin))
    r+=cardinaliteFin+" ";
    r+=fin;
    if(!"".equals(roleFin)) r+=" ("+roleFin+")";
    return r;
  }

  public String toString()
  {
    return "RELATIONBIORIENTEE("+verbe+","+debut+","+fin+")";
  }
}
