/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AglSilkPrimitives.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.agl;
import com.memoire.agl.*;



// Ce fichier a ete genere a partir de agl.scm.
// Ne pas le modifier!

public class AglSilkPrimitives {
  public static final String CODE = 

"\n" +
";;; Silk Scheme API\n" +

"\n" +
"(define writeln\n" +
  "(lambda (x)\n" +
    "(write-char x)\n" +
    "(write-char (integer->char 10))\n" +
    "()\n" +
    "))\n" +

"\n" +
"(writeln ((method \"hello\" \"AglPublicAPI\")))\n" +

"\n" +
"(define true?\n" +
  "(macro (x)\n" +
    "`(not (null? ,x))\n" +
    "))\n" +

"\n" +
"(define remove-nil\n" +
  "(lambda (l)\n" +
    "(if (null? l) ()\n" +
	"(if (null? (car l)) (remove-nil (cdr l))\n" +
	    "(cons (car l) (remove-nil (cdr l)))))))\n" +

"\n" +
";;; general\n" +

"\n" +
"(define get-class\n" +
  "(macro (x)\n" +
    "`(,(method \"get_class\" \"AglPublicAPI\" \"java.lang.Object\") ,x)\n" +
    "))\n" +

"\n" +
"(define is-a\n" +
  "(macro (x y)\n" +
    "`(,(method \"is_a\" \"AglPublicAPI\" \"java.lang.Object\" \"java.lang.Class\")\n" +
      ",x ,y)\n" +
    "))\n" +

"\n" +
"(define code\n" +
  "(macro (x)\n" +
    "`(,(method \"code\" \"AglPublicAPI\" \"java.lang.Object\") ,x)\n" +
    "))\n" +

"\n" +
";;; types\n" +

"\n" +
"(define defined-types\n" +
  "(macro ()\n" +
    "`(vector->list (,(method \"defined_types\" \"AglPublicAPI\")))\n" +
    "))\n" +

"\n" +
"(define defined-type-names\n" +
  "(macro ()\n" +
    "`(map (lambda (t) (get-type-name t)) (defined-types))\n" +
    "))\n" +

"\n" +
"(define get-type-name\n" +
  "(macro (x)\n" +
    "`(,(method \"get_type_name\" \"AglPublicAPI\" \"AglType\") ,x)\n" +
    "))\n" +

"\n" +
"(define type-by-name\n" +
  "(macro (x)\n" +
    "`(,(method \"type_by_name\" \"AglPublicAPI\" \"java.lang.String\")\n" +
      "(string->symbol ,x))\n" +
    "))\n" +

"\n" +
";;; classes\n" +

"\n" +
"(define defined-classes\n" +
  "(macro ()\n" +
    "`(remove-nil\n" +
      "(vector->list (,(method \"defined_classes\" \"AglPublicAPI\"))))\n" +
    "))\n" +

"\n" +
"(define defined-class-names\n" +
  "(macro ()\n" +
    "`(map (lambda (t) (get-type-name t)) (defined-classes))\n" +
    "))\n" +

"\n" +
"(define create-class\n" +
  "(macro (x)\n" +
    "`(,(method \"create_class\" \"AglPublicAPI\" \"java.lang.String\")\n" +
      "(string->symbol ,x))\n" +
    "))\n" +

"\n" +
"(define elementary?\n" +
  "(macro (x)\n" +
    "`(true? (,(method \"is_elementary\" \"AglPublicAPI\" \"AglClasse\") ,x))\n" +
    "))\n" +
   
"\n" +
"(define interface?\n" +
  "(macro (x)\n" +
    "`(true? (,(method \"is_interface\" \"AglPublicAPI\" \"AglClasse\") ,x))\n" +
    "))\n" +

"\n" +
"(define get-class-attributes\n" +
  "(macro (x)\n" +
    "`(,(method \"get_class_attributes\" \"AglPublicAPI\" \"AglClasse\") ,x)\n" +
    "))\n" +

"\n" +
";;; structs\n" +

"\n" +
"(define defined-structs\n" +
  "(macro ()\n" +
    "`(remove-nil\n" +
      "(vector->list (,(method \"defined_structs\" \"AglPublicAPI\"))))\n" +
    "))\n" +

"\n" +
"(define defined-struct-names\n" +
  "(macro ()\n" +
    "`(map (lambda (t) (get-type-name t)) (defined-structs))\n" +
    "))\n" +

"\n" +
"(define create-struct\n" +
  "(macro (x)\n" +
    "`(,(method \"create_struct\" \"AglPublicAPI\" \"java.lang.String\")\n" +
      "(string->symbol ,x))\n" +
    "))\n" +

"\n" +

"\n" +
";;; exemples\n" +

"\n" +
"(writeln \"\")\n" +
"(writeln \"Exemples\")\n" +
"(writeln \"--------\")\n" +
"(writeln (define *float* (type-by-name \"float\")))\n" +
"(writeln (create-class \"java.lang.String\"))\n" +
"(writeln (create-struct \"MyStruct\"))\n" +

"\n" +

"\n" +
"";
}
