/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AglSortie.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.agl;
import com.memoire.agl.*;
import java.io.*;
import java.util.*;

public class AglSortie
       implements Serializable
{
  public String mimetype;
  public String syntaxe;
  public String fichier;
  public Object donnee;

  public AglSortie()
  {
  }

  public AglSortie
  (String _mimetype, String _syntaxe, String _fichier, Object _donnee)
  {
    mimetype=_mimetype;
    syntaxe =_syntaxe;
    fichier =_fichier;
    donnee  =_donnee;
  }

  public String toString()
  {
    String r="";

    r+="Content-Type: "+mimetype+"\n";
    r+="Syntax:       "+syntaxe+"\n";
    r+="File:         "+fichier+"\n";
    if(donnee!=null) r+="Class:        "+donnee.getClass().getName()+"\n";
    else             r+="Class:        null\n";
    r+="\n";

    if(donnee instanceof String)
      r+=(String)donnee;

    return r;
  }
}
