/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AglTableOrdonnee.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.agl;
import com.memoire.agl.*;
import com.memoire.fu.*;

import java.io.*;
import java.util.*;

public class AglTableOrdonnee
       implements Serializable
{
  // protected
  public AglVecteur        k_;
  public AglVecteur        v_;
  public FuHashtablePublic t_;

  public AglTableOrdonnee()
  {
    clear();
  }

  public synchronized void clear()
  {
    k_=new AglVecteur       ();
    v_=new AglVecteur       ();
    t_=new FuHashtablePublic();
  }

  public synchronized void put(Object _key, Object _value)
  {
    remove(_key);
    k_.addElement(_key  );
    v_.addElement(_value);
    t_.put(_key,_value);
  }

  public synchronized Object at(int _index)
  { return (_index<size()) ? v_.elementAt(_index) : null; }

  public synchronized int index(Object _value)
  { return v_.indexOf(_value); }

  public synchronized Object get(Object _key)
  { return t_.get(_key); }

  public synchronized void remove(Object _key)
  {
    Object value=t_.get(_key);

    if(value!=null)
    {
      int i=k_.indexOf(_key);

      /*
      if(i<0)
      {
        System.err.println("$$$ AglTableOrdonnee I=-1 "+_key+" "+value);
        System.err.println("$$$ "+_key.getClass());
        System.err.println("$$$ "+((AglNom)_key).formeJava());

	for(int j=0;j<k_.size();j++)
	  System.err.println("  "+k_.elementAt(j)+" "+k_.elementAt(j).getClass());
	System.exit(1);
      }
      */

      k_.removeElementAt(i);
      v_.removeElementAt(i);
      t_.remove(_key);

      if(k_.indexOf(_key)>=0)
      {
	System.err.println("DUPLICATE ELEMENT TABLE ORDONNEE");
	System.exit(1);
      }
    }
  }

  public synchronized int size()
  { return k_.size(); }

  public synchronized boolean isEmpty()
  { return k_.isEmpty(); }

  public synchronized Enumeration keys()
  { return k_.elements(); }

  public synchronized Enumeration elements()
  { return v_.elements(); }

  public synchronized Enumeration reverseKeys()
  { return k_.reverseElements(); }

  public synchronized Enumeration reverseElements()
  { return v_.reverseElements(); }
}
