/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AglTerminalSystem.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.agl;
import com.memoire.agl.*;
import java.io.*;

public class AglTerminalSystem
       implements AglTerminal
{
  public void syntaxe(String s)
  {
    System.err.println("Syntaxe      : "+s);
    if(AglPreferences.AGL.getBooleanProperty("agl.stop",true))
      System.exit(1);
    else
      throw new RuntimeException("Syntax:"+s);
  }

  public void erreur(String s)
  {
    System.err.println("Erreur       : "+s);
    if(AglPreferences.AGL.getBooleanProperty("agl.stop",true))
      System.exit(2);
    else
      throw new RuntimeException("Error:"+s);
  }

  public void avertissement(String s)
  {
    if(AglOptions.avertissement)
      System.err.println("Avertissement: "+s);
  }

  public void suivi(String s)
  {
    if(AglOptions.suivi)
      System.err.println(s);
  }

  public void trace(String s)
  {
    if(AglOptions.trace)
      System.err.println(s);
  }

  public void message(String s)
  {
    System.err.println(s);
  }

  public void sortie(String s)
  {
    System.out.println(s);
  }

  public void progres(int v)
  {
  }

  public InputStream  getInputStream()
  {
    return System.in;
  }

  public OutputStream getOutputStream()
  {
    return System.out;
  }

  public OutputStream getErrorStream()
  {
    return System.err;
  }
}
