/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AglTypeAlias.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.agl;
import com.memoire.agl.*;


public class AglTypeAlias extends AglType
{
  public AglType type;
  public String  langage;

  public AglTypeAlias() // yapod
  {
    this(AglLib.genereNom("type_alias"),AglTypePrimitif.tvoid);
  }

  public AglTypeAlias(String _nom, AglType _type)
  {
    this(_nom,_type,"Source");
  }

  public AglTypeAlias(String _nom, AglType _type, String _langage)
  {
    this(new AglNom(_nom),_type,_langage);
  }

  public AglTypeAlias(AglNom _nom, AglType _type, String _langage)
  {
    super(_nom);
    type   =_type;
    langage=_langage;
  }

  public String toString()
  {
    String r="TYPE_ALIAS("+nom;
    if(!langage.equals("Source"))
      r+=","+langage;
    r+=")";
    return r;
  }

  public static AglType simplifie(AglType _type)
  { return simplifie(_type,null); }

  public static AglType simplifie(AglType _type,String _target)
  {
    boolean encore=true;
    AglType r     =_type;

    while(encore)
    {
      encore=false;
      if(  (r instanceof AglTypeAlias)
	 &&((_target==null)||!_target.equals(((AglTypeAlias)r).langage)))
	{ r=((AglTypeAlias)r).type; encore=true; }
    }

    return r;
  }
}
