/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AglTypePrimitif.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.agl;
import com.memoire.agl.*;


public class AglTypePrimitif extends AglType
{
  public static AglTypePrimitif tvoid   ;
  public static AglTypePrimitif tboolean;
  public static AglTypePrimitif tchar   ;
  public static AglTypePrimitif tbyte   ;
  public static AglTypePrimitif tshort  ;
  public static AglTypePrimitif tinteger;
  public static AglTypePrimitif tlong   ;
  public static AglTypePrimitif tfloat  ;
  public static AglTypePrimitif tdouble ;

  public static void reinit()
  {
    AglOptions.terminal.trace("$$$ AglTypePrimitif");

    tvoid   =new AglTypePrimitif("void"   );
    tboolean=new AglTypePrimitif("boolean");
    tchar   =new AglTypePrimitif("char"   );
    tbyte   =new AglTypePrimitif("byte"   );
    tshort  =new AglTypePrimitif("short"  );
    tinteger=new AglTypePrimitif("int"    );
    tlong   =new AglTypePrimitif("long"   );
    tfloat  =new AglTypePrimitif("float"  );
    tdouble =new AglTypePrimitif("double" );
  }

  public AglTypePrimitif() // yapod
  {
    this(AglLib.genereNom("type_primitif"));
  }

  public AglTypePrimitif(String _nom)
  {
    super(new AglNom(_nom));
  }

  public String toString()
  {
    return "TYPE_PRIMITIF("+nom+")";
  }
}
