/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AglTypeTableau.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.agl;
import com.memoire.agl.*;


public class AglTypeTableau extends AglType
{
  public AglType       type;
  public AglExpression dimension;

  public AglTypeTableau() // yapod
  {
    this(AglTypePrimitif.tvoid);
  }

  public AglTypeTableau(AglType _type)
  {
    super(new AglNom(_type.nom.parent(),_type.nom.dernier()+"[]"));
    type=_type;
    dimension=null;
  }

  public AglTypeTableau(AglType _type, AglExpression _dimension)
  {
    super(new AglNom(_type.nom.parent(),_type.nom.dernier()
		     +"["+dimension(_dimension)+"]"));
    type=_type;
    dimension=_dimension;
  }

  private final static String dimension(AglExpression _dimension)
  {
    String r="";
    if(_dimension instanceof AglExpressionGenerique)
	r=((AglExpressionGenerique)_dimension).body;
    return r;
  }

  public String toString()
  {
    return "TYPE_TABLEAU("+type.nom+","+dimension+")";
  }
}
