/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AglUnite.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.agl;
import com.memoire.agl.*;


import java.util.*;

public class AglUnite extends AglObjet
{
  public static AglTableTriee table;

  public static void reinit(boolean _nouveau)
  {
    if(_nouveau||(table==null))
    {
      AglOptions.terminal.trace("$$$ AglUnite");
      table=new AglTableTriee();
    }
  }

  public String        fichier;
  public String        langage;
  public AglPaquet     paquet;
  public AglTableTriee imports;
  public AglTableTriee types;
  public boolean       cible;

  public AglUnite() // yapod
  {
    this("-");
  }

  public AglUnite(String _fichier)
  {
    fichier  =_fichier;
    ligne    =0;
    langage  ="";
    paquet=null;
    imports  =new AglTableTriee();
    types    =new AglTableTriee();
    cible    =false;

    AglOptions.terminal.trace("Create unit: "+fichier);
    reinit(false);
    table.put(fichier,this);
  }

  public String toString()
  {
    return "UNITE("+fichier+")";
  }
}
