/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AglVisibilite.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.agl;
import com.memoire.agl.*;


public class AglVisibilite
    extends AglObjet
{
  public boolean vabstract;
  public boolean vinline;
  public boolean vpublic;
  public boolean vprivate;
  public boolean vprotected;
  public boolean vstatic;
  public boolean vfinal;
  public boolean vnative;
  public boolean vtransient;
  public boolean vstrictfp;
  public boolean vsynchronized;
  public boolean voneway;
  public boolean vreadonly;
  public boolean vregister;
  public boolean vvirtual;

  // local, redeclare, mutable, obsolete (variables)
  // redefine (methods)
  // cf. TOM
  // http://www.gerbil.org/tom/doc/tome/x1087.html
  // http://www.gerbil.org/tom/doc/tome/x1150.html

  public AglVisibilite()
  {
    reset();
  }

  public void reset()
  {
    vabstract=vinline=vpublic=vprivate=vprotected=vstatic=
    vfinal=vnative=vtransient=vstrictfp=vsynchronized=voneway=
    vreadonly=vregister=vvirtual=false;
  }

  public AglVisibilite copie()
  {
    AglVisibilite r=new AglVisibilite();
    r.vabstract    =vabstract;
    r.vinline      =vinline;
    r.vpublic      =vpublic;
    r.vprivate     =vprivate;
    r.vprotected   =vprotected;
    r.vstatic      =vstatic;
    r.vfinal       =vfinal;
    r.vnative      =vnative;
    r.vtransient   =vtransient;
    r.vstrictfp    =vstrictfp;
    r.vsynchronized=vsynchronized;
    r.voneway      =voneway;
    r.vreadonly    =vreadonly;
    r.vregister    =vregister;
    r.vvirtual     =vvirtual;
    return r;
  }
}
