/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AlmaArbre.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.alma;
import com.memoire.agl.*;
import com.memoire.alma.*;
import com.memoire.bu.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import javax.swing.tree.*;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.io.*;
import java.util.*;

public class AlmaArbre
       extends BuTree
       // implements MouseListener // , PropertyChangeListener
{
  public AlmaArbre()
  {
    super();
    setName("trARBRE_MODELE");
    // setRequestFocusEnabled(false);
    setShowsRootHandles(true);
    setBorder(new EmptyBorder(5,5,5,5));
    setCellRenderer(new AlmaArbreCellRenderer());
    // setRootVisible(false);

    // addMouseListener(this);
    // getSelectionModel().setSelectionMode
    // (TreeSelectionModel.DISCONTIGUOUS_TREE_SELECTION);
    // setModel(new AlmaArbreModel());
    rafraichir();
  }

  public void rafraichir()
  {
    // TreePath[] paths=getSelectionPaths();

    // Pb Look and Feel
    try { setModel(new AlmaArbreModel()); }
    catch(Exception ex) { }

    /*
    if(paths!=null)
      for(int i=0;i<paths.length;i++)
	expandPath(paths[i]);
    setSelectionPaths(paths);
    */
  }

  /*
  public BCalque[] getSelection()
  {
    BCalque[]  r   =null;
    TreePath[] path=getSelectionPaths();

    if(path==null)
      r=new BCalque[0];
    else
    {
      int l=path.length;
      r=new BCalque[l];

      for(int i=0;i<l;i++)
	r[i]=(BCalque)path[i].getLastPathComponent();
    }

    return r;
  }
  */

  /*
  public BArbreNormalMenu buildNormalMenu()
    { return new BArbreNormalMenu(this); }

  public BArbrePopupMenu buildPopupMenu(BCalque _calque)
    { return new BArbrePopupMenu(this,_calque); }
  */

  // Mouse

  /*
  public void mouseDown(MouseEvent _evt)
  { }

  public void mouseEntered(MouseEvent _evt)
  { }

  public void mouseExited(MouseEvent _evt)
  { }

  public void mousePressed(MouseEvent _evt)
  {
    if(  _evt.isPopupTrigger()
       ||((_evt.getModifiers()&MouseEvent.BUTTON3_MASK)!=0))
      setModel(new AlmaArbreModel());
  }

  public void mouseReleased(MouseEvent _evt)
  { }

  public void mouseUp(MouseEvent _evt)
  { }

  public void mouseClicked(MouseEvent _evt)
  { }
  */
}

class AlmaNoeudUnites extends AlmaNoeud
{
  Icon   icon_;
  String titre_;

  AlmaNoeudUnites()
  {
    icon_ =AlmaResource.ALMA.getIcon("liste",16);
    titre_=AlmaResource.ALMA.getString("Units");
  }

  int getChildCount()
    { return AglUnite.table.size(); }

  boolean isLeaf()
    { return (getChildCount()==0); }

  Object getChild(int _index)
  {
    return new AlmaNoeudUnite((AglUnite)AglUnite.table.at(_index));
  }

  int getIndexOfChild(Object _child)
  {
    return AglUnite.table.index(_child);
  }

  public String toString()
    { return titre_+" ["+getChildCount()+"]"; }

  public Object getValue()
  {
    AglVecteur r=new AglVecteur(AglUnite.table.size(),1);

    for(Enumeration e=AglUnite.table.elements(); e.hasMoreElements(); )
    {
      Object o=e.nextElement();
      String f=((AglUnite)o).fichier;
      int i=f.lastIndexOf(File.separatorChar);
      if(i>=0) f=f.substring(i+1);
      r.addElement(f);
    }

    return r;
  }

  public Icon getIcon() { return icon_; } 
}

class AlmaNoeudUnite extends AlmaNoeud
{
  AglUnite unite_;

  AlmaNoeudUnite(AglUnite _unite)
  {
    unite_=_unite;
  }

  int     getChildCount  ()              { return 0; }
  boolean isLeaf         ()              { return true; }
  Object  getChild       (int _index)    { return null; }
  int     getIndexOfChild(Object _child) { return -1; }

  public String toString()
  {
    String r=unite_.fichier;
    int    i=r.lastIndexOf(File.separatorChar);
    if(i>=0) r=r.substring(i+1);
    return r;
  }

  public Object getValue()
  {
    return unite_.cible ? null : unite_;
  }

  public Icon   getIcon()
  {
    return BuResource.BU.getIcon(unite_.cible ? "cible" : "texte",16);
  } 
}

class AlmaNoeudTypeType extends AlmaNoeud
{
  Icon   icon_;
  String titre_;
  Class  type_;

  AlmaNoeudTypeType(String _titre, Class _type)
  {
    icon_=AlmaResource.ALMA.getIcon("liste",16);
    titre_=_titre;
    type_ =_type;
  }

  int getChildCount()
  {
    int r=0;
    for(Enumeration e=AglType.table.elements(); e.hasMoreElements(); )
      if(e.nextElement().getClass()==type_)
	r++;

    // System.err.println("~~~ "+type_+" "+r);
    return r;
  }

  boolean isLeaf()
    { return (getChildCount()==0); }

  Object  getChild(int _index)
  {
    Object r=null;
    int    j=0;

    for(Enumeration e=AglType.table.elements(); e.hasMoreElements(); )
    {
      Object o=e.nextElement();
      if(o.getClass()==type_)
      {
	if(_index==j)
	{
	       if(o instanceof AglClasse) r=new AlmaNoeudClasse((AglClasse)o);
	  else if(o instanceof AglStruct) r=new AlmaNoeudStruct((AglStruct)o);
	  else r=new AlmaNoeudType((AglType)o);
	}
	j++;
      }
    }

    // System.err.println("~~~ "+type_+"["+_index+"]="+r);
    return r;
  }

  int getIndexOfChild(Object _child)
  {
    int r=-1;
    int j=0;

    for(Enumeration e=AglType.table.elements(); e.hasMoreElements(); )
    {
      Object o=e.nextElement();
      if(o.getClass()==type_)
      {
	if(_child==o) r=j;
	j++;
      }
    }

    // System.err.println("~~~ "+_c+"["+_o+"]="+r);
    return r;
  }

  public String toString()
    { return titre_+" ["+getChildCount()+"]"; }

  public Object getValue()
  {
    AglVecteur r=new AglVecteur(11,11);

    for(Enumeration e=AglType.table.elements(); e.hasMoreElements(); )
    {
      Object o=e.nextElement();
      if(o.getClass()==type_)
	r.addElement(((AglType)o).nom);
    }

    return r;
  }

  public Icon   getIcon()  { return icon_; } 
}

class AlmaNoeudPaquets extends AlmaNoeud
{
  Icon   icon_;
  String titre_;

  AlmaNoeudPaquets()
  {
    icon_ =AlmaResource.ALMA.getIcon("liste",16);
    titre_=AlmaResource.ALMA.getString("Paquets");
  }

  int getChildCount()
    { return AglPaquet.table.size(); }

  boolean isLeaf()
    { return (getChildCount()==0); }

  Object  getChild(int _index)
  {
    Object r=null;
    int    j=0;

    for(Enumeration e=AglPaquet.table.elements(); e.hasMoreElements(); )
    {
      Object o=e.nextElement();
      if(_index==j)
	r=new AlmaNoeudPaquet((AglPaquet)o);
      j++;
    }

    return r;
  }

  int getIndexOfChild(Object _child)
  {
    int r=-1;
    int j=0;

    for(Enumeration e=AglPaquet.table.elements(); e.hasMoreElements(); )
    {
      Object o=e.nextElement();
      if(_child==o) r=j;
      j++;
    }

    return r;
  }

  public String toString()
    { return titre_+" ["+getChildCount()+"]"; }

  public Object getValue()
  {
    AglVecteur r=new AglVecteur(AglPaquet.table.size(),1);

    for(Enumeration e=AglPaquet.table.elements(); e.hasMoreElements(); )
    {
      Object o=e.nextElement();
      r.addElement(((AglPaquet)o).nom);
    }

    return r;
  }

  public Icon getIcon() { return icon_; } 
}

class AlmaNoeudPatrons extends AlmaNoeud
{
  Icon   icon_;
  String titre_;

  AlmaNoeudPatrons()
  {
    icon_ =AlmaResource.ALMA.getIcon("liste",16);
    titre_=AlmaResource.ALMA.getString("Patrons");
  }

  int getChildCount()
    { return AglPatron.table.size(); }

  boolean isLeaf()
    { return (getChildCount()==0); }

  Object  getChild(int _index)
  {
    Object r=null;
    int    j=0;

    for(Enumeration e=AglPatron.table.elements(); e.hasMoreElements(); )
    {
      Object o=e.nextElement();
      if(_index==j)
	r=new AlmaNoeudPatron((AglPatron)o);
      j++;
    }

    return r;
  }

  int getIndexOfChild(Object _child)
  {
    int r=-1;
    int j=0;

    for(Enumeration e=AglPatron.table.elements(); e.hasMoreElements(); )
    {
      Object o=e.nextElement();
      if(_child==o) r=j;
      j++;
    }

    return r;
  }

  public String toString()
    { return titre_+" ["+getChildCount()+"]"; }

  public Object getValue()
  {
    AglVecteur r=new AglVecteur(AglPatron.table.size(),1);

    for(Enumeration e=AglPatron.table.elements(); e.hasMoreElements(); )
    {
      Object o=e.nextElement();
      r.addElement(((AglPatron)o).nom);
    }

    return r;
  }

  public Icon getIcon() { return icon_; } 
}

class AlmaNoeudRelations extends AlmaNoeud
{
  Icon   icon_;
  String titre_;

  AlmaNoeudRelations()
  {
    icon_ =AlmaResource.ALMA.getIcon("liste",16);
    titre_=AlmaResource.ALMA.getString("Relations");
  }

  int getChildCount()
    { return AglRelation.table.size(); }

  boolean isLeaf()
    { return (getChildCount()==0); }

  Object  getChild(int _index)
  {
    return new AlmaNoeudRelation
      ((AglRelation)AglRelation.table.elementAt(_index),true);
  }

  int getIndexOfChild(Object _child)
  {
    AlmaNoeudRelation n=(AlmaNoeudRelation)_child;
    return AglRelation.table.indexOf(n.relation_);
  }

  public String toString()
    { return titre_+" ["+getChildCount()+"]"; }

  /*
  public Object getValue()
  {
    Vector r=new Vector();

    for(Enumeration e=AglRelation.table.elements(); e.hasMoreElements(); )
    {
      AglRelation o=(AglRelation)e.nextElement();
      r.addElement(o.getIntituleCourt());
    }
    return r;
  }
  */

  public Icon getIcon() { return icon_; } 
}

class AlmaNoeudType extends AlmaNoeud
{
  Icon        icon_;
  AglType     type_;

  AlmaNoeudType(AglType _type)
  {
    if(_type instanceof AglTypePrimitif)
      icon_=AlmaResource.ALMA.getIcon("type-primitif",16);
    else
    if(_type instanceof AglTypeAlias)
      icon_=AlmaResource.ALMA.getIcon("type-alias",16);
    else
    if(_type instanceof AglTypeTableau)
      icon_=AlmaResource.ALMA.getIcon("type-tableau",16);
    else
      icon_=AlmaResource.ALMA.getIcon("type",16);

    type_=_type;
  }

  int     getChildCount  ()              { return 0; }
  boolean isLeaf         ()              { return true; }
  Object  getChild       (int _index)    { return null; }
  int     getIndexOfChild(Object _child) { return -1; }

  public String toString()
  {
    AglType at=type_;
    String r=at.nom.dernier();
    while(at instanceof AglTypeTableau)
    {
      at=((AglTypeTableau)at).type;
      r=at.nom.dernier()+r;
    }

    return r;
  }

  public Object getValue() { return type_; }
  public Icon   getIcon()  { return icon_; } 
}

class AlmaNoeudPaquet extends AlmaNoeud
{
  Icon         icon_;
  AglPaquet paquet_;

  AlmaNoeudPaquet(AglPaquet _paquet)
  {
    paquet_=_paquet;
    icon_     =AlmaResource.ALMA.getIcon("paquet",16);
  }

  int     getChildCount  ()              { return 0; }
  boolean isLeaf         ()              { return true; }
  Object  getChild       (int _index)    { return null; }
  int     getIndexOfChild(Object _child) { return -1; }

  public String toString() { return paquet_.nom.formeJava(); }
  public Object getValue() { return paquet_; }
  public Icon   getIcon()  { return icon_; } 
}

class AlmaNoeudPatron extends AlmaNoeud
{
  Icon      icon_;
  AglPatron patron_;

  AlmaNoeudPatron(AglPatron _patron)
  {
    patron_=_patron;
    icon_=AlmaResource.ALMA.getIcon("patron",16);
  }

  int     getChildCount  ()              { return 0; }
  boolean isLeaf         ()              { return true; }
  Object  getChild       (int _index)    { return null; }
  int     getIndexOfChild(Object _child) { return -1; }

  public String toString() { return patron_.nom; }
  public Object getValue() { return patron_; }
  public Icon   getIcon()  { return icon_; } 
}

class AlmaNoeudRelation extends AlmaNoeud
{
  boolean     longue_;
  Icon        icon_;
  AglRelation relation_;

  AlmaNoeudRelation(AglRelation _relation, boolean _longue)
  {
    longue_=_longue;
    relation_=_relation;
    icon_=AlmaResource.ALMA.getIcon("relation",16);

    if(relation_ instanceof AglRelationBiOrientee)
    {
      String v=((AglRelationBiOrientee)relation_).verbe;
      if(v.equals("hrite de"))
	icon_=AlmaResource.ALMA.getIcon("relation-heritede",16);
      else
      if(v.equals("est hrit par"))
	icon_=AlmaResource.ALMA.getIcon("relation-estheritepar",16);
      else
      if(v.equals("implante"))
	icon_=AlmaResource.ALMA.getIcon("relation-implante",16);
      else
      if(v.equals("est implant par"))
	icon_=AlmaResource.ALMA.getIcon("relation-estimplantepar",16);
      else
      if(v.equals("contient"))
	icon_=AlmaResource.ALMA.getIcon("relation-contient",16);
      else
      if(v.equals("est contenu par"))
	icon_=AlmaResource.ALMA.getIcon("relation-estcontenupar",16);
      else
      if(v.equals("utilise"))
	icon_=AlmaResource.ALMA.getIcon("relation-utilise",16);
      else
      if(v.equals("est utilis par"))
	icon_=AlmaResource.ALMA.getIcon("relation-estutilisepar",16);
    }
  }

  int     getChildCount  ()              { return 0; }
  boolean isLeaf         ()              { return true; }
  Object  getChild       (int _index)    { return null; }
  int     getIndexOfChild(Object _child) { return -1; }

  public String toString()
  {
    String r;
    if(longue_) r=relation_.getIntituleLong();
    else        r=relation_.getIntituleCourt();
    return r;
  }

  public Object getValue() { return relation_; }
  public Icon   getIcon()  { return icon_; } 
}

class AlmaNoeudCondition extends AlmaNoeud
{
  Icon         icon_;
  AglCondition condition_;

  AlmaNoeudCondition(AglCondition _condition)
  {
    condition_=_condition;

    if(condition_.pre)
      icon_=AlmaResource.ALMA.getIcon("condition-pre",16);
    else
    if(condition_.post)
      icon_=AlmaResource.ALMA.getIcon("condition-post",16);
    else
      icon_=AlmaResource.ALMA.getIcon("condition",16);
  }

  int     getChildCount  ()              { return 0; }
  boolean isLeaf         ()              { return true; }
  Object  getChild       (int _index)    { return null; }
  int     getIndexOfChild(Object _child) { return -1; }

  public String toString() { return AglOptions.code().code(condition_.test); }
  public Object getValue() { return condition_; }
  public Icon   getIcon()  { return icon_; } 
}

class AlmaNoeudCommentaireSimple extends AlmaNoeud
{
  Icon                 icon_;
  AglCommentaireSimple commentaire_;

  AlmaNoeudCommentaireSimple(AglCommentaireSimple _commentaire)
  {
    commentaire_=_commentaire;
    icon_=AlmaResource.ALMA.getIcon("commentaire",16);
  }

  int     getChildCount  ()              { return 0; }
  boolean isLeaf         ()              { return true; }
  Object  getChild       (int _index)    { return null; }
  int     getIndexOfChild(Object _child) { return -1; }

  public String toString()
  {
    return "Commentaire";
  }

  public Object getValue() { return commentaire_; }
  public Icon   getIcon()  { return icon_; }
}

class AlmaNoeudCommentaireMulti extends AlmaNoeud
{
  Icon                 icon_;
  AglCommentaireMulti commentaire_;

  AlmaNoeudCommentaireMulti(AglCommentaireMulti _commentaire)
  {
    commentaire_=_commentaire;
    icon_=AlmaResource.ALMA.getIcon("commentaire",16);
  }

  int     getChildCount  ()              { return 0; }
  boolean isLeaf         ()              { return true; }
  Object  getChild       (int _index)    { return null; }
  int     getIndexOfChild(Object _child) { return -1; }

  public String toString()
  {
    return "Commentaire";
  }

  public Object getValue() { return commentaire_; }
  public Icon   getIcon()  { return icon_; }
}

class AlmaNoeudRacine extends AlmaNoeud
{
  Icon        icon_;
  AlmaNoeud[] noeuds_;

  public AlmaNoeudRacine()
  {
    icon_=AlmaResource.ALMA.getIcon("projet",16);

    noeuds_=new AlmaNoeud[9];
    noeuds_[0]=new AlmaNoeudTypeType
      (AlmaResource.ALMA.getString("Primitifs"), AglTypePrimitif.class);
    noeuds_[1]=new AlmaNoeudTypeType
      (AlmaResource.ALMA.getString("Alias"),     AglTypeAlias.class);
    noeuds_[2]=new AlmaNoeudTypeType
      (AlmaResource.ALMA.getString("Tableaux"),  AglTypeTableau.class);
    noeuds_[3]=new AlmaNoeudTypeType
      (AlmaResource.ALMA.getString("Classes"),   AglClasse.class);
    noeuds_[4]=new AlmaNoeudTypeType
      (AlmaResource.ALMA.getString("Structures"),AglStruct.class);
    noeuds_[5]=new AlmaNoeudPaquets();
    noeuds_[6]=new AlmaNoeudRelations();
    noeuds_[7]=new AlmaNoeudPatrons();
    noeuds_[8]=new AlmaNoeudUnites();
  }

  int     getChildCount ()           { return noeuds_.length; }
  boolean isLeaf        ()           { return false; }
  Object  getChild      (int _index) { return noeuds_[_index]; }

  int getIndexOfChild(Object _child)
  {
    int r=-1;
    for(int i=0;i<noeuds_.length;i++)
      if(noeuds_[i]==_child) r=i;
    return r;
  }

  public String toString() { return AlmaResource.ALMA.getString("Projet"); }
  public Object getValue() { return null; }
  public Icon   getIcon()  { return icon_; } 
}

class AlmaNoeudClasse extends AlmaNoeud
{
  Icon        icon_;
  AglClasse   classe_;
  AlmaNoeud[] noeuds_;

  AlmaNoeudClasse(AglClasse _classe)
  {
    if(!_classe.normale)
      icon_=AlmaResource.ALMA.getIcon("interface",16);
    else
    if(_classe.elementaire)
      icon_=AlmaResource.ALMA.getIcon("classe-elementaire",16);
    else
    if(_classe.visibilite.vabstract)
      icon_=AlmaResource.ALMA.getIcon("classe-abstraite",16);
    else
      icon_=AlmaResource.ALMA.getIcon("classe-normale",16);

    classe_=_classe;
    noeuds_=new AlmaNoeud[9];
    
    noeuds_[0]=new AlmaNoeudValeur   
      (AlmaResource.ALMA.getString("Visibilit"   ),classe_.visibilite,"visibilite");
    noeuds_[1]=new AlmaNoeudListeNoms
      (AlmaResource.ALMA.getString("Mres"        ),classe_.meres);
    noeuds_[2]=new AlmaNoeudListeNoms
      (AlmaResource.ALMA.getString("Interfaces"   ),classe_.interfaces);
    noeuds_[3]=new AlmaNoeudListeNoms
      (AlmaResource.ALMA.getString("Exceptions"   ),classe_.exceptions);
    noeuds_[4]=new AlmaNoeudTable
      (AlmaResource.ALMA.getString("Attributs"    ),classe_.attributs);
    noeuds_[5]=new AlmaNoeudTable
      (AlmaResource.ALMA.getString("Constructeurs"),classe_.constructeurs);
    noeuds_[6]=new AlmaNoeudTable
      (AlmaResource.ALMA.getString("Mthodes"     ),classe_.methodes);
    noeuds_[7]=new AlmaNoeudVecteur
      (AlmaResource.ALMA.getString("Commentaires" ),classe_.commentaires);
    noeuds_[8]=new AlmaNoeudVecteur
      (AlmaResource.ALMA.getString("Relations"    ),classe_.relations);
  }

  int     getChildCount ()           { return noeuds_.length; }
  boolean isLeaf        ()           { return classe_.elementaire; }
  Object  getChild      (int _index) { return noeuds_[_index]; }

  int getIndexOfChild(Object _child)
  {
    int r=-1;
    for(int i=0;i<noeuds_.length;i++)
      if(noeuds_[i]==_child) r=i;
    return r;
  }

  public String toString() { return classe_.nom.dernier(); }
  public Object getValue() { return classe_; }
  public Icon   getIcon()  { return icon_; } 
}

class AlmaNoeudStruct extends AlmaNoeud
{
  Icon        icon_;
  AglStruct   struct_;
  AlmaNoeud[] noeuds_;

  AlmaNoeudStruct(AglStruct _struct)
  {
    struct_=_struct;
    icon_  =AlmaResource.ALMA.getIcon("structure",16);
    noeuds_=new AlmaNoeud[3];

    noeuds_[0]=new AlmaNoeudTable
      (AlmaResource.ALMA.getString("Attributs"    ),struct_.attributs);
    noeuds_[1]=new AlmaNoeudVecteur
      (AlmaResource.ALMA.getString("Commentaires" ),struct_.commentaires);
    noeuds_[2]=new AlmaNoeudVecteur
      (AlmaResource.ALMA.getString("Relations"    ),struct_.relations);
  }

  int     getChildCount ()           { return noeuds_.length; }
  boolean isLeaf        ()           { return false; }
  Object  getChild      (int _index) { return noeuds_[_index]; }

  int getIndexOfChild(Object _child)
  {
    int r=-1;
    for(int i=0;i<noeuds_.length;i++)
      if(noeuds_[i]==_child) r=i;
    return r;
  }

  public String toString() { return struct_.nom.dernier(); }
  public Icon   getIcon()  { return icon_; } 
  public Object getValue() { return struct_; }
}

class AlmaNoeudAttribut extends AlmaNoeud
{
  Icon        icon_;
  AglAttribut attribut_;
  AlmaNoeud[] noeuds_;

  AlmaNoeudAttribut(AglAttribut _attribut)
  {
    if(_attribut.visibilite.vprivate)
      icon_=AlmaResource.ALMA.getIcon("attribut-prive",16);
    else
    if(_attribut.visibilite.vprotected)
      icon_=AlmaResource.ALMA.getIcon("attribut-protege",16);
    else
      icon_=AlmaResource.ALMA.getIcon("attribut",16);

    attribut_=_attribut;
    noeuds_=new AlmaNoeud[4];

    noeuds_[0]=new AlmaNoeudValeur
      (AlmaResource.ALMA.getString("Visibilit"  ),attribut_.visibilite,"visibilite");
    noeuds_[1]=new AlmaNoeudValeur
      (AlmaResource.ALMA.getString("Type"        ),attribut_.type      ,"type");
    noeuds_[2]=new AlmaNoeudValeur
      (AlmaResource.ALMA.getString("Initiale"    ),attribut_.initiale  ,"valeur-initiale");
    noeuds_[3]=new AlmaNoeudVecteur
      (AlmaResource.ALMA.getString("Commentaires"),attribut_.commentaires);
  }

  int     getChildCount ()           { return noeuds_.length; }
  boolean isLeaf        ()           { return false; }
  Object  getChild      (int _index) { return noeuds_[_index]; }

  int getIndexOfChild(Object _child)
  {
    int r=-1;
    for(int i=0;i<noeuds_.length;i++)
      if(noeuds_[i]==_child) r=i;
    return r;
  }

  public String toString() { return attribut_.nom; }
  public Object getValue() { return attribut_; }
  public Icon   getIcon()  { return icon_; } 
}

class AlmaNoeudParametre extends AlmaNoeud
{
  Icon         icon_;
  AglParametre parametre_;

  AlmaNoeudParametre(AglParametre _parametre)
  {
    icon_     =AlmaResource.ALMA.getIcon("valeur",16);
    parametre_=_parametre;
  }

  int     getChildCount  ()              { return 0; }
  boolean isLeaf         ()              { return true; }
  Object  getChild       (int _index)    { return null; }
  int     getIndexOfChild(Object _child) { return -1; }

  public String toString() { return parametre_.nom; }
  public Object getValue() { return parametre_; }
  public Icon   getIcon()  { return icon_; } 
}

class AlmaNoeudConstructeur extends AlmaNoeud
{
  Icon            icon_;
  AglConstructeur constructeur_;
  AlmaNoeud[]     noeuds_;

  AlmaNoeudConstructeur(AglConstructeur _constructeur)
  {
    if(_constructeur.visibilite.vprivate)
      icon_=AlmaResource.ALMA.getIcon("methode-prive",16);
    else
    if(_constructeur.visibilite.vprotected)
      icon_=AlmaResource.ALMA.getIcon("methode-protege",16);
    else
      icon_=AlmaResource.ALMA.getIcon("methode",16);

    constructeur_=_constructeur;
    noeuds_=new AlmaNoeud[5];

    noeuds_[0]=new AlmaNoeudValeur    
      (AlmaResource.ALMA.getString("Visibilit"  ),constructeur_.visibilite,"visibilite");
    noeuds_[1]=new AlmaNoeudVecteur    
      (AlmaResource.ALMA.getString("Paramtres"  ),constructeur_.parametres);
    noeuds_[2]=new AlmaNoeudListeNoms 
      (AlmaResource.ALMA.getString("Exceptions"  ),constructeur_.exceptions);
    noeuds_[3]=new AlmaNoeudValeur    
      (AlmaResource.ALMA.getString("Corps"       ),constructeur_.corps     ,"liste");
    noeuds_[4]=new AlmaNoeudVecteur
      (AlmaResource.ALMA.getString("Commentaires"),constructeur_.commentaires);
  }

  int     getChildCount ()           { return noeuds_.length; }
  boolean isLeaf        ()           { return false; }
  Object  getChild      (int _index) { return noeuds_[_index]; }

  int getIndexOfChild(Object _child)
  {
    int r=-1;
    for(int i=0;i<noeuds_.length;i++)
      if(noeuds_[i]==_child) r=i;
    return r;
  }

  public String toString() { return constructeur_.nom.dernier(); }
  public Object getValue() { return constructeur_; }
  public Icon   getIcon()  { return icon_; } 
}

class AlmaNoeudMethode extends AlmaNoeud
{
  Icon        icon_;
  AglMethode  methode_;
  AlmaNoeud[] noeuds_;

  AlmaNoeudMethode(AglMethode _methode)
  {
    if(_methode.visibilite.vprivate)
      icon_=AlmaResource.ALMA.getIcon("methode-prive",16);
    else
    if(_methode.visibilite.vprotected)
      icon_=AlmaResource.ALMA.getIcon("methode-protege",16);
    else
      icon_=AlmaResource.ALMA.getIcon("methode",16);

    methode_=_methode;
    noeuds_=new AlmaNoeud[8];

    noeuds_[0]=new AlmaNoeudValeur
      (AlmaResource.ALMA.getString("Visibilit"    ),methode_.visibilite,"visibilite");
    noeuds_[1]=new AlmaNoeudValeur
      (AlmaResource.ALMA.getString("Retour"        ),methode_.type      ,"type-retour");
    noeuds_[2]=new AlmaNoeudVecteur
      (AlmaResource.ALMA.getString("Paramtres"    ),methode_.parametres);
    noeuds_[3]=new AlmaNoeudListeNoms
      (AlmaResource.ALMA.getString("Exceptions"    ),methode_.exceptions);
    noeuds_[4]=new AlmaNoeudValeur
      (AlmaResource.ALMA.getString("Corps"         ),methode_.corps     ,"liste");
    noeuds_[5]=new AlmaNoeudVecteur
      (AlmaResource.ALMA.getString("Commentaires"  ),methode_.commentaires);
    noeuds_[6]=new AlmaNoeudVecteur
      (AlmaResource.ALMA.getString("Prconditions" ),methode_.preconditions);
    noeuds_[7]=new AlmaNoeudVecteur
      (AlmaResource.ALMA.getString("Postconditions"),methode_.postconditions);
  }

  int     getChildCount ()           { return noeuds_.length; }
  boolean isLeaf        ()           { return false; }
  Object  getChild      (int _index) { return noeuds_[_index]; }

  int getIndexOfChild(Object _child)
  {
    int r=-1;
    for(int i=0;i<noeuds_.length;i++)
      if(noeuds_[i]==_child) r=i;
    return r;
  }

  public String toString() { return methode_.nom; }
  public Object getValue() { return methode_; }
  public Icon   getIcon()  { return icon_; } 
}

class AlmaNoeudValeur extends AlmaNoeud
{
  Icon   icon_;
  String titre_;
  Object valeur_;

  AlmaNoeudValeur(String _titre, Object _valeur)
  { this(_titre,_valeur,null); }

  AlmaNoeudValeur(String _titre, Object _valeur, String _icon)
  {
    if(_icon!=null) icon_=AlmaResource.ALMA.getIcon(_icon,16);
    titre_ =_titre;
    valeur_=_valeur;
  }

  int     getChildCount  ()              { return 0; }
  boolean isLeaf         ()              { return true; }
  Object  getChild       (int _index)    { return null; }
  int     getIndexOfChild(Object _child) { return -1; }

  public String toString() { return titre_; }
  public Object getValue() { return valeur_; }
  public Icon   getIcon()  { return icon_; } 
}

class AlmaNoeudNom extends AlmaNoeud
{
  Icon   icon_;
  AglNom nom_;

  AlmaNoeudNom(AglNom _nom)
  {
    icon_=AlmaResource.ALMA.getIcon("valeur",16);
    nom_ =_nom;
  }

  int     getChildCount  ()              { return 0; }
  boolean isLeaf         ()              { return true; }
  Object  getChild       (int _index)    { return null; }
  int     getIndexOfChild(Object _child) { return -1; }

  public String toString() { return nom_.dernier(); }
  public Object getValue() { return AglType.cherche(nom_); }
  public Icon   getIcon()  { return icon_; } 
}

class AlmaNoeudListeNoms extends AlmaNoeud
{
  Icon         icon_;
  String       titre_;
  AglListeNoms liste_;

  AlmaNoeudListeNoms(String _titre, AglListeNoms _liste)
  {
    icon_ =AlmaResource.ALMA.getIcon("liste",16);
    titre_=_titre;
    liste_=_liste;
  }

  int     getChildCount ()           { return liste_.noms.size(); }
  boolean isLeaf        ()           { return (liste_.noms.size()==0); }

  Object  getChild (int _index)
    { return new AlmaNoeudNom((AglNom)liste_.noms.elementAt(_index)); }

  int getIndexOfChild(Object _child)
  {
    int r=-1;
    for(int i=0;i<liste_.noms.size();i++)
      if(liste_.noms.elementAt(i)==_child) r=i;
    return r;
  }

  public String toString() { return titre_+" ["+liste_.noms.size()+"]"; }
  public Object getValue() { return liste_; }
  public Icon   getIcon()  { return icon_; } 
}

class AlmaNoeudVecteur extends AlmaNoeud
{
  Icon       icon_;
  String     titre_;
  AglVecteur liste_;

  AlmaNoeudVecteur(String _titre, AglVecteur _liste)
  {
    icon_ =AlmaResource.ALMA.getIcon("liste",16);
    titre_=_titre;
    liste_=_liste;
  }

  int getChildCount()
  {
    return (liste_==null ? 0 : liste_.size());
  }

  boolean isLeaf()
  {
    return (liste_==null ? true : liste_.size()==0);
  }

  Object  getChild (int _index)
  {
    if(liste_==null) return null;

    Object r=liste_.elementAt(_index);

    if(r instanceof AglAttribut)
      r=new AlmaNoeudAttribut((AglAttribut)r);
    else if(r instanceof AglConstructeur)
      r=new AlmaNoeudConstructeur((AglConstructeur)r);
    else if(r instanceof AglMethode)
      r=new AlmaNoeudMethode((AglMethode)r);
    else if(r instanceof AglParametre)
      r=new AlmaNoeudParametre((AglParametre)r);
    else if(r instanceof AglCondition)
      r=new AlmaNoeudCondition((AglCondition)r);
    else if(r instanceof AglRelation)
      r=new AlmaNoeudRelation((AglRelation)r,false);
    else if(r instanceof AglCommentaireSimple)
      r=new AlmaNoeudCommentaireSimple((AglCommentaireSimple) r);
    else if(r instanceof AglCommentaireMulti)
      r=new AlmaNoeudCommentaireMulti((AglCommentaireMulti)r);

    return r;
  }

  int getIndexOfChild(Object _child)
  {
    int r=-1;
    if(liste_!=null)
      for(int i=0;i<liste_.size();i++)
        if(liste_.elementAt(i)==_child) r=i;
    return r;
  }

  public String toString() { return titre_+" ["+getChildCount()+"]"; }
  public Object getValue() { return liste_; }
  public Icon   getIcon()  { return icon_; } 
}

class AlmaNoeudTable extends AlmaNoeud
{
  Icon             icon_;
  String           titre_;
  AglTableOrdonnee liste_;

  AlmaNoeudTable(String _titre, AglTableOrdonnee _liste)
  {
    icon_ =AlmaResource.ALMA.getIcon("liste",16);
    titre_=_titre;
    liste_=_liste;
  }

  int     getChildCount ()           { return liste_.size(); }
  boolean isLeaf        ()           { return (liste_.size()==0); }

  Object  getChild (int _index)
  {
    Object r=liste_.at(_index);

    if(r instanceof AglAttribut)
      r=new AlmaNoeudAttribut((AglAttribut)r);
    else if(r instanceof AglConstructeur)
      r=new AlmaNoeudConstructeur((AglConstructeur)r);
    else if(r instanceof AglMethode)
      r=new AlmaNoeudMethode((AglMethode)r);
    else if(r instanceof AglParametre)
      r=new AlmaNoeudParametre((AglParametre)r);
    else if(r instanceof AglCondition)
      r=new AlmaNoeudCondition((AglCondition)r);
    else if(r instanceof AglRelation)
      r=new AlmaNoeudRelation((AglRelation)r,false);
    else if(r instanceof AglCommentaireSimple)
      r=new AlmaNoeudCommentaireSimple((AglCommentaireSimple) r);
    else if(r instanceof AglCommentaireMulti)
      r=new AlmaNoeudCommentaireMulti((AglCommentaireMulti)r);

    return r;
  }

  int getIndexOfChild(Object _child)
  {
    int r=-1;
    for(int i=0;i<liste_.size();i++)
      if(liste_.at(i)==_child) r=i;
    return r;
  }

  public String toString() { return titre_+" ["+liste_.size()+"]"; }
  public Object getValue() { return liste_; }
  public Icon   getIcon()  { return icon_; } 
}

class AlmaArbreModel
      implements TreeModel
{
  Vector          listeners_;
  AlmaNoeudRacine racine_;

  public AlmaArbreModel()
  {
    racine_=new AlmaNoeudRacine();
    listeners_=new Vector();
  }

  public int getChildCount(Object _parent)
  {
    int r=0;
    if(_parent instanceof AlmaNoeud)
      r=((AlmaNoeud)_parent).getChildCount();
    return r;
  }

  public Object getChild(Object _parent, int _index)
  {
    Object r=null;
    if(_parent instanceof AlmaNoeud)
      r=((AlmaNoeud)_parent).getChild(_index);
    return r;
  }

  public int getIndexOfChild(Object _parent, Object _child)
  {
    int r=-1;
    if(_parent instanceof AlmaNoeud)
      r=((AlmaNoeud)_parent).getIndexOfChild(_child);
    return r;
  }

  public boolean isLeaf(Object _node)
  {
    boolean r=true;
    if(_node instanceof AlmaNoeud)
      r=((AlmaNoeud)_node).isLeaf();
    return r;
  }

  public Object getRoot()
  { return racine_; }

  public void addTreeModelListener(TreeModelListener _l)
  { listeners_.addElement(_l); }

  public void removeTreeModelListener(TreeModelListener _l)
  { listeners_.removeElement(_l); }

  public void valueForPathChanged(TreePath _path, Object _newValue)
  {
  }
}

class AlmaArbreCellRenderer
    extends BuAbstractCellRenderer
{
  public AlmaArbreCellRenderer()
  {
    super(BuAbstractCellRenderer.TREE);
  }

  public Component getTreeCellRendererComponent
    (JTree   tree,
     Object  value,
     boolean selected,
     boolean expanded,
     boolean leaf,
     int     row,
     boolean focus)
  {
    BuLabel r=(BuLabel)super.getTreeCellRendererComponent
	(tree,value,selected,expanded,leaf,row,focus);

    if(value instanceof AlmaNoeud)
    {
      AlmaNoeud noeud=(AlmaNoeud)value;
      r.setText(noeud.getTitle());
      r.setIcon(noeud.getIcon());
    }

    return r;
  }
}
