/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AlmaCodeUmlHierarchieFrame.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.alma;
import com.memoire.agl.*;
import com.memoire.alma.*;
import com.memoire.bu.*;

import java.util.*;
import java.awt.*;
import java.awt.image.*;
import java.io.*;

import javax.swing.*;
import javax.swing.border.*;

public class AlmaCodeUmlHierarchieFrame
       extends BuInternalFrame
       implements BuPrintable
{
  AglCodeUmlHierarchie       a;
  AglCodeUmlHierarchieCanvas c;

  private JComponent    content;
  private BorderLayout  layout;
  private JScrollPane   spGraphe;

  private String        fichier_;

  public AlmaCodeUmlHierarchieFrame(AglCodeUmlHierarchie _a)
  {
    super("",true,true,true,true);
    a=_a;

    content=(JComponent)getContentPane();
    layout=new BorderLayout();
    content.setLayout(layout);
    content.setBorder(new EmptyBorder(0,0,0,0));

    c=new AglCodeUmlHierarchieCanvas(a);
    c.setBorder(new EmptyBorder(0,0,0,0));

    spGraphe=new JScrollPane(c);
    content.add("Center",spGraphe);

    fichier_=AglOptions.module;
    if(fichier_.equals("")) fichier_=a.projet.nom;
    setTitle(fichier_+" ["
	     +AlmaResource.ALMA.getString("Gnr")
	     +"/"+a.langage()+"]");
    fichier_="_H_"+fichier_;

    setFrameIcon(BuResource.BU.getIcon("graphe"));
    setLocation(60,30);

    Dimension ps=new Dimension(300,300);
    setSize(ps);
    setPreferredSize(ps);
  }

  public String getFichier()
    { return fichier_; }

  public Image getImage()
    { return c.getImage(); }

  // BuInternalFrame

  public String[] getEnabledActions()
  {
    String[] r=new String[]
      {
	"ENREGISTRER",
	"ENREGISTRERSOUS",
	"IMPRIMER",
	"PREVISUALISER",
      };
    return r;
  }

  // BuPrintable

  public void print(PrintJob _job, Graphics _g)
  {
    BuPrinter.INFO_DOC     =new BuInformationsDocument();
    BuPrinter.INFO_DOC.name=getTitle();
    BuPrinter.INFO_DOC.logo=BuResource.BU.getIcon("graphe",24);

    BuPrinter.printComponent(_job,_g,c);
    // BuPrinter.printImage(_job,_g,getImage());
  }
}

