/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AlmaDjaMessage.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.alma;
import com.memoire.agl.*;
import com.memoire.alma.*;
import com.memoire.dja.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.border.*;

public class AlmaDjaMessage
       extends DjaBrokenArrow
       implements AlmaDjaValeur
{
  private transient AglMethode methode_;

  public AlmaDjaMessage()
  {
    this(null);
  }

  public AlmaDjaMessage(AglMethode _methode)
  {
    super(null);
    methode_=_methode;

    String s="";
    if(methode_!=null) s=methode_.nom;

    addText(s);
    putProperty("methode",s);

    setEndType(17);
    //ajusteTerminaisons();
  }

  public void beforeSaving()
  {
    if(methode_!=null)
    {
      putProperty("methode",methode_.nom);
    }
  }

  public AglMethode getMethode()
  { return methode_; }

  public AglObjet getObjet()
  { return methode_; }
}




