/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AlmaDjaRelationBiOrientee.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.alma;
import com.memoire.agl.*;
import com.memoire.alma.*;
import com.memoire.dja.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.border.*;

public class AlmaDjaRelationBiOrientee
       extends DjaBrokenArrow
       implements AlmaDjaValeur
{
  private transient AglRelationBiOrientee relation_;

  public AlmaDjaRelationBiOrientee()
  {
    this(null);
  }

  public AlmaDjaRelationBiOrientee(AglRelationBiOrientee _relation)
  {
    super();
    relation_=_relation;

    if(relation_!=null)
      setText(relation_.verbe,0);
    else
    {
      putProperty("relation"        ,"");
      putProperty("cardinaliteDebut","");
      putProperty("cardinaliteFin"  ,"");
      putProperty("roleDebut"       ,"");
      putProperty("roleFin"         ,"");
    }

    ajusteTerminaisons();
  }

  public void beforeSaving()
  {
    if(relation_!=null)
    {
      putProperty("relation"        ,relation_.getIntituleLong());
      putProperty("cardinaliteDebut",relation_.cardinaliteDebut);
      putProperty("cardinaliteFin"  ,relation_.cardinaliteFin);
      putProperty("roleDebut"       ,relation_.roleDebut);
      putProperty("roleFin"         ,relation_.roleFin);
    }
  }

  public AglRelationBiOrientee getRelation()
  { return relation_; }

  public AglObjet getObjet()
  { return relation_; }

  public String getCardinaliteDebut()
  {
    return relation_!=null
	   ? relation_.cardinaliteDebut
           : getProperty("cardinaliteDebut");
  }

  public String getCardinaliteFin()
  {
    return relation_!=null
	   ? relation_.cardinaliteFin
           : getProperty("cardinaliteFin");
  }

  public String getRoleDebut()
  {
    return relation_!=null
	   ? relation_.roleDebut
           : getProperty("roleDebut");
  }

  public String getRoleFin()
  {
    return relation_!=null
	   ? relation_.roleFin
           : getProperty("roleFin");
  }

  private void ajusteTerminaisons()
  {
    int tb=0;
    int te=0;

    String tx=getText(0);
    if(tx!=null)
    {
      if(tx.equals("hrite de"       )) te=6;
      if(tx.equals("est hrit par"  )) tb=3;
      if(tx.equals("implante"        )) te=6;
      if(tx.equals("est implant par")) tb=3;
      if(tx.equals("contient"        )) te=9;
      if(tx.equals("est contenu par" )) tb=9;
      if(tx.equals("utilise"         )) te=15;
      if(tx.equals("est utilis par" )) tb=15;
    }

    setBeginType(tb);
    setEndType(te);
  }

  public void paintObject(Graphics _g)
  {
    super.paintObject(_g);

    Font ft=getFont();
    _g.setFont(ft);
    _g.setColor(getColor());

    FontMetrics fm=_g.getFontMetrics(ft);
    int hs=ft.getSize();
    int ws;

    _g.drawString(getRoleDebut()       ,xbegin_+14,ybegin_-3);
    _g.drawString(getCardinaliteDebut(),xbegin_+14,ybegin_+hs-1);

    ws=fm.stringWidth(getRoleFin());
    _g.drawString(getRoleFin(),xend_-14-ws,yend_-3);
    ws=fm.stringWidth(getCardinaliteFin());
    _g.drawString(getCardinaliteFin(),xend_-14-ws,yend_+hs-1);
  }
}




