/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AlmaDnd.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.alma;
import com.memoire.agl.*;
import com.memoire.alma.*;
import com.memoire.bu.*;
import com.memoire.dnd.*;

import javax.swing.*;

public class AlmaDnd
{
  public final static DndSource SOURCE=
    new DndSource(new AlmaDndRequest());

  public final static DndTarget TARGET=
    new DndTarget()
       .accept(AglType.class,
	       DndTransferObject.SINGLETON,
	       AlmaDndManager.SINGLETON)
       .accept(AglPaquet.class,
	       DndTransferObject.SINGLETON,
	       AlmaDndManager.SINGLETON)
       .accept(AglMethode.class,
	       DndTransferObject.SINGLETON,
	       AlmaDndManager.SINGLETON)
       .accept(AglCommentaire.class,
	       DndTransferObject.SINGLETON,
	       AlmaDndManager.SINGLETON)
       .accept(AglNom.class,
	       DndTransferObject.SINGLETON,
	       AlmaDndManager.SINGLETON)
       .accept(String.class,
	       DndTransferString.SINGLETON,
	       AlmaDndManager.SINGLETON);
       
  public final static void installIcons()
  {
    DndIcons.setNoDropIcon (BuResource.BU.getIcon
			    (DndIcons.class.getResource("dnd-nodrop_24.gif" )));
    DndIcons.setCanDropIcon(BuResource.BU.getIcon
			    (DndIcons.class.getResource("dnd-candrop_24.gif")));
    DndIcons.setDefaultIcon(BuResource.BU.getIcon
			    (DndIcons.class.getResource("dnd-default_24.gif")));
    
    DndIcons.put(AglType.class        ,AlmaResource.ALMA.getIcon("type"          ,16));
    DndIcons.put(AglTypeAlias.class   ,AlmaResource.ALMA.getIcon("type-alias"    ,16));
    DndIcons.put(AglTypePrimitif.class,AlmaResource.ALMA.getIcon("type-primitif" ,16));
    DndIcons.put(AglTypeTableau.class ,AlmaResource.ALMA.getIcon("type-tableau"  ,16));
    DndIcons.put(AglCommentaire.class ,AlmaResource.ALMA.getIcon("commentaire"   ,16));
    DndIcons.put(AglClasse.class      ,AlmaResource.ALMA.getIcon("classe"        ,16));
    DndIcons.put(AglStruct.class      ,AlmaResource.ALMA.getIcon("structure"     ,16));
    DndIcons.put(AglPaquet.class      ,AlmaResource.ALMA.getIcon("paquet"        ,16));
    DndIcons.put(AglAttribut.class    ,AlmaResource.ALMA.getIcon("attribut"      ,16));
    DndIcons.put(AglMethode.class     ,AlmaResource.ALMA.getIcon("methode"       ,16));
    DndIcons.put(AglParametre.class   ,AlmaResource.ALMA.getIcon("parametre"     ,16));
    DndIcons.put(AglVisibilite.class  ,AlmaResource.ALMA.getIcon("visibilite"    ,16));
    DndIcons.setDefaultIcon(AlmaResource.ALMA.getIcon("valeur",16));
  }
}
