/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AlmaDndManager.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.alma;
import com.memoire.agl.*;
import com.memoire.alma.*;
import com.memoire.dja.*;
import com.memoire.dnd.*;

import java.awt.*;
import java.io.*;
import javax.swing.*;
import javax.swing.text.*;

public class AlmaDndManager
    implements DndManageData
{
    public final static AlmaDndManager SINGLETON=
	new AlmaDndManager();

    public boolean manage
	(Object _data,JComponent _comp,Point _location)
    {
	boolean r=true;

	if(_data.getClass().isArray())
	{
	    Object[] a=(Object[])_data;
	    for(int i=0;i<a.length;i++)
		r&=manage1(a[i],_comp,_location);
	}
	else r=manage1(_data,_comp,_location);

	if(_comp instanceof DjaGrid)
	{
	  //((DjaGrid)_comp).recenter();
	  ((DjaGrid)_comp).revalidate();
	  ((DjaGrid)_comp).repaint();
	}

	return r;
    }

    private boolean manage1
	(Object _data,JComponent _comp,Point _location)
    {
	System.err.println("Manage1:Objet="+_data);
	boolean r=false;

	if(!_comp.isEnabled())
	    ;
	else
	if(_comp instanceof JComboBox)
	{
	    JComboBox c=(JComboBox)_comp;
	    Object    o=null;

	    if(_data instanceof AglPaquet)
	    {
		if(c.getModel() instanceof AlmaPaquetsModel)
		    o=((AglPaquet)_data).nom.formeJava();
	    }
	    else
	    if(_data instanceof AglType)
	    {
		if(c.getModel() instanceof AlmaTypesModel)
		    o=((AglType)_data).nom.dernier();
		else
		if(c.getModel() instanceof AlmaPaquetsModel)
		    o=((AglType)_data).nom.parent().formeJava();
		else
		    o=((AglType)_data).nom.dernier();
	    }
	    else
	    if(_data instanceof AglNom)
	    {
		if(c.getModel() instanceof AlmaTypesModel)
		    o=((AglNom)_data).dernier();
		else
		if(c.getModel() instanceof AlmaPaquetsModel)
		    o=((AglNom)_data).parent().formeJava();
		else
		    o=((AglNom)_data).dernier();
	    }
	    else
	    if(_data instanceof String)
		o=_data;

	    if(o!=null)
	    {
		c.setSelectedItem(o);
		r=true;
	    }
	}
	else
	if(_comp instanceof JTextComponent)
	{
	    String o=null;

	    if(_data instanceof AglObjet)
		o=AglOptions.code().code(_data);
	    else
		o=_data.toString();

	    if(_comp instanceof JTextField)
		r=DndManageText.SINGLETON_REPLACE_ALL.manage
		    (o,_comp,_location);
	    else
		r=DndManageText.SINGLETON_INSERT_AT_CURSOR.manage
		    (o,_comp,_location);
	}
	else
	if(_comp instanceof DjaGrid)
	{
	    DjaGrid grid=(DjaGrid)_comp;
	    if(grid.isInteractive())
	    {
	      DjaObject o=null;

	      if(_data instanceof AglObjet)
		o=AlmaDjaRelations.dejaPresent(grid,(AglObjet)_data);

	      if(o!=null)
	      {
		((DjaGridInteractive)grid).setSelection(o);
	        r=true;
	      }
	      else
	      {
		if(_data instanceof AglPaquet)
		  o=new AlmaDjaPaquet((AglPaquet)_data);
	        else
	        if(_data instanceof AglClasse)
		  o=new AlmaDjaClasse((AglClasse)_data);
	        else
	        if(_data instanceof AglStruct)
		  o=new AlmaDjaStruct((AglStruct)_data);
		else
		if(_data instanceof AglMethode)
		  o=new AlmaDjaMessage((AglMethode)_data);
		else
		if(_data instanceof AglCommentaire)
		  o=new AlmaDjaCommentaire((AglCommentaire)_data);
		else
	        if(_data instanceof AglType)
		  o=new DjaBox(((AglType)_data).nom.dernier());
	        else
	        if(_data instanceof String)
		  o=new AlmaDjaNote((String)_data);

		if(o!=null)
		{
		  grid.add(o);
		  // System.err.println("-- XY="+_location.x+","+_location.y);
		  o.setX(_location.x);
		  o.setY(_location.y);
		  grid.avoidOverlap(o);
		  AlmaDjaRelations.creeTout(grid,o);
		  //grid.recenter();
		  //grid.repaint();

		  /*
		    if(o.getX()==_location.x)
		    _location.x+=o.getWidth()+DjaOptions.deltaX;
		  */

		  r=true;
		}
	      }	      
	    }
	}
	/*
	else
	if(_comp instanceof JDesktopPane)
	{
	    AlmaImplementation imp=(AlmaImplementation)AglOptions.application;
	    AglProjet projet=new AglProjet();
	    if(_data instanceof AglType)
		projet.nom=((AglType)_data).nom.dernier()+
		    "."+AglOptions.code.extension();
	    String source;
	    if(_data instanceof String) source=(String)_data;
	    else                        source=AglOptions.code().code(_data);
	    imp.ajouteFenetre(new AlmaFilleCible(imp,projet,source));
	}
	*/

	return r;
    }

    /*
    public void dragOver(DropTargetDragEvent _evt)
    {
	System.err.println("[AlmaDndTarget] dragOver");
	System.err.println("EVT="+_evt);
        super.dragOver(_evt);
    }

    public static void setOn(JComponent _comp)
    {
	new AlmaDndTarget(_comp);
    }
    */
}


