/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AlmaDndRequest.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.alma;
import com.memoire.agl.*;
import com.memoire.alma.*;
import com.memoire.dnd.*;

import java.awt.*;
import java.util.*;
import javax.swing.*;
import javax.swing.tree.*;

public class AlmaDndRequest
    // extends DndRequestItem
    implements DndRequestData
{
    public Object[] request(JComponent _component,Point _location)
    {
	Object[] v;// super.request(_component,_location);

	//if(_component instanceof JTree)
	{
	    v=DndRequestSelection.SINGLETON.request(_component,_location);
	    if(v.length>0)
	    {
		v=(Object[])v[0];
		int l=v.length;
		if(l==1)
		{
		    v=translate(v[0]);
		}
		else
		{
		    AglObjet[] t=new AglObjet[l];
		    AglNom  [] n=new AglNom  [l];
		    String  [] s=new String  [l];

		    for(int i=0;i<l;i++)
		    {
			Object[] o=translate(v[i]);
			t[i]=(AglObjet)o[0];
			n[i]=(AglNom)  o[1];
			s[i]=(String)  o[2];
		    }

		    v=new Object[] { t,n,s };
		}
	    }
	}
	/*
	else
	{
	    v=DndRequestItem.SINGLETON.request(_component,_location);
	    if(v.length>0) v=translate(v[0]);
	}
	*/

	return v;
    }

    private Object[] translate(Object o)
    {
	if(o instanceof AlmaNoeud)
	    o=((AlmaNoeud)o).getValue();

	AglObjet t=null; 
	AglNom   n=null;
	String   s=null;

	if(o instanceof String)
	{
	    s=(String)o;
	    t=AglType.cherche(s);
	    if(t!=null)
		n=((AglType)t).nom;
	    else
	    {
		t=AglPaquet.cherche(s);
		if(t!=null)
		    n=((AglPaquet)t).nom;
	    }
	}
	else
	if(o instanceof AglType)
	{
	    t=(AglType)o;
	    n=((AglType)t).nom;
	    s=n.dernier();
	}
	else
	if(o instanceof AglPaquet)
	{
	    t=(AglPaquet)o;
	    n=((AglPaquet)t).nom;
	    s=n.formeJava();
	}
	else
	if(o instanceof AglNom)
	{
	    n=(AglNom)o;
	    t=AglType.cherche(n);
	    s=n.dernier();
	}
	else
	if(o instanceof AglAttribut)
	{
	    t=(AglAttribut)o;
	    s=((AglAttribut)t).nom;
	}
	else
	if(o instanceof AglConstructeur)
	{
	    t=(AglConstructeur)o;
	    n=((AglConstructeur)t).nom;
	    s=n.dernier();
	}
	else
	if(o instanceof AglMethode)
	{
	    t=(AglMethode)o;
	    s=((AglMethode)t).nom;
	}
	else
	if(o instanceof AglObjet)
	{
	    t=(AglObjet)o;
	}

	return new Object[] { t,n,s };
    }
}
