/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AlmaEditeur.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.alma;
import com.memoire.alma.*;
import com.memoire.bu.*;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;

public abstract class AlmaEditeur
       extends BuPalette // JDialog TMP ?
       implements ActionListener
{
  protected AlmaImplementation app_;
  protected JComponent         content_;

  private JComponent pnMain;
  private JPanel     pnButtons;
  private BuButton   btValider_, btAnnuler_;
  //private int        reponse_;
  private Object     objet_;

  public AlmaEditeur(AlmaImplementation _app, Object _objet)
  {
    // super("",true,true,false,true);
    super();
    app_    =_app;
    objet_  =_objet;
    //reponse_=JOptionPane.CANCEL_OPTION;

    pnMain=getComponent();

    // Panneau de validation
    pnButtons=new JPanel();
    pnButtons.setLayout(new FlowLayout(FlowLayout.RIGHT));

    btAnnuler_=new BuButton(BuResource.BU.getString("Annuler"));
    btAnnuler_.setIcon(BuResource.BU.getIcon("annuler"));
    btAnnuler_.setName("btANNULER");
    btAnnuler_.setActionCommand("ANNULER");
    btAnnuler_.addActionListener(this);
    pnButtons.add(btAnnuler_);

    btValider_=new BuButton(BuResource.BU.getString("Valider"));
    btValider_.setIcon(BuResource.BU.getIcon("valider"));
    btValider_.setName("btVALIDER");
    btValider_.setActionCommand("VALIDER");
    btValider_.addActionListener(this);
    getRootPane().setDefaultButton(btValider_);
    pnButtons.add(btValider_);
    
    JComponent content=(JComponent)getContentPane();
    content.setLayout(new BuBorderLayout());
    content.add(pnMain   ,BuBorderLayout.CENTER);
    content.add(pnButtons,BuBorderLayout.SOUTH);

    //setModal(true);
    setTitle(getTitle());
    setFrameIcon(getIcon());
    pack();
    setLocation(250,140);
  }

  public void actionPerformed(ActionEvent _evt)
  {
    JComponent source=(JComponent)_evt.getSource();
    // System.err.println("ACTION ON "+source.getName());

    if(source==btValider_)
    {
      setClosed(true);
      //setVisible(false);
      //reponse_=JOptionPane.OK_OPTION;
      valider();
    }

    if(source==btAnnuler_)
    {
      setClosed(true);
      //setVisible(false);
      //reponse_=JOptionPane.CANCEL_OPTION;
      annuler();
    }
  }

  public final void setClosed(boolean _closed)
  {
    try { super.setClosed(_closed); }
    catch(PropertyVetoException ex) { }
    if(isClosed()&&(getParent()!=null))
      app_.removeInternalFrame(this);
  }

  public final Object getObjet() { return objet_; }
  public abstract JComponent getComponent();
  public String getTitle() { return BuResource.BU.getString("Edition"); }
  public Icon   getIcon() { return null; }

  public abstract void valider();
  public void annuler() { }

  public final void /*int*/ activate()
  {
    /*
    Dimension d=getPreferredSize();
    Dimension ecran=getToolkit().getScreenSize();

    setLocation((ecran.width-d.width)/2,(ecran.height-d.height)/2);
    show();
    return reponse_;
    */

    app_.addInternalFrame(this);
    // return reponse_;
  }
}
