/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AlmaEditeurCondition.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.alma;
import com.memoire.agl.*;
import com.memoire.alma.*;
import com.memoire.bu.*;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.io.*;
import java.util.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;

public class AlmaEditeurCondition
       extends AlmaEditeur
{
  JComboBox  cbt;
  JTextField tfe;

  public AlmaEditeurCondition(AlmaImplementation _app, AglCondition _condition)
  {
    super(_app,_condition);
  }

  public JComponent getComponent()
  {
    AglCondition condition=(AglCondition)getObjet();

    JPanel pnMain=new JPanel();
    BuGridLayout loMain=new BuGridLayout();
    loMain.setColumns(1);
    loMain.setHgap(5);
    loMain.setVgap(5);
    pnMain.setLayout(loMain);
    pnMain.setBorder(new EmptyBorder(5,5,5,5));
    
    int n=0;

    BuLabel lbt=new BuLabel(AlmaResource.ALMA.getString
			    ("Type:"),BuLabel.LEFT);
    cbt=new JComboBox();
    cbt.addItem("invariant");
    cbt.addItem("precondition");
    cbt.addItem("postcondition");
    cbt.addItem("undefined condition");
    pnMain.add(lbt,n++);
    pnMain.add(cbt,n++);

    BuLabel lbe=new BuLabel(AlmaResource.ALMA.getString
			    ("Expression:"),BuLabel.LEFT);
    tfe=new JTextField(20);
    pnMain.add(lbe,n++);
    pnMain.add(tfe,n++);

         if((condition.pre)&&(condition.post)) cbt.setSelectedIndex(0);
    else if(condition.pre)                     cbt.setSelectedIndex(1);
    else if(condition.post)                    cbt.setSelectedIndex(2);
    else                                       cbt.setSelectedIndex(3);

    tfe.setText(condition.test.toString()); // AglCode.language("Java").code(...)

    boolean e=(cbt.getSelectedIndex()==3);
    cbt.setEnabled(e);
    tfe.setEnabled(e);

    return pnMain;
  }

  public String getTitle()
  {
    return super.getTitle()+": "+AlmaResource.ALMA.getString("Condition");
  }

  public Icon getIcon()
  {
    return AlmaResource.ALMA.getIcon("condition");
  }

  public void valider()
  {
    AglCondition condition=(AglCondition)getObjet();
    switch(cbt.getSelectedIndex())
    {
    case  0: condition.pre=true;  condition.post=true;  break;
    case  1: condition.pre=true;  condition.post=false; break;
    case  2: condition.pre=false; condition.post=true;  break;
    default: condition.pre=false; condition.post=false; break;
    }
    condition.test=new AglExpressionGenerique(tfe.getText());
  }
}
