/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AlmaEditeurPatron.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.alma;
import com.memoire.agl.*;
import com.memoire.alma.*;
import com.memoire.bu.*;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;

public class AlmaEditeurPatron
       extends AlmaEditeur
{
  // JTextField[] tf;
  private JComboBox[] ch;

  public AlmaEditeurPatron(AlmaImplementation _app, AglPatron _patron)
  {
    super(_app,_patron);
  }

  public JComponent getComponent()
  {
    AglPatron patron=(AglPatron)getObjet();

    JPanel pnMain=new JPanel();
    BuGridLayout loMain=new BuGridLayout();
    loMain.setColumns(2);
    loMain.setHgap(5);
    loMain.setVgap(5);
    pnMain.setLayout(loMain);
    pnMain.setBorder(new EmptyBorder(5,5,5,5));
    
    int n=0;

    BuLabel lbn=new BuLabel(AlmaResource.ALMA.getString
			    ("Nom:"),BuLabel.RIGHT);
    JTextField tfn=new JTextField(patron.nom,20);
    tfn.setEditable(false);
    pnMain.add(lbn,n++);
    pnMain.add(tfn,n++);

    BuLabel lbt=new BuLabel(AlmaResource.ALMA.getString
			    ("Type:"),BuLabel.RIGHT);
    JTextField tft=new JTextField(patron.type.nom,20);
    tft.setEditable(false);
    pnMain.add(lbt,n++);
    pnMain.add(tft,n++);

    String[] roles=patron.type.roles;
    // tf=new JTextField[roles.length];
    ch=new JComboBox[roles.length];

    for(int i=0;i<roles.length;i++)
    {
      BuLabel lb1=new BuLabel(roles[i]+":",BuLabel.RIGHT);
      pnMain.add(lb1,n++);

      AlmaTypesModel m;
      if(roles[i].endsWith("Interface"))
	m=new AlmaTypesModel(false,false,true,false);
      else
      if(roles[i].startsWith("abstract"))
	m=new AlmaTypesModel(false,true,true,false);
      else
      if(  roles[i].startsWith("concrete")
	 ||(roles[i].indexOf("Concrete")>=0))
	m=new AlmaTypesModel(false,true,false,false);
      else
	m=new AlmaTypesModel(false,true,true,true);

      String s=(String)patron.roles.get(roles[i]);
      /*
	tf[i]=new JTextField();
	pnMain.add(tf[i],n++);
	if(s!=null) tf[i].setText(s);
      */
      ch[i]=new JComboBox();
      ch[i].setModel(m);
      ch[i].setEditable(true);
      ch[i].setSelectedItem(s);
      ch[i].setName("chROLE"+i);
      ch[i].setActionCommand("ROLE("+i+")");
      ch[i].setMaximumRowCount(5);
      pnMain.add(ch[i],n++);
      // ch[i].addActionListener(this);
      // ch[i].addFocusListener(this);
      AlmaDnd.TARGET.add(ch[i]);
    }

    return pnMain;
  }

  public String getTitle()
  {
    return super.getTitle()+": "+AlmaResource.ALMA.getString("Patron");
  }

  public Icon getIcon()
  {
    return AlmaResource.ALMA.getIcon("patron");
  }

  // for DnD
  public JComboBox[] getComboBoxes()
  {
      return ch;
  }

  public void valider()
  {
    AglPatron patron=(AglPatron)getObjet();

    String[] roles=patron.type.roles;
    for(int i=0;i<roles.length;i++)
    {
      // String s=tf[i].getText();
      String s=(String)ch[i].getSelectedItem();
      if((s==null)||(s.equals("")))
	patron.roles.remove(roles[i]);
      else
	patron.roles.put(roles[i],s);
    }
  }
}
