/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AlmaFilleDiagramme.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.alma;
import com.memoire.agl.*;
import com.memoire.alma.*;
import com.memoire.bu.*;
import com.memoire.dja.*;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.beans.*;
import java.util.*;

import javax.swing.*;
import javax.swing.border.*;

public class AlmaFilleDiagramme
       extends DjaFrame
{
  private BuPopupButton pbAlma_;
  private BuButton      btDeplier_;
  private MouseListener ml_;
  
  public AlmaFilleDiagramme
    (AlmaImplementation _app, String _file, DjaGrid _grid)
  {
    super(_app,_file,_grid,true);

    AlmaPaletteUml srcalma=new AlmaPaletteUml(this);
    pbAlma_=new BuPopupButton("Alma",srcalma);
    pbAlma_.setToolTipText(AlmaResource.ALMA.getString("Palette d'lments Alma"));
    pbAlma_.setIcon(BuResource.BU.getIcon("classe",16));
    pbAlma_.setEnabled (_grid instanceof DjaGridInteractive);

    btDeplier_=new BuButton();
    //AlmaResource.ALMA.getString("Dplier");
    btDeplier_.setActionCommand("DJA_UNFOLD");
    btDeplier_.setToolTipText
      (AlmaResource.ALMA.getString("Dplier les classes slectionnes")); 
    btDeplier_.setIcon(AlmaResource.ALMA.getIcon("DEPLIER",16));
    btDeplier_.setName("btDEPLIER_UNITE");
    btDeplier_.setRequestFocusEnabled(false);
    btDeplier_.addActionListener(this);
    btDeplier_.setEnabled(grid_.isInteractive());

    ml_=new MouseAdapter()
      {
	public void mouseClicked(MouseEvent _evt)
	{
	  onMouseClicked(_evt);
	  /*
	  DjaObject o=DjaLibDetect.detectObject
	    (grid_,_evt.getX(),_evt.getY());
	  if(o instanceof AlmaDjaValeur)
	  {
	    AglObjet c=((AlmaDjaValeur)o).getObjet();
	    // System.out.println(AglOptions.code().code(c));
	    new BuDialogMessage(app_,app_.getInformationsSoftware(),
				AglOptions.code().code(c)).activate();
	  }
	  */
	}
      };

    if(!grid_.isInteractive())
      grid_.addMouseListener(ml_);

    MouseMotionListener mml_=new MouseMotionAdapter()
      {
	public void mouseMoved(MouseEvent _evt)
	  {
	    onMouseMoved(_evt);
	    /*
	    DjaObject o=DjaLibDetect.detectObject
	      (grid_,_evt.getX(),_evt.getY());
	    String s=null;
	    if(o instanceof AlmaDjaValeur)
	    {
	      s=(""+o).substring(7);
	      //grid_.setToolTipTextLocation
	      //(new Point(o.getX()+o.getWidth()+3,o.getY()));
	    }
	    grid_.setToolTipText(s);
	    */
	  }
      };
    grid_.addMouseMotionListener(mml_);

    AlmaDnd.TARGET.add(grid_);
  }

  public void onMouseClicked(MouseEvent _evt)
  {
    DjaObject o=DjaLibDetect.detectObject
	(grid_,_evt.getX(),_evt.getY());
    if(o instanceof AlmaDjaValeur)
    {
	AglObjet c=((AlmaDjaValeur)o).getObjet();
	// System.out.println(AglOptions.code().code(c));
	new BuDialogMessage(app_,app_.getInformationsSoftware(),
			    AglOptions.code().code(c)).activate();
    }
  }

  public void onMouseMoved(MouseEvent _evt)
  {
    DjaObject o=DjaLibDetect.detectObject
	(grid_,_evt.getX(),_evt.getY());
    String s=null;
    if(o instanceof AlmaDjaValeur)
    {
      s=(""+o).substring(7);
      /*
	grid_.setToolTipTextLocation
	(new Point(o.getX()+o.getWidth()+3,o.getY()));
      */
    }
    grid_.setToolTipText(s);
  }

  public void actionPerformed(ActionEvent _evt)
  {
    String action=_evt.getActionCommand();
    String arg   ="";

    int i=action.indexOf('(');
    if(i>=0)
    {
      arg   =action.substring(i+1,action.length()-1);
      action=action.substring(0,i);
    }

    if("DJA_TOGGLE_INTERACTIVE".equals(action))
    {
      super.actionPerformed(_evt);
      if(!grid_.isInteractive())
	grid_.addMouseListener(ml_);
      else
	grid_.removeMouseListener(ml_);
    }
    else
    if("DJA_UNFOLD".equals(action))
    {
      if(grid_.isInteractive())
      {
	for(Enumeration e=((DjaGridInteractive)grid_).
	      getSelection().elements(); e.hasMoreElements(); )
	{
	  DjaObject f=(DjaObject)e.nextElement();
	  String depliee=f.getProperty("depliee");
	  if(depliee!=null)
	  {
	    f.setWidth (0);
	    f.setHeight(0);
	    f.putProperty("depliee","vrai".equals(depliee) ? "faux" : "vrai");
	  }
	}
	grid_.revalidate();
	grid_.repaint();
      }
    }
    else
    if("DJA_CREATE_ALMA".equals(action))
    {
      if("Classe"     .equals(arg)) grid_.add(new AlmaDjaClasse());
      if("Struct"     .equals(arg)) grid_.add(new AlmaDjaStruct());
      if("Paquet"     .equals(arg)) grid_.add(new AlmaDjaPaquet());
      if("Relation"   .equals(arg)) grid_.add(new AlmaDjaRelationBiOrientee());
      //if("Commentaire".equals(arg)) grid_.add(new AlmaDjaCommentaire());
      if("Note"       .equals(arg)) grid_.add(new AlmaDjaNote());

      grid_.revalidate();
      grid_.repaint();
    }
    else
      super.actionPerformed(_evt);
  }

  // TMP
  /*
  protected DjaObject detectObject(MouseEvent _evt)
  {
    int x=_evt.getX();
    int y=_evt.getY();

    for(Enumeration e=grid_.getObjects().elements(); e.hasMoreElements(); )
    {
      DjaObject o=(DjaObject)e.nextElement();

      if(o.contains(x,y))
	return o;
    }

    return null;
  }
  */

  public JComponent[] getSpecificTools()
  {
    JComponent[] p=super.getSpecificTools();
    int l=p.length;

    JComponent[] r=new JComponent[l+3];
    System.arraycopy(p,0,r,0,l);

    pbAlma_.setDesktop((BuDesktop)getDesktopPane());
    r[l  ]=null;
    r[l+1]=pbAlma_;
    r[l+2]=btDeplier_;
    return r;
  }
}
