/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AlmaFilleOptions.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.alma;
import com.memoire.agl.*;
import com.memoire.alma.*;
import com.memoire.bu.*;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.io.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;

public class AlmaFilleOptions
       extends BuInternalFrame
       implements ActionListener, ChangeListener, FocusListener
{
  private AlmaImplementation app_;
  private JComponent         content_;

  private BuPanel      pnParse;
  private BuComboBox   chParse;
  private BuCheckBox   cbTrace;
  private BuCheckBox   cbStdCls;
  private BuCheckBox   cbComments;

  private BuPanel      pnCode;
  private BuComboBox   chCode;
  //private JCheckBox  cbSimplifie;
  private BuCheckBox   cbExpReg;
  private BuComboBox   chFormatImage;
  private BuTextField  tfStyleHtml;
  private BuComboBox   chModule;
  private BuComboBox   chClasse;

  private BuPanel      pnRappel;
  private BuCheckBox   cbEntete;
  private BuCheckBox   cbRappelClasses;
  private BuCheckBox   cbRappelPatrons;
  private BuCheckBox   cbRappelRelations;

  private BuTabbedPane tpMain;

  public AlmaFilleOptions(AlmaImplementation _app)
  {
    super("",true,true,false,true);
    app_=_app;

    setName("ifOPTIONS");
    app_.installContextHelp(getRootPane(),"alma/p-options.html");

    int n;

    // Parse

    pnParse=new BuPanel();
    BuGridLayout loParse=new BuGridLayout();
    loParse.setColumns(2);
    loParse.setHgap(5);
    loParse.setVgap(5);
    pnParse.setLayout(loParse);
    pnParse.setBorder(new EmptyBorder(5,5,5,5));
    n=0;

    BuLabel lb1=new BuLabel(AlmaResource.ALMA.getString
			    ("Langage:"),BuLabel.RIGHT);
    pnParse.add(lb1,n++);
    chParse=new BuComboBox();
    chParse.setName("chLANGAGE_ANALYSE");
    chParse.setActionCommand("LANGAGE_ANALYSE");
    chParse.setEditable(true);
    chParse.setMaximumRowCount(6);
    chParse.addItem("Class");
    chParse.addItem("Cpp");
    chParse.addItem("Fortran");
    chParse.addItem("Idl");
    chParse.addItem("Java");
    chParse.addItem("JavaP");
    chParse.addItem("Jsp");
    chParse.addItem("Mdl");
    chParse.addItem("Pascal");
    chParse.addItem("Taglib");
    chParse.addItem("Xmi");
    chParse.addItem("Xsd");
    chParse.setSelectedItem(AglOptions.parse);
    pnParse.add(chParse,n++);
    chParse.addActionListener(this);

    BuLabel lb3=new BuLabel(AlmaResource.ALMA.getString
			  ("Mode verbeux:"),BuLabel.RIGHT);
    pnParse.add(lb3,n++);
    cbTrace=new BuCheckBox(AlmaResource.ALMA.getString("actif"));
    cbTrace.setName("cbMODE_VERBEUX");
    cbTrace.setActionCommand("MODE_VERBEUX");
    cbTrace.setSelected(AglOptions.suivi);
    BuLib.setAutoMnemonic(cbTrace,false);
    pnParse.add(cbTrace,n++);
    cbTrace.addActionListener(this);

    BuLabel lb4=new BuLabel(AlmaResource.ALMA.getString
			  ("Classes lmentaires:"),BuLabel.RIGHT);
    pnParse.add(lb4,n++);
    cbStdCls=new BuCheckBox(AlmaResource.ALMA.getString("charges"));
    cbStdCls.setName("cbMODE_CLASSES_FONDAMENTALES");
    cbStdCls.setActionCommand("MODE_CLASSES_FONDAMENTALES");
    cbStdCls.setSelected(AglOptions.classesFondamentales);
    BuLib.setAutoMnemonic(cbStdCls,false);
    pnParse.add(cbStdCls,n++);
    cbStdCls.addActionListener(this);

    BuLabel lb41=new BuLabel(AlmaResource.ALMA.getString
			   ("Commentaires:"),BuLabel.RIGHT);
    pnParse.add(lb41,n++);
    cbComments=new BuCheckBox(AlmaResource.ALMA.getString("analyss"));
    cbComments.setName("cbMODE_COMMENTAIRES_ANALYSES");
    cbComments.setActionCommand("MODE_COMMENTAIRES_ANALYSES");
    cbComments.setSelected(AglOptions.analyserCommentaires);
    BuLib.setAutoMnemonic(cbComments,false);
    pnParse.add(cbComments,n++);
    cbComments.addActionListener(this);

    // Code

    pnCode=new BuPanel();
    BuGridLayout loCode=new BuGridLayout();
    loCode.setColumns(2);
    loCode.setHgap(5);
    loCode.setVgap(5);
    pnCode.setLayout(loCode);
    pnCode.setBorder(new EmptyBorder(5,5,5,5));
    n=0;

    BuLabel lb2=new BuLabel(AlmaResource.ALMA.getString
			    ("Langage:"),BuLabel.RIGHT);
    pnCode.add(lb2,n++);
    chCode=new BuComboBox();
    chCode.setName("chLANGAGE_GENERATION");
    chCode.setActionCommand("LANGAGE_GENERATION");
    chCode.setEditable(true);
    chCode.setMaximumRowCount(6);
    chCode.addItem("Autotest");
    chCode.addItem("Bdl");
    chCode.addItem("C");
    chCode.addItem("Cpp");
    chCode.addItem("Delphi");
    chCode.addItem("Dependance");
    chCode.addItem("DjaPaquets");
    chCode.addItem("DocHtml");
    chCode.addItem("Eiffel");
    chCode.addItem("Formel");
    chCode.addItem("Generique");
    chCode.addItem("Gui");
    chCode.addItem("H");
    chCode.addItem("Hpp");
    chCode.addItem("Idl");
    chCode.addItem("Jasmin");
    chCode.addItem("Java");
    chCode.addItem("JniC");
    chCode.addItem("JniH");
    chCode.addItem("Lisp");
    chCode.addItem("Naturel");
    chCode.addItem("Odl");
    chCode.addItem("Python");
    chCode.addItem("Qualite");
    chCode.addItem("Rebol");
    chCode.addItem("Resume");
    chCode.addItem("Ruby");
    chCode.addItem("Sql2");
    chCode.addItem("Sql3");
    chCode.addItem("SrcHtml");
    chCode.addItem("Tom");
    chCode.addItem("UmlHierarchie");
    chCode.addItem("UmlRelations");
    chCode.addItem("Uxf");
    chCode.addItem("Xmi");
    chCode.addItem("XmlProto");
    chCode.addItem("Xsd");
    chCode.addItem("JtkCpp");
    chCode.addItem("JtkHpp");
    chCode.setSelectedItem(AglOptions.code);
    pnCode.add(chCode,n++);
    chCode.addActionListener(this);

    /*
    BuLabel lb31=new BuLabel(AlmaResource.ALMA.getString
      ("Mode simplifi:"),BuLabel.RIGHT);
    pnCode.add(lb31,n++);
    cbSimplifie=new BuCheckBox(AlmaResource.ALMA.getString("actif"));
    cbSimplifie.setName("cbMODE_SIMPLIFIE");
    cbSimplifie.setActionCommand("MODE_SIMPLIFIE");
    cbSimplifie.setSelected(AglOptions.simplifie);
    BuLib.setAutoMnemonic(cbSimplifie,false);
    pnCode.add(cbSimplifie,n++);
    cbSimplifie.addActionListener(this);
    */

    BuLabel lb6=new BuLabel(AlmaResource.ALMA.getString
			    ("Module:"),BuLabel.RIGHT);
    pnCode.add(lb6,n++);

    chModule=new BuComboBox();
    chModule.setModel(new AlmaPaquetsModel()); // app_.lmPaquets);
    chModule.setEditable(true);
    chModule.setSelectedItem(AglOptions.module);
    chModule.setName("chFILTRE_MODULE");
    chModule.setActionCommand("FILTRE_MODULE");
    chModule.setMaximumRowCount(5);
    pnCode.add(chModule,n++);
    chModule.addActionListener(this);
    chModule.addFocusListener(this);
    AlmaDnd.TARGET.add(chModule);
    
    BuLabel lb7=new BuLabel(AlmaResource.ALMA.getString
			    ("Classe:"),BuLabel.RIGHT);
    pnCode.add(lb7,n++);

    chClasse=new BuComboBox();
    chClasse.setModel(new AlmaTypesModel()); // app_.lmTypes);
    chClasse.setEditable(true);
    chClasse.setSelectedItem(AglOptions.classe);
    chClasse.setName("chFILTRE_CLASSE");
    chClasse.setActionCommand("FILTRE_CLASSE");
    chClasse.setMaximumRowCount(5);
    pnCode.add(chClasse,n++);
    chClasse.addActionListener(this);
    chClasse.addFocusListener(this);
    AlmaDnd.TARGET.add(chClasse);
    
    BuLabel lb8=new BuLabel(AlmaResource.ALMA.getString
			  ("Expressions rgulires:"),BuLabel.RIGHT);
    pnCode.add(lb8,n++);
    cbExpReg=new BuCheckBox(AlmaResource.ALMA.getString("appliques"));
    cbExpReg.setName("cbMODE_EXPRESSIONS_REGULIERES");
    cbExpReg.setActionCommand("MODE_EXPRESSIONS_REGULIERES");
    cbExpReg.setSelected(AglOptions.appliquerExpReg);
    BuLib.setAutoMnemonic(cbExpReg,false);
    pnCode.add(cbExpReg,n++);
    cbExpReg.addActionListener(this);

    BuLabel lb62=new BuLabel(AlmaResource.ALMA.getString
			     ("Format des images:"),BuLabel.RIGHT);
    pnCode.add(lb62,n++);
    chFormatImage=new BuComboBox();
    chFormatImage.setName("chFORMAT_IMAGE");
    chFormatImage.setActionCommand("FORMAT_IMAGE");
    chFormatImage.setMaximumRowCount(6);
    chFormatImage.addItem("Gif");
    chFormatImage.addItem("Jpeg");
    chFormatImage.addItem("Ppm");
    chFormatImage.setSelectedItem(AglOptions.formatImage);
    pnCode.add(chFormatImage,n++);
    chFormatImage.addActionListener(this);

    BuLabel lb61=new BuLabel(AlmaResource.ALMA.getString
			     ("Style Html:"),BuLabel.RIGHT);
    pnCode.add(lb61,n++);
    tfStyleHtml=BuTextField.createFileField();
    tfStyleHtml.setText(AglOptions.styleHtml);
    tfStyleHtml.setName("tfSTYLE_HTML");
    tfStyleHtml.setActionCommand("STYLE_HTML");
    pnCode.add(tfStyleHtml,n++);
    tfStyleHtml.addActionListener(this);
    tfStyleHtml.addFocusListener(this);

    // Rappel

    pnRappel=new BuPanel();
    BuGridLayout loRappel=new BuGridLayout();
    loRappel.setColumns(2);
    loRappel.setHgap(5);
    loRappel.setVgap(5);
    pnRappel.setLayout(loRappel);
    pnRappel.setBorder(new EmptyBorder(5,5,5,5));
    n=0;

    BuLabel lb51=new BuLabel(AlmaResource.ALMA.getString
			     ("Entte d'unit:"),BuLabel.RIGHT);
    pnRappel.add(lb51,n++);
    cbEntete=new BuCheckBox(AlmaResource.ALMA.getString("actif"));
    cbEntete.setName("cbMODE_ENTETE");
    cbEntete.setActionCommand("MODE_ENTETE");
    cbEntete.setSelected(AglOptions.entete);
    BuLib.setAutoMnemonic(cbEntete,false);
    pnRappel.add(cbEntete,n++);
    cbEntete.addActionListener(this);

    BuLabel lb5=new BuLabel(AlmaResource.ALMA.getString
			    ("Rappel des classes:"),BuLabel.RIGHT);
    pnRappel.add(lb5,n++);
    cbRappelClasses=new BuCheckBox(AlmaResource.ALMA.getString("actif"));
    cbRappelClasses.setName("cbMODE_RAPPELCLASSES");
    cbRappelClasses.setActionCommand("MODE_RAPPELCLASSES");
    cbRappelClasses.setSelected(AglOptions.rappelClasses);
    BuLib.setAutoMnemonic(cbRappelClasses,false);
    pnRappel.add(cbRappelClasses,n++);
    cbRappelClasses.addActionListener(this);

    BuLabel lb91=new BuLabel(AlmaResource.ALMA.getString
			     ("Rappel des patrons:"),BuLabel.RIGHT);
    pnRappel.add(lb91,n++);
    cbRappelPatrons=new BuCheckBox(AlmaResource.ALMA.getString("actif"));
    cbRappelPatrons.setName("cbMODE_RAPPELPATRONS");
    cbRappelPatrons.setActionCommand("MODE_RAPPELPATRONS");
    cbRappelPatrons.setSelected(AglOptions.rappelPatrons);
    BuLib.setAutoMnemonic(cbRappelPatrons,false);
    pnRappel.add(cbRappelPatrons,n++);
    cbRappelPatrons.addActionListener(this);

    BuLabel lb9=new BuLabel(AlmaResource.ALMA.getString
			    ("Rappel des relations:"),BuLabel.RIGHT);
    pnRappel.add(lb9,n++);
    cbRappelRelations=new BuCheckBox(AlmaResource.ALMA.getString("actif"));
    cbRappelRelations.setName("cbMODE_RAPPELRELATIONS");
    cbRappelRelations.setActionCommand("MODE_RAPPELRELATIONS");
    cbRappelRelations.setSelected(AglOptions.rappelRelations);
    BuLib.setAutoMnemonic(cbRappelRelations,false);
    pnRappel.add(cbRappelRelations,n++);
    cbRappelRelations.addActionListener(this);

    // Agl - Options specifiques

    BuPanel        pnAgl=new BuPanel();
    BuBorderLayout loAgl=new BuBorderLayout();
    loAgl.setHgap(5);
    loAgl.setVgap(5);
    pnAgl.setLayout(loAgl);
    pnAgl.setBorder(new EmptyBorder(5,5,5,5));

    BuTable tbAgl=new BuTable
      (new BuGenericPreferencesModel(AglPreferences.AGL));
    BuScrollPane spAgl=new BuScrollPane(tbAgl);
    spAgl.setPreferredSize(new Dimension(150,150));
    pnAgl.add(spAgl,BuBorderLayout.CENTER);

    // Main

    tpMain=new BuTabbedPane();
    // tpMain.setName("tpCONFIGURATION");
    tpMain.setTabPlacement(BuLib.getTabPlacement());
    tpMain.addChangeListener(this);

    BuPanel cdParse=new BuPanel();
    cdParse.setLayout(new BuBorderLayout());
    cdParse.add(pnParse,BuBorderLayout.NORTH);
    tpMain.addTab(AlmaResource.ALMA.getString("Analyse"),
		  BuResource.BU.loadTabCommandIcon("ANALYSER"),
		  cdParse,AlmaResource.ALMA.getString
		  ("Options d'analyse de source"));

    BuPanel cdCode=new BuPanel();
    cdCode.setLayout(new BuBorderLayout());
    cdCode.add(pnCode,BuBorderLayout.NORTH);
    tpMain.addTab(AlmaResource.ALMA.getString("Gnration"),
		  BuResource.BU.loadTabCommandIcon("GENERER"),
		  cdCode,AlmaResource.ALMA.getString
		  ("Options de gnration de code"));

    BuPanel cdRappel=new BuPanel();
    cdRappel.setLayout(new BuBorderLayout());
    cdRappel.add(pnRappel,BuBorderLayout.NORTH);
    tpMain.addTab(AlmaResource.ALMA.getString("Rappels"),
		  BuResource.BU.loadTabCommandIcon("TEXTE"),
		  cdRappel,AlmaResource.ALMA.getString
		  ("Options de rappel"));

    tpMain.addTab("Agl",
		  AlmaResource.ALMA.getTabIcon("alma"),
		  pnAgl,AlmaResource.ALMA.getString("Options")+" AGL");

    content_=(JComponent)getContentPane();
    content_.setLayout(new BuBorderLayout());
    content_.setBorder(new EmptyBorder(5,5,5,5));
    content_.add(tpMain,BuBorderLayout.CENTER);

    BuLib.computeMnemonics(pnParse ,this);
    BuLib.computeMnemonics(pnCode  ,this);
    BuLib.computeMnemonics(pnRappel,this);

    setTitle(AlmaResource.ALMA.getString("Configuration"));
    setFrameIcon(BuResource.BU.getBarIcon("configurer"));
    pack();
    setMinimumSize(getPreferredSize());

    valide(chParse);
    valide(chCode);
  }

  public void setSelected(boolean _state) throws PropertyVetoException
  {
    super.setSelected(_state);
    if(isSelected()) tpMain.requestFocus();
  }

  public void actionPerformed(ActionEvent _evt)
  {
    JComponent source=(JComponent)_evt.getSource();
    // System.err.println("ACTION ON "+source.getClass().getName());
    valide(source);
  }

  public void stateChanged(ChangeEvent _evt)
  {
    JComponent source=(JComponent)_evt.getSource();
    if(source==tpMain) tpMain.requestFocus();
  }

  public void focusGained(FocusEvent _evt)
  {
    JComponent source=(JComponent)_evt.getSource();
    // System.err.println("Focus reu  : "+source.getClass().getName());
  }

  public void focusLost(FocusEvent _evt)
  {
    JComponent source=(JComponent)_evt.getSource();
    // System.err.println("Focus perdu : "+source.getClass().getName());
    valide(source);
  }

  public void valide(JComponent source)
  {
    if(source==chParse)
    {
      /*
	System.err.println("Slection du langage d'analyse "+
	                   chParse.getSelectedItem());
      */
      AglOptions.parse=(String)chParse.getSelectedItem();

      AglParse p=AglOptions.parse();
      if(p!=null)
      {
	cbTrace.setEnabled   (p.optionTrace());
	cbStdCls.setEnabled  (p.optionClassesFondamentales());
	cbComments.setEnabled(p.optionAnalyserCommentaires());

	if(AlmaPreferences.ALMA.getBooleanProperty("module.explorer",true))
	{
	  BuExplorer expl=app_.getExplorer();
	  if(expl!=null)
	    expl.addFilter
	      (new BuFileFilter(p.extensions(),p.langage()+" files"));
	}
      }
    }

    if(source==chCode)
    {
      /*
	System.err.println("Slection du langage de gnration "+
	                   chCode.getSelectedItem());
      */
      AglOptions.code=(String)chCode.getSelectedItem();

      AglCode c=AglOptions.code();
      if(c!=null)
      {
	//cbSimplifie.setEnabled(c.optionSimplifie());
	chFormatImage.setEnabled(c.optionFormatImage());
	tfStyleHtml.setEnabled  (c.optionStyleHtml());
	chModule.setEnabled     (c.optionModule());
	chClasse.setEnabled     (c.optionClasse());
	cbExpReg.setEnabled     (c.optionAppliquerExpReg());

	if(AlmaPreferences.ALMA.getBooleanProperty("module.explorer",true))
	{
	  BuExplorer expl=app_.getExplorer();
	  if(expl!=null)
	    expl.addFilter
	      (new BuFileFilter(c.extensions(),c.langage()+" files"));
	}
      }
    }

    if(source==cbTrace)
      AglOptions.suivi=cbTrace.isSelected();

    if(source==cbComments)
      AglOptions.analyserCommentaires=cbComments.isSelected();

    //if(source==cbSimplifie) AglOptions.simplifie=cbSimplifie.isSelected();

    if(source==cbStdCls)
      AglOptions.classesFondamentales=cbStdCls.isSelected();

    if(source==cbEntete)
      AglOptions.entete=cbEntete.isSelected();

    if(source==cbRappelClasses)
      AglOptions.rappelClasses=cbRappelClasses.isSelected();

    if(source==cbRappelPatrons)
      AglOptions.rappelPatrons=cbRappelPatrons.isSelected();

    if(source==cbRappelRelations)
      AglOptions.rappelRelations=cbRappelRelations.isSelected();

    if(source==cbExpReg)
      AglOptions.appliquerExpReg=cbExpReg.isSelected();

    if(source==chFormatImage)
      AglOptions.formatImage=(String)chFormatImage.getSelectedItem();

    if(source==tfStyleHtml)
      AglOptions.styleHtml=tfStyleHtml.getText();

    if(source==chModule)
      AglOptions.module=(String)chModule.getSelectedItem();

    if(source==chClasse)
      AglOptions.classe=(String)chClasse.getSelectedItem();
  }

  // InternalFrame

  public String[] getDisabledActions()
  {
    String[] r=new String[] { "CONFIGURER" };
    return r;
  }
}
