/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AlmaFillePatronType.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.alma;
import com.memoire.agl.*;
import com.memoire.alma.*;
import com.memoire.bu.*;
import com.memoire.dja.*;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;

public class AlmaFillePatronType
       extends BuInternalFrame // BuPalette
       implements ActionListener, ListSelectionListener
{
  private AlmaImplementation app_;
  private JComponent         uml_;

  private BuPanel    pnMain,pnButtons;
  private BuComboBox chPatronCategorie;
  private BuComboBox chPatronType;
  private BuList     ltRoles;
  private BuPanel    pnGrille;
  private BuButton   btCreer_, btFermer_;

  public AlmaFillePatronType(AlmaImplementation _app)
  {
    super("",true,false,false,false);
    app_=_app;
    uml_=null;

    setName("ifPATRONS_TYPE");
    app_.installContextHelp(getRootPane(),"alma/p-patrons-type.html");

    int n;

    pnMain=new BuPanel();
    BuGridLayout loMain=new BuGridLayout();
    loMain.setCfilled(true);
    loMain.setRfilled(true);
    loMain.setColumns(2);
    loMain.setHgap(5);
    loMain.setVgap(5);
    pnMain.setLayout(loMain);
    pnMain.setBorder(new EmptyBorder(5,5,5,5));
    n=0;

    BuLabel lb1=new BuLabel(AlmaResource.ALMA.getString
			  ("Catgorie:"),BuLabel.RIGHT);
    pnMain.add(lb1,n++);
    chPatronCategorie=new BuComboBox();
    for(int i=0; i<AglPatronType.categories.length; i++)
      chPatronCategorie.addItem(AglPatronType.categories[i]);
    chPatronCategorie.setMaximumRowCount(6);
    chPatronCategorie.setName("chPATRON_CATEGORIE");
    chPatronCategorie.setActionCommand("PATRON_CATEGORIE");
    pnMain.add(chPatronCategorie,n++);
    chPatronCategorie.addActionListener(this);

    BuLabel lb2=new BuLabel(AlmaResource.ALMA.getString
			  ("Type:"),BuLabel.RIGHT);
    pnMain.add(lb2,n++);
    chPatronType=new BuComboBox();
    chPatronType.setMaximumRowCount(6);
    chPatronType.setName("chPATRON_TYPE");
    chPatronType.setActionCommand("PATRON_TYPE");
    chPatronType.setEnabled(false);
    pnMain.add(chPatronType,n++);
    chPatronType.addActionListener(this);

    BuLabel lb3=new BuLabel(AlmaResource.ALMA.getString
			  ("Rles:"),BuLabel.RIGHT);
    lb3.setVerticalAlignment(BuLabel.TOP);
    pnMain.add(lb3,n++);
    ltRoles=new BuList();
    ltRoles.setName("ltPATRON_ROLE");
    JScrollPane spRoles=new BuScrollPane(ltRoles);
    spRoles.setPreferredSize(new Dimension(150,70));
    pnMain.add(spRoles,n++);
    ltRoles.addListSelectionListener(this);

    BuLabel lb4=new BuLabel(AlmaResource.ALMA.getString
			  ("UML:"),BuLabel.RIGHT);
    lb4.setVerticalAlignment(BuLabel.TOP);
    pnMain.add(lb4,n++);
    pnGrille=new BuPanel();
    pnGrille.setLayout(new BuBorderLayout());
    pnGrille.setName("pnPATRON_GRILLE");
    JScrollPane spGrille=new BuScrollPane(pnGrille);
    spGrille.setPreferredSize(new Dimension(150,100));
    pnMain.add(spGrille,n++);

    // Panneau de validation
    pnButtons=new BuPanel();
    pnButtons.setLayout(new FlowLayout(FlowLayout.RIGHT));

    btFermer_=new BuButton(BuResource.BU.getString("Fermer"));
    btFermer_.setIcon(BuResource.BU.getIcon("fermer"));
    btFermer_.setName("btFERMER");
    btFermer_.setActionCommand("FERMER");
    btFermer_.addActionListener(this);
    pnButtons.add(btFermer_);

    btCreer_=new BuButton(BuResource.BU.getString("Crer"));
    btCreer_.setIcon(BuResource.BU.getIcon("creer"));
    btFermer_.setName("btCREER");
    btCreer_.setActionCommand("CREER");
    btCreer_.addActionListener(this);
    pnButtons.add(btCreer_);
    
    JPanel pn=new BuPanel();
    pn.setLayout(new BuBorderLayout());
    pn.add(pnMain   ,BuBorderLayout.CENTER);
    pn.add(pnButtons,BuBorderLayout.SOUTH);
    setContentPane(pn);

    setTitle(AlmaResource.ALMA.getString("Patrons-type"));
    setFrameIcon(AlmaResource.ALMA.getBarIcon("patron"));
    setLocation(150,170);

    Dimension d=getPreferredSize();
    if(d.width <470) d.width =470;
    if(d.height<470) d.height=470;
    setPreferredSize(d);
    setSize(d);
    setResizable(true);

    chPatronCategorie.setSelectedIndex(0);
    valide(chPatronCategorie);
  }

  public void setSelected(boolean _state) throws PropertyVetoException
  {
    super.setSelected(_state);
    if(isSelected()) chPatronCategorie.requestFocus();
  }

  public void valueChanged(ListSelectionEvent ev)
  {
    JComponent source=(JComponent)ev.getSource();
    if(source==ltRoles) ltRoles.setSelectedValue(null,false);
  }

  public void actionPerformed(ActionEvent _evt)
  {
    JComponent source=(JComponent)_evt.getSource();
    // System.err.println("ACTION ON "+source.getName());
    valide(source);

    if(source==btCreer_)
    {
      String s=(String)chPatronType.getSelectedItem();
      if(s!=null)
      {
	AglPatronType t=null;
	t=(AglPatronType)AglPatronType.table.get(s);
	if(t!=null)
	{
	  AglPatron m=new AglPatron(t);
	  app_.rafraichir();
	  new AlmaEditeurPatron(app_,m).activate();
	}
      }
    }

    if(source==btFermer_)
    {
      try { setClosed(true); }
      catch(PropertyVetoException ex) { }
    }
  }

  public void valide(JComponent source)
  {
    if(source==chPatronCategorie)
    {
      int s=chPatronCategorie.getSelectedIndex();
      //System.err.println("Slection du patron-categorie "+s);

      int n=0;
      chPatronType.removeAllItems();
      for(Enumeration e=AglPatronType.table.elements();
	e.hasMoreElements(); )
	{
	  AglPatronType m=(AglPatronType)e.nextElement();
	  if(m.categorie==s)
	  {
	    chPatronType.addItem(m.nom);
	    n++;
	  }
	}

      if(n==0)
	chPatronType.addItem("");

      chPatronType.setEnabled(n!=0);
      chPatronType.revalidate();
      chPatronType.repaint();
    }

    if(source==chPatronType)
    {
      String s=(String)chPatronType.getSelectedItem();
      //System.err.println("Slection du patron-type "+s);

      AglPatronType m=null;
      if(s!=null) m=(AglPatronType)AglPatronType.table.get(s);

      if((m!=null)&&(m.roles!=null))
      {
	ltRoles.setListData(m.roles);
	btCreer_.setEnabled(true);
      }
      else
      {
	ltRoles.setListData(new Vector());
	btCreer_.setEnabled(false);
      }

      ltRoles.revalidate();
      ltRoles.repaint();

      if(uml_!=null) pnGrille.remove(uml_);

      uml_=null;
      try
      {
	InputStream in=AglPatronType.class.
	  getResourceAsStream("Pattern"+s+".dja");
	if(in==null) throw new NullPointerException();

	uml_=new DjaGrid(DjaLoader.loadAsText(in));
	pnGrille.add(uml_,BuBorderLayout.CENTER);
      }
      catch(Exception ex)
      {
	uml_=new BuLabel(BuResource.BU.getString("Non disponible"));
	((BuLabel)uml_).setHorizontalAlignment(BuLabel.CENTER);
	pnGrille.add(uml_,BuBorderLayout.CENTER);
      }

      pnGrille.revalidate();
      pnGrille.repaint();
    }

    if(source==ltRoles)
    {
      /*
	System.err.println("Slection du rle "+
	ltRoles.getSelectedValue());
      */
    }
  }
}
