/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AlmaPaquetsModel.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.alma;
import com.memoire.agl.*;
import com.memoire.alma.*;

import java.util.*;

import javax.swing.*;
import javax.swing.event.*;

public class AlmaPaquetsModel
       implements ComboBoxModel
{
  private boolean elementaires_;
  private Vector  listeners_;
  private Vector  items_;
  private Object  selection_;
  private int     size_;

  public AlmaPaquetsModel()
  { this(false); }

  public AlmaPaquetsModel(boolean _e)
  {
    listeners_   =new Vector(2,2);
    items_       =new Vector(0,11);
    selection_   =null;
    elementaires_=_e;
    size_        =-1;
    updateItems();
  }

  public void update()
  {
    updateItems();
    fireContentsChanged();
  }

  private void fireContentsChanged()
  {
    ListDataEvent evt=new ListDataEvent
      (this,ListDataEvent.CONTENTS_CHANGED,-1,-1);

    synchronized (listeners_)
    {
      for(Enumeration e=listeners_.elements(); e.hasMoreElements(); )
      {
	try
	{
	  ((ListDataListener)e.nextElement()).
	    contentsChanged(evt);
	}
	catch(Exception ex) { }
      }
    }
  }

  public boolean isElementaires()
  { return elementaires_; }

  public void setElementaires(boolean _b)
  {
    if(elementaires_!=_b)
    {
      elementaires_=_b;
      update();
    }
  }

  public Object getSelectedItem()
  {
    /*
    Object r=null;
    if((selection_!=null)&&items_.contains(selection_)) r=selection_;
    return r;
    */
    return selection_;
  }

  public void setSelectedItem(Object _o)
  {
    if(selection_!=_o) // if(items_.contains(_o))
    {
      selection_=_o;
      fireContentsChanged();
    }
  }

  public int getSize()
  {
    updateItemsIfNeeded();
    return items_.size();
  }

  public Object getElementAt(int _i)
  {
    Object r=null;
    if((_i>=0)&&(_i<items_.size())) r=items_.elementAt(_i);
    return r;
  }
    
  public void addListDataListener(ListDataListener _l)
  { listeners_.addElement(_l); }
    
  public void removeListDataListener(ListDataListener _l)
  { listeners_.removeElement(_l); }

  private void updateItemsIfNeeded()
  {
    if(size_!=AglPaquet.table.size())
      updateItems();
  }

  private void updateItems()
  {
    size_=AglPaquet.table.size();

    synchronized (items_)
    {
      items_.removeAllElements();

      for(Enumeration e=AglPaquet.table.elements(); e.hasMoreElements(); )
      {
	AglPaquet ap=(AglPaquet)e.nextElement();
	if(elementaires_||!ap.elementaire)
	  items_.addElement(ap.nom.formeJava());
      }

      if(items_.size()==0)
	items_.addElement("");
    }
  }
}
