/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AlmaScreenCopy.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.alma;
import com.memoire.agl.*;
import com.memoire.alma.*;
import com.memoire.bu.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import javax.swing.tree.*;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

public class AlmaScreenCopy
       extends JFrame
       implements ActionListener, WindowListener, BuPrintable
{
  JComponent    content_;
  int           n_;
  Component     c_;
  JLabel        l_;
  JPanel        p_;
  Hashtable     photos_;
  ComponentTree tree_;

  public AlmaScreenCopy(Component _c)
  {
    if(_c==null) _c=this;
    if(_c instanceof JFrame ) _c=((JFrame )_c).getRootPane();
    if(_c instanceof JApplet) _c=((JApplet)_c).getRootPane();

    c_=_c;

    n_=0;
    photos_=new Hashtable();

    content_=(JComponent)getContentPane();

    BuVerticalLayout lo=new BuVerticalLayout();
    lo.setVgap(5);
    lo.setVfilled(true);
    content_.setLayout(lo);
    content_.setBorder(new EmptyBorder(5,5,5,5));

    l_=new JLabel("0 images");

    BuHorizontalLayout lop=new BuHorizontalLayout();
    lop.setHgap(5);

    p_=new JPanel();
    p_.setLayout(lop);
    p_.setBorder(new EmptyBorder(3,3,3,3));

    JScrollPane spp=new JScrollPane(p_);
    spp.setBackground(UIManager.getColor("Panel.background"));
    spp.setPreferredSize(new Dimension(100,110));
    /*
      spp.setBorder(new CompoundBorder
       (new BuLightBorder(BuLightBorder.RAISED ,1),
        new BuLightBorder(BuLightBorder.LOWERED,3)));
    */

    // p_=new Picture();
    // p_.setPreferredSize(new Dimension(100,100));
    // p_.setBorder(new LineBorder(Color.black));

    JButton bp=new JButton("Photo"      );
    JButton br=new JButton("Rafale"     );
    JButton ba=new JButton("Arbre"      );
    JButton bs=new JButton("Supprimer"  );
    JButton bi=new JButton("Imprimer"   );
    JButton be=new JButton("Enregistrer");
    JButton bf=new JButton("Rafraichir" );

    bp.setActionCommand("PHOTO");
    br.setActionCommand("RAFALE");
    ba.setActionCommand("ARBRE");
    bs.setActionCommand("SUPPRIMER");
    bi.setActionCommand("IMPRIMER");
    be.setActionCommand("ENREGISTRER");
    bf.setActionCommand("RAFRAICHIR");

    bp.addActionListener(this);
    br.addActionListener(this);
    ba.addActionListener(this);
    bs.addActionListener(this);
    bi.addActionListener(this);
    be.addActionListener(this);
    bf.addActionListener(this);

    br.setEnabled(false);
    
    BuGridLayout lob=new BuGridLayout();
    lob.setColumns(4);
    lob.setHgap(5);
    lob.setVgap(5);
    lob.setCfilled(false);

    JPanel pnb=new JPanel();
    pnb.setLayout(lob);
    pnb.add(bp);
    pnb.add(ba);
    pnb.add(bi);
    pnb.add(bf);
    pnb.add(br);
    pnb.add(bs);
    pnb.add(be);

    tree_=new ComponentTree(c_);
    tree_.setSelectionRow(0);
    tree_.setBackground(UIManager.getColor("Panel.background"));
    tree_.setBorder(new EmptyBorder(3,3,3,3));
    JScrollPane sp=new JScrollPane(tree_);
    sp.setBackground(UIManager.getColor("Panel.background"));
    sp.setPreferredSize(new Dimension(250,150));
    /*
      sp.setBorder(new CompoundBorder
        (new BuLightBorder(BuLightBorder.RAISED ,1),
	 new BuLightBorder(BuLightBorder.LOWERED,3)));
    */
    content_.add(l_);
    content_.add(pnb);
    content_.add(spp);
    content_.add(sp);

    addWindowListener(this);
    BuRegistry.register(this);

    setTitle("Appareil");
    pack();
    setVisible(true);
    setLocation(10,30);
  }
  // Window

  public void windowActivated(WindowEvent _evt)
  { }

  public void windowClosed(WindowEvent _evt)
  { }

  public void windowClosing(WindowEvent _evt)
  { BuRegistry.unregister(this); }

  public void windowDeactivated(WindowEvent _evt)
  { }

  public void windowDeiconified(WindowEvent _evt)
  { }

  public void windowIconified(WindowEvent _evt)
  { }

  public void windowOpened(WindowEvent _evt)
  { }

  // Actions

  public Image photo()
  {
    return photo(tree_.getSelection());
  }

  public Image photo(Component c)
  {
    Image     r=null;

    if(c.isVisible())
    {
      Dimension size =c.getSize();
      int       w    =size.width;
      int       h    =size.height;
      
      try { r=createImage(w,h); }
      catch(Exception ex) { r=null; }

      if(r!=null)
      {
	try { Thread.sleep(500); }
	catch(Exception ex) { }

	try { c.paint(r.getGraphics()); }
	catch(Exception ex) { r=null; }

	if(r!=null)
	{
	  String s=c.getName();
	  if(s==null)
	  {
	    s=c.getClass().getName();
	    int i=s.lastIndexOf('.');
	    if(i>=0) s=s.substring(i+1,s.length());
	  }
	  if(!c.isEnabled())
	    s+="-inhibe";

	  photos_.put(s,r);
	  l_.setText(""+photos_.size()+" images");
	  l_.repaint();

	  Picture pic=new Picture(r);
	  pic.setToolTipText(s);
	  p_.add(pic);
	  p_.revalidate();
	  p_.repaint();
	}
      }
    }

    return r;
  }

  public void rafale(int n)
  {
    while(n>0)
    {
      Image r=photo();
      if(r!=null) n--;
    }
  }

  public void arbre()
  {
    arbre(tree_.getSelection());
  }

  public void arbre(Component c)
  {
    if(c.getName()!=null)
      photo(c);

    if(c instanceof Container)
    {
      Component[] f=((Container)c).getComponents();
      for(int i=0;i<f.length;i++)
      	arbre(f[i]);
    }

    if(c instanceof JMenu)
      arbre(((JMenu)c).getPopupMenu());
  }

  public void supprimer()
  {
    Component c=tree_.getSelection();

    if(c!=null)
    {
      String s=c.getName();
      if(s==null)
      {
	s=c.getClass().getName();
	int i=s.lastIndexOf('.');
	if(i>=0) s=s.substring(i+1,s.length());
      }
      photos_.remove(s);
      p_.repaint();
    }
  }

  public void imprimer()
  {
    BuPrinter.print(this,"Vue d'cran",this);
  }

  public void print(PrintJob _job, Graphics _g)
  {
    Component c=tree_.getSelection();

    if(c.isVisible())
    {
      BuPrinter.INFO_DOC     =new BuInformationsDocument();
      BuPrinter.INFO_DOC.name="Vue d'cran";
      BuPrinter.INFO_DOC.logo=BuResource.BU.getIcon("image",24);

      BuPrinter.printComponent(_job,_g,c);
      // BuPrinter.printImage(_g,getImage());
    }
  }

  public void enregistrer()
  {
    for(Enumeration e=photos_.keys(); e.hasMoreElements() ; )
    {
      System.gc();

      String f =(String)e.nextElement();
      Image img=(Image)(photos_.get(f));

      f="p-"+f.toLowerCase();
      System.err.print(f+": ");
      f="images/"+f;
      AglImageEncoder.save(img,f,"Gif");
      System.err.print("enregistre");

      long l=new File(f+".gif").length();
      if(l<4096l)
	System.err.println(" ("+l+"o)");
      else
	System.err.println(" ("+(l/1024l)+"ko)");

      n_++;
    }
    photos_.clear();
    p_.removeAll();
    p_.revalidate();
    p_.repaint();
  }

  public void rafraichir()
  {
    //try { tree_.setModel(new ComponentTreeModel(c_)); }
    //catch(Exception ex) { }
    try
    {
      ComponentTreeModel m=(ComponentTreeModel)tree_.getModel();
      TreePath           s=tree_.getSelectionPath();
      Vector             l=m.getListeners();

      for(Enumeration e=l.elements(); e.hasMoreElements(); )
      {
	((TreeModelListener)e.nextElement()).treeStructureChanged
	  (new TreeModelEvent(m,s));
      }
    }
    catch(Exception ex) { ex.printStackTrace(); }
  }

  public void actionPerformed(ActionEvent _evt)
  {
    String action=_evt.getActionCommand();
    System.err.println("ACTION="+action);

    if(action.equals("PHOTO"      )) photo      ();       
    if(action.equals("RAFALE"     )) rafale     (5);
    if(action.equals("ARBRE"      )) arbre      ();
    if(action.equals("SUPPRIMER"  )) supprimer  ();
    if(action.equals("IMPRIMER"   )) imprimer   ();
    if(action.equals("ENREGISTRER")) enregistrer();
    if(action.equals("RAFRAICHIR" )) rafraichir ();
  }

  class Picture
        extends JComponent
  {
    Image image;

    public Picture(Image _image)
    {
      // image=_image;

      setBorder(new LineBorder(Color.black));

      int wi=_image.getWidth(this);
      int hi=_image.getHeight(this);
      int wc=Math.min(80,wi);
      int hc=Math.min(80,hi);

      int fd=Math.min(100*wc/wi,100*hc/hi);
      int wd=wi*fd/100;
      int hd=hi*fd/100;

      image=_image.
	  getScaledInstance(wd,hd,Image.SCALE_SMOOTH);


      Insets insets=this.getInsets();
      Dimension d=new Dimension(wd+insets.left+insets.right+1,
				hd+insets.top+insets.bottom+1);
      setPreferredSize(d);
      this.setSize(d);
    }

    public void paint(Graphics _g)
    {
      Insets insets=this.getInsets();

      /*
      int wc=this.getWidth() -insets.left-insets.right-1;
      int hc=this.getHeight()-insets.top-insets.bottom-1;
      int wi=image.getWidth(this);
      int hi=image.getHeight(this);

      int fd=Math.min(100*wc/wi,100*hc/hi);
      int wd=wi*fd/100;
      int hd=hi*fd/100;
      _g.drawImage(image,insets.left+1,insets.top+1,wd+1,hd+1,this);
      */

      _g.drawImage(image,insets.left+1,insets.top+1,this);
      super.paint(_g);
    }
  }

  class ComponentTree extends JTree
  {
    ComponentTree(Component _root)
    {
      setModel(new ComponentTreeModel(_root));
      setCellRenderer(new ComponentTreeRenderer());
      setShowsRootHandles(true);
    }

    public Component getSelection()
    {
      Component r   =null;
      TreePath  path=getSelectionPath();

      if(path!=null)
	r=(Component)path.getLastPathComponent();
      
      return r;
    }
  }

  class ComponentTreeRenderer
      implements TreeCellRenderer
  {
    public Component getTreeCellRendererComponent
      (JTree   tree,
       Object  value,
       boolean selected,
       boolean expanded,
       boolean leaf,
       int     row,
       boolean hasFocus)
    {
      JLabel    r=new JLabel();
      Component c=(Component)value;

      Font ft=tree.getFont();

      String s=c.getName();
      if(s==null)
      {
	s=c.getClass().getName();
	int i=s.lastIndexOf('.');
	if(i>=0) s=s.substring(i+1,s.length());
	s="["+s+"] (sans nom)";
	ft=BuLib.deriveFont(ft,-2);
      }

      if(!c.isVisible())
      {
	s+=" (cach)";
	ft=BuLib.deriveFont(ft,-2);
      }

      r.setText(" "+s+" ");
      r.setFont(ft);

      if(selected)
      {
      	r.setOpaque(true);
      	r.setBackground(UIManager.getColor("Tree.selectionBackground"));
	r.setForeground(UIManager.getColor("Tree.foregroundSelectionColor"));
	r.setBorder(new BuLightBorder());
      }
      else
      {
      	r.setOpaque(false);
      	r.setBackground(tree.getBackground());
	r.setForeground(tree.getForeground());
	r.setBorder(new EmptyBorder(1,1,1,1));
      }

      return r;
    }
  }

  class ComponentTreeModel implements TreeModel
  {
    Vector    listeners_;
    Component root_;

    ComponentTreeModel(Component _root)
    {
      root_=_root;
      listeners_=new Vector();
    }

    public int getChildCount(Object _parent)
    { 
      int r=0;
      if(_parent instanceof Container)
	r=((Container)_parent).getComponentCount();
      return r;
    }

    public Object getChild(Object _parent, int _index)
    {
      Object r=null;
      if(_parent instanceof Container)
	r=((Container)_parent).getComponent(_index);
      return r;
    }

    public int getIndexOfChild(Object _parent, Object _child)
    {
      int r=-1;
      if(_parent instanceof Container)
      {
	Component[] c=((Container)_parent).getComponents();
      for(int i=0;i<c.length;i++)
      	if(c[i]==_child) r=i;
      }
      return r;
    }

    public Object getRoot()
      { return root_; }

    public boolean isLeaf(Object _node)
    {
      boolean r=true;
      if(_node instanceof Container)
	r=(((Container)_node).getComponentCount()==0);
      return r;
    }

    public void addTreeModelListener(TreeModelListener _l)
      { listeners_.addElement(_l); }
    
    public void removeTreeModelListener(TreeModelListener _l)
      { listeners_.removeElement(_l); }
    
    public void valueForPathChanged(TreePath _path, Object _newValue)
      { }

    public Vector getListeners()
      { return listeners_; }
  }

  public static void main(String[] _args)
  {
      new AlmaScreenCopy(null);
  }
}
