/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AlmaTacheConstructionConditions.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.alma;

import com.memoire.agl.*;
import com.memoire.alma.*;
import com.memoire.bu.*;

import java.io.*;

public class AlmaTacheConstructionConditions
       extends BuTask
{
  private AlmaImplementation app_;

  public AlmaTacheConstructionConditions(AlmaImplementation _app)
  {
    super();
    app_ =_app;

    setName(AlmaResource.ALMA.getString("Construction des conditions"));
    setTaskView(app_.getMainPanel().getTaskView());
  }

  public void start()
  {
    super.start();
  }

  public void run()
  {
     try
     {
       AglOptions.terminal.message(AlmaResource.ALMA.getString("Conditions"));
       AglOptions.terminal.progres(0);
       AglCondition.construireConditions();

       AglOptions.terminal.progres(100);
       app_.rafraichir();
     }
     catch(Exception ex) { ex.printStackTrace(); }

     AglOptions.terminal.progres(0);
     super.run();
  }
}
