/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AlmaTacheConstructionRelations.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.alma;
import com.memoire.agl.*;
import com.memoire.alma.*;
import com.memoire.bu.*;

import java.io.*;

public class AlmaTacheConstructionRelations
       extends BuTask
{
  private AlmaImplementation app_;

  public AlmaTacheConstructionRelations(AlmaImplementation _app)
  {
    super();
    app_ =_app;

    setName(AlmaResource.ALMA.getString("Construction des relations"));
    setTaskView(app_.getMainPanel().getTaskView());
  }

  public void start()
  {
    super.start();
  }

  public void run()
  {
     try
     {
       String t;

       AglRelation.detruireRelationsGenerees();

       t=AlmaResource.ALMA.getString("Relations")+
	 ": "+AlmaResource.ALMA.getString("hritage");
       AglOptions.terminal.message(t);
       setName(t);
       AglOptions.terminal.progres(0);
       AglRelation.construireRelationsHeritage();
       AglOptions.terminal.progres(100);

       t=AlmaResource.ALMA.getString("Relations")+
	 ": "+AlmaResource.ALMA.getString("implantation");
       AglOptions.terminal.message(t);
       setName(t);
       AglOptions.terminal.progres(0);
       AglRelation.construireRelationsImplantation();
       AglOptions.terminal.progres(100);

       t=AlmaResource.ALMA.getString("Relations")+
	 ": "+AlmaResource.ALMA.getString("contenance");
       AglOptions.terminal.message(t);
       setName(t);
       AglOptions.terminal.progres(0);
       AglRelation.construireRelationsContenance();
       AglOptions.terminal.progres(100);

       t=AlmaResource.ALMA.getString("Relations")+
	 ": "+AlmaResource.ALMA.getString("utilisation");
       AglOptions.terminal.message(t);
       setName(t);

       AglOptions.terminal.progres(0);
       AglRelation.construireRelationsUtilisation();
       AglOptions.terminal.progres(100);
       app_.rafraichir();
     }
     catch(Exception ex) { ex.printStackTrace(); }

     AglOptions.terminal.progres(0);
     super.run();
  }
}
