/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AlmaTacheEnregistrement.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.alma;
import com.memoire.agl.*;
import com.memoire.alma.*;
import com.memoire.bu.*;

import java.awt.*;
import java.io.*;

public class AlmaTacheEnregistrement
       extends BuTask
{
  private AlmaImplementation f;
  private String             r;
  private String             t;
  private Image              i;

  public AlmaTacheEnregistrement(AlmaImplementation _f, String _r, String _t)
  {
    this(_f,_r,_t,null);
  }

  public AlmaTacheEnregistrement(AlmaImplementation _f, String _r, Image _i)
  {
    this(_f,_r,null,_i);
  }

  private AlmaTacheEnregistrement(AlmaImplementation _f, String _r,
				  String _t, Image _i)
  {
    f=_f;
    r=_r;
    t=_t;
    i=_i;
    
    setName(AlmaResource.ALMA.getString("Enregistrement")+
	    ": "+BuLib.fileName(r));
    setTaskView(f.getMainPanel().getTaskView());
  }

  public void run()
  {
     AglOptions.terminal.message(AlmaResource.ALMA.getString("Enregistrement")+
				 ": "+BuLib.reducedPath(r));
     AglOptions.terminal.progres(0);

     if(t!=null)
     try
     {
       File             file   =new File(r);
       int              taille =t.length();
       PrintWriter      sout   =new PrintWriter(new FileWriter(file));

       AglOptions.terminal.progres(10);
       sout.print(t);
       AglOptions.terminal.progres(40);
       sout.flush();
       sout.close();
     }
     catch(Exception ex) { ex.printStackTrace(); }

     if(i!=null)
     {
       AglOptions.terminal.progres(60);
       AglImageEncoder.save(i,r,AglOptions.formatImage);
     }

     AglOptions.terminal.progres(100);
     AglOptions.terminal.message(BuLib.reducedPath(r)+" "+
				 AlmaResource.ALMA.getString("enregistr"));
     AglOptions.terminal.progres(0);
     super.run();
  }
}
