/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AlmaTacheGenerer.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.alma;
import com.memoire.agl.*;
import com.memoire.alma.*;
import com.memoire.bu.*;
import com.memoire.dja.*;

import java.awt.*;
import java.io.*;

public class AlmaTacheGenerer
       extends BuTask
{
  private AlmaImplementation app_;
  private AglProjet          projet_;
  private AglSortie[]        sorties_;

  public AlmaTacheGenerer(AlmaImplementation _app, AglProjet _projet)
  {
    app_    =_app;
    projet_ =_projet;
    sorties_=new AglSortie[0];

    setName(AlmaResource.ALMA.getString("Gnration")+
	    ": "+projet_.nom);
    setTaskView(app_.getMainPanel().getTaskView());
  }

  public void start()
  {
    super.start();
  }

  public void run()
  {
     AglOptions.terminal.message(AlmaResource.ALMA.getString("Gnration")+
				 ": "+projet_.nom);
     AglOptions.terminal.message(AlmaResource.ALMA.getString("Langage")+
				 ": "+AglOptions.code);
     AglOptions.terminal.progres(0);

     try
     {
       AglCode c=AglOptions.code();

       AglOptions.terminal.progres(10);
       sorties_=c.code(projet_);

       AglOptions.terminal.progres(70);

       for(int k=0;k<sorties_.length;k++)
       {
	 if(sorties_[k].donnee instanceof String)
	 {
	   String s=(String)sorties_[k].donnee;
	   //String f=sorties_[k].fichier;

	   if("text/html".equals(sorties_[k].mimetype))
	   {
	     app_.addInternalFrame(new BuBrowserFrame(app_,s));
	   }

	   if(AglOptions.appliquerExpReg)
	   {
	     AglOptions.terminal.message
	       ("Application des expressions rgulires");
	     s=c.appliqueExpReg(s);
	   }

	   //if(f==null) f=projet_;
	   app_.addInternalFrame(new AlmaFilleCible(app_,projet_,s));
	 }
	 else
	 if(sorties_[k].donnee instanceof DjaGrid)
	 {
	   DjaGrid s=(DjaGrid)sorties_[k].donnee;
	   String  f=sorties_[k].fichier;
	   if(f==null) f=projet_.nom+".dja";
	   app_.addInternalFrame(new AlmaFilleDiagramme(app_,f,s));
	 }
	 else
	 if(sorties_[k].donnee instanceof Image)
	 {
	   Image   s=(Image)sorties_[k].donnee;
	   String  f=sorties_[k].fichier;
	   if(f==null) f=projet_.nom+"."+AglOptions.formatImage.toLowerCase();
	   app_.addInternalFrame(new BuFrameImage(app_,f,s));
	 }
	 else
	 {
	   AglOptions.terminal.message(sorties_[k].toString());
	 }
       }

       AglOptions.terminal.progres(90);
       app_.rafraichir();

       AglOptions.terminal.progres(100);
       AglOptions.terminal.message(projet_.nom+" "+
				   AlmaResource.ALMA.getString("gnr"));
     }
     catch(Exception ex)
     {
       sorties_=new AglSortie[0];
       ex.printStackTrace();
       System.err.println(ex);
       AglOptions.terminal.erreur(projet_.nom+" "+ex.getMessage());
     }

     AglOptions.terminal.progres(0);
     super.run();
  }
}
