/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         AlmaTacheOuverture.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:06 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.alma;
import com.memoire.agl.*;
import com.memoire.alma.*;
import com.memoire.bu.*;

import java.io.*;

public class AlmaTacheOuverture
       extends BuTask
{
  private String             path_;
  private String             source_;
  private AlmaImplementation app_;

  public AlmaTacheOuverture
    (AlmaImplementation _app, String _path)
  {
    super();
    app_ =_app;
    path_=_path;

    setName(AlmaResource.ALMA.getString("Ouverture")+
	    ": "+BuLib.fileName(path_));
    setTaskView(app_.getMainPanel().getTaskView());
  }

  public void start()
  {
    super.start();
  }

  public void run()
  {
     AglOptions.terminal.message(AlmaResource.ALMA.getString("Ouverture")+
				 ": "+BuLib.reducedPath(path_));
     AglOptions.terminal.progres(0);
     source_="";

     try
     {
       File             file   =new File(path_);
       int              taille =(int)file.length();

       AglOptions.terminal.trace("FILE="+file);
       LineNumberReader sin=new LineNumberReader(new FileReader(file));
       AglOptions.terminal.trace("SIN="+sin);

       StringBuffer sb=new StringBuffer(taille);
       int pc,pp=-1;

       while(sin.ready())
       {
	 String l=sin.readLine();
	 if(l==null) break;

         sb.append(l);
	 sb.append('\n');
	 pc=100*sb.length()/taille;
         if(pp!=pc)
	 {
	   AglOptions.terminal.progres(pc);
	   pp=pc;
	 }
       }

       source_=sb.toString();
       sb=null;

       //System.err.println("FIN OUVERTURE");

       app_.addInternalFrame(new AlmaFilleSource(app_,path_,source_));

       AglOptions.terminal.message(BuLib.reducedPath(path_)+" "+
				   AlmaResource.ALMA.getString("ouvert"));
       AglOptions.terminal.progres(100);
     }
     catch(Exception ex) { ex.printStackTrace(); }

     AglOptions.terminal.progres(0);
     super.run();
  }
}
