/**
 * @modification $Date: 2001/12/03 16:28:06 $
 * @statut       unstable
 * @file         BuAbstractCellRenderer.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.table.*;
import javax.swing.tree.*;

public class BuAbstractCellRenderer
    extends    BuLabel
    implements ListCellRenderer, TreeCellRenderer
	       // , ComponentListener, ContainerListener
{
  public final static int LIST    =0;
  public final static int COMBOBOX=1;
  public final static int TREE    =2;

  private final static int TABLE   =3; //TMP

  /*
  public final static ListCellRenderer LIST_CR=new DefaultListCellRenderer();
  public final static TreeCellRenderer TREE_CR=new DefaultTreeCellRenderer();
  */

  protected final static Border NO_FOCUS_BORDER=new EmptyBorder(1,1,1,1);

  protected int type_;
  protected JLabel delegate_;

  protected BuAbstractCellRenderer(int _type)
  {
    type_    =_type;
    delegate_=this;
  }

  public void paint(Graphics _g)
  {
    if((delegate_==this)||(delegate_==null))
      super.paint(_g);
    else
    {
      /*
      Dimension ps=delegate_.getPreferredSize();
      Dimension cs=delegate_.getSize();
      delegate_.setSize(Math.max(ps.width,cs.width),
			Math.max(ps.height,cs.height));
      */
      BuLib.setAntialiasing(_g);
      delegate_.paint(_g);
    }
  }

  public Color getBackground()
  {
    if((delegate_==this)||(delegate_==null))
      return super.getBackground();
    else
      return delegate_.getBackground();
  }

  public void setBackground(Color _color)
  {
    if((delegate_==this)||(delegate_==null))
      super.setBackground(_color);
    else
      delegate_.setBackground(_color);
  }

  public Color getForeground()
  {
    if((delegate_==this)||(delegate_==null))
      return super.getForeground();
    else
      return delegate_.getForeground();
  }

  public void setForeground(Color _color)
  {
    if((delegate_==this)||(delegate_==null))
      super.setForeground(_color);
    else
      delegate_.setForeground(_color);
  }

  public void setBounds(int _x,int _y,int _w, int _h)
  {
    if((delegate_==this)||(delegate_==null))
      super.setBounds(_x,_y,_w,_h);
    else
      delegate_.setBounds(_x,_y,_w,_h);
  }

  public boolean isDoubleBuffered()
  {
    if((delegate_==this)||(delegate_==null))
      return super.isDoubleBuffered();
    else
      return delegate_.isDoubleBuffered();
  }

  public void setDoubleBuffered(boolean _state)
  {
    if((delegate_==this)||(delegate_==null))
      super.setDoubleBuffered(_state);
    else
      delegate_.setDoubleBuffered(_state);
  }

  public Container getParent()
  {
    if((delegate_==this)||(delegate_==null))
      return super.getParent();
    else
      return delegate_.getParent();
  }

  public Icon getIcon()
  {
    if((delegate_==this)||(delegate_==null))
      return super.getIcon();
    else
      return delegate_.getIcon();
  }

  public void setIcon(Icon _icon)
  {
    if((delegate_==this)||(delegate_==null))
      super.setIcon(_icon);
    else
      delegate_.setIcon(_icon);
  }

  public Icon getDisabledIcon()
  {
    if((delegate_==this)||(delegate_==null))
      return super.getDisabledIcon();
    else
      return delegate_.getDisabledIcon();
  }

  public void setDisabledIcon(Icon _icon)
  {
    if((delegate_==this)||(delegate_==null))
      super.setDisabledIcon(_icon);
    else
      delegate_.setDisabledIcon(_icon);
  }

  public int getDisplayedMnemonic()
  {
    if((delegate_==this)||(delegate_==null))
      return super.getDisplayedMnemonic();
    else
      return delegate_.getDisplayedMnemonic();
  }

  public void setDisplayedMnemonic(int _mnemonic)
  {
    if((delegate_==this)||(delegate_==null))
      super.setDisplayedMnemonic(_mnemonic);
    else
      delegate_.setDisplayedMnemonic(_mnemonic);
  }

  public int getHorizontalAlignment()
  {
    if((delegate_==this)||(delegate_==null))
      return super.getHorizontalAlignment();
    else
      return delegate_.getHorizontalAlignment();
  }

  public void setHorizontalAlignment(int _halign)
  {
    if((delegate_==this)||(delegate_==null))
      super.setHorizontalAlignment(_halign);
    else
      delegate_.setHorizontalAlignment(_halign);
  }

  public int getHorizontalTextPosition()
  {
    if((delegate_==this)||(delegate_==null))
      return super.getHorizontalTextPosition();
    else
      return delegate_.getHorizontalTextPosition();
  }

  public void setHorizontalTextPosition(int _htp)
  {
    if((delegate_==this)||(delegate_==null))
      super.setHorizontalTextPosition(_htp);
    else
      delegate_.setHorizontalTextPosition(_htp);
  }

  public int getIconTextGap()
  {
    if((delegate_==this)||(delegate_==null))
      return super.getIconTextGap();
    else
      return delegate_.getIconTextGap();
  }

  public void setIconTextGap(int _itg)
  {
    if((delegate_==this)||(delegate_==null))
      super.setIconTextGap(_itg);
    else
      delegate_.setIconTextGap(_itg);
  }

  public Dimension getMinimumSize()
  {
    if((delegate_==this)||(delegate_==null))
      return super.getMinimumSize();
    else
      return delegate_.getMinimumSize();
  }

  public void setMinimumSize(Dimension _size)
  {
    if((delegate_==this)||(delegate_==null))
      super.setMinimumSize(_size);
    else
      delegate_.setMinimumSize(_size);
  }

  public Dimension getMaximumSize()
  {
    if((delegate_==this)||(delegate_==null))
      return super.getMaximumSize();
    else
      return delegate_.getMaximumSize();
  }

  public void setMaximumSize(Dimension _size)
  {
    if((delegate_==this)||(delegate_==null))
      super.setMaximumSize(_size);
    else
      delegate_.setMaximumSize(_size);
  }

  public Dimension getPreferredSize()
  {
    Dimension r=null;

    if((delegate_==this)||(delegate_==null))
    {
      r=super.getPreferredSize();
      if((type_==TREE)&&(r!=null))
	r=new Dimension(r.width+3,r.height);
    }
    else
      r=delegate_.getPreferredSize();

    return r;
  }

  public void setPreferredSize(Dimension _size)
  {
    if((delegate_==this)||(delegate_==null))
      super.setPreferredSize(_size);
    else
      delegate_.setPreferredSize(_size);
  }

  public String getText()
  {
    if((delegate_==this)||(delegate_==null))
      return super.getText();
    else
      return delegate_.getText();
  }

  public void setText(String _text)
  {
    if((delegate_==this)||(delegate_==null))
      super.setText(_text);
    else
      delegate_.setText(_text);
  }

  public int getVerticalAlignment()
  {
    if((delegate_==this)||(delegate_==null))
      return super.getVerticalAlignment();
    else
      return delegate_.getVerticalAlignment();
  }

  public void setVerticalAlignment(int _halign)
  {
    if((delegate_==this)||(delegate_==null))
      super.setVerticalAlignment(_halign);
    else
      delegate_.setVerticalAlignment(_halign);
  }

  public int getVerticalTextPosition()
  {
    if((delegate_==this)||(delegate_==null))
      return super.getVerticalTextPosition();
    else
      return delegate_.getVerticalTextPosition();
  }

  public void setVerticalTextPosition(int _htp)
  {
    if((delegate_==this)||(delegate_==null))
      super.setVerticalTextPosition(_htp);
    else
      delegate_.setVerticalTextPosition(_htp);
  }

  /*
    + getLabelFor () : Component
    + getUI () : LabelUI
    + getUIClassID () : String
  */

  public void doLayout()
  {
    if((delegate_==this)||(delegate_==null))
      super.doLayout();
    else
      delegate_.doLayout();
  }

  public void revalidate()
  {
    if((delegate_==this)||(delegate_==null))
      super.revalidate();
    else
      delegate_.revalidate();
  }

  public void invalidate()
  {
    if((delegate_==this)||(delegate_==null))
      super.invalidate();
    else
      delegate_.invalidate();
  }

  public void validate()
  {
    if((delegate_==this)||(delegate_==null))
      super.validate();
    else
      delegate_.validate();
  }

  //public void validate() {}
  //public void revalidate() {}
  //public void repaint(long tm, int x, int y, int width, int height) {}
  //public void repaint(Rectangle r) {}

  protected void firePropertyChange(String _name, Object _old, Object _new)
  {
    if(_name=="text")
      super.firePropertyChange(_name, _old, _new);
  }

  public void firePropertyChange(String _name, byte    _old, byte    _new) { }
  public void firePropertyChange(String _name, char    _old, char    _new) { }
  public void firePropertyChange(String _name, short   _old, short   _new) { }
  public void firePropertyChange(String _name, int     _old, int     _new) { }
  public void firePropertyChange(String _name, long    _old, long    _new) { }
  public void firePropertyChange(String _name, float   _old, float   _new) { }
  public void firePropertyChange(String _name, double  _old, double  _new) { }
  public void firePropertyChange(String _name, boolean _old, boolean _new) { }

  /*
  public void componentResized(ComponentEvent _evt) { }
  public void componentMoved  (ComponentEvent _evt) { }
  public void componentShown  (ComponentEvent _evt) { }
  public void componentHidden (ComponentEvent _evt) { }

  public void componentAdded  (ContainerEvent _evt) { }
  public void componentRemoved(ContainerEvent _evt) { }
  */

  public synchronized Component getListCellRendererComponent
    (JList   _list,
     Object  _value,
     int     _index,
     boolean _selected,
     boolean _focus)
  {
    return getRealRenderer
      (_list,_value,_selected,false,true,_index,_focus);
  }

  public synchronized Component getTreeCellRendererComponent
    (JTree   _tree,
     Object  _value,
     boolean _selected,
     boolean _expanded,
     boolean _leaf,
     int     _index,
     boolean _focus)
  {
    return getRealRenderer
      (_tree,_value,_selected,_expanded,_leaf,_index,_focus);
  }

  protected synchronized Component getRealRenderer
    (JComponent _comp,
     Object     _value,
     boolean    _selected,
     boolean    _expanded,
     boolean    _leaf,
     int        _index,
     boolean    _focus)
  {
    delegate_=this;

    Object o=null;
    switch(type_)
    {
    case LIST:
	o=UIManager.get("List.cellRenderer");
	break;
    case COMBOBOX:
	o=UIManager.get("ComboBox.cellRenderer");
	if(o==null) o=UIManager.get("ComboBox.renderer");
	if(o==null) o=UIManager.get("List.cellRenderer");
	break;
    case TREE:     o=UIManager.get("Tree.cellRenderer");  break;
    case TABLE:    o=UIManager.get("Table.cellRenderer"); break;
    }

    if(o instanceof ListCellRenderer)
    {
      o=((ListCellRenderer)o).
	  getListCellRendererComponent
	  ((JList)_comp,_value,_index,_selected,_focus);
      if(o instanceof JLabel) delegate_=(JLabel)o;
    }

    if(o instanceof TreeCellRenderer)
    {
      o=((TreeCellRenderer)o).
	  getTreeCellRendererComponent
	  ((JTree)_comp,_value,_selected,_expanded,_leaf,_index,_focus);
      if(o instanceof JLabel) delegate_=(JLabel)o;
    }

    /*
    if(delegate_==this)
    {
      switch(type_)
      {
        case LIST:
	    delegate_=(JLabel)LIST_CR.
		getListCellRendererComponent
		((JList)_comp,_value,_index,_selected,_focus);
	    break;
        case COMBOBOX:
	    delegate_=(JLabel)LIST_CR. //COMBOBOX_CR.
		getListCellRendererComponent
		((JList)_comp,_value,_index,_selected,_focus);
	    break;
        case TREE:
	    delegate_=(JLabel)TREE_CR.
		getTreeCellRendererComponent
		((JTree)_comp,_value,_selected,_expanded,_leaf,_index,_focus);
	    break;
        case TABLE:
	    break;
      }
    }
    */

    if(delegate_==this)
    {
      // JDK 1.1
      //delegate_.setComponentOrientation(_list.getComponentOrientation());

      //System.err.println("BuAbstractCellRenderer: "+type_+" not found");
      
      if(_selected)
      {
	//delegate_.setOpaque(true);
	if(_comp instanceof JList)
	{
	  delegate_.setBackground(((JList)_comp).getSelectionBackground());
	  delegate_.setForeground(((JList)_comp).getSelectionForeground());
	}
	else
	if(_comp instanceof JTree)
	{
	  delegate_.setBackground(UIManager.getColor("Tree.selectionBackground"));
	  delegate_.setForeground(UIManager.getColor("Tree.selectionForeground"));
	}
      }
      else
      {
	//delegate_.setOpaque(false);
	delegate_.setBackground(_comp.getBackground());
	delegate_.setForeground(_comp.getForeground());

	/*
	if(_comp instanceof JList)
	{
	  delegate_.setBackground(((JList)_comp).getBackground());
	  delegate_.setForeground(((JList)_comp).getForeground());
	}
	else
	if(_comp instanceof JTree)
	{
	  delegate_.setBackground(UIManager.getColor("Tree.textBackground"));
	  delegate_.setForeground(UIManager.getColor("Tree.textForeground"));
	}
	*/
      }

      if(_comp instanceof JTree)
      {
	     if(_leaf    ) delegate_.setIcon(UIManager.getIcon("Tree.leafIcon"  ));
	else if(_expanded) delegate_.setIcon(UIManager.getIcon("Tree.openIcon"  ));
	else               delegate_.setIcon(UIManager.getIcon("Tree.closedIcon"));
      }

      delegate_.setOpaque(true);
      delegate_.setEnabled(_comp.isEnabled());
      delegate_.setFont(_comp.getFont());
      delegate_.setBorder
	  (_focus
	   ? UIManager.getBorder("List.focusCellHighlightBorder")
	   : NO_FOCUS_BORDER);
    }

    /*
    Color  bg=getBackground();
    Color  fg=getForeground();
    int    a =LEFT;
    String t ="";
    Icon   i =getIcon();

    if(_value instanceof Number)
    {
      a=RIGHT;
      if(((Number)_value).doubleValue()<0)
	fg=blueify(fg);
      if(numberFormat_!=null)
	t=numberFormat_.format(((Number)_value).doubleValue());
      else
	t=_value.toString();
    }
    else
    if(_value instanceof Date)
    {
      if(dateFormat_!=null)
	t=dateFormat_.format((Date)_value);
      else
	t=_value.toString();
    }
    else
    if(_value instanceof Boolean)
    {
      if(_selected)
	bg=((Boolean)_value).booleanValue()
	  ? BuLib.getColor(new Color(128,255,128))
	  : BuLib.getColor(new Color(255,128,128));
      else
	bg=((Boolean)_value).booleanValue()
	  ? BuLib.getColor(new Color(192,255,192))
	  : BuLib.getColor(new Color(255,192,192));
    }
    else
    if(_value instanceof BuIcon)
    {
      i=BuResource.resizeIcon((BuIcon)_value,Math.max(16,ft.getSize()));
    }
    else
    if(_value instanceof Icon)
    {
      i=(Icon)_value;
    }
    else
    if(_value==null)
    {
      t="";
    }
    else
    {
      t=_value.toString();
    }
    */

    if((_index%2)==1) setBackground(darken(getBackground()));

    return this;
  }

  private static final Color darken(Color _c)
  {
    int r=_c.getRed();
    int g=_c.getGreen();
    int b=_c.getBlue();

    r=r*19/20;
    g=g*19/20;
    b=b*19/20;

    return new Color(r,g,b);
  }

  // Factory

  private final static ListCellRenderer LCR =
      new BuAbstractCellRenderer(LIST);
  private final static ListCellRenderer CBCR=
      new BuAbstractCellRenderer(COMBOBOX);

  public final static ListCellRenderer getDefaultListCellRenderer()
  {
    return LCR;
  }

  public final static ListCellRenderer getDefaultComboBoxCellRenderer()
  {
    return CBCR;
  }
}
