/**
 * @modification $Date: 2001/12/03 16:28:06 $
 * @statut       unstable
 * @file         BuAbstractPreferencesPanel.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import com.memoire.dnd.*;
import com.memoire.fu.*;
import com.memoire.re.*;


import java.awt.event.*;
import java.awt.*;
import java.util.*;

import javax.swing.*;
import javax.swing.border.*;

/**
 * An abstract root class for panels attended to be added in the
 * BuPreferencesFrame.
 */

public abstract class BuAbstractPreferencesPanel
       extends JPanel
       // implements BuPreferencesInterface
{
  public abstract String getTitle();
  public String getToolTipText() { return null; }

  public boolean isPreferencesValidable() { return false; }
  public void validatePreferences() { }

  public boolean isPreferencesApplyable() { return false; }
  public void applyPreferences() { }

  public boolean isPreferencesCancelable() { return false; }
  public void cancelPreferences() { }
}
