/**
 * @modification $Date: 2001/12/03 16:28:06 $
 * @statut       unstable
 * @file         BuActionRemover.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import com.memoire.dnd.*;
import com.memoire.fu.*;
import com.memoire.re.*;


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * An utility class to remove controls by their command name.
 * The command name is a string defined for each control
 * using setActionCommand().
 */

public class BuActionRemover
{

  // Menu

  public static void removeAction
    (JMenuBar _bar, String _action)
  {
    MenuElement[] c=_bar.getSubElements();
    for(int i=0; i<c.length; i++)
      if(c[i] instanceof JMenu)
	removeAction((JMenu)c[i],_action);
  }

  public static void removeAction
    (JMenu _menu, String _action)
  {
    if(_menu.getActionCommand().equals(_action))
    {
      Container c=_menu.getParent();
      c.remove(_menu);

      // bug of swing ?
      try
      {
	//c.doLayout();
	//c.validate();
      }
      catch(ArrayIndexOutOfBoundsException ex) { }
    }

    MenuElement[] c=_menu.getSubElements();
    for(int i=0; i<c.length; i++)
    {
      if(c[i] instanceof JMenu)
	removeAction((JMenu)c[i],_action);
      else
      if(c[i] instanceof JPopupMenu)
	removeAction((JPopupMenu)c[i],_action);
      else
      if(c[i] instanceof JMenuItem)
	removeAction((JMenuItem)c[i],_action);
      else
	System.err.println("??? "+c[i]);
    }
  }

  public static void removeAction
    (JPopupMenu _menu, String _action)
  {
    MenuElement[] c=_menu.getSubElements();
    for(int i=0; i<c.length; i++)
    {
      if(c[i] instanceof JMenu)
	removeAction((JMenu)c[i],_action);
      else
      if(c[i] instanceof JPopupMenu)
	removeAction((JPopupMenu)c[i],_action);
      else
      if(c[i] instanceof JMenuItem)
	removeAction((JMenuItem)c[i],_action);
      else
	System.err.println("??? "+c[i]);
    }
  }

  public static void removeAction
    (JMenuItem _item, String _action)
  {
    if(_item.getActionCommand().equals(_action))
    {
      Container c=_item.getParent();
      c.remove(_item);

      // bug of swing ?
      try
      {
	c.doLayout();
	c.validate();
      }
      catch(ArrayIndexOutOfBoundsException ex) { }
    }
  }

  // Tool

  public static void removeAction
    (JToolBar _bar, String _action)
  {
    Component[] c=_bar.getComponents();
    for(int i=0; i<c.length; i++)
      if(c[i] instanceof JButton)
	removeAction((JButton)c[i],_action);
  }

  public static void removeAction
    (JButton _item, String _action)
  {
    if(_item.getActionCommand().equals(_action))
    {
      Container c=_item.getParent();
      c.remove(_item);

      // bug of swing ?
      try
      {
	c.doLayout();
	c.validate();
      }
      catch(ArrayIndexOutOfBoundsException ex) { }
    }
  }
}
