/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuCheckBoxMenuItem.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * Like JCheckBoxMenuItem but with better management of icons.
 */

public class BuCheckBoxMenuItem
       extends JCheckBoxMenuItem
{
  public BuCheckBoxMenuItem()
  {
    this(null,"");
  }

  public BuCheckBoxMenuItem(BuIcon _icon)
  {
    this(_icon,"");
  }

  public BuCheckBoxMenuItem(String _label)
  {
    this(null,_label);
  }

  public BuCheckBoxMenuItem(BuIcon _icon, String _label)
  {
    super();

    // setCursor(new Cursor(Cursor.HAND_CURSOR));
    if(_icon!=null) setIcon(_icon);
    if(_label==null) _label="";
    setText(_label);
  }

  /**
   * @deprecated
   */
  public BuCheckBoxMenuItem(Icon _icon)
  {
    this(null,_icon,false);
  }

  /**
   * @deprecated
   */
  public BuCheckBoxMenuItem(Icon _icon, boolean _selected)
  {
    this(null,_icon,_selected);
  }

  /**
   * @deprecated
   */
  public BuCheckBoxMenuItem(String _text,Icon _icon)
  {
    this(_text,_icon,false);
  }

  /**
   * @deprecated
   */
  public BuCheckBoxMenuItem(String _text,boolean _selected)
  {
    this(_text,null,_selected);
  }

  /**
   * @deprecated
   */
  public BuCheckBoxMenuItem(String _text,Icon _icon,boolean _selected)
  {
    super();
    setIcon(_icon);
    setText(_text);
    setSelected(_selected);
  }

  // Anti-aliasing

  public void paint(Graphics _g)
  {
    BuLib.setAntialiasing(_g);
    super.paint(_g);
  }

  public void setIcon(BuIcon _icon)
    { BuLib.setIcon(this,_icon); }

  public Point getToolTipLocation(MouseEvent _evt)
  {
    Point r=super.getToolTipLocation(_evt);
    if(r==null) r=new Point(getWidth(),0);
    return r;
  }
}
