/**
 * @modification $Date: 2001/12/07 18:28:12 $
 * @statut       unstable
 * @file         BuColorIcon.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import com.memoire.dnd.*;
import com.memoire.fu.*;
import com.memoire.re.*;


import java.awt.*;
import javax.swing.*;

/**
 * A simple icon which displays a 16x16 rect filled with
 * a given color.
 */

public class BuColorIcon
       implements Icon
{
  private Color color_;

  public BuColorIcon(Color _color)
  {
    super();
    color_=_color;
  }

  public int getIconHeight() { return BuResource.BU.getDefaultSize(); }
  public int getIconWidth () { return BuResource.BU.getDefaultSize(); } 
                
  public void paintIcon(Component _c, Graphics _g, int _x, int _y)
  {
    if(color_!=null)
    {
      Color old=_g.getColor();
      //BuLib.setColor(_g,color_);
      _g.setColor(color_);
      _g.fillRect(_x+2,_y+2,getIconWidth()-4,getIconHeight()-4);
      _g.setColor(UIManager.getColor("MenuItem.background"));
      _g.draw3DRect(_x+1,_y+1,getIconWidth()-3,getIconHeight()-3,false);
      _g.setColor(old);
    }
  }
}
