/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuCommandPreferencesPanel.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import com.memoire.fu.*;

import java.awt.event.*;
import java.awt.*;
import java.util.*;

import javax.swing.*;
import javax.swing.border.*;

/**
 * A panel where the user can choose which elements to
 * put on his toolbar.
 */

/**
 * command.*
 */

public class BuCommandPreferencesPanel
       extends BuAbstractPreferencesPanel
{
  public final static String[][] CODES=
  {
  // name              default short           long                       command            enabled
  { "create"          ,"true" ,"Crer"        ,"Crer..."                ,"CREER"           ,"false" },
  { "open"            ,"true" ,"Ouvrir"       ,"Ouvrir..."               ,"OUVRIR"          ,"false" },
  { "save"            ,"true" ,"Enregistrer"  ,"Enregistrer"             ,"ENREGISTRER"     ,"false" },
  { "save_as"         ,"false","Enregistrer"  ,"Enregistrer sous..."     ,"ENREGISTRERSOUS" ,"false" },
  { "close"           ,"false","Fermer"       ,"Fermer..."               ,"FERMER"          ,"false" },
  { "separator1"      ,"true" ,"-"            ,""                        ,""                ,"true"  },
  { "print"           ,"true" ,"Imprimer"     ,"Imprimer..."             ,"IMPRIMER"        ,"false" },
  { "preview"         ,"false","Prvisualiser","Prvisualiser..."        ,"PREVISUALISER"   ,"false" },
  { "separator2"      ,"true" ,"-"            ,""                        ,""                ,"true"  },
  { "undo"            ,"true" ,"Dfaire"      ,"Dfaire"                 ,"DEFAIRE"         ,"false" },
  { "redo"            ,"true" ,"Refaire"      ,"Refaire"                 ,"REFAIRE"         ,"false" },
  { "separator3"      ,"true" ,"-"            ,""                        ,""                ,"true"  },
  { "copy"            ,"true" ,"Copier"       ,"Copier"                  ,"COPIER"          ,"false" },
  { "cut"             ,"true" ,"Couper"       ,"Couper"                  ,"COUPER"          ,"false" },
  { "paste"           ,"true" ,"Coller"       ,"Coller"                  ,"COLLER"          ,"false" },
  { "duplicate"       ,"false","Dupliquer"    ,"Dupliquer"               ,"DUPLIQUER"       ,"false" },
  { "separator4"      ,"true" ,"-"            ,""                        ,""                ,"true"  },
  { "select_all"      ,"true" ,"Slectionner" ,"Tout slectionner"       ,"TOUTSELECTIONNER","false" },
  { "find"            ,"true" ,"Rechercher"   ,"Rechercher..."           ,"RECHERCHER"      ,"false" },
  { "replace"         ,"true" ,"Remplacer"    ,"Remplacer..."            ,"REMPLACER"       ,"false" },
  { "separator5"      ,"true" ,"-"            ,""                        ,""                ,"true"  },
  { "fullscreen"      ,"false","Ecran"        ,"Plein cran"             ,"PLEINECRAN"      ,"true"  },
  { "waterfall"       ,"false","Cascade"      ,"Ranger en cascade"       ,"CASCADE"         ,"true"  },
  { "tile"            ,"false","Mosaique"     ,"Ranger en mosaique"      ,"MOSAIQUE"        ,"true"  },
  { "arrange_icons"   ,"true" ,"Icnes"       ,"Ranger les icnes"       ,"RANGERICONES"    ,"true"  },
  { "arrange_palettes","true" ,"Palettes"     ,"Ranger les palettes"     ,"RANGERPALETTES"  ,"true"  },
  { "swap_columns"    ,"false","Echanger"     ,"Echanger les colonnes"   ,"ECHANGER"        ,"true"  },
  { "separator6"      ,"true" ,"-"            ,""                        ,""                ,"true"  },
  { "preference"      ,"false","Prfrences"  ,"Prfrences de dmarrage","PREFERENCE"      ,"false" },
  { "help"            ,"false","Aide"         ,"Aide en-ligne"           ,"AIDE"            ,"true"  },
  { "help_pointer"    ,"true" ,"Pointeur"     ,"Pointeur d'aide"         ,"POINTEURAIDE"    ,"true"  },
  { "tip"             ,"false","Astuces"      ,"Astuces"                 ,"ASTUCE"          ,"false" },
  };

  /*
  private final static String[] CODES=new String[]
  {
    "create",
    "open",
    "save",
    "save_as",
    "close",
    "separator1",
    "print",
    "preview",
    "separator2",
    "undo",
    "redo",
    "separator3",

    "copy",
    "cut",
    "paste",
    "duplicate",
    "separator4",
    "select_all",
    "find",
    "replace",
    "separator5",
    "fullscreen",
    "waterfall",
    "arrange_icons",
    "arrange_palettes",
    "swap_columns",

    "separator6",
    "help",
    "help_pointer",
  };

  private final static boolean[] DEFAUTS=new boolean[]
  {
    true,
    true,
    true,
    true,
    true,
    true,
    false,
    true,
    true,
    true,
    true,
    true,
    false,
  };

  private final static String[] INTITULES=new String[]
  {
    "Colonne gauche",
    "Outils spcifiques",
    "Colonne droite",
    "Barre d'tat",
    "Colonnes inverses",
    "Assistant",
    "Icne de bouton",
    "Dtachement des barres",
    "Texte de bouton",
    "Survol des barres",
    "Ecran d'accueil",
    "Bureau  onglets",
  };
  */

  BuCommonInterface appli_;
  BuPreferences     options_;
  BuCheckBox[]      cbEtats_;

  public String getTitle()
    { return BuResource.BU.getString("Barre"); }

  // Constructeur
  
  public BuCommandPreferencesPanel(BuCommonInterface _appli)
  {
    super();
    appli_     =_appli;
    options_   =BuPreferences.BU;

    BuPanel q=new BuPanel();
    q.setLayout(new BuGridLayout(2,5,2));
    q.setBorder(new EmptyBorder(0,5,0,5));

    cbEtats_=new BuCheckBox[CODES.length];
    for(int i=0;i<CODES.length;i++)
    {
      cbEtats_[i]=new BuCheckBox();
      cbEtats_[i].setName("cb"+CODES[i][4]);
      cbEtats_[i].setActionCommand(CODES[i][4]);
      cbEtats_[i].setText(BuResource.BU.getString(CODES[i][2]));
      q.add(cbEtats_[i]);
      BuLabel lb=new BuLabel();
      lb.setIcon(BuResource.BU.loadBarCommandIcon(CODES[i][4]));
      lb.setText(BuResource.BU.getString(CODES[i][3]));
      lb.setFont(BuLib.deriveFont("Label",-2));
      q.add(lb);
    }

    BuPanel p=new BuPanel();
    p.setBorder
      (new CompoundBorder
       (new TitledBorder(getTitle()),
	new EmptyBorder(5,5,5,5)));
    p.setLayout(new BuBorderLayout());
    p.add(new BuScrollPane(q),BuBorderLayout.CENTER);

    setLayout(new BuBorderLayout());
    setBorder(new EmptyBorder(5,5,5,5));
    setPreferredSize(new Dimension(100,100));
    add(p,BuBorderLayout.CENTER);

    for(int i=0;i<CODES.length;i++)
      cbEtats_[i].setSelected("true".equals(CODES[i][1]));

    updateComponents();
  }
  
  // Methodes publiques

  public boolean isPreferencesValidable()
    { return true; }

  public void validatePreferences()
  {
    fillTable();
    options_.writeIniFile();
  }

  /*
  public boolean isPreferencesApplyable()
    { return true; }
  
  public void applyPreferences()
  {
    fillTable();
    options_.applyOn(appli_);
  }
  */

  public boolean isPreferencesCancelable()
    { return true; }

  public void cancelPreferences()
  {
    options_.readIniFile();
    updateComponents();
  }
  
  // Methodes privees
  
  private void fillTable()
  {
    for(int i=0;i<CODES.length;i++)
      options_.putBooleanProperty
	  ("command."+CODES[i][0],cbEtats_[i].isSelected());
  }

  private void updateComponents()
  {
    for(int i=0;i<CODES.length;i++)
      cbEtats_[i].setSelected
	(options_.getBooleanProperty
	 ("command."+CODES[i][0],"true".equals(CODES[i][1])));
  }
}

