/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuCommonInterface.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import com.memoire.dnd.*;
import com.memoire.fu.*;
import com.memoire.re.*;


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * A common interface for Applications, Applets and SubApps.
 * To access uniformly to services and avoid redundant coding.
 */

public interface BuCommonInterface
       extends   ActionListener, BuCutCopyPasteInterface,
                 BuUndoRedoInterface, BuSelectFindReplaceInterface
{
  BuCommonInterface      getApp();
  BuCommonImplementation getImplementation();

  BuMainPanel   getMainPanel();
  void          setMainPanel(BuMainPanel _p);
  BuMenuBar     getMainMenuBar();
  void          setMainMenuBar(BuMenuBar _mb);
  BuToolBar     getMainToolBar();
  void          setMainToolBar(BuToolBar _tb);
  BuSpecificBar getSpecificBar();
  void          setSpecificBar(BuSpecificBar _sb);

  /*
  BuSplashScreen getSplashScreen();
  void           setSplashScreen(BuSplashScreen _ss);
  */

  void start();
  void init();
  void actionPerformed(ActionEvent _evt);
  void doLayout();
  void validate();

  void setTitle(String _s);
  void setLookAndFeel(String _lnf);
  void setJMenuBar(JMenuBar _mb);
  void setContentPane(Container _c);

  JRootPane getRootPane();
  Frame     getFrame();

  void showOrHide(String _a, JComponent _c);
  void removeAction(String _cmd);
  void setEnabledForAction(String _cmd, boolean _enabled);
  void setCheckedForAction(String _cmd, boolean _checked);

  boolean confirmExit();
  void displayURL(String _url);

  void about  ();
  void cut    ();
  void copy   ();
  void exit   ();
  void find   ();
  void license();
  void paste  ();
  void print  ();
  void redo   ();
  void replace();
  void select ();
  void undo   ();

  BuInformationsSoftware getInformationsSoftware();
}
