/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuComposedIcon.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import com.memoire.dnd.*;
import com.memoire.fu.*;
import com.memoire.re.*;


import java.awt.*;
import java.util.*;
import javax.swing.*;

/**
 * An icon composer which overlays other icons.
 */

public class BuComposedIcon
       implements Icon
{
  private Icon[] icons_;

  public BuComposedIcon(Icon _icon1, Icon _icon2)
  {
    icons_=new Icon[2];
    icons_[0]=_icon1;
    icons_[1]=_icon2;
  }

  public BuComposedIcon(Icon[] _icons)
  {
    if(_icons==null) _icons=new Icon[0];
    icons_=_icons;
  }

  public int getIconHeight()
  {
    int h=0;
    for(int i=0;i<icons_.length;i++)
      h=Math.max(h,icons_[i].getIconHeight());
    return h;
  }

  public int getIconWidth()
  {
    int w=0;
    for(int i=0;i<icons_.length;i++)
      w=Math.max(w,icons_[i].getIconWidth());
    return w;
  }
                
  public void paintIcon(Component _c, Graphics _g, int _x, int _y)
  {
    for(int i=0;i<icons_.length;i++)
      icons_[i].paintIcon(_c,_g,_x,_y);
  }
}
