/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuDesktopManager.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import com.memoire.dnd.*;
import com.memoire.fu.*;
import com.memoire.re.*;


import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import javax.swing.*;
import javax.swing.border.*;

/**
 * A desktop manager which adjust size of the internal frames.
 */

public class BuDesktopManager
       extends DefaultDesktopManager
{
  private BuDesktop desktop_;

  public BuDesktopManager(BuDesktop _desktop)
  {
    super();
    desktop_=_desktop;
  }

  public void dragFrame(JComponent _f, int _x, int _y)
  {
    if(  !desktop_.isTabbed()
       ||_f.getClientProperty("JInternalFrame.isPalette")==Boolean.TRUE)
      super.dragFrame(_f,_x,_y);
  }

  public void endDraggingFrame(JComponent _f)
  {
    super.endDraggingFrame(_f);
    desktop_.snapXY(_f);
    /*
    if(  BuPreferences.BU.getBooleanProperty("desktop.snap",false)
       &&!desktop_.isTabbed()
       &&!BuDesktop.isPalette(_f))
    {
      Point   p=_f.getLocation();
      boolean b=false;
      if(p.x%37!=0) { p.x=p.x-p.x%37; b=true; }
      if(p.y%37!=0) { p.y=p.y-p.y%37; b=true; }
      if(b) _f.setLocation(p);
    }
    */
    desktop_.adjustSize();
  }

  public void endResizingFrame(JComponent _f)
  {
    super.endResizingFrame(_f);
    desktop_.snapWH(_f);
    /*
    if(  BuPreferences.BU.getBooleanProperty("desktop.snap",false)
       &&!desktop_.isTabbed()
       &&!BuDesktop.isPalette(_f)
       &&(_f instanceof JInternalFrame)
       &&((JInternalFrame)_f).isResizable())
    {
      Dimension d=_f.getSize();
      boolean   b=false;
      if(d.width %37!=0) { d.width =d.width +35-d.width %37; b=true; }
      if(d.height%37!=0) { d.height=d.height+35-d.height%37; b=true; }
      if(b) _f.setSize(d);
    }
    */
    desktop_.adjustSize();
  }

  /*
  public void setBoundsForFrame
    (JComponent _f, int _x, int _y, int _width, int _height)
  {
    if(!desktop_.isTabbed()) 
      super.setBoundsForFrame(_f,_x,_y,_width,_height);
    else
    {
      Dimension dd=desktop_.getSize();
      super.setBoundsForFrame(_f,desktop_.LEFT_MARGIN+3,0,
			      dd.width-desktop_.LEFT_MARGIN-3,dd.height);
    }
  }
  */
}
