/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuDialogConfirmation.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import com.memoire.dnd.*;
import com.memoire.fu.*;
import com.memoire.re.*;


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

/**
 * A standard confirm dialog (yes/no).
 */

public class BuDialogConfirmation
       extends BuDialog
       implements ActionListener
{
  protected BuButton btOui_;
  protected BuButton btNon_;

  public BuDialogConfirmation(BuCommonInterface      _parent,
			      BuInformationsSoftware _isoft,
			      Object                 _message)
  {
    super(_parent,_isoft,BuResource.BU.getString("Confirmation"),_message);

    BuPanel pnb=new BuPanel();
    pnb.setLayout(new FlowLayout(FlowLayout.RIGHT));

    btOui_=new BuButton(BuLib.loadCommandIcon("OUI"),
		       BuResource.BU.getString("Oui"));
    btOui_.addActionListener(this);
    pnb.add(btOui_);

    btNon_=new BuButton(BuLib.loadCommandIcon("NON"),
		       BuResource.BU.getString("Non"));
    btNon_.addActionListener(this);
    getRootPane().setDefaultButton(btNon_);
    pnb.add(btNon_);

    content_.add(pnb,BuBorderLayout.SOUTH);
  }

  public JComponent getComponent()
  { return null; }

  public void actionPerformed(ActionEvent _evt)
  {
    JComponent source=(JComponent)_evt.getSource();
    // System.err.println("BuDialog : "+source);

    if(source==btOui_)
    {
      reponse_=JOptionPane.YES_OPTION;
      setVisible(false);
    }

    if(source==btNon_)
    {
      reponse_=JOptionPane.NO_OPTION;
      setVisible(false);
    }
  }
}
