/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuDialogFind.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import com.memoire.dnd.*;
import com.memoire.fu.*;
import com.memoire.re.*;


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

/**
 * A standard dialog to find, with history.
 */

public class BuDialogFind
       extends BuDialog
       implements ActionListener
{
  protected BuButton                 btRechercher_;
  protected BuButton                 btFermer_;
  protected BuTextComponentInterface tcTexte_;
  protected BuTextField              tfMotif_;
  protected BuCheckBox               cbCasse_;

  // TEMP
  /*
  public BuDialogFind(BuCommonInterface      _parent,
		      BuInformationsSoftware _isoft,
		      BuTextPane             _texte)
  {
    super(_parent,_isoft,BuResource.BU.getString("Recherche"));
  }
  */

  public BuDialogFind(BuCommonInterface        _parent,
		      BuInformationsSoftware   _isoft,
		      BuTextComponentInterface _texte)
  {
    super(_parent,_isoft,BuResource.BU.getString("Recherche"));

    tcTexte_=_texte;

    BuPanel pnb=new BuPanel();
    pnb.setLayout(new FlowLayout(FlowLayout.RIGHT));

    btRechercher_=new BuButton(BuLib.loadCommandIcon("RECHERCHER"),
		       BuResource.BU.getString("Rechercher"));
    btRechercher_.addActionListener(this);
    getRootPane().setDefaultButton(btRechercher_);
    pnb.add(btRechercher_);

    btFermer_=new BuButton(BuLib.loadCommandIcon("QUITTER"),
		       BuResource.BU.getString("Fermer"));
    btFermer_.addActionListener(this);
    pnb.add(btFermer_);

    content_.add(pnb,BuBorderLayout.SOUTH);
  }

  public JComponent getComponent()
  {
    tfMotif_=new BuTextField();
    tfMotif_.setColumns(20);
    tfMotif_.addActionListener(this);
    
    cbCasse_=new BuCheckBox(BuResource.BU.getString
			    ("Distinction majuscules/minuscules"));
    
    BuPanel p=new BuPanel();
    p.setLayout(new BuVerticalLayout());
    p.setBorder(new EmptyBorder(5,5,5,5));
    p.add(new BuLabel(BuResource.BU.getString("Texte  rechercher:")));
    p.add(tfMotif_);
    p.add(cbCasse_);
    p.add(new BuPanel());
    return p;
  }

  public void actionPerformed(ActionEvent _evt)
  {
    JComponent source=(JComponent)_evt.getSource();
    // System.err.println("BuDialogFind : "+source);

    if((source==btRechercher_)||(source==tfMotif_))
    {
      reponse_=JOptionPane.OK_OPTION;

      int     pos  =tcTexte_.getCaretPosition();
      String  motif=tfMotif_.getText();
      boolean casse=cbCasse_.isSelected();

      if(pos==tcTexte_.getLength()) pos=0;
      if((!tcTexte_.find(motif,pos,!casse))&&(pos>0))
	tcTexte_.find(motif,0,!casse);
	
      // setVisible(false);
    }

    if(source==btFermer_)
    {
      reponse_=JOptionPane.CANCEL_OPTION;
      setVisible(false);
    }
  }
}

