/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuDialogMulti.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

/**
 * A standard dialog for input.
 */

public class BuDialogMulti
       extends BuDialog
       implements ActionListener
{
  protected BuButton    btValider_;
  protected BuButton    btAnnuler_;
  protected BuTextArea  taValeur_;
  protected BuLabel     lbValeur_;

  public BuDialogMulti(BuCommonInterface      _parent,
		       BuInformationsSoftware _isoft,
		       String                 _title,
		       String                 _label,
		       String                 _value)
  {
    super(_parent,_isoft,_title);

    taValeur_.setText(_value);
    lbValeur_.setText(_label);
    valeur_=null;
    
    BuPanel pnb=new BuPanel();
    pnb.setLayout(new FlowLayout(FlowLayout.RIGHT));

    btValider_=new BuButton(BuLib.loadCommandIcon("VALIDER"),
		       BuResource.BU.getString("Valider"));
    btValider_.addActionListener(this);
    getRootPane().setDefaultButton(btValider_);
    pnb.add(btValider_);

    btAnnuler_=new BuButton(BuLib.loadCommandIcon("ANNULER"),
		       BuResource.BU.getString("Annuler"));
    btAnnuler_.addActionListener(this);
    pnb.add(btAnnuler_);

    content_.add(pnb,BuBorderLayout.SOUTH);
  }

  public JComponent getComponent()
  {
    taValeur_=new BuTextArea();
    taValeur_.setColumns(20);
    taValeur_.setRows(10);
    // taValeur_.addActionListener(this);

    lbValeur_=new BuLabel();

    BuPanel p=new BuPanel();
    p.setLayout(new BuVerticalLayout());
    p.setBorder(new EmptyBorder(5,5,5,5));
    p.add(lbValeur_);
    p.add(taValeur_);
    p.add(new BuPanel());
    return p;
  }

  public void actionPerformed(ActionEvent _evt)
  {
    JComponent source=(JComponent)_evt.getSource();
    // System.err.println("BuDialogInput : "+source);

    if((source==btValider_)||(source==taValeur_))
    {
      reponse_=JOptionPane.OK_OPTION;
      valeur_ =taValeur_.getText();
      setVisible(false);
    }

    if(source==btAnnuler_)
    {
      reponse_=JOptionPane.CANCEL_OPTION;
      valeur_ =null;
      setVisible(false);
    }
  }

  private String valeur_;

  public String getValue()
    { return valeur_; }

  public void setValue(String _value)
  {
    taValeur_.setText(_value);
    valeur_=_value;
  }
}

