/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuDialogReplace.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import com.memoire.dnd.*;
import com.memoire.fu.*;
import com.memoire.re.*;


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

/**
 * A standard dialog to replace, with history.
 */

public class BuDialogReplace
       extends BuDialog
       implements ActionListener
{
  protected BuButton                 btRemplacer_;
  protected BuButton                 btFermer_;
  protected BuTextComponentInterface tcTexte_;
  protected BuTextField              tfMotif_;
  protected BuTextField              tfCible_;
  protected BuCheckBox               cbCasse_;

  public BuDialogReplace(BuCommonInterface        _parent,
			 BuInformationsSoftware   _isoft,
			 BuTextComponentInterface _texte)
  {
    super(_parent,_isoft,BuResource.BU.getString("Remplacement"));

    tcTexte_=_texte;

    BuPanel pnb=new BuPanel();
    pnb.setLayout(new FlowLayout(FlowLayout.RIGHT));

    btRemplacer_=new BuButton(BuLib.loadCommandIcon("REMPLACER"),
		       BuResource.BU.getString("Remplacer"));
    btRemplacer_.addActionListener(this);
    getRootPane().setDefaultButton(btRemplacer_);
    pnb.add(btRemplacer_);

    btFermer_=new BuButton(BuLib.loadCommandIcon("QUITTER"),
		       BuResource.BU.getString("Fermer"));
    btFermer_.addActionListener(this);
    pnb.add(btFermer_);

    content_.add(pnb,BuBorderLayout.SOUTH);
  }

  public JComponent getComponent()
  {
    tfMotif_=new BuTextField();
    tfMotif_.setColumns(20);

    tfCible_=new BuTextField();
    tfCible_.setColumns(20);
    
    cbCasse_=new BuCheckBox(BuResource.BU.getString
			  ("Distinction majuscules/minuscules"));
    
    BuPanel p=new BuPanel();
    p.setLayout(new BuVerticalLayout());
    p.setBorder(new EmptyBorder(5,5,5,5));
    p.add(new BuLabel(BuResource.BU.getString("Texte  rechercher:")));
    p.add(tfMotif_);
    p.add(new BuLabel(BuResource.BU.getString("Remplacer par:")));
    p.add(tfCible_);
    p.add(cbCasse_);
    p.add(new BuPanel());
    return p;
  }

  public void actionPerformed(ActionEvent _evt)
  {
    JComponent source=(JComponent)_evt.getSource();
    // System.err.println("BuDialogReplace : "+source);

    if(source==btRemplacer_)
    {
      reponse_=JOptionPane.OK_OPTION;

      int     pos  =tcTexte_.getCaretPosition();
      String  motif=tfMotif_.getText();
      String  cible=tfCible_.getText();
      boolean casse=cbCasse_.isSelected();

      if(pos==tcTexte_.getLength()) pos=0;
      if(  (!tcTexte_.replace(motif,cible,pos,tcTexte_.getLength(),!casse))
	 &&(pos>0))
	tcTexte_.replace(motif,cible,0,tcTexte_.getLength(),!casse);
	
      // setVisible(false);
    }

    if(source==btFermer_)
    {
      reponse_=JOptionPane.CANCEL_OPTION;
      setVisible(false);
    }
  }
}

