/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuDynamicMenu.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
//import com.memoire.fu.*;
import java.awt.*;

public abstract class BuDynamicMenu
                extends BuMenu
{
  public BuDynamicMenu(String _s, String _cmd)
  {
    super(_s,_cmd);
  }

  protected abstract void    build();
  protected abstract boolean isActive();

  public final void setSelected(boolean _state)
  {
    if(_state&&!isSelected()) build();
    super.setSelected(_state);
  }

  public final boolean isEnabled()
  {
    return super.isEnabled();
  }

  public final void setEnabled(boolean _enabled)
  {
    super.setEnabled(_enabled);
  }

  public final void paintComponent(Graphics _g)
  {
    boolean a=isActive();
    boolean r=isEnabled();
    if(r!=a) setEnabled(a);
    super.paintComponent(_g);
  }
}
