/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuEmptyList.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import javax.swing.*;
import java.awt.*;

/**
 * A list which changes its background and displays a message
 * when it's empty.
 */

public class BuEmptyList
       extends BuList
{
  protected static Font getETF()
  {
    return BuLib.deriveFont("List",Font.PLAIN,-2);
  }

  public BuEmptyList()
  {
    super();
  }

  public Color getBackground()
  {
    Color     bg=null;
    ListModel lm=getModel();

    if(lm.getSize()==0)
      bg=UIManager.getColor("Label.background");
    else
      bg=super.getBackground();
      // UIManager.getColor("Label.background").brighter();

    return bg;
  }

  /*
  public Dimension getMinimumSize()
  {
    Dimension r=null;

    ListModel lm=getModel();
    if(lm.getSize()==0)
    {
      Insets      insets=getInsets();
      Font        ft    =getETF();
      FontMetrics fm    =getToolkit().getFontMetrics(ft);
      int         hs    =ft.getSize();
      int         ws    =fm.stringWidth(getEmptyText());

      r=new Dimension(insets.left+insets.right+4+ws,
		      insets.top+insets.bottom+4+hs);
    }
    else r=super.getMinimumSize();

    return r;
  }
  */

  /*
  public Dimension getPreferredSize()
  {
    Dimension r=null;

    ListModel lm=getModel();
    if(lm.getSize()==0)
    {
      Insets      insets=getInsets();
      Font        ft    =getETF();
      FontMetrics fm    =getToolkit().getFontMetrics(ft);
      int         hs    =ft.getSize();
      int         ws    =fm.stringWidth(getEmptyText());

      r=new Dimension(insets.left+insets.right+4+ws,
		      insets.top+insets.bottom+4+hs);
    }
    else r=super.getPreferredSize();

    return r;
  }
  */

  public void paintComponent(Graphics _g)
  {
    try { super.paintComponent(_g); }
    catch(ArrayIndexOutOfBoundsException ex) { } // swing 1.03

    ListModel lm=getModel();
    if(lm.getSize()==0)
    {
      Insets  insets=getInsets();
      Font    ft    =getETF();
      int     hs    =ft.getSize();
      Color   fg    =getForeground();
      Color   bg    =getBackground();
      String  s     =getEmptyText();

      _g.setFont(ft);
      _g.setColor(fg);
      _g.drawString(s,insets.left+2,insets.top+hs);
    }
  }

  private String emptyText_="";
  public String getEmptyText() { return emptyText_; }
  public void setEmptyText(String _v)
  {
    if(!emptyText_.equals(_v))
    {
      String vp=emptyText_;
      emptyText_=_v;
      firePropertyChange("emptyText",_v,vp);
      repaint();
    }
  }
}







