/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuFileChooser.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import com.memoire.dnd.*;
import com.memoire.fu.*;
import com.memoire.re.*;


import java.awt.*;
import java.io.*;
import javax.swing.filechooser.*;
import javax.swing.*;

/**
 * Similar to JFileChooser but with a size adapted to the screen.
 */
public class BuFileChooser
       extends JFileChooser
{
  public BuFileChooser()
  {
    super();
    setDialogTitle(BuResource.BU.getString("Fichier"));
    Dimension e=getToolkit().getScreenSize();
    setPreferredSize(new Dimension(Math.min(480,e.width-160),
				   Math.max(480,e.height-160)));
  }

  /**
   * @deprecated
   */
  public BuFileChooser(File _file)
  {
    this();
    setCurrentDirectory(_file);
  }

  /**
   * @deprecated
   */
  public BuFileChooser(String _file)
  {
    this(new File(_file));
  }
}
