/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuFixedSizeIcon.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import com.memoire.dnd.*;
import com.memoire.fu.*;
import com.memoire.re.*;


import java.awt.*;
import java.net.*;
import javax.swing.*;

/**
 * An Icon but with fixed size.
 */

public class BuFixedSizeIcon
       implements Icon
{
  private Icon icon_;
  private int  w_,h_;

  public BuFixedSizeIcon(Icon _icon, int _w, int _h)
  {
    icon_=_icon;
    w_=_w;
    h_=_h;
  }

  public int getIconWidth () { return w_; }
  public int getIconHeight() { return h_; }

  public void paintIcon(Component _c, Graphics _g, int _x, int _y)
  {
    Shape old=_g.getClip();
    _g.setClip(new Rectangle(_x,_y,w_,h_));
    int x=_x+(w_-icon_.getIconWidth ())/2;
    int y=_y+(h_-icon_.getIconHeight())/2;
    icon_.paintIcon(_c,_g,x,y);
    _g.setClip(old);
  }
}
