/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuGenericPreferencesPanel.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import com.memoire.fu.*;

/**
 * @creation     2001-03-06
 * @modification 2001-03-06
 * @statut       unstable
 */

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import javax.swing.table.*;

/**
 * A panel where the user can view/edit preferences.
 * any
 */
public class BuGenericPreferencesPanel
       extends BuAbstractPreferencesPanel
{
  private String                    title_;
  private BuCommonInterface         appli_;
  private FuPreferences             options_;
  private boolean                   editable_,growable_;
  private BuGenericPreferencesModel model_;

  public String getTitle() { return title_; }

  public BuGenericPreferencesPanel
    (BuCommonInterface _appli, String _title, FuPreferences _options)
  {
    this(_appli,_title,_options,"",true,false);
  }

  public BuGenericPreferencesPanel
    (BuCommonInterface _appli, String _title, FuPreferences _options,
     String _mask, boolean _editable, boolean _growable)
  {
    super();
    appli_   =_appli;
    title_   =_title;
    options_ =_options;
    editable_=_editable;
    growable_=_growable;
    model_   =new BuGenericPreferencesModel
	(options_,_mask,editable_,growable_);

    BuBorderLayout lo=new BuBorderLayout();
    lo.setVgap(5);
    lo.setHgap(5);

    BuPanel p=new BuPanel();
    p.setBorder
      (new CompoundBorder
       (new TitledBorder(getTitle()),
	new EmptyBorder(5,5,5,5)));
    p.setLayout(lo);

    BuTable table=new BuTable(model_);
    //table.setFont(BuLib.deriveFont("Table",-2));
    p.add(new BuScrollPane(table),BuBorderLayout.CENTER);

    setLayout(new BuBorderLayout());
    setBorder(new EmptyBorder(5,5,5,5));
    add(p,BuBorderLayout.CENTER);
    setPreferredSize(new Dimension(200,200));
  }

  public boolean isPreferencesValidable()
  { return (editable_||growable_); }

  public void validatePreferences()
  {
    options_.writeIniFile();
  }

  public boolean isPreferencesCancelable()
  { return (editable_||growable_); }

  public void cancelPreferences()
  {
    options_.readIniFile();
    model_.fireTableChanged();
  }
}
