/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuIcon.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import com.memoire.dnd.*;
import com.memoire.fu.*;
import com.memoire.re.*;


import java.awt.*;
import java.awt.image.*;
import java.io.*;
import java.net.*;
import javax.swing.*;

/**
 * An ImageIcon but with always some image.
 */

public class BuIcon
       extends ImageIcon
{
  protected static Image defaut_;

  static
  {
    int[] di=new int[]
      {
	0x49, 0x47, 0x38, 0x46, 0x61, 0x37, 0x00, 0x01, 0x00, 0x01,
	0x00, 0x80, 0xf8, 0x00, 0xf8, 0xfc, 0x00, 0x00, 0x2c, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x02, 0x00,
	0x44, 0x02, 0x00, 0x01, 0x00, 0x3b
      };

    byte[] db=new byte[di.length];
    for(int i=0;i<di.length;i++) db[i]=(byte)di[i];

    defaut_=BuLib.HELPER.getToolkit().createImage(db);
  }

  public BuIcon(URL _url)
  {
    //super(_url);
    super();

    if(_url!=null)
    {
      try
      {
	if(_url.toString().startsWith("jar:"))
	{
	  setImage(new ImageIcon(_url).getImage());
	}
	else
	{
	  InputStream           in =_url.openStream();
	  ByteArrayOutputStream out=new ByteArrayOutputStream();
	  while(in.available()>0)
	    out.write(in.read());
	  setImage(BuLib.HELPER.getToolkit().createImage(out.toByteArray()));
	}
      }
      catch(Throwable ex)
      {
	System.err.println("Problem with "+_url);
      }
    }

    if(getImage()==null) setImage(defaut_);
    // System.out.println("BuIcon("+_url+")");
  }

  public BuIcon(Image _image)
  {
    super();
    if(_image!=null) setImage(_image);
    else             setImage(defaut_);
  }

  public BuIcon()
  {
    super();
    setImage(defaut_);
  }

  // Property hotspot
  private Point hotspot_=null;
  public Point getHotSpot() { return hotspot_; }
  public void setHotSpot(Point _hotspot) { hotspot_=_hotspot; }

  public void paintIcon(Component _c, Graphics _g, int _x, int _y)
  {
    BuLib.setAntialiasing(_g);
    if(hotspot_!=null) _g.translate(-hotspot_.x,-hotspot_.y);
    super.paintIcon(_c,_g,_x,_y);
    if(hotspot_!=null) _g.translate(hotspot_.x,hotspot_.y);
  } 

  public String toString()
  {
    String r=getDescription();
    if(r==null) r="";
    return r;
  }
}
