// Produit: Alma (Atelier logiciel de modelistion et d'analyse)
// Fichier: BuImageEncoder.java
// Version: 0.34
// Page   : http://www.memoire.com/guillaume-desnoix/alma/
// Date   : 2001-09-25
// Auteur : Guillaume Desnoix
// Mel    : guillaume@desnoix.com
// Licence: GNU General Public License 2 (GPL2)
//          Copyright (c)1998-2001 Guillaume Desnoix.
//          Tous droits reserves.
package com.memoire.bu;
import com.memoire.acme.*;
import com.memoire.bu.*;

import java.io.*;
import java.awt.*;

public class BuImageEncoder
{
  public static void save(Image _image, String _fichier, String _format)
    throws IOException
  {
    _format=_format.toLowerCase();
    if(_format.equals("jpeg")) _format="jpg";

    if(!_fichier.endsWith("."+_format))
      _fichier+="."+_format;

    OutputStream     out=new FileOutputStream(_fichier);
    AcmeImageEncoder ie =null;

         if(_format.equals("gif")) ie=new AcmeGifEncoder (_image,out);
    else if(_format.equals("jpg")) ie=new AcmeJpegEncoder(_image,out);
    else if(_format.equals("ppm")) ie=new AcmePpmEncoder (_image,out);
    else throw new IOException("Unknown image format");

    ie.encode();
    out.close();
  }
}
