/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuInformationsSoftware.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import com.memoire.dnd.*;
import com.memoire.fu.*;
import com.memoire.re.*;


/**
 * Basic informations for a software.
 */

public class BuInformationsSoftware
       extends Object
{
  public String   name;
  public String   version;
  public String   date;
  public String   rights;
  public String   contact;
  public String   license;
  public String   languages;
  public BuIcon   logo;
  public BuIcon   banner;
  public String   ftp;
  public String   http;
  public String   man;
  public String   update;
  public String   citation;
  public String[] authors;
  public String[] specifiers;
  public String[] contributors;
  public String[] documentors;
  public String[] translators;
  public String[] testers;
  public String[] libraries;
  public String[] thanks;

  public BuInformationsSoftware()
  {
    name        ="Inconnu";
    version     ="inconnue";
    date        ="1970-01-01";
    rights      ="";
    contact     ="guillaume@desnoix.com";
    license     ="GNU General Public License 2 (GPL)";
    languages   ="fr";
    logo        =null;
    banner      =null;
    // ftp="ftp://ftp.memoire.com/";
    http        ="http://www.memoire.com/";
    man         ="http://www.memoire.com/";
    update      ="http://www.memoire.com/";
    citation    ="Richard M. Stallman";
    authors     =null;
    specifiers  =null;
    contributors=null;
    documentors =null;
    translators =null;
    testers     =null;
    libraries   =null;
    thanks      =null;
  }

  public String about()
  {
    String r=
      name+" version "+version+" ["+date+"]\n"+
      "Distribue sous les termes de\n"+
      "  la "+license+"\n"+
      rights+"\n"+
      "  Tous droits rservs.\n"+
      "Contact\n  "+contact+"\n"+
      "Site\n  "+http;

    if(citation!=null)
      r+="\n \nCette version est ddicace  "+citation+".";

    int i;

    if(authors!=null)
    {
      r+="\n \nDveloppement";
      for(i=0;i<authors.length;i++)
	r+="\n  "+authors[i];
    }

    if(specifiers!=null)
    {
      r+="\n \nSpcifications";
      for(i=0;i<specifiers.length;i++)
	r+="\n  "+specifiers[i];
    }

    if(contributors!=null)
    {
      r+="\n \nContributions";
      for(i=0;i<contributors.length;i++)
	r+="\n  "+contributors[i];
    }

    if(documentors!=null)
    {
      r+="\n \nDocumentation";
      for(i=0;i<documentors.length;i++)
	r+="\n  "+documentors[i];
    }

    if(translators!=null)
    {
      r+="\n \nTraduction";
      for(i=0;i<translators.length;i++)
	r+="\n  "+translators[i];
    }

    if(testers!=null)
    {
      r+="\n \nTests";
      for(i=0;i<testers.length;i++)
	r+="\n  "+testers[i];
    }

    if(libraries!=null)
    {
      r+="\n \nBibliothques";
      for(i=0;i<libraries.length;i++)
	r+="\n  "+libraries[i];
    }

    if(thanks!=null)
    {
      r+="\n \nRemerciements";
      for(i=0;i<thanks.length;i++)
	r+="\n  "+thanks[i];
    }

    return r;
  }

  public String license()
  {
    String r=
      name+" version "+version+" ["+date+"]\n"+
      "est distribu sous les termes de\n"+
      "la "+license+"\n"+
      rights+"\n"+
      "Tous droits rservs.";

    if("GPL2".equals(license))
    {
      r+="\n \nTexte original:"
	+"\n  http://www.gnu.org/copyleft/gpl.html"
	+"\nTraduction en franais:"
	+"\n  http://www.april.org/gnu/gpl_french.html";
    }
    return r;
  }

  public String baseManUrl()
  {
    return man+name.toLowerCase().replace(' ','-')+"/";
  }

  public String toString()
  {
    String r="Software[";
    r+=name+","+version+","+date;
    if(!contact .equals("")) r+=","+contact;
    if(!license .equals("")) r+=","+license;
    if(!http    .equals("")) r+=","+http;
    r+="]";
    return r;
  }
}
