/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuLabelMultiLine.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.border.*;

/**
 * A multi-line label. Not completely implemented.
 */

public class BuLabelMultiLine
       extends BuLabel
{
  public BuLabelMultiLine()
  {
    this(null);
  }

  public BuLabelMultiLine(String _texte)
  {
    super(_texte);
    setHorizontalAlignment(LEFT);
    setSize(getPreferredSize());
  }

  // Anti-aliasing

  public void paint(Graphics _g)
  {
    BuLib.setAntialiasing(_g);
    super.paint(_g);
  }

  protected void paintComponent(Graphics _g)
  {
    Insets      insets=getInsets();
    Font        ft=getFont();
    String      tt=getText();
    int         wm=getWidth();
    int         al=getHorizontalAlignment();

    _g.setFont(ft);
    _g.setColor(getForeground());

    FontMetrics fm=_g.getFontMetrics();
    int         x =insets.left;
    int         y =fm.getMaxAscent()+insets.top;
    int         hs=fm.getMaxAscent()+fm.getMaxDescent();

    while(!tt.equals(""))
    {
      int    i,j;
      String s;

      i=tt.indexOf('\n');
      if(i>=0) { s=tt.substring(0,i); tt=tt.substring(i+1); }
      else     { s=tt; tt=""; }

      while(!"".equals(s))
      {
	int    ws=0;
	String ss=null;

	for(j=s.length();j>0;j--)
	{
	  ws=fm.stringWidth(s.substring(0,j));
	  if(ws<wm-insets.left-insets.right)
	  {
	    ss=s.substring(0,j);
	    s=s.substring(j);
	    break;
	  }
	}
	if(j==0) { ss=s; s=""; ws=fm.stringWidth(ss); }

	     if(al==LEFT)  x=insets.left;
	else if(al==RIGHT) x=wm-insets.right-ws;
	else x=insets.left+(wm-insets.left-insets.right-ws)/2;
	_g.drawString(ss,x,y);
	y+=hs;
      }
    }
  }

  public Dimension getPreferredSize()
  {
    Insets      insets=getInsets();
    Font        ft=getFont();
    String      tt=getText();

    FontMetrics fm=BuLib.getFontMetrics(this,ft);
    int         w =0;
    int         h =0;

    while(!tt.equals(""))
    {
      int    i=tt.indexOf('\n');
      String s;
      if(i>=0) { s=tt.substring(0,i); tt=tt.substring(i+1); }
      else     { s=tt; tt=""; }
      w=Math.max(w,fm.stringWidth(s));
      h+=fm.getMaxAscent()+fm.getMaxDescent();
    }

    return new Dimension(w+1+insets.left+insets.right,
			 h+1+insets.top+insets.bottom);
  }
}

