/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuList.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * The Swing list.
 */

public class BuList
       extends JList
{
  public BuList()
  {
    super();
    setCellRenderer(BuAbstractCellRenderer.getDefaultListCellRenderer());
  }

  // Anti-aliasing

  public void paint(Graphics _g)
  {
    BuLib.setAntialiasing(_g);
    super.paint(_g);
  }

  // bug swing 1.0
  public Dimension getPreferredScrollableViewportSize()
  {
    Dimension r;
    try { r=super.getPreferredScrollableViewportSize(); }
    catch(Exception ex) { r=new Dimension(120,80); }
    return r;
  }

  // bug swing 1.0
  public Dimension getPreferredSize()
  {
    Dimension r;
    try { r=super.getPreferredSize(); }
    catch(Exception ex) { r=new Dimension(120,80); }
    return r;
  }

  public boolean getRequestFocusEnabled()
  {
    return getModel().getSize()!=0;
  }

  public boolean isFocusTraversable()
  {
    return getModel().getSize()!=0;
  }

  protected void processMouseMotionEvent(MouseEvent _evt)
  {
    Object p=getClientProperty("DND_EVENTS");
    if(p==null)
      super.processMouseMotionEvent(_evt);
    else
      ((MouseMotionListener)p).mouseDragged(_evt);
  }
}
