/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuMenuInternalFrames.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import com.memoire.dnd.*;
import com.memoire.fu.*;
import com.memoire.re.*;


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class BuMenuInternalFrames
       extends BuDynamicMenu
       implements ContainerListener
{
  public BuMenuInternalFrames()
  {
    super(BuResource.BU.getString("Liste"),"LISTE_FENETRES");
  }

  private BuDesktop desktop_;

  public BuDesktop getDesktop()
    { return desktop_; }

  public void setDesktop(BuDesktop _desktop)
  {
    if(desktop_!=null) desktop_.removeContainerListener(this);
    desktop_=_desktop;
    if(desktop_!=null) desktop_.addContainerListener(this);
    build();
  }

  public void componentAdded(ContainerEvent _evt)
    { build(); }

  public void componentRemoved(ContainerEvent _evt)
    { build(); }

  protected void build()
  {
    if(isPopupMenuVisible()) return;

    removeAll();
    if(desktop_==null) return;
    
    JInternalFrame[] frames=desktop_.getAllFrames();

    for(int i=0; i<frames.length-1; i++)
    {
      String t0=frames[i  ].getTitle();
      String t1=frames[i+1].getTitle();

      if(t0==null)
	System.err.println("No title for "+frames[i  ].getName());
      /*
      if(t1==null)
	System.err.println("No title for "+frames[i+1].getName());
      */

      if((t0!=null)&&(t1!=null)&&(t1.compareTo(t0)<0))
      {
	JInternalFrame tmp=frames[i];
	frames[i]  =frames[i+1];
	frames[i+1]=tmp;
	i-=2; if(i<0) i=-1;
      }
    }
  
    for(int i=0; i<frames.length; i++)
    {
      JInternalFrame f=frames[i];
      String         n=f.getName();
      if(  (n!=null)
         &&(f.getClientProperty("JInternalFrame.isPalette")!=Boolean.TRUE))
      {
	if(n.startsWith("if")) n=n.substring(2);
	BuMenuItem mi=addMenuItem(f.getTitle(),"FILLE_ACTIVER("+n+")",
				  true,BuInternalFrame.getShortcut(f));
	Icon icon=f.getFrameIcon();
	if(icon instanceof BuIcon)
	  mi.setIcon(BuResource.BU.reduceMenuIcon((BuIcon)icon));
	else
	  mi.setIcon(icon);
      }
    }

    computeMnemonics();
  }

  public boolean isActive()
  {
    return (desktop_!=null)&&
           (desktop_.getAllFrames().length>0);
  }
}
