/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuMonitorClock.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import com.memoire.dnd.*;
import com.memoire.fu.*;
import com.memoire.re.*;


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

/**
 * A clock.
 */

public class BuMonitorClock
       extends BuMonitorAbstract
{
  protected long actu_;

  public BuMonitorClock()
  {
    super();

    actu_=System.currentTimeMillis();

    setName("buMONITOR_CLOCK");
    setForeground(new Color(64,32,96));
  }

  public int getValue()
  { return 0; }

  public int getMaximum()
  { return 100*(int)((actu_/1000)%60)/60; }

  public String getText()
  { return BuLib.time(actu_); }

  public String getToolTipText()
  { return BuLib.date(actu_); }

  public long getDelay()
  { return 1000l; }

  public boolean refreshState()
  {
    actu_=System.currentTimeMillis();
    return true;
  }
}
