/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuMonitorCpu.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import com.memoire.dnd.*;
import com.memoire.fu.*;
import com.memoire.re.*;


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

/**
 * A monitor to watch cpu usage.
 */

public class BuMonitorCpu
       extends BuMonitorAbstract
{
  protected int     value_;
  protected int     minimum_;
  protected int     maximum_;
  protected long    v_,vmin_,vmax_;

  public BuMonitorCpu()
  {
    super();

    value_  =0;
    minimum_=0;
    maximum_=0;
    v_      =0l;
    vmin_   =0l;
    vmax_   =0l;

    setName("buMONITOR_CPU");
    setForeground(new Color(32,64,96));
  }

  public int getValue()
  { return value_; }

  public int getMaximum()
  { return maximum_; }

  public String getText()
  { return ""+value_+"%"; }

  public String getToolTipText()
  { return "Cpu utilis: "+value_+"%"; }

  public long getDelay()
  { return 1000l; }

  public synchronized boolean refreshState()
  {
    boolean r=false;

    long avant=System.currentTimeMillis();
    double z=0.;
    for(int i=0;i<100;i++)
    {
      z+=Math.cos((double)i*z);
      Thread.yield();
      try { Thread.sleep(10); }
      catch(Exception ex) { }
    }
    long apres=System.currentTimeMillis();

    v_=apres-avant;
    if(v_>vmax_) vmax_=v_+1;
    if(v_<vmin_) vmin_=v_;

    int p=(int)(100l*(v_-vmin_)/(vmax_-vmin_));
    if(p!=value_)
    {
      r=true;
      value_=p;
      if(value_>maximum_) maximum_=value_;
    }

    if(Math.random()<0.1) vmin_++;
    if(v_<vmin_) vmin_=v_;

    if(Math.random()<0.1) vmax_--;
    if(v_>vmax_) vmax_=v_;
    if(10>vmax_) vmax_=10;      

    return r;
  }
}
