/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuMonitorMemory.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import com.memoire.dnd.*;
import com.memoire.fu.*;
import com.memoire.re.*;


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

/**
 * A monitor to watch free and used memories.
 */

public class BuMonitorMemory
       extends BuMonitorAbstract
{
  protected Runtime runtime_;
  protected float   megas_;
  protected long    kilos_;
  protected int     value_;
  protected int     maximum_;
  protected long    last_;

  public BuMonitorMemory()
  {
    super();

    megas_  =0;
    kilos_  =0;
    value_  =0;
    maximum_=0;
    last_   =0;

    setName("buMONITOR_MEMORY");
  }

  public int getValue()
  { return value_; }

  public int getMaximum()
  { return maximum_; }

  public String getText()
  { return ""+megas_+"M"; }

  public String getToolTipText()
  { return "Mmoire utilise: "+value_+"% ("+kilos_+"k)"; }

  public long getDelay()
  { return 1000l; }

  public synchronized boolean refreshState()
  {
    boolean r=false;

    if(runtime_==null)
      runtime_=Runtime.getRuntime();

    int t=(int)(runtime_.totalMemory()/1024l);
    int f=(int)(runtime_.freeMemory()/1024l);
    int m=t-f;
    int v=m*100/t;

    if(maximum_<v) maximum_=v;

    if(value_!=v)
    {
      r=true;
      kilos_=m;
      megas_=((float)(m/102l))/10.f;
      value_=v;
    }

    // 5 mn
    if(  (last_+300000l<System.currentTimeMillis())
       &&!FuLib.verifyMemory(2))
    {
      new BuDialogWarning
	(getApp(),null,
	 "Available memory is low (less than 2Mb).\n"+
	 "Save your project and relaunch the software.\n"+
	 "Optionnaly change the option -mx of the java command.\n")
	.activate();
      last_=System.currentTimeMillis();
    }

    return r;
  }
}
