/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuMonitorTime.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import com.memoire.dnd.*;
import com.memoire.fu.*;
import com.memoire.re.*;


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

/**
 * A monitor to watch time since the beginning.
 */

public class BuMonitorTime
       extends BuMonitorAbstract
{
  protected long begin_,actu_;

  public BuMonitorTime()
  {
    super();

    begin_=System.currentTimeMillis();
    actu_ =begin_;

    setName("buMONITOR_TIME");
    setForeground(new Color(96,64,32));
  }

  public int getValue()
  { return 0; }

  public int getMaximum()
  { return 100*(int)(((actu_-begin_)/1000)%60)/60; }

  public String getText()
  { return BuLib.duration(actu_-begin_); }

  public String getToolTipText()
  { return null; }

  public long getDelay()
  { return 1000l; }

  public boolean refreshState()
  {
    actu_=System.currentTimeMillis();
    return true;
  }
}
