/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuPalette.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import com.memoire.dnd.*;
import com.memoire.fu.*;
import com.memoire.re.*;


import javax.swing.*;
import javax.swing.border.*;
import javax.swing.plaf.*;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;

/**
 * A component derived from JInternalFrame to make palettes.
 */

public class BuPalette
       extends JInternalFrame
{
  private final static Border BORDER=
    new BorderUIResource(new BuLightBorder(BuLightBorder.RAISED,3));

  JComponent content_;

  public BuPalette()
  {
    setName ("plPALETTE");
    setTitle("");
    setFrameIcon(new BuEmptyIcon());
    putClientProperty("JInternalFrame.isPalette",Boolean.TRUE);
    content_=(JComponent)getContentPane();
    content_.setLayout(new BuBorderLayout());

    setSize(120,120);
    setResizable(false);
  }

  /*
  public boolean isFocusCycleRoot()
    { return false; }
  */

  public void updateUI()
  {
    super.updateUI();

    //if(!BuLib.isSlaf()) setBorder(BORDER);
    if(UIManager.getBorder("InternalFrame.paletteBorder")==null)
      setBorder(BORDER);

    if(!isResizable())
    {
      setResizable(true);
      SwingUtilities.updateComponentTreeUI(getContentPane());
      pack();
      setResizable(false);
    }
    else SwingUtilities.updateComponentTreeUI(getContentPane());
  }

  private JComponent cp_=null;

  public void setContent(JComponent _cp)
  {
    cp_=_cp;
    content_.add(cp_,BuBorderLayout.CENTER);
    cp_.revalidate();

    pack();
    revalidate();
  }

  /**
   * Une palette ne peut etre activee (selectionnee).
   */
  public void setSelected(boolean _b) throws PropertyVetoException
  {
    moveToFront();
    if(_b) throw new PropertyVetoException("Palette",null);
  }

  public final void paintBorder(Graphics _g) { }

  protected void paintSuperBorder(Graphics _g)
  {
    super.paintBorder(_g);
  }

  public void paint(Graphics _g)
  {
    super.paint(_g);
    paintSuperBorder(_g);
  }

  // Test

  public static void main(String[] _args)
  {
    try
    {
      UIManager.setLookAndFeel
        ("com.memoire.slaf.SlafLookAndFeel");
    }
    catch (Exception ex) { } // System.err.println("SLAF not found");

    JFrame f=new JFrame();
    BuPanel barre=new BuPanel();
    BuDesktop dt=new BuDesktop();

    // ButtonGroup bg=new ButtonGroup();

    BuLabel p1=new BuLabel("Hello the world");
    BuPopupButton w1=new BuPopupButton("P1",p1);
    w1.setText("Click here!");
    w1.setDesktop(dt);

    BuButton p2=new BuButton("Bonjour Monde");
    BuPopupButton w2=new BuPopupButton("P2",p2);
    w2.setText("Click here!");
    w2.setDesktop(dt);

    // bg.add(w1);
    // bg.add(w2);

    barre.add(w1);
    barre.add(w2);
    f.getContentPane().add(barre              ,BuBorderLayout.NORTH);
    f.getContentPane().add(new BuScrollPane(dt),BuBorderLayout.CENTER);

    BuPalette pal=new BuPalette();
    pal.setTitle("WWW");
    pal.setContent(new BuLabel("Hello"));
    dt.addInternalFrame(pal);

    dt.addInternalFrame(new BuInternalFrame("XXX",true,true,true,true));

    f.setSize(300,300);
    f.setVisible(true);
    f.setLocation(300,150);
  }
}
