/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuPopupButton.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import com.memoire.dnd.*;
import com.memoire.fu.*;
import com.memoire.re.*;


import javax.swing.*;
import javax.swing.event.*;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;

/**
 * A toggle button for toolbar  which hides/shows a
 * given component.
 */

public class BuPopupButton
       extends BuToggleButton
       implements ActionListener
{
  private BuPalette window_;

  public BuPopupButton(JComponent _component)
  {
    this("NULL",null,_component);
  }

  public BuPopupButton(String _title, JComponent _component)
  {
    this("NULL",_title,_component);
  }

  public BuPopupButton(String _name, String _title, JComponent _component)
  {
    super();

    setName("pb"+_name);
    setRequestFocusEnabled(false);

    window_=new BuPalette();
    window_.setName   ("pl"+_name);
    window_.setTitle  (_title);
    window_.setContent(_component);
    // window_.pack();

    addActionListener(this);
  }

  /*
  private final static int[] vtax=new int[] { 6,3,0 };
  private final static int[] vtay=new int[] { 6,0,6 };
  private final static int[] vbax=new int[] { 0,3,6 };
  private final static int[] vbay=new int[] { 0,6,0 };

  public void paintBorder(Graphics _g)
  {
    super.paintBorder(_g);

    Dimension size  =getSize();

    int x=size.width -7;
    int y=size.height-7;

    _g.translate(x,y);
    _g.setColor(getForeground());
    if(isSelected()) _g.fillPolygon(vtax,vtay,3);
    else             _g.fillPolygon(vbax,vbay,3);
    _g.translate(-x,-y);
  }
  */

  public void actionPerformed(ActionEvent _evt)
  {
    if(isSelected())
      showWindow();
    else
      hideWindow();
  }

  public static int nbr_=-1;
  private Point loc_=null;

  public void setPaletteLocation(int _x, int _y)
  {
    loc_=new Point(_x,_y);
    window_.setLocation(loc_);
  }

  public Dimension getPalettePreferredSize()
  {
    return window_.getPreferredSize();
  }

  private void showWindow()
  {
    if(loc_==null)
    {
      loc_=window_.getLocation();
      if((loc_.x==0)&&(loc_.y==0))
      {
	nbr_=(nbr_+1)%8;
	loc_=new Point(5+20*nbr_,5+20*nbr_);
	window_.setLocation(loc_);
      }
    }

    window_.pack();

    Icon i=getIcon();
    if(i!=null) window_.setFrameIcon(i);

    // SwingUtilities.updateComponentTreeUI(window_);
    window_.setVisible(true);
    if(desktop_!=null)
      desktop_.addInternalFrame(window_);
    window_.setLocation(loc_);
    window_.revalidate();
  }

  private void hideWindow()
  {
    loc_=window_.getLocation();
    window_.setVisible(false);
    window_.revalidate();
    if(desktop_!=null)
      desktop_.removeInternalFrame(window_);
  }

  private BuDesktop desktop_;
  public BuDesktop getDesktop()
    { return desktop_; }
  public void setDesktop(BuDesktop _desktop)
    { desktop_=_desktop; }

  public void setVisible(final boolean _b)
  {
    super.setVisible(_b);

    if(_b)
    {
      if(isSelected()) showWindow();
    }
    else
      hideWindow();
  }
}
