/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuPreviewFrame.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import com.memoire.dnd.*;
import com.memoire.fu.*;
import com.memoire.re.*;


import java.awt.*;
import java.awt.event.*;
import java.beans.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;

/**
 *
 */

public class BuPreviewFrame
       extends BuInternalFrame
       implements ActionListener, ChangeListener
{
  private BuTabbedPane tpMain_;
  private BuPanel      pnButtons_;
  private BuButton     btFermer_;

  // Constructeur
  
  public BuPreviewFrame()
  { this(null); }

  public BuPreviewFrame(BuCommonImplementation _app)
  {
    super("",false,true,true,true);

    setName("ifPREVIEW");
    /*
    if(_app!=null)
      _app.installContextHelp(getRootPane(),"bu/p-previsualisateur.html");
    setShortcut(KeyEvent.VK_F2);
    */

    tpMain_=new BuTabbedPane();
    tpMain_.setTabPlacement(BuLib.getTabPlacement());
    tpMain_.addChangeListener(this);

    // Panneau de validation
    pnButtons_=new BuPanel();
    pnButtons_.setLayout(new FlowLayout(FlowLayout.RIGHT));

    btFermer_=new BuButton(BuResource.BU.getString("Fermer"));
    btFermer_.setIcon(BuResource.BU.getIcon("fermer"));
    btFermer_.setActionCommand("FERMER");
    btFermer_.addActionListener(this);
    pnButtons_.add(btFermer_,0);
    
    JComponent content=(JComponent)getContentPane();
    content.setLayout(new BuBorderLayout());
    content.setBorder(new EmptyBorder(5,5,5,5));
    content.add(tpMain_ ,BuBorderLayout.CENTER);
    // content.add(pnButtons_,BuBorderLayout.SOUTH);

    setTitle(BuResource.BU.getString("Prvisualisation"));
    setFrameIcon(BuResource.BU.getBarIcon("previsualiser"));

    setSize(300,400);
    updateButtons();
  }
  
  // Evenements
  
  public void actionPerformed(ActionEvent _evt)
  {
    String actionCmd=_evt.getActionCommand();

    if(actionCmd.equals("FERMER"))
    {
      try { setClosed(true); }
      catch(PropertyVetoException ex) { }
    }

    updateButtons();
  }

  public void setSelected(boolean _state) throws PropertyVetoException
  {
    super.setSelected(_state);
    if(isSelected()) tpMain_.requestFocus();
   }

  public void stateChanged(ChangeEvent _evt)
  {
    JComponent source=(JComponent)_evt.getSource();
    // System.err.println("Change : "+source.getName());
    updateButtons();
  }

  private void updateButtons()
  {
    Component c=tpMain_.getSelectedComponent();
  }

  // Methodes publiques

  public void selectTab(int _index)
  {
    tpMain_.setSelectedIndex(_index);
  }
  
  public void addTab(int _page,Image _image)
  {
    String    title  =""+_page;
    String    tooltip="Page "+_page;
    BuPicture picture=new BuPicture(_image);

    picture.setBorder(new LineBorder(Color.black));
    picture.setMode(BuPicture.ZOOM);

    BuPanel pn=new BuPanel();
    pn.setLayout(new FlowLayout());
    pn.add(picture);

    tpMain_.addTab(title, null, pn, tooltip);
  }
  
  // Methodes privees
  
}
