/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuPreviewJob.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import com.memoire.dnd.*;
import com.memoire.fu.*;
import com.memoire.re.*;


import java.awt.*;
import java.util.*;

public class BuPreviewJob
       extends PrintJob
{
  private BuCommonImplementation app_;
  private String  name_;
  private Vector  images_;
  private boolean end_;

  public BuPreviewJob(BuCommonImplementation _app, String _name)
  {
    app_   =_app;
    name_  =_name;
    images_=new Vector(1,5);
    end_=false;
  }

  public Dimension getPageDimension()
  { return new Dimension(595,841); }

  public int getPageResolution()
  { return 72; }

  public boolean lastPageFirst()
  { return false; }

  public Graphics getGraphics()
  {
    Dimension size =getPageDimension();
    Image     image=app_.getFrame().createImage(size.width,size.height);

    images_.addElement(image);

    Graphics r=image.getGraphics();
    r.setClip(0, 0,size.width,size.height);
    r.setColor(Color.white);
    r.fillRect(0, 0,size.width,size.height);
    r.setColor(Color.black);
    return r;
  }

  public void end()
  {
    if(end_) return;

    end_=true;

    BuPreviewFrame frame=new BuPreviewFrame();

    int p=1;
    for(Enumeration e=images_.elements(); e.hasMoreElements(); p++)
    {
      Image image=(Image)e.nextElement();

      Dimension size=getPageDimension();
      size.width /=3;
      size.height/=3;
      Image reduite=app_.getFrame().createImage(size.width,size.height);
      Graphics g=reduite.getGraphics();
      g.setClip(0, 0,size.width,size.height);
      g.setColor(Color.white);
      g.fillRect(0, 0,size.width,size.height);
      g.setColor(Color.black);
      g.drawImage(image.getScaledInstance
		  (size.width,size.height,Image.SCALE_SMOOTH),
		  0,0,app_.getFrame());
      frame.addTab(p,reduite);
    }

    app_.addInternalFrame(frame);
  }
}
