/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuProgressBar.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import com.memoire.dnd.*;
import com.memoire.fu.*;
import com.memoire.re.*;


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * A progress bar which displays the value as a number.
 */

public class BuProgressBar
       extends JProgressBar
{
  public BuProgressBar()
  {
    setFont(BuLib.deriveFont("ProgressBar",Font.BOLD,-2));
    setSize(getPreferredSize());
  }

  // Anti-aliasing

  public void paint(Graphics _g)
  {
    BuLib.setAntialiasing(_g);
    super.paint(_g);
  }

  public void  paintComponent(Graphics _g)
  {
    Insets      insets=getInsets();
    Dimension   d     =getSize();
    String      s     ="";

    int v   =getValue();
    int vmin=getMinimum();
    int vmax=getMaximum();

    super.paintComponent(_g);

    if((vmax>vmin)&&(v>vmin))
    {
      Font        f     =getFont();
      FontMetrics fm    =_g.getFontMetrics(f);

      s=""+((v-vmin)*100/(vmax-vmin));
      if((vmin==0)&&(vmax==100)) s+="%";

      int ws=fm.stringWidth(s);
      int hs=fm.getAscent()+fm.getDescent();
      // int xs=Math.max(d.width-insets.right-ws-2,insets.left+4);
      // int ys=insets.top+fm.getAscent();
      int xs=insets.left+
	(d.width-insets.left-insets.right-ws)/2;
      /*
      int ys=insets.top+
        (d.height-insets.top-insets.bottom-hs)/2+fm.getAscent();
      */
      int ys=insets.top+(d.height-insets.top-insets.bottom)-2;
      /*
      int cs=0;
      try
      {
        cs=((Integer)UIManager.get("ProgressBar.cellSpacing")).intValue();
      }
      catch(Exception ex) { }

      Color fg;
      if(cs>0)
	fg=new Color((getBackground().getRGB()^
		      getForeground().getRGB())&
		     0x00FFFFFF);
      else
	fg=getBackground();

      _g.setXORMode(fg);
      _g.drawString(s,xs,ys);
      _g.setPaintMode();
      */

      Shape old=_g.getClip();
      Rectangle r=_g.getClipBounds();
      int wb=getWidth ()-insets.left-insets.right;
      int hb=getHeight()-insets.top-insets.bottom;
      int xb=(v-vmin)*wb/(vmax-vmin);
      _g.setClip(r.intersection
		 (new Rectangle(insets.left+xb,insets.top,wb-xb,hb)));
      _g.setColor(getForeground());
      _g.drawString(s,xs,ys);
      _g.setClip(r.intersection
		 (new Rectangle(insets.left,insets.top,xb,hb)));
      _g.setColor(getBackground());
      _g.drawString(s,xs+1,ys);

      _g.setClip(old);
    }
  }
}
