/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuRadioButtonMenuItem.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import com.memoire.dnd.*;
import com.memoire.fu.*;
import com.memoire.re.*;


import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.swing.*;
import javax.swing.border.*;

/**
 * Like JRadioButtonMenuItem but with better management of icons.
 */

public class BuRadioButtonMenuItem
       extends JRadioButtonMenuItem
{
  public BuRadioButtonMenuItem()
  {
    this(null,"");
  }

  public BuRadioButtonMenuItem(BuIcon _icon)
  {
    this(_icon,"");
  }

  public BuRadioButtonMenuItem(String _label)
  {
    this(null,_label);
  }

  public BuRadioButtonMenuItem(BuIcon _icon, String _label)
  {
    super();

    // setCursor(new Cursor(Cursor.HAND_CURSOR));
    if(_icon!=null) setIcon(_icon);
    if(_label==null) _label="";
    setText(_label);
  }

  // Anti-aliasing

  public void paint(Graphics _g)
  {
    BuLib.setAntialiasing(_g);
    super.paint(_g);
  }

  public void setIcon(BuIcon _icon)
    { BuLib.setIcon(this,_icon); }

  public Point getToolTipLocation(MouseEvent _evt)
  {
    Point r=super.getToolTipLocation(_evt);
    if(r==null) r=new Point(getWidth(),0);
    return r;
  }
}
