/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuScrollPane.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import com.memoire.dnd.*;
import com.memoire.fu.*;
import com.memoire.re.*;


import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.*;

/**
 * Nothing more than JScrollPane.
 */

public class BuScrollPane
       extends JScrollPane
       implements ActionListener
{
  public BuScrollPane()
  {
    this(null);
  }

  public BuScrollPane(JComponent _c)
  {
    super(_c);

    BuButton lr=new BuButton("");
    lr.setBorder(new EmptyBorder(0,0,0,0));
    lr.setMargin(new Insets(0,0,0,0));
    lr.setRequestFocusEnabled(false);
    lr.addActionListener(this);
    setCorner(BuScrollPane.LOWER_RIGHT_CORNER,lr);
  }

  public void actionPerformed(ActionEvent _evt)
  {
    JViewport vp=getViewport();

    Point     p =vp.getViewPosition();
    Dimension vs=vp.getViewSize();
    Dimension es=vp.getExtentSize();

    if((p.x==0)&&(p.y==0))
      { p.x=vs.width-es.width; p.y=vs.height-es.height; }
    else
      { p.x=0; p.y=0; }
    vp.setViewPosition(p);
  }
}
