/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuSeparator.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import com.memoire.dnd.*;
import com.memoire.fu.*;
import com.memoire.re.*;


import java.awt.*;
import javax.swing.*;

/**
 * A separator for menus which displays a string.
 */

public class BuSeparator
       extends JSeparator
{
  private String text_;

  public BuSeparator()
  {
    this(null);
  }

  public BuSeparator(String _text)
  {
    super();
    text_=_text;
  }

  public void paintComponent(Graphics _g)
  {
    Object bar=UIManager.get("PopupMenuSeparator.bar");
    if((bar==null)||(Boolean.TRUE.equals(bar)))
      super.paintComponent(_g);

    if(text_!=null)
    {
      Color bg=UIManager.getColor("PopupMenuSeparator.background");
      Color fg=UIManager.getColor("PopupMenuSeparator.foreground");
      if(bg==null) bg=getParent().getBackground();
      if(fg==null) fg=getParent().getForeground();

      Dimension   d =getSize();
      Font        ft=BuLib.deriveFont("MenuItem",-2);
      int hs=ft.getSize()+2;

      _g.setFont(ft);

      //Object bar=UIManager.get("PopupMenuSeparator.bar");
      if((bar==null)||(Boolean.TRUE.equals(bar)))
      {
        _g.setColor(bg);
        _g.drawString(text_,2,hs-1);
        _g.drawString(text_,2,hs  );
        _g.drawString(text_,2,hs+1);
        _g.drawString(text_,4,hs-1);
        _g.drawString(text_,4,hs  );
        _g.drawString(text_,4,hs+1);
      }

      _g.setColor(fg);
      _g.drawString(text_,3,hs);
    }
  }

  public Dimension getPreferredSize()
  {
    Font        ft=BuLib.deriveFont("MenuItem",-2);
    FontMetrics fm=BuLib.getFontMetrics(this,ft);

    Dimension r=super.getPreferredSize();

    if(text_!=null)
    {
      r.width =Math.max(r.width ,6+fm.stringWidth(text_));
      r.height=Math.max(r.height,6+fm.getAscent()+fm.getDescent());
    }

    return r;
  }
}
