/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuSpecificBar.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import com.memoire.dnd.*;
import com.memoire.fu.*;
import com.memoire.re.*;


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

/**
 * A tool bar with simplified adding methods.
 */

public class BuSpecificBar
extends BuToolBar // J
{
  private int w_,h_;
  private JPanel espace_=null;

  public BuSpecificBar()
  {
    super();

    setName("tbSPECIFIC_TOOLBAR");

    /*
    setFloatable
      (BuPreferences.BU.getBooleanProperty("toolbar.floatable",true));
    putClientProperty
      ("JToolBar.isRollover",
       BuPreferences.BU.getBooleanProperty("toolbar.rollover",true)
       ? Boolean.TRUE : Boolean.FALSE);
    */
  }

  public void updateUI()
  {
    w_=h_=0;
    super.updateUI();
  }

  /*
  public boolean isFocusCycleRoot()
  { return true; }
  */

  public void addTool(JComponent _tool)
  {
    if(_tool==null)
      addSeparator();
    else
    {
      _tool.setRequestFocusEnabled(false);
      _tool.setVisible(true);
      SwingUtilities.updateComponentTreeUI(_tool);
      add(_tool);

      if(_tool instanceof JButton)
      {
	((JButton)_tool).setMargin(new Insets(1,1,1,1));
	((JButton)_tool).setRolloverEnabled(true);
      }
      if(_tool instanceof JToggleButton)
      {
	((JToggleButton)_tool).setMargin(new Insets(1,1,1,1));
	((JToggleButton)_tool).setRolloverEnabled(true);
      }
    }
  }

  public void addTools(JComponent[] _tools)
  {
    if((_tools==null)||(_tools.length==0)) return;

    for(int i=0;i<_tools.length;i++)
      addTool(_tools[i]);

    //doLayout();
    //validate();
    revalidate();

    /*
    Container p=getParent();
    if(p!=null)
    {
      p.doLayout();
      p.validate();
    }
    repaint();
    */
  }

  public void removeTool(JComponent _tool)
  {
    if(_tool==null)
    {
      Component c=getComponentAtIndex(0);
      if(c instanceof JToolBar.Separator) remove(c);
    }
    else
    {
      _tool.setVisible(false);
      remove(_tool);
    }
  }

  public void removeTools(JComponent[] _tools)
  {
    if((_tools==null)||(_tools.length==0)) return;

    for(int i=0;i<_tools.length;i++)
      removeTool(_tools[i]);

    //doLayout();
    //validate();
    revalidate();

    /*
    Container p=getParent();
    if(p!=null)
    {
      p.doLayout();
      p.validate();
    }
    repaint();
    */
  }

  public Dimension getPreferredSize()
  {
    Dimension d=null;

    try
    {
      d=super.getPreferredSize();

      if(d.height>d.width)
      {
	if(d.width<w_)  d.width=w_;
	else            w_=d.width;
      }
      else
      {
	if(d.height<h_) d.height=h_;
	else            h_=d.height;
      }
    }
    catch(NullPointerException ex) { } // swing 1.03

    return d;
  }
}
