/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuTableCellEditor.java
 * @version      0.36
 * @author       Axel von Arnim
 * @email        axel.vonarnim@cetmef.equipement.gouv.fr
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 * (c)1998-2001 Axel von Arnim
 * axel.vonarnim@cetmef.equipement.gouv.fr
 */

package com.memoire.bu;

import com.memoire.bu.*;
import com.memoire.dnd.*;
import com.memoire.fu.*;
import com.memoire.re.*;


import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;

import java.awt.*;
import java.util.*;

/**
 * An editor for table cells, which controls input through
 * input validators like date or integer validators.
 * @author Axel von Arnim
 * @email axel.vonarnim@cetmef.equipement.gouv.fr
 */
public class BuTableCellEditor
       implements TableCellEditor
{
  Object      oldValue_;
  BuTextField tf_;
  Vector      listeners_;

  public BuTableCellEditor(BuTextField _tf)
  {
    if(_tf==null)
      throw new IllegalArgumentException /*System.err.println*/
	("BuTableCellEditor: param _tf is null in the constructor");

    tf_=_tf;
    listeners_=new Vector(1,1);
  }

  public Component getTableCellEditorComponent
    (JTable _table, Object _value, boolean _selected, int _row, int _column)
  {
    oldValue_=_value;
    tf_.setValue(_value);
    return tf_;
  }

  public void addCellEditorListener(CellEditorListener _l)
  {
    if(!listeners_.contains(_l))
      listeners_.addElement(_l);
  }

  public void cancelCellEditing()
  {
    tf_.setValue(oldValue_);
    ChangeEvent evt=new ChangeEvent(this);
    for(Enumeration e=listeners_.elements(); e.hasMoreElements();)
      ((CellEditorListener)e.nextElement()).editingCanceled(evt);
  }

  public Object getCellEditorValue()
  { return tf_.getValue(); }

  public boolean isCellEditable(EventObject _evt)
  { return true; }

  public void removeCellEditorListener(CellEditorListener _l)
  { listeners_.removeElement(_l); }

  public boolean shouldSelectCell(EventObject _evt)
  { return true; }

  public boolean stopCellEditing()
  {
    ChangeEvent evt=new ChangeEvent(this);
    for(Enumeration e=listeners_.elements(); e.hasMoreElements();)
      ((CellEditorListener)e.nextElement()).editingStopped(evt);
    return false;
  }
}
