/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuTableRowHeader.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import com.memoire.fu.*;

import java.beans.*;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import java.awt.*;
import java.awt.event.*;

public class BuTableRowHeader
  extends BuList
  implements TableModelListener, PropertyChangeListener
{
  private JTable     table_;
  private TableModel model_;

  public BuTableRowHeader(JTable _table,boolean _letters)
  {
    table_=_table;
    model_=table_.getModel();

    setModel(new AbstractListModel()
	     {
	       public int getSize() { return table_.getRowCount(); }
	       public Object getElementAt(int index) { return null; }
	     });

    table_.addPropertyChangeListener(this);
    if(model_!=null) model_.addTableModelListener(this);

    //setSelectionModel(_table.getSelectionModel());

    /*
    _table.getSelectionModel()
      .addListSelectionListener
      (new ListSelectionListener()
       {
	 public void valueChanged(ListSelectionEvent _evt)
	 {
	   table_.setColumnSelectionInterval(0,table_.getColumnCount()-1);
	 }
       });

    _table.getColumnModel().getSelectionModel()
      .addListSelectionListener
      (new ListSelectionListener()
       {
	 public void valueChanged(ListSelectionEvent _evt)
	 {
	   table_.getSelectionModel().setSelectionInterval
	     (0,table_.getRowCount()-1);
	 }
       });
       */

    setFixedCellWidth(40);
    setFixedCellHeight(table_.getRowHeight());
    //+table_.getIntercellSpacing().height);
    setCellRenderer(new BuTableRowHeaderRenderer(_letters));
    setRequestFocusEnabled(false);
  }

  public void propertyChange(PropertyChangeEvent _evt)
  {
    if("model".equals(_evt.getPropertyName()))
    {
      if(model_!=null) model_.removeTableModelListener(this);
      model_=table_.getModel();
      if(model_!=null) model_.addTableModelListener(this);
    }
  }

  public void tableChanged(TableModelEvent _evt)
  {
    invalidate();
    repaint();
  }

  public void updateUI()
  {
    super.updateUI();
    setOpaque    (false);
    setBorder    (UIManager.getBorder("TableHeader.border"));
    setForeground(UIManager.getColor ("ScrollPane.foreground"));
    setBackground(UIManager.getColor ("ScrollPane.background"));
    setFont      (UIManager.getFont  ("TableHeader.font"));
  }

  public boolean isFocusTraversable() { return false; }
  public void processMouseMotionEvent(MouseEvent _evt) { }
  public void processMouseEvent(MouseEvent _evt) { }
}

