/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         BuTableRowHeaderRenderer.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;

import com.memoire.bu.*;
import com.memoire.dnd.*;
import com.memoire.fu.*;
import com.memoire.re.*;


import java.awt.*;
import java.text.*;
import java.util.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.table.*;

/**
 * A displayer for table cells, which darkens every second line and
 * accepts different formats for numbers and dates.
 */

public class BuTableRowHeaderRenderer
       extends JLabel implements ListCellRenderer
{
  private boolean letters_;

  public BuTableRowHeaderRenderer(boolean _letters)
  {
    letters_=_letters;
  }
  
  public Component getListCellRendererComponent
    (JList _list, Object _value, int _index, boolean _selected,
     boolean _hasFocus) 
  {
    setOpaque(true);
    setHorizontalAlignment(letters_ ? CENTER : RIGHT);
    setBorder    (UIManager.getBorder("TableHeader.cellBorder"));
    setForeground(UIManager.getColor ("TableHeader.foreground"));
    setBackground(UIManager.getColor ("TableHeader.background"));
    setFont      (UIManager.getFont  ("TableHeader.font"));

    String text; // .=((_value == null) ? "" : _value.toString());
    if(letters_)
    {
      text=(char)((int)'A'+_index%26)+" ";
      while(_index>=26)
      {
	_index=_index/26-1;
	text=(char)((int)'A'+_index%26)+text;
      }
    }
    else text=_index+" ";

    setText(text);

    /* DEBUG
    if(_selected) setBackground(Color.red);
    else          setBackground(Color.lightGray);
    */

    return this;
  }
}

