/**
 * @modification $Date: 2001/12/04 18:29:50 $
 * @statut       unstable
 * @file         BuUpdateGUI.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.bu;
import com.memoire.bu.*;
import com.memoire.fu.*;

import java.awt.*;
import java.awt.event.*;
import java.lang.reflect.*;
import javax.swing.*;
import javax.swing.border.*;

/**
 * A way to safely repaint a component.
 */
public class BuUpdateGUI
  implements Runnable
{
  private JComponent c_;

  public BuUpdateGUI(JComponent _c)
  {
    c_=_c;
  }

  public void run()
  {
    repaintComponent(c_);
  }

  private final static void repaintComponent(JComponent _c)
  {
    if(_c.isShowing()) //Visible()
    {
      _c.revalidate();
      _c.repaint(0); // c_.paintImmediately(c_.getBounds());
    }
  }

  public static void repaintNow(JComponent _c)
  {
    boolean later=true;

    if(!SwingUtilities.isEventDispatchThread())
    {
      try
      {
	SwingUtilities.invokeAndWait(new BuUpdateGUI(_c));
	later=false;
      }
      catch(InterruptedException ex) { }
      catch(InvocationTargetException ex) { }
    }

    if(later)
      repaintComponent(_c);
  }

  public static void repaintLater(JComponent _c)
  {
    if(!SwingUtilities.isEventDispatchThread())
      SwingUtilities.invokeLater(new BuUpdateGUI(_c));
    else
      if(_c.isShowing())  // Visible()
	_c.repaint();
  }
}
