/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         Dja.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.dja;

import com.memoire.fu.*;
import com.memoire.dnd.*;
import com.memoire.bu.*;
import com.memoire.dja.*;
import com.memoire.mst.*;


import java.util.*;
import javax.swing.*;

public class Dja
{
  public static boolean verify(int _megas)
  {
    int     m=1048576*_megas;
    boolean r=true;

    try
    {
      byte[] b=new byte[m];
      b=null;
      System.gc();
    }
    catch(OutOfMemoryError ex) { r=false; }

    return r;
  }

  public static void main(String args[])
  {
    Thread.currentThread().setName("Dja main thread");
    Thread.currentThread().setPriority(Thread.MIN_PRIORITY);

    if(!verify(6))
    {
      String t="You need at least 8M to run safely Dja.\n"+
	       "Please use the -mx option of java.";
      boolean ok=verify(1);
      if(ok)
      {
	try { new BuDialogMessage(null,null,t).activate();}
	catch(Throwable e) { ok=false; }
      }
      if(!ok) System.err.println(t);
      System.exit(-1);
    }

    /*
    String jv=System.getProperty("java.version");
    if(jv.compareTo("1.1.2")<0)
    {
      System.err.println("JVM >1.1.2 needed for Swing");
      System.exit(-1);
    }
    */

    BuPreferences.BU.applyLookAndFeel();

    BuInformationsSoftware il=DjaImplementation.informationsSoftware();

    if(BuPreferences.BU.getStringProperty("locale.language").equals(""))
    {
      BuLanguagePreferencesPanel pp=
	new BuLanguagePreferencesPanel(il.languages);

      new BuDialogMessage
	(null,il,pp).activate();

      Locale.setDefault(new Locale(pp.getLocaleString(),""));
    }

    BuPreferences.BU.applyLanguage(il.languages);

    // Splash screen

    BuSplashScreen ss=new BuSplashScreen
      (il,1000,new String[][]
       { FuLib.JAVA_CLASSES, BuLib.SWING_CLASSES, BuLib.BU_CLASSES,
	 DjaLib.DJA_CLASSES });
    //DjaImplementation.class.getName()

    if(BuPreferences.BU.getBooleanProperty("splashscreen.visible",true))
    {
      // Exception dans Mac L&F
      try { ss.start(); } catch(Exception ex) { }
    }

    ss.setText("Cration de l'application");
    ss.setProgression(0);
    BuApplication app=new BuApplication();
    DjaImplementation imp=new DjaImplementation();
    imp.setSplashScreen(ss);
    app.setImplementation(imp);
    app.init();

    BuGlassPaneStop glasspane=new BuGlassPaneStop();
    app.setGlassPane(glasspane);
    glasspane.setVisible(true);

    ss.setProgression(100);
    ss.setText("Dmarrage de l'application");

    try { Thread.sleep(500); }
    catch(Exception ex) { }

    ss.setVisible(false);
    ss=null;

    app.setVisible(true);
    app.start();

    glasspane.setVisible(false);

    if(args.length>0)
      imp.cmdArguments(args);
  }
}
