/**
 * @modification $Date: 2001/12/03 16:28:07 $
 * @statut       unstable
 * @file         DjaCoder.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.dja;

import com.memoire.fu.*;
import com.memoire.dnd.*;
import com.memoire.bu.*;
import com.memoire.dja.*;
import com.memoire.mst.*;


import java.net.URLEncoder;

public class DjaCoder
{
  public static String encode(String s)
  {
    return URLEncoder.encode(s);
  }

  public static String decode(String s)
  {
    String r=null;
    try { r=internal_decode(s); }
    catch(Exception ex) { }
    return r;
  }

  public static String internal_decode(String s) throws Exception {
    StringBuffer sb = new StringBuffer();
    for(int i=0; i<s.length(); i++) {
      char c = s.charAt(i);
      switch (c) {
      case '+':
	sb.append(' ');
	break;
      case '%':
	try {
	  sb.append((char)Integer.parseInt
		    (s.substring(i+1,i+3),16));
	}
	catch (NumberFormatException e) {
	  throw new IllegalArgumentException();
	}
	i += 2;
	break;
      default:
	sb.append(c);
	break;
      }
    }
    // Undo conversion to external encoding
    String result = sb.toString();
    byte[] inputBytes = result.getBytes("8859_1");
    return new String(inputBytes);
  }
}
