/**
 * @modification $Date: 2001/12/03 16:28:08 $
 * @statut       unstable
 * @file         DjaColor.java
 * @version      0.32
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 * guillaume-desnoix@memoire.com
 */

package com.memoire.dja;

import com.memoire.dja.*;

import java.awt.*;
import java.io.*;

public class DjaColor
  implements DjaOptions, Cloneable, Serializable
{
    private int rgb_;

    private transient Color color_=null;

    public DjaColor()
    {
      rgb_=Color.black.getRGB();
    }

    public DjaColor(int _rgb)
    {
	rgb_=_rgb;
    }

    public DjaColor(Color _color)
    {
	rgb_  =_color.getRGB();
    }

    public Color getColor()
    {
	if(color_==null) color_=new Color(rgb_);
	return color_;
    }
}
