/**
 * @modification $Date: 2001/12/03 16:28:08 $
 * @statut       unstable
 * @file         DjaFont.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.dja;

import com.memoire.dja.*;

import java.awt.*;
import java.io.*;

public class DjaFont
  implements DjaOptions, Cloneable, Serializable
{
    private String family_;
    private int    style_;
    private int    size_;

    private transient Font font_;

    public DjaFont()
    {
	this(defaultPlainFont);
    }

    public DjaFont(String _family, int _style, int _size)
    {
	this(new Font(_family,_style,_size));
    }

    public DjaFont(Font _font)
    {
	font_  =_font;
	family_=_font.getFamily();
	style_ =_font.getStyle();
	size_  =_font.getSize();
    }

    public Font getFont()
    {
	if(font_==null) font_=new Font(family_,style_,size_);
	return font_;
    }
}
