/**
 * @modification $Date: 2001/12/03 16:28:08 $
 * @statut       unstable
 * @file         DjaForm.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.dja;

import com.memoire.fu.*;
import com.memoire.dnd.*;
import com.memoire.bu.*;
import com.memoire.dja.*;
import com.memoire.mst.*;


import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;
import javax.swing.border.*;

public abstract class DjaForm
                extends DjaObject
{
  private int x_,y_,width_,height_;

  public DjaForm(String _text)
  {
    this(_text,CENTER);
  }

  public DjaForm(String _text,int _position)
  {
    super();

    setX(deltaX);
    setY(deltaY);
    setWidth(80);
    setHeight(40);

    if(_text!=null)
    {
      DjaText t0=new DjaText(this,0,_text,true,0,0);
      t0.setPosition(_position);
      setTextArray(new DjaText[] { t0 });
    }
  }

  public void addText(String _text)
  {
    DjaText t=new DjaText(this,-1,_text);
    int p=CENTER;
    switch(getTexts().length)
    {
    case 0: p=CENTER; break;
    case 1: p=SOUTH;  break;
    case 2: p=NORTH;  break;
    case 3: p=EAST;   break;
    case 4: p=WEST;   break;
    }
    t.setPosition(p);
    addText(t);
  }

  public int getX()
    { return x_; }

  public void setX(int _x)
    { x_=_x; }

  public int getY()
    { return y_; }

  public void setY(int _y)
    { y_=_y; }

  public int getWidth()
    { return width_; }

  public void setWidth(int _width)
    { width_=_width; }

  public int getHeight()
    { return height_; }

  public void setHeight(int _height)
    { height_=_height; }

  public Rectangle getBounds()
    { return new Rectangle(getX(),getY(),getWidth(),getHeight()); }

  public final DjaAttach[] getAttachs()
  {
    return new DjaAttach[0];
  }
}
