/**
 * @modification $Date: 2001/12/03 16:28:08 $
 * @statut       unstable
 * @file         DjaGridEvent.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.dja;

import com.memoire.fu.*;
import com.memoire.dnd.*;
import com.memoire.bu.*;
import com.memoire.dja.*;
import com.memoire.mst.*;


import java.util.*;

public class DjaGridEvent
       extends EventObject
{
    public final static int ADDED       =1;
    public final static int REMOVED     =2;
    public final static int CONNECTED   =3;
    public final static int DISCONNECTED=4;
    public final static int SELECTED    =5;
    public final static int UNSELECTED  =6;
    public final static int MODIFIED    =7;

    private int      id_;
    private DjaOwner object_;

    public DjaGridEvent(DjaGrid _grid,DjaOwner _object,int _id)
    {
	super(_grid);
	object_=_object;
	id_    =_id;
    }

    public DjaGrid getGrid()
    {
	return (DjaGrid)getSource();
    }

    public int getID()
    {
	return id_;
    }

    public DjaOwner getObject()
    {
	return object_;
    }

    public String toString()
    {
      String r=""+getObject()+" ";

      switch(getID())
      {
	case DjaGridEvent.ADDED       : r+="added"; break;
	case DjaGridEvent.REMOVED     : r+="removed"; break;
        case DjaGridEvent.CONNECTED   : r+="connected"; break;
	case DjaGridEvent.DISCONNECTED: r+="disconnected"; break;
	case DjaGridEvent.SELECTED    : r+="selected"; break;
	case DjaGridEvent.UNSELECTED  : r+="unselected"; break;
        case DjaGridEvent.MODIFIED    : r+="modified"; break;
      }

      return r+" ("+getSource()+")";
    }
}
