/**
 * @modification $Date: 2001/12/03 16:28:08 $
 * @statut       unstable
 * @file         DjaLayoutCircle.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.dja;

import com.memoire.dja.*;
import java.util.*;

public class DjaLayoutCircle
  implements DjaLayoutInterface
{
  public DjaLayoutCircle()
  {
  }

  public void layout(DjaGrid _grid)
  {
    DjaVector v=new DjaVector();
    for(Enumeration e=_grid.enumerate(DjaForm.class);
	e.hasMoreElements(); )
      v.addElement(e.nextElement());

    int    n=v.size();
    double r=20.+10.*n;

    for(int i=0;i<n;i++)
    {
      DjaForm f=(DjaForm)v.elementAt(i);
      double  a=Math.PI*2.*(double)i/(double)n;
      int     x=10+40+(int)Math.round(1.2*r+1.2*r*Math.sin(a));
      int     y=10+20+(int)Math.round(0.8*r-0.8*r*Math.cos(a));
      f.setX(x);
      f.setY(y);
    }
  }
}
