/**
 * @modification $Date: 2001/12/03 16:28:08 $
 * @statut       unstable
 * @file         DjaLayoutTree.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.dja;

import com.memoire.dja.*;
import java.util.*;

public class DjaLayoutTree
  implements DjaLayoutInterface
{
  public DjaLayoutTree()
  {
  }

  public void layout(DjaGrid _grid)
  {
    DjaVector v=new DjaVector();
    for(Enumeration e=_grid.enumerate(DjaForm.class);
	e.hasMoreElements(); )
      v.addElement(e.nextElement());

    int n=v.size();
    int x=10;
    int y=10;
    int w=0;
    for(int i=0;i<n;i++)
    {
      DjaForm f=(DjaForm)v.elementAt(i);

      if((f.getEndConnections().length>0)||(f.getBeginConnections().length>0))
      {
	x+=w-10;
	x+=10-x%10;
	w=0;
      }

      w=Math.max(w,f.getWidth());

      f.setX(x);
      f.setY(y);
      DjaLib.snap(f);

      y+=f.getHeight()+5;
      y+=10-y%10;
    }
  }
}
