/**
 * @modification $Date: 2001/12/03 16:28:08 $
 * @statut       unstable
 * @file         DjaLibDetect.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.dja;

import com.memoire.fu.*;
import com.memoire.bu.*;
import com.memoire.dja.*;

import java.awt.*;
import java.util.*;

public class DjaLibDetect
{
  public final static Object detect
  (DjaGrid _grid,int _x, int _y)
  {
    return detect(_grid,_grid.getObjects(),_x,_y,null);
  }

  public final static Object detect
  (DjaGrid _grid,int _x, int _y,Object _exclude)
  {
    return detect(_grid,_grid.getObjects(),_x,_y,_exclude);
  }
  
  public final static Object detect
  (DjaGrid _grid,DjaVector _v,int _x, int _y,Object _exclude)
  {
    for(Enumeration e=_v.elements(); e.hasMoreElements(); )
    {
      DjaObject o=(DjaObject)e.nextElement();
      
      if(o==_exclude) continue;

      // Handles
      if(o.isSelected())
      {
	DjaHandle[] handles=o.getHandles();
	int l=handles.length;
	for(int i=0;i<l;i++)
	{
	  DjaHandle h=handles[i];
	  if(DjaLib.close(h.getX(),h.getY(),_x,_y))
	    if(h!=_exclude)
	      return h;
	}
      }

      // Controls
      if(o.isSelected())
      {
	DjaControl[] controls=o.getControls();
	int l=controls.length;
	for(int i=0;i<l;i++)
	{
	  DjaControl c=controls[i];
	  if(DjaLib.close(c.getX(),c.getY(),_x,_y))
	    if(c!=_exclude)
	      return c;
	}
      }

      // Attachs
      if(_grid.isAttachsVisible())
      {
	DjaAttach[] attachs=o.getAttachs();
	int l=attachs.length;
	for(int i=0;i<l;i++)
	{
	  DjaAttach a=attachs[i];
	  if(DjaLib.close(a.getX(),a.getY(),_x,_y))
	    if(a!=_exclude)
	      return a;
	}
      }
      
      // Anchors
      if(_grid.isAnchorsVisible())
      {
	DjaAnchor[] anchors=o.getAnchors();
	int l=anchors.length;
	for(int i=0;i<l;i++)
	{
	  DjaAnchor a=anchors[i];
	  if(DjaLib.close(a.getX(),a.getY(),_x,_y))
	    if(a!=_exclude)
	      return a;
	}
      }
      
      // Texts
      if(o.isSelected())
      {
	DjaText[] texts=o.getTexts();
	int l=texts.length;
	for(int i=0;i<l;i++)
	{
	  DjaText t=texts[i];
	  if(t.getBounds().contains(_x,_y))
	    if(t!=_exclude)
	      return t;
	}
      }

      // Object
      {
	if(o.contains(_x,_y))
	  return o;
      }
    }

    return null;
  }

  public final static DjaObject detectObject
  (DjaGrid _grid, int _x, int _y)
  {
    return detectObject(_grid.getObjects(),_x,_y);
  }

  public final static DjaObject detectObject
  (DjaVector _v, int _x, int _y)
  {
    for(Enumeration e=_v.elements(); e.hasMoreElements(); )
    {
      DjaObject o=(DjaObject)e.nextElement();
      if(o.contains(_x,_y)) return o;
    }
    
    return null;
  }
}
