/**
 * @modification $Date: 2001/12/03 16:28:08 $
 * @statut       unstable
 * @file         DjaLoadSaveImage.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.dja;

import com.memoire.bu.*;
import com.memoire.dja.*;

import java.awt.*;
import java.io.*;
import java.util.*;

public abstract class DjaLoadSaveImage
       implements DjaLoadSaveInterface
{
  private String format_;

  public DjaLoadSaveImage(String _format)
  {
    format_=_format;
  }

  public final boolean canLoad() { return false; }
  public final boolean canSave() { return true; }

  public final DjaVector load(File _file)
    throws Exception
  {
    throw new Exception("Not implemented");
  }

  public final void save(File _file, DjaVector _vector)
    throws Exception
  {
    DjaGrid grid=null;

    if(_vector.size()!=0)
    {
      DjaObject o=(DjaObject)_vector.elementAt(0);
      grid=o.getGrid();
    }

    if(grid==null) grid=new DjaGrid();
    Image   i   =grid.getImage();
    BuImageEncoder.save(i,_file.getAbsolutePath(),format_);
  }

  public final BuFileFilter getFilter()
  {
    return new BuFileFilter
      (new String[] { format_.toLowerCase(), format_.toUpperCase() },
      format_+" images");
  }
}
