/**
 * @modification $Date: 2001/12/03 16:28:08 $
 * @statut       unstable
 * @file         DjaManipulator.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.dja;

import com.memoire.fu.*;
import com.memoire.dnd.*;
import com.memoire.bu.*;
import com.memoire.dja.*;
import com.memoire.mst.*;


public abstract class DjaManipulator
       implements DjaOwner, DjaOptions
{
  public DjaGrid getGrid()
  {
    DjaGrid  r=null;

    DjaOwner o=getOwner();
    while(o!=null)
    {
      if(o instanceof DjaGrid)
	{ r=(DjaGrid)o; break; }
      o=o.getOwner();
    }

    return r;
  }

  public void fireGridEvent(DjaOwner _object,int _id)
  {
    DjaGrid grid=getGrid();
    if(grid!=null) grid.fireGridEvent(_object,_id);
  }

  public abstract DjaOwner getOwner();
}
