/**
 * @modification $Date: 2001/12/03 16:28:08 $
 * @statut       unstable
 * @file         DjaPoint.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.dja;

import com.memoire.fu.*;
import com.memoire.dnd.*;
import com.memoire.bu.*;
import com.memoire.dja.*;
import com.memoire.mst.*;


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

public class DjaPoint
       extends DjaForm
{
  public DjaPoint(String _texte)
  {
    super(_texte,SOUTH);
    super.setWidth (1);
    super.setHeight(1);
  }

  public DjaPoint()
  {
    this(null);
  }

  public void setWidth(int _w)
  { }

  public void setHeight(int _h)
  { }

  public int getWidth()
  { return 1; }

  public int getHeight()
  { return 1; }

  public boolean contains(int _x, int _y)
  {
    Rectangle r=getBounds();
    r.grow(7,7);
    return r.contains(_x,_y);
  }

  public DjaAnchor[] getAnchors()
  {
    DjaAnchor[] r=new DjaAnchor[1];
    r[0]=new DjaAnchor(this,0,NORTH,getX(),getY());
    return r;
  }

  public DjaHandle[] getHandles()
  {
    DjaHandle[] r=new DjaHandle[0];
    return r;
  }

  public void paintInteractive(Graphics _g)
  {
    int x=getX();
    int y=getY();

    Color bg=getBackground();
    if(bg!=null)
    {
      _g.setColor(bg);
      _g.fillOval(x-4,y-4,9,9);
    }

    Color fg=getForeground();
    if(fg!=null)
    {
      _g.setColor(fg);
      _g.drawOval(x-5,y-5,10,10);
    }

    super.paintInteractive(_g);
  }
}
