/**
 * @modification $Date: 2001/12/03 16:28:08 $
 * @statut       unstable
 * @file         DjaVLine.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.dja;

import com.memoire.fu.*;
import com.memoire.dnd.*;
import com.memoire.bu.*;
import com.memoire.dja.*;
import com.memoire.mst.*;


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

public class DjaVLine
       extends DjaForm
{
  public DjaVLine(String _texte)
  {
    super(_texte,EAST);
  }

  public DjaVLine()
  {
    this(null);
  }

  public int getWidth()
  {
    return 1;
  }

  public void setWidth(int _w)
  {
    super.setWidth(1);
  }

  public boolean contains(int _x, int _y)
  {
    return new Rectangle(getX()-3,getY(),7,getHeight()).contains(_x,_y);
  }

  public DjaAnchor[] getAnchors()
  {
    int x=getX();
    int y=getY();
    int h=getHeight();

    DjaAnchor[] r=new DjaAnchor[2];
    r[0]=new DjaAnchor(this,0,NORTH,x,y);
    r[1]=new DjaAnchor(this,1,SOUTH,x,y+h-1);

    return r;
  }

  public DjaHandle[] getHandles()
  {
    int x=getX();
    int y=getY();
    int h=getHeight();

    DjaHandle[] r=new DjaHandle[2];
    r[0]=new DjaHandle(this,NORTH,x,y-deltaY);
    r[1]=new DjaHandle(this,SOUTH,x,y+h-1+deltaY);

    return r;
  }

  public void paintObject(Graphics _g)
  {
    Color fg=getForeground();
    if(fg!=null)
    {
      _g.setColor(fg);

      DjaGraphics.BresenhamParams bp=DjaGraphics.getBresenhamParams(this);
      DjaGraphics.drawLine(_g,getX(),getY(),getX(),getY()+getHeight(),bp);
    }

    super.paintObject(_g);
  }
}
