/**
 * @modification $Date: 2001/12/03 16:28:08 $
 * @statut       unstable
 * @file         DndIcons.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.dnd;
import com.memoire.dnd.*;


import java.awt.*;
import java.awt.event.*;
import java.lang.reflect.*;
import java.util.*;

import javax.swing.*;

public class DndIcons
{
    private final static Hashtable icons_=new Hashtable(11);

    public final static void put(Class _class, Icon _icon)
    {
	/*
        Object v=icons_.get(_class);
	if((v!=null)&&(v!=_icon))
	  System.err.println(_class.getName()+" already has an icon");
	*/

	icons_.put(_class,_icon);
    }

    public final static Icon get(Class _class)
    {
	return (Icon)icons_.get(_class);
    }

    public final static Icon getIcon(Object[] _data)
    {
	Icon    r=null;
	boolean multi=false;
	boolean array=false;

	for(int i=0;i<_data.length;i++)
	{
	    if(_data[i]==null) continue;
	    Class c=_data[i].getClass();
	    array=c.isArray();
	    if(array)
	    {
	      c=DndTarget.getCommonClass(_data[i]);
	      multi|=(Array.getLength(_data[i])>1);
	    }
	    // System.err.println("CLASS="+c);
	    r=get(c);
	    if(r!=null) break;
	}

	if(r==null)
	{
	loop:
	    for(int i=0;i<_data.length;i++)
	    {
		if(_data[i]==null) continue;
		Class c=_data[i].getClass();
		if(array) c=c.getComponentType();
		for(Enumeration e=icons_.keys(); e.hasMoreElements(); )
		{
		    Class d=(Class)e.nextElement();
		    if(d.isAssignableFrom(c))
			{ r=get(d); break; }
		}
	    }
	}

	if(r==null) r=getDefaultIcon();
	
	return (multi ? new DndMultiIcon(r) : r);
    }

    private static boolean iconDisplayed_ =true;
    public final static boolean isIconDisplayed()
    { return iconDisplayed_; }
    public final static void setIconDisplayed(boolean _b)
    { iconDisplayed_=_b; }

    private static Icon defaultIcon_ =null;
    public final static Icon getDefaultIcon()
    { return defaultIcon_; }
    public final static void setDefaultIcon(Icon _icon)
    { defaultIcon_=_icon; }

    private static Icon noDropIcon_ =null;
    public final static Icon getNoDropIcon()
    { return noDropIcon_; }
    public final static void setNoDropIcon(Icon _icon)
    { noDropIcon_=_icon; }

    private static Icon canDropIcon_=null;
    public final static Icon getCanDropIcon()
    { return canDropIcon_; }
    public final static void setCanDropIcon(Icon _icon)
    { canDropIcon_=_icon; }
}
