/**
 * @modification $Date: 2001/12/03 16:28:08 $
 * @statut       unstable
 * @file         DndManageText.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.dnd;
import com.memoire.dnd.*;


import java.awt.*;
import javax.swing.*;
import javax.swing.text.*;

public class DndManageText
    implements DndManageData, DndModes
{
    public final static DndManageText SINGLETON_REPLACE_ALL=
	new DndManageText(REPLACE_ALL);

    public final static DndManageText SINGLETON_INSERT_AT_CURSOR=
	new DndManageText(INSERT_AT_CURSOR);

    private int mode_;

    public DndManageText(int _mode)
    {
	mode_=_mode;
    }

    public boolean manage
	(Object _data,JComponent _component,Point _location)
    {
	boolean r=false;

	try
	{
	    String         str =_data.toString();
	    JTextComponent text=(JTextComponent)_component;
	    Document       doc =text.getDocument();
	    int            pos =-1;

	    synchronized(text)
	    {
	    synchronized(doc)
	    {

	    switch(mode_)
	    {
	    case INSERT_AT_BEGIN:
		pos=doc.getStartPosition().getOffset();
		break;
	    case INSERT_AT_END:
		pos=doc.getEndPosition().getOffset();
		break;
	    case INSERT_AT_CURSOR:
		Point p=_location;
		pos=text.viewToModel(p);
		break;
	    case INSERT_AT_CARET:
		pos=text.getCaretPosition();
		break;
	    case INSERT_BEFORE_SELECTION:
		pos=text.getSelectionStart();
		break;
	    case INSERT_AFTER_SELECTION:
		pos=text.getSelectionEnd();
		break;
	    case REPLACE_SELECTION:
		pos=text.getSelectionStart();
		doc.remove(pos,text.getSelectionEnd()-pos);
		break;
	    case REPLACE_ALL:
		int start=doc.getStartPosition().getOffset();
		doc.remove(start,doc.getLength());
		pos=start;
		break;
	    }

	    text.setCaretPosition(pos);
	    doc.insertString(pos,str,null);
	    r=true;

	    }
	    }
	}
	catch(BadLocationException ex) {}
	return r;
    }
}
