/**
 * @modification $Date: 2001/12/03 16:28:08 $
 * @statut       unstable
 * @file         DndRequestItem.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.dnd;
import com.memoire.dnd.*;


import java.awt.*;
import javax.swing.*;
import javax.swing.tree.*;

public class DndRequestItem
    implements DndRequestData
{
    public final static DndRequestItem SINGLETON=
	new DndRequestItem();

    protected DndRequestItem() { }

    public Object[] request(JComponent _component,Point _location)
    {
	Object v=null;

	if(_component instanceof JList)
	{
	    JList list =(JList)_component;
	    int   index=list.locationToIndex(_location);
	    if(index>=0) v=list.getModel().getElementAt(index);
	    //System.err.println("INDEX="+index);
	}
	else
	if(_component instanceof JTree)
	{
	    JTree    tree=(JTree)_component;
	    TreePath path=tree.getPathForLocation(_location.x,_location.y);
	    if(path!=null) v=path.getLastPathComponent();
	}

	/*
	  System.err.println
	  ("VALUE="+v+
	  (v!=null ? ":"+v.getClass().getName() : ""));
	*/

	return (v==null ? new Object[0] : new Object[] { v });
    }
}
