/**
 * @modification $Date: 2001/12/03 16:28:08 $
 * @statut       unstable
 * @file         DndRequestSelection.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.dnd;
import com.memoire.dnd.*;


import java.awt.*;
import javax.swing.*;
import javax.swing.tree.*;

public class DndRequestSelection
    implements DndRequestData
{
    public final static DndRequestSelection SINGLETON=
	new DndRequestSelection();

    protected DndRequestSelection() { }

    public Object[] request(JComponent _component,Point _location)
    {
	Object[] r=null;

	if(_component instanceof JList)
	{
	    JList list=(JList)_component;
	    r=list.getSelectedValues();
	}
	else
	if(_component instanceof JTree)
	{
	    JTree      tree=(JTree)_component;
	    TreePath[] path=tree.getSelectionPaths();

	    if(path!=null)
	    {
	      int        l   =path.length;
	      r=new Object[l];
	      for(int i=0;i<l;i++)
		r[i]=path[i].getLastPathComponent();
	    }
	}

	/*
	  if(r!=null)
	  System.err.println("VALUE[]="+r.length);
	*/

	return (r!=null ? new Object[] { r } : new Object[0]);
    }
}
