/**
 * @modification $Date: 2001/12/03 16:28:08 $
 * @statut       unstable
 * @file         DndTest.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.dnd;
import com.memoire.dnd.*;


import java.awt.*;
import javax.swing.*;

public class DndTest
{
    public static void main(String[] args)
    {
	DndIcons.setNoDropIcon (new ImageIcon("dnd-nodrop_24.gif"));
	DndIcons.setCanDropIcon(new ImageIcon("dnd-candrop_24.gif"));
	DndIcons.setDefaultIcon(new ImageIcon("dnd-default_24.gif"));

	Color[] COLOR=new Color[]
	{ Color.yellow, Color.blue, Color.red, Color.green, Color.magenta };

	JPanel   pc=new JPanel(new GridLayout(5,1));
	JLabel[] cl=new JLabel[5];
	for(int i=0;i<5;i++)
	{
	    cl[i]=new JLabel("  ");
	    cl[i].setOpaque(true);
	    cl[i].setBackground(COLOR[i]);
	    pc.add(cl[i],i);

	    /*
	    new DndComponentSource(cl[i],new DndRequestData()
	    {
		public Object[] request(Component _component,Point _location)
		{
		    Color c=_component.getBackground();
		    return new Object[]
		    {
			c,
			"#"+Integer.toHexString(c.getRGB()),
		    };
		}
	    });
	    */

	    new DndSource(new DndRequestObject
		(new Object[]
		    {
			new DndProperty("foreground",COLOR[i]),
			COLOR[i],
			"#"+Integer.toHexString(COLOR[i].getRGB())
		    } ))
		.add(cl[i]);
	}
	
        JFrame     frame=new JFrame("Drag&Drop Test");
	JTextField tf=new JTextField(20);
        JTextArea  ta=new JTextArea(10,20); //tmp()
	JLabel     lb=new JLabel("file:///hello/");
	JLabel     no=new JLabel("<no>");
	JPanel     pn=new JPanel(new BorderLayout());

	ta.setLineWrap(true);
	//ta.setWrapStyleWord(true);

	pn.add("North",tf);
	pn.add("Center",new JScrollPane(ta));
	pn.add("South",lb);
	pn.add("East",no);
	pn.add("West",pc);
        frame.setContentPane(pn);

	new DndSource(new DndRequestObject("machin"))
		.add(lb);

	new DndSource(new DndRequestObject
	    (new DndProperty("font",new Font("SansSerif",Font.PLAIN,10))))
		.add(no);

	new DndTarget()
	    .accept(Color.class,
		    DndTransferObject.SINGLETON,
		    DndManageBackground.SINGLETON)
	    .accept(String.class,
		    DndTransferString.SINGLETON,
		    DndManageText.SINGLETON_REPLACE_ALL)
	    .add(tf);

	new DndTarget()
	    .accept(DndProperty.class,
		    DndTransferObject.SINGLETON,
		    DndManageProperty.SINGLETON)
	    .accept(String.class,
		    DndTransferString.SINGLETON,
		    DndManageText.SINGLETON_INSERT_AT_CURSOR)
	    .accept(Object.class,
		    DndTransferString.SINGLETON,
		    DndManageText.SINGLETON_INSERT_AT_CURSOR)
	    .add(ta);

	/*
	  DndTargetText.setOn
	    (ta,DndTargetText.INSERT_AT_CURSOR);

	DndComponentTarget dct=new DndComponentTarget(tf);
	dct.addAcceptedClass(String.class,
			     DndTransferString.SINGLETON,
			     DndManageText.SINGLETON);
	dct.addAcceptedClass(Color.class,
			     DndTransferObject.SINGLETON,
			     DndManageBackground.SINGLETON);
	*/
	//DndTargetText.setOn
	//    (tf,DndTargetText.REPLACE_ALL);
	//DndTargetColor.setOn(tf);

	//DndTargetColor.setOn(no);

	/*
	new DndComponentSource(lb,new DndRequestData()
	{
	    public Object[] request(Component _component,Point _location)
	    {
		return new Object[]
		{
		    _component,
		    ((JLabel)_component).getText(),
		};
	    }
	});
	*/

	//DndTargetProperty.setOn(tf);
	//DndTargetProperty.setOn(ta);
	/*
	new DndComponentSource
	    (no,new DndRequestProperty
		("font",new Font("SansSerif",Font.PLAIN,10)));
	*/

        frame.pack();
        frame.show();
    }
}
