/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         Editor.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:08 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.editor;
import com.memoire.editor.*;


public abstract class Editor
{
  public static final EditorInterface editor(String _editor,boolean _extern)
  {
    EditorInterface r=null;

    try
    {
      // System.err.println("EDITOR="+_editor);

      if(!"".equals(_editor))
      {
	if(!_extern)
	{
	  try 
	  {
	    String ein=Editor.class.getName()+ // "Editor"+
	      _editor.substring(0,1).toUpperCase()+
	      _editor.substring(1).toLowerCase();
	    //System.err.println("    -> "+ein);
	    Class  eic=Class.forName(ein);
	    Object eii=eic.newInstance();
	    if(eii instanceof EditorInterface) r=(EditorInterface)eii;
	    else System.err.println("    -> "+eii+
				    " is not an EditorInterface.");
	  }
	  catch(Exception ex)
	  {
	    // ex.printStackTrace();
	    System.err.println(""+_editor+" can not be found."+
			       " Please verify your classpath.");
	  }
	}
	else
	{
	  r=new EditorExternal(_editor);
	}
      }

      if(r==null)
      {
	r=new EditorButextarea();
	System.err.println("    -> uses default BuTextArea.");
      }
    }
    catch (Exception ex)
      { r=null; }

    return r;
  }
}
