/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         EditorButextpane.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:08 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.editor;
import com.memoire.bu.*;
import com.memoire.editor.*;

import java.awt.*;
import java.io.*;
import javax.swing.*;
import javax.swing.text.*;

public class EditorButextpane
       implements EditorInterface
{
  private BuTextPane ta_ =null;

  public String getName()
  {
    return "BuTextPane";
  }

  public String getShortDescription()
  {
    return "BuTextPane is a simple text editor component";
  }

  public String getLongDescription()
  {
    return "BuTextPane is a simple text editor component "+
           "(com.memoire.bu.BuTextPane)";
  }

  public Object getIcon()
  {
    return null;
  }

  public boolean can(String _action)
  {
    boolean r=false;
    if("colorize".equals(_action)) r=true;
    if("copy"    .equals(_action)) r=true;
    if("cut"     .equals(_action)) r=true;
    if("duplicate".equals(_action)) r=true;
    if("find"    .equals(_action)) r=true;
    if("paste"   .equals(_action)) r=true;
    if("redo"    .equals(_action)) r=true;
    if("replace" .equals(_action)) r=true;
    if("select"  .equals(_action)) r=true;
    if("undo"    .equals(_action)) r=true;
    return r;
  }

  public void act(String _action)
  {
    if("colorize" .equals(_action)) colorize();
    if("copy"     .equals(_action)) ta_.copy();
    if("cut"      .equals(_action)) ta_.cut();
    if("duplicate".equals(_action)) ta_.duplicate();
    if("paste"    .equals(_action)) ta_.paste();
    if("redo"     .equals(_action)) ta_.redo();
    if("undo"     .equals(_action)) ta_.undo();
  }

  public boolean needScrollBars()
  {
    return true;
  }

  public Object getGUI()
  {
    return ta_;
  }

  public void start()
  {
    if(ta_==null) ta_=new BuTextPane();
  }

  public void run()
  {
  }

  public void exit()
  {
  }

  /**
   * Loads some files.
   */
  // public void load(InputStream _in);
  // public void load(String      _filename);
  // public void load(File        _file);
  // public void load(URL         _url);

  private void colorize()
  {
    ta_.colorize((BuCommonInterface)ta_.
		 getClientProperty("BU_IMPLEMENTATION"));
  }

  public void setText(String _text)
  {
    ta_.setText(_text);
    // colorize();
  }

  public String getText()
  {
    return ta_.getText();
  }

  private String syntax_=null;

  public void setSyntax(String _syntax)
  {
    syntax_=_syntax;
    BuAutoStyledDocument doc=(BuAutoStyledDocument)ta_.getDocument();
    doc.setSyntax(_syntax);
  }

  public String getSyntax()
  {
    return syntax_;
  }

  public void setEditable(boolean _editable)
  {
    ta_.setEditable(_editable);
  }

  public boolean isEditable()
  {
    return ta_.isEditable();
  }

  public static void main(String[] args)
  {
    EditorButextpane buta=new EditorButextpane();
    buta.start();

    StringBuffer s=new StringBuffer();
    try
    {
      LineNumberReader lnr=new LineNumberReader
	(new FileReader("../essai/Vecteur.e"));

      while(true)
      {
	String l=lnr.readLine();
	if(l==null) break;
	s.append(l);
	s.append('\n');
      }
    }
    catch(Exception ex) { }
    // System.out.println(s);

    buta.setSyntax("Eiffel");
    buta.setText(s.toString().substring(0,1024));

    JFrame f=new JFrame("EditorButextpane");
    f.getContentPane().add("Center",
			   new JScrollPane((Component)buta.getGUI()));
    f.setSize(400,300);
    f.show();

    buta.run();

    /*
    try { Thread.sleep(30000); }
    catch(Exception ex) { }
    System.out.println(""+buta.getText());
    buta.exit();
    System.exit(0);
    */
  }
}
