/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         EditorExternal.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:08 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.editor;
import com.memoire.editor.*;


import java.io.*;

public class EditorExternal
       implements EditorInterface
{
  private String cmd_    ="";
  private String text_   ="";
  private String tmpfile_=null;

  public EditorExternal(String _cmd)
  {
    cmd_=_cmd;
  }

  public String getName()
  {
    return cmd_;
  }

  public String getShortDescription()
  {
    return cmd_+" should launch your favorite editor";
  }

  public String getLongDescription()
  {
    return cmd_+" is surely your favorite editor";
  }

  public Object getIcon()
  {
    return null;
  }

  public boolean can(String _action)
  {
    return false;
  }

  public void act(String _action)
  {
  }

  public boolean needScrollBars()
  {
    return false;
  }

  public Object getGUI()
  {
    return null;
  }

  public void start()
  {
  }

  private String getTmpFile()
  {
    if(tmpfile_==null)
      tmpfile_=System.getProperty("user.dir")+
	       System.getProperty("file.separator")+
	       "F"+System.currentTimeMillis()+".tmp";
    return tmpfile_;
  }

  public void run()
  {
    try
    {
      File file=new File(getTmpFile());
      FileOutputStream out=new FileOutputStream(file);
      out.write(text_.getBytes());
      String[] cmd=new String[] { cmd_,getTmpFile() };
      Process p=Runtime.getRuntime().exec(cmd);
      p.waitFor();

      if(editable_)
      {
	FileInputStream in=new FileInputStream(file);
	text_="";
	while(in.available()>0) text_+=(char)in.read();
	file.delete();
      }
    }
    catch(Exception ex) { }
  }

  public void exit()
  {
  }

  /**
   * Loads some files.
   */
  // public void load(InputStream _in);
  // public void load(String      _filename);
  // public void load(File        _file);
  // public void load(URL         _url);

  public void setText(String _text)
  {
    text_=_text;
  }

  public String getText()
  {
    return text_;
  }

  private String syntax_=null;

  public void setSyntax(String _syntax)
  {
    syntax_=_syntax;
  }

  public String getSyntax()
  {
    return syntax_;
  }

  private boolean editable_=true;

  public void setEditable(boolean _editable)
  {
    editable_=_editable;
  }

  public boolean isEditable()
  {
    return editable_;
  }

  public static void main(String[] args)
  {
    EditorExternal elvis=new EditorExternal("elvis");
    elvis.start();
    elvis.setText("hello");
    elvis.run();
    System.out.println(""+elvis.getText());
    elvis.exit();
  }
}
