/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         EditorJext.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:08 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.editor;
import com.memoire.editor.*;


import java.awt.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import org.jext.*;
//import com.chez.powerteam.jext.*;
import org.gjt.sp.jedit.syntax.*;
// import org.gjt.sp.jedit.textarea.*;

public class EditorJext
       implements EditorInterface
{
  static
  {
    Jext.initProperties();
    Jext.setProperty("lookandfeel",
		     UIManager.getLookAndFeel().getClass().getName());
  }

  class XJE extends JextFrame
  {
    public XJE()
    {
      try
      {
	// BuRegistry.register(this);
	Hashtable r=(Hashtable)System.getProperties().get("BuRegistry");
	if(r!=null) r.put(this,""+this);
      } catch(Exception ex) { }
    }

    public void closeToQuit()
    {
      JextTextArea[] t=getTextAreas();

      for(int i=0;i<t.length;i++)
	if(t[i].getClientProperty("EditorJext.mark")!=null)
	  close(t[i]);

      closeWindow(false);

      try
      {
	// BuRegistry.unregister(this);
	Hashtable r=(Hashtable)System.getProperties().get("BuRegistry");
	if(r!=null) r.remove(this);
      } catch(Exception ex) { }

      jext_=null;
    }

    public boolean contains(JextTextArea _ta)
    {
      if(getTabbedPane()!=null)
      {
        JextTextArea[] t=getTextAreas();

        for(int i=0;i<t.length;i++)
	  if(t[i]==_ta) return true; 
      }

      return false;
    }

    public void close(JextTextArea textArea)
    {
      close(textArea,textArea.getClientProperty("EditorJext.mark")==null);
    }
  }

  private static XJE jext_=null;
  private static int ntas_=0;

  private JextTextArea ta_=null;

  /*
  public EditorJext()
  {
  }
  */

  public String getName()
  {
    return "Jext";
  }

  public String getShortDescription()
  {
    return "Jext is a powerfull text editor";
  }

  public String getLongDescription()
  {
    return  "Jext is a powerfull text editor written in Java"
           +" by Romain Guy (version "+Jext.RELEASE+")";
  }

  public Object getIcon()
  {
    return null;
  }

  public boolean can(String _action)
  {
    return false;
  }

  public void act(String _action)
  {
  }

  public boolean needScrollBars()
  {
    return false;
  }

  public Object getGUI()
  {
    return jext_;
  }

  public void start()
  {
    if(jext_==null)
    {
      jext_=new XJE();
      // System.out.println("START JEXT");
      Jext.getInstances().add(jext_);
      // jext_.setVisible(false);
    }
  }

  public void run()
  {
    if((jext_!=null)&&(ta_==null))
    {
      ta_=jext_.createFile();
      ta_.putClientProperty("EditorJext.mark",Boolean.TRUE);
      ta_.setText(text_);
      ntas_++;
      jext_.setTextAreaName(ta_,"From Alma");

      /*
      if(ntas_==1)
      {
	JextTextArea[] t=jext_.getTextAreas();
	for(int i=0;i<t.length;i++)
	  if(t[i]!=ta_) jext_.close(t[i]);
      }
      */
    }

    // System.out.println("RUN JEXT");
    // jext_.setVisible(true);
    while((ta_!=null)&&(jext_!=null)&&jext_.contains(ta_))
    {
      try { Thread.sleep(500); }
      catch(Exception ex) { }
      Thread.yield();
    }

    exit();
  }

  public void exit()
  {
    if(ta_!=null)
    {
      getText();
      ntas_--;

      // System.err.println("EXIT EI");
      if((jext_!=null)&&jext_.contains(ta_))
      {
	// System.err.println("CLOSE TA");
	jext_.close(ta_);
      }
      ta_=null;
    }
  }

  /**
   * Loads some files.
   */
  // public void load(InputStream _in);
  // public void load(String      _filename);
  // public void load(File        _file);
  // public void load(URL         _url);

  private String text_="";

  public void setText(String _text)
  {
    text_=_text;
    if(ta_!=null)     ta_.setText(_text);
    if(syntax_!=null) setSyntax(syntax_);
  }

  public String getText()
  {
    if(ta_!=null) text_=ta_.getText();
    return text_;
  }

  private String syntax_=null;

  public void setSyntax(String _syntax)
  {
    syntax_=_syntax;

    if(ta_==null) return;

    String stx=syntax_;
    try
    {
      /*
      if("Cpp"       .equals(stx)) stx="CC";
      if("Hpp"       .equals(stx)) stx="CC";
      if("Html"      .equals(stx)) stx="HTML";
      if("Idl"       .equals(stx)) stx="IDL";
      if("Javascript".equals(stx)) stx="JavaScript";
      if("Sql2"      .equals(stx)) stx="SQL";
      if("Sql3"      .equals(stx)) stx="SQL";
      if("Svg"       .equals(stx)) stx="XML";
      if("Uxf"       .equals(stx)) stx="XML";
      if("Xml"       .equals(stx)) stx="XML";
      if("Xmi"       .equals(stx)) stx="XML";

      String pkg=TokenMarker.class.getName();

      int    i=pkg.lastIndexOf('.');
      if(i>=0) pkg=pkg.substring(0,i+1);
      else     pkg="";

      System.err.println("TOKENMARKER="+pkg+stx+"TokenMarker");

      Class  tmc=Class.forName(pkg+stx+"TokenMarker");
      Object tmi=tmc.newInstance();
      jext_.getTextArea().setTokenMarker((TokenMarker)tmi);
      */

      if(stx!=null) stx=stx.toLowerCase();
      else          stx="plain";

      if("cpp"       .equals(stx)) stx="cc";
      if("hpp"       .equals(stx)) stx="cc";
      if("html"      .equals(stx)) stx="html";
      // if("Idl"       .equals(stx)) stx="Idl";
      // if("Javascript".equals(stx)) stx="JavaScript";
      // if("Sql2"      .equals(stx)) stx="SQL";
      // if("Sql3"      .equals(stx)) stx="SQL";
      if("svg"       .equals(stx)) stx="xml";
      if("uxf"       .equals(stx)) stx="xml";
      if("xml"       .equals(stx)) stx="xml";
      if("xmi"       .equals(stx)) stx="xml";

      ta_.setColorizing(stx);

      System.err.println("Use syntax: "+stx);
    }
    catch(Exception ex) { System.err.println("ERROR for "+stx); }
  }

  public String getSyntax()
  {
    return syntax_;
  }

  private boolean editable_=true;

  public void setEditable(boolean _editable)
  {
    editable_=_editable;
    if(ta_!=null) ta_.setEditable(_editable);
  }

  public boolean isEditable()
  {
    return editable_;
  }

  public static void main(String[] args)
  {
    new Frame().addNotify();

    EditorJext buta=new EditorJext();
    System.out.println(buta.getLongDescription());
    buta.start();
    buta.setText("Hello from EditorJext!");
    buta.setSyntax("python");

    EditorJext butb=new EditorJext();
    System.out.println(butb.getLongDescription());
    butb.start();
    butb.setText("Bye from EditorJext!");
    butb.setSyntax("text");

    buta.run();
    butb.run();

    // On attend 10 s et on quitte...
    // debut test ------
    /*
    try { Thread.sleep(10000); }
    catch(Exception ex) { }
    */
    System.out.println(""+buta.getText());
    System.out.println(""+butb.getText());

    buta.exit();
    butb.exit();
    // System.exit(0);
  }
}
