/**
 * @modification $Date: 2001/12/03 16:28:08 $
 * @statut       unstable
 * @file         Foo.java
 * @version      0.08
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2001 Guillaume Desnoix
 */

package com.memoire.foo;
import com.memoire.foo.*;

import java.io.*;

public class Foo
{
  public static String VERSION="0.06";
  public static String DATE   ="2001-02-08";

  public static void main(String[] _args)
  {
    boolean _keep_=false;

    FooParser parser=new FooParser();
    parser.setStandAlone(true);
    
    try
    {
      boolean _stdin_=true;

      for(int i=0;i<_args.length;i++)
      {
	if("-a".equals(_args[i]))
	{
	  parser.setAnsi(true);
	}
	else
	if("-k".equals(_args[i]))
	{
	  _keep_=true;
	}
	else
	if("-s".equals(_args[i]))
	{
	  parser.setStep(true);
	}
	else
	if("-t".equals(_args[i]))
	{
	  parser.setTrace(true);
	}
	else
	if("-x".equals(_args[i]))
	{
	  parser.setException(true);
	}
	else
	if("-e".equals(_args[i]))
	{
	  i++;
	  parser.parseString(_args[i+1]);
	}
	else
	if(  "-h".equals(_args[i])
	   ||"--help".equals(_args[i]))
	{
	  System.out.println();
	  System.out.println
	    ("Foo interpreter version "+VERSION+" ["+DATE+"]");
	  System.out.println
	    ("(c)2000-2001 Guillaume Desnoix <guillaume@desnoix.com>");
	  System.out.println
	    ("Distributed under the terms of the GNU General Public"+
	     " License 2");
	  System.out.println
	    ("-----------------------------------------------------"+
	     "----------");
	  System.out.println
	    ("Syntax: java com.memoire.foo.Foo [options] [script [...]]");
	  System.out.println
	    ("  -a        ansi mode");
	  System.out.println
	    ("  -k        keep (don't quit)");
	  System.out.println
	    ("  -s        step mode");
	  System.out.println
	    ("  -t        trace mode");
	  System.out.println
	    ("  -x        exception mode");
	  System.out.println
	    ("  -e <expr> evaluate expression");
	  System.out.println();
	  _stdin_=false;
	}
	else
	if("-".equals(_args[i]))
	{
	  parser.parseStdin();
	  _stdin_=false;
	}
	else
	{
	  FileReader rin=new FileReader(_args[i]);
	  parser.parseMain(rin,_args[i],false);
	  _stdin_=false;
	}
      }

      if(_keep_ ) _stdin_=true;
      if(_stdin_) parser.parseStdin();
    }
    catch(Exception ex) { parser.error(ex); }
  }
}
