/**
 * @modification $Date: 2001/12/03 16:28:08 $
 * @statut       unstable
 * @file         FooAgent.java
 * @version      0.08
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2001 Guillaume Desnoix
 */

package com.memoire.foo;
import com.memoire.foo.*;

import java.util.*;

public class FooAgent
       extends Object
       implements Cloneable
{
  static
  {
    FooSymbol.put_raw("AGENTS",new FooList());
  }

  private static int cpt_=0;
  private int n_;

  private Hashtable memory_;

  public FooAgent()
  {
    cpt_++; n_=cpt_;

    memory_=new Hashtable();
    ((FooList)FooSymbol.get_raw("AGENTS")).add(this);
  }

  public void learn(Object _a,Object _b)
  {
    if(_b==null) _b=FooNull.NULL;
    if(_a!=null) memory_.put(_a,_b);
  }

  public Object remember(Object _a)
  {
    Object r=null;
    if(_a!=null) r=memory_.get(_a);
    return r;
  }

  public void forget(Object _a)
  {
    if(_a!=null) memory_.remove(_a);
  }

  public FooList memories()
  {
    FooList     r=new FooList();
    Enumeration e=memory_.keys();
    while(e.hasMoreElements())
      r.add(e.nextElement());
    return r;
  }

  public Object clone()
       throws CloneNotSupportedException
  {
    FooAgent r=new FooAgent();
    memory_=(Hashtable)memory_.clone();
    return r;
  }

  public String toString()
  {
    String r=getClass().getName();
    int i=r.lastIndexOf('.');
    if(i>=0) r=r.substring(i+1);
    return r+"-"+n_;
  }
}




