/**
 * @modification $Date: 2001/12/03 16:28:08 $
 * @statut       unstable
 * @file         FooDynamic.java
 * @version      0.08
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2001 Guillaume Desnoix
 */

package com.memoire.foo;
import com.memoire.foo.*;

import java.lang.reflect.*;

/**
 * A dynamic value is a non-constant variable, evaluated
 * at each request.
 * ('time =: '(java.lang.System "currentTimeMillis()"))
 **/
public class FooDynamic
{
    Object o_;

    private FooDynamic(Object _o)
    {
	o_=_o;
    }

    public static Object create(Object _o)
    {
	if(!(_o instanceof FooEval))
	    FooLib.getParser().warning("not an evaluable object:"+_o);
	return new FooDynamic(_o);
    }

    public Object dynamic()
    {
	return FooLib.eval(o_);
    }

    public String toString()
    {
	return "dynamic "+FooLib.toString(o_);
    }
}
