/**
 * @modification $Date: 2001/12/03 16:28:08 $
 * @statut       unstable
 * @file         FooException.java
 * @version      0.08
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2001 Guillaume Desnoix
 */

package com.memoire.foo;
import com.memoire.foo.*;

import java.io.*;

public class FooException
       extends RuntimeException
{
  private Exception ex_;

  public FooException(String _msg)
  {
    this(_msg,null);
  }

  public FooException(Exception _ex)
  {
    this(_ex.getMessage(),null);
  }

  public FooException(String _msg, Exception _ex)
  {
    super(_msg);
    ex_=_ex;
  }

  public void printStackTrace()
  {
    if(ex_!=null) ex_.printStackTrace();
    super.printStackTrace();
  }

  public void printStackTrace(PrintStream _out)
  {
    if(ex_!=null) ex_.printStackTrace(_out);
    super.printStackTrace(_out);
  }

  public void printStackTrace(PrintWriter _out)
  {
    if(ex_!=null) ex_.printStackTrace(_out);
    super.printStackTrace(_out);
  }
}
