/**
 * @modification $Date: 2001/12/03 16:28:08 $
 * @statut       unstable
 * @file         FooFile.java
 * @version      0.08
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2001 Guillaume Desnoix
 */

package com.memoire.foo;
import com.memoire.foo.*;

import java.io.*;

public class FooFile
{
  private static FooCategory pkg_=null;

  public final static FooCategory init()
  {
    if(pkg_==null)
    {
      pkg_=FooCategory.create(File.class);

      pkg_.setMessage("cat"     ,FooFile.class,"catMsg");
      pkg_.setMessage("ls"      ,FooFile.class,"lsMsg");
      pkg_.setMessage("ll"      ,FooFile.class,"llMsg");
    }

    return pkg_;
  }

    public static void catMsg(File _file)
    {
	if(_file.isDirectory())
	    throw new RuntimeException(_file+" is a directory");

	try
	{
	    LineNumberReader in =new LineNumberReader(new FileReader(_file));
	    PrintStream      out=FooLib.getOutput();
	    while(true)
	    {
		String l=in.readLine();
		if(l==null) break;
		out.println(l);
	    }
	}
	catch(IOException ex) { }
    }

    public static Object lsMsg(File _file)
    {
	Object r=null;

	if(!_file.isDirectory())
	    r=_file.getName();
	else
	    r=new FooList().append(_file.list());

	return r;
    }

    public static Object llMsg(File _file)
    {
	Object r=null;

	try
	{
	    if(!_file.isDirectory())
		r=_file.getCanonicalPath();
	    else
	    {
		String[] l=_file.list();
		for(int i=0;i<l.length;i++)
		    l[i]=new File(_file,l[i]).getCanonicalPath();
		r=new FooList().append(l);
	    }
	}
	catch(IOException ex)
	{
	    throw new RuntimeException
		("can not get the canonical path of "+_file);
	}

	return r;
    }
}
