/**
 * @modification $Date: 2001/12/03 16:28:08 $
 * @statut       unstable
 * @file         FooMessage.java
 * @version      0.08
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2001 Guillaume Desnoix
 */

package com.memoire.foo;
import com.memoire.foo.*;

import java.io.*;
import java.util.*;
import java.lang.reflect.*;

public class FooMessage
{
  private static FooCategory pkg_=null;

  public final static FooCategory init()
  {
    if(pkg_==null)
    {
      pkg_=FooCategory.create(FooMessage.class);
      pkg_.alias("&message");

      // pkg_.setMessage("new"     ,FooMessage.class,"newMsg");
      // pkg_.setMessage("method"  ,FooMessage.class,"methodMsg");
      // pkg_.setMessage("message" ,FooMessage.class,"messageMsg");
    }

    return pkg_;
  }

    private String     name_;
    private Method     method_;
    private Field      field_;
    private Object[]   block_;
    private String     alias_;
    //private boolean    ellipsis_;
    //private Object[]   default_;
    private boolean    evalargs_;
    private String[]   argnames_;
    
    private FooMessage(String _name, Method _method, Field _field,
		       Object[] _block, String _alias,
		       boolean _evalargs, String[] _argnames)
    {
	name_    =_name;
	method_  =_method;
	field_   =_field;
	block_   =_block;
	alias_   =_alias;
	evalargs_=_evalargs;
	argnames_=_argnames;
    }

    public FooMessage(String _name, Method _method, boolean _evalargs)
    {
	this(_name,_method,null,null,null,_evalargs,null);
    }

    public FooMessage(String _name, Field _field, boolean _evalargs)
    {
	this(_name,null,_field,null,null,_evalargs,null);
    }

    public FooMessage(String _name, Object[] _block, boolean _evalargs)
    {
	this(_name,null,null,_block,null,_evalargs,null);
    }

    public FooMessage(String _name, Object[] _block, String[] _argnames, boolean _evalargs)
    {
	this(_name,null,null,_block,null,_evalargs,_argnames);
    }

    public FooMessage(String _name, String _alias, boolean _evalargs)
    {
	this(_name,null,null,null,_alias,_evalargs,null);
    }

    public String getName()
    {
	return name_;
    }

    public Object getObject()
    {
	Object r=null;
	     if(method_!=null) r=method_;
	else if(field_ !=null) r=field_;
	else if(block_ !=null) r=block_;
	else if(alias_ !=null) r=alias_;
	else throw new RuntimeException("invalid message:"+name_);
	return r;
    }

    public boolean shouldEvalArgs()
    {
	return evalargs_;
    }

    public String[] getArgNames()
    {
      return argnames_;
    }

    public String toString()
    {
	return name_;
    }
}
