/**
 * @modification $Date: 2001/12/03 16:28:08 $
 * @statut       unstable
 * @file         FooString.java
 * @version      0.08
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2001 Guillaume Desnoix
 */

package com.memoire.foo;
import com.memoire.foo.*;

import com.memoire.re.*;
//import gnu.regexp.*;

public class FooString
{
  private static FooCategory pkg_=null;

  public final static FooCategory init()
  {
    if(pkg_==null)
    {
      pkg_=FooCategory.create(String.class);
      pkg_.alias("&string");

      pkg_.setMessage("symbol",FooSymbol.class,
		      "create(java.lang.String)");

      pkg_.setMessage("#",String.class   ,"length");
      pkg_.setMessage("+",FooString.class,"addMsg");
      pkg_.setMessage("[]",FooString.class,"extractII");
      pkg_.setMessage("[[",FooString.class,"extractIX");
      pkg_.setMessage("]]",FooString.class,"extractXI");
      pkg_.setMessage("][",FooString.class,"extractXX");

      pkg_.setMessage("exec"    ,FooString.class,"exec");
      pkg_.setMessage("split"   ,FooString.class,"split");
      pkg_.setMessage("join"    ,FooString.class,"join");
      pkg_.setMessage("contains",FooString.class,"contains");
      pkg_.setMessage("match"   ,FooString.class,"match");
      pkg_.setMessage("match_i" ,FooString.class,"match_i");
      pkg_.setMessage("~" ,"match");
      pkg_.setMessage("~i","match_i");
    }

    return pkg_;
  }
	

    public static String addMsg(Object[] _n)
    {
	StringBuffer r=new StringBuffer();
	for(int i=0;i<_n.length;i++)
	{
	    if(_n[i]!=null)
		r.append(_n[i].toString());
	}
	return r.toString();
    }    

    public static Object extractII(Object[] _o)
    {
	FooLib.checkClassArgument(String.class,_o[0],0);

	Object r=null;

	switch(_o.length)
	{
	case 2:
	    FooLib.checkClassArgument(Number.class,_o[1],1);
	    r=new Character
		(((String)_o[0]).charAt(((Number)_o[1]).intValue()));	
	    break;
	case 3:
	    FooLib.checkClassArgument(Number.class,_o[1],1);
	    FooLib.checkClassArgument(Number.class,_o[2],2);
	    r=((String)_o[0]).
		substring(((Number)_o[1]).intValue()+0,
			  ((Number)_o[2]).intValue()+1);
	    break;
	default:
	    FooLib.checkNumberArgument(2,_o.length);
	    break;
	}

	return r;
    }

    public static Object extractIX(Object[] _o)
    {
	FooLib.checkClassArgument(String.class,_o[0],0);

	Object r=null;

	switch(_o.length)
	{
	case 3:
	    FooLib.checkClassArgument(Number.class,_o[1],1);
	    FooLib.checkClassArgument(Number.class,_o[2],2);
	    r=((String)_o[0]).
		substring(((Number)_o[1]).intValue()+0,
			  ((Number)_o[2]).intValue()+0);
	    break;
	default:
	    FooLib.checkNumberArgument(2,_o.length);
	    break;
	}

	return r;
    }

    public static Object extractXI(Object[] _o)
    {
	FooLib.checkClassArgument(String.class,_o[0],0);

	Object r=null;

	switch(_o.length)
	{
	case 3:
	    FooLib.checkClassArgument(Number.class,_o[1],1);
	    FooLib.checkClassArgument(Number.class,_o[2],2);
	    r=((String)_o[0]).
		substring(((Number)_o[1]).intValue()+1,
			  ((Number)_o[2]).intValue()+1);
	    break;
	default:
	    FooLib.checkNumberArgument(2,_o.length);
	    break;
	}

	return r;
    }

    public static Object extractXX(Object[] _o)
    {
	FooLib.checkClassArgument(String.class,_o[0],0);

	Object r=null;

	switch(_o.length)
	{
	case 3:
	    FooLib.checkClassArgument(Number.class,_o[1],1);
	    FooLib.checkClassArgument(Number.class,_o[2],2);
	    r=((String)_o[0]).
		substring(((Number)_o[1]).intValue()+1,
			  ((Number)_o[2]).intValue()+0);
	    break;
	default:
	    FooLib.checkNumberArgument(2,_o.length);
	    break;
	}

	return r;
    }

    /*
    public static Object brkMsg(Object[] _o)
    {
	FooLib.checkClassArgument(String.class,_o[0],0);

	Object r=null;

	switch(_o.length)
	{
	case 0:
	case 1:
	case 2:
	    FooLib.checkNumberArgument(2,_o.length-1);
	    break;
	case 3:
	    FooLib.checkClassArgument(Number.class,_o[1],1);
	    FooLib.checkValueArgument("]",_o[2],2);
	    r=new Character
		(((String)_o[0]).charAt(((Number)_o[1]).intValue()));	
	    break;
	case 4:
	    FooLib.checkClassArgument(Number.class,_o[1],1);
	    FooLib.checkClassArgument(Number.class,_o[2],2);
	    FooLib.checkBracket(_o[3],3);
	    r=((String)_o[0]).
		substring(((Number)_o[1]).intValue(),
			  ((Number)_o[2]).intValue()+
			  ("]".equals(_o[3]) ? 1 : 0));
	    break;
	default:
	    FooLib.checkNumberArgument(4,_o.length);
	    break;
	}

	return r;
    }
    */

    /*
    public static Object brkMsg2(Object[] _o)
    {
	FooLib.checkClassArgument(String.class,_o[0],0);

	Object r=null;

	switch(_o.length)
	{
	case 4:
	    FooLib.checkClassArgument(Number.class,_o[1],1);
	    FooLib.checkClassArgument(Number.class,_o[2],2);
	    FooLib.checkBracket(_o[3],3);
	    r=((String)_o[0]).
		substring(((Number)_o[1]).intValue()+1,
			  ((Number)_o[2]).intValue()+
			  ("]".equals(_o[3]) ? 1 : 0));
	    break;
	default:
	    FooLib.checkNumberArgument(4,_o.length);
	    break;
	}

	return r;
    }
    */

    public static Object exec(String _code)
    {
	Object r=null;
	FooParser parser=FooLib.getParser();
	synchronized (parser)
	{
	    FooTokenizer old=parser.getTokenizer();
	    r=parser.parseInline(_code);
	    parser.setTokenizer(old);
	}
	return r;
    }

    public static FooList split(String _sep, String _str)
    {
	FooList r=new FooList();
	String s=_str;

	if((_sep!=null)&&!_sep.equals(""))
	{
	    int i;
	    while((i=s.indexOf(_sep))>=0)
	    {
		r.add(s.substring(0,i));
		s=s.substring(i+_sep.length());
	    }
	}

	r.add(s);
	return r;
    }

    public static String join(Object[] _n)
    {
	FooLib.checkClassArgument(String.class,_n[0],0);
	StringBuffer r=new StringBuffer();

	String s=(String)_n[0];
	for(int i=1;i<_n.length;i++)
	{
	    if(i>1) r.append(s);
	    Object o=_n[i];
	    r.append(o==null ?
		     "null"
		     : (o.getClass().isArray()
			? FooLib.stringValue(o)
			: o));
	}

	return r.toString();
    }

  public static boolean contains(String _str, String _substr)
  {
    boolean r=((_str!=null)&&(_substr!=null));
    
    if(r) r=(_str.indexOf(_substr)>=0);
    
    return r;
  }

  public static FooList match
    (String _str, String _pattern)
  {
    return match0(_str,_pattern,false);
  }

  public static FooList match_i
    (String _str, String _pattern)
  {
    return match0(_str,_pattern,true);
  }

  private static FooList match0
    (String _str, String _pattern, boolean _igncase)
  {
    RE regexp=null;

    try
    {
      regexp=new RE(_pattern,
		    (_igncase ? RE.REG_ICASE : 0) | RE.REG_MULTILINE,
		    RESyntax.RE_SYNTAX_PERL5);
    }
    catch(REException ex)
    {
      throw new RuntimeException
	("unvalid regexp:"+_pattern);
    }

    REMatch[] matches=regexp.getAllMatches(_str);
    FooList r=new FooList();

    for(int i=0;i<matches.length;i++)
    {
      FooList s=new FooList();
      int j=0;
      while(true)
      {
	int start=matches[i].getSubStartIndex(j);
	int end  =matches[i].getSubEndIndex(j);
	if((start==-1)||(end==-1)) break;
	s.add(matches[i].toString(j));
	j++;
      }
      r.add(s);
    }

    return r;
  }

  public static String toSource(String _s)
  {
    String r="\"";
    int    l=_s.length();

    for(int i=0;i<l;i++)
    {
      char c=_s.charAt(i);
           if(c=='\007') r+="\\g";
      else if(c=='\n'  ) r+="\\n";
      else if(c=='\r'  ) r+="\\r";
      else if(c=='\t'  ) r+="\\t";
      else if(c=='\\'  ) r+="\\\\";
      else if(c=='\"'  ) r+="\\\"";
      else if(c=='\''  ) r+="\\'";
      else if(c=='`'   ) r+="`";
      else r+=c;
    }
    r+="\"";

    return r;
  }
}

