/**
 * @modification $Date: 2001/12/03 16:28:08 $
 * @statut       unstable
 * @file         FooThread.java
 * @version      0.08
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2001 Guillaume Desnoix
 */

package com.memoire.foo;
import com.memoire.foo.*;

import java.util.*;

public class FooThread
  extends Thread
  implements FooEval
{
  private FooThread parent_;
  private boolean   killed_,ended_;
  private Object    o_,r_;

  public FooThread(Object _o)
  {
    this(_o,null,null);
  }

  public FooThread(Object _o,Thread _t,Object _r)
  {
    if(_t==null)_t=Thread.currentThread();

    o_=_o;
    r_=_r;
    if(_t instanceof FooThread) parent_=(FooThread)_t;
    setPriority(MIN_PRIORITY);
  }

  /*
  public void start()
  {
    System.err.println("$$$ T="+this+" start");
    super.start();
  }
  */

  public void run()
  {
    try
      { r_=FooLib.eval(o_); }
    catch(ThreadDeath ex)
      { System.err.println("$$$ DIE $$$ T="+this); }

    //System.err.println("$$$ T="+this+" --> "+r_);
    ended_=true;
    super.run();
  }

  public Object eval()
  {
    //System.err.println("CURRENT-T="+Thread.currentThread());
    //System.err.println("FooThread="+this);
    //System.err.println("$$$ T="+this+" eval");
    //System.err.println("$$$ R="+r_);
    //System.err.println("$$$ P="+parent_);

    while(!isKilled()&&!isEnded())
    {
      Thread t=Thread.currentThread();
      if(t!=this)
      {
	t.yield();
	try { this.join(); }
	//try { t.sleep(50); }
	catch(InterruptedException ex) { }
      }
      else
      {
	FooLib.getParser().error(new RuntimeException("dead lock:"+this));
      }
    }

    return r_;
  }

  /*
  public Object result()
  {
    return r_;
  }
  */

  public FooThread parent()
  {
    return parent_;
  }

  public void kill()
  {
    killed_=true;
    //catch(Exception ex) { System.err.println(ex); }
  }

  public boolean isKilled()
  {
    return killed_;
      // ||((parent_!=null)&&(parent_.isKilled())));
  }

  public boolean isEnded()
  {
    return ended_;
  }

  public String toString()
  {
    return "thread "+FooLib.toString(o_);
  }
}

