/**
 * @modification $Date: 2001/12/03 16:28:08 $
 * @statut       unstable
 * @file         FuClassLoaderDedicated.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.fu;

import com.memoire.fu.*;


import java.io.*;
import java.net.*;
import java.util.*;

/**
 * Very unstable and buggy. Don't use.
 */
public class FuClassLoaderDedicated
       extends ClassLoader
{
  private final static FuHashtableFast global_=new FuHashtableFast(501);

  private FuHashtableFast local_=new FuHashtableFast(11);
  private Class only_;

  public FuClassLoaderDedicated()
  {
    only_=null;
  }

  public final synchronized Class get(String _name)
  {
    String s=_name.intern();
    Class  r=(Class)global_.get(s);
    if(r==null) r=(Class)local_.get(s);
    return r;
  }

  public final synchronized void putLocal(Class _class)
  {
    local_.put(_class.getName().intern(),_class);
  }

  public final static synchronized void putGlobal(Class _class)
  {
    global_.put(_class.getName().intern(),_class);
  }

  public final synchronized Class[] list()
  {
    Class[] r=new Class[local_.size()];

    Enumeration e=local_.elements();
    int         i=0;
    while(e.hasMoreElements())
    {
      r[i]=(Class)e.nextElement();
      //System.err.println("  - Fu:list "+r[i]);
      i++;
    }

    return r;
  }

  public Class loadClass(String _name)
    throws ClassNotFoundException
  {
    return loadClass(_name,true);
  }

  public Class loadClass
    (String _name, boolean _resolve)
    throws ClassNotFoundException
  {
    Class r=get(_name);

    if(r==null)
    {
      /*
      if(only_!=null)
      {
	//System.err.println("SUBLOADER");
	r=Class.forName(_name);
	putGlobal(r);
	//r=load(_name,list());
	//putLocal(r);
      }
      else
      */

      if(!_name.startsWith("java"))
      {
	try
	{
	  String n=_name.replace('.','/')+".class";
	  //System.err.println("N="+n);

	  InputStream in=null;
	  //System.err.println("IN="+in);

	  /*
	  if(in==null)
	  {
	    try { in=new FileInputStream(n); }
	    catch(Exception ex) { }
	  }
	  */

	  String classpath=System.getProperty("java.class.path");
	  //System.err.println(classpath);
	  StringTokenizer st=new StringTokenizer(classpath,":");

	  while(st.hasMoreTokens())
	  {
	    String t=st.nextToken();
	    if(in==null)
	    {
	      try
	      {
		File d=new File(t);
		if(d.isDirectory())
		{
		  File f=new File(d,n);
		  if(f.exists())
		  {
		    //System.err.println("Fu:file="+f);
		    System.err.println("FuClassLoaderDedicated:"+f);
		    in=new FileInputStream(f);
		  }
		}
	      }
	      catch(Exception ex) { }
	    }
	  }

	  /*
	  if(in==null)
	  {
	    try
	    {
	      URL url=new URL("http://localhost/repository/"+n);
	      System.err.println("Fu:url="+url);
	      in=url.openStream();
	    }
	    catch(Exception ex) { }
	  }
	  if(in==null)
	  {
	    try
	    {
	      URL url=new URL("http://www.memoire.com/repository/"+n);
	      System.err.println("Fu:url="+url);
	      in=url.openStream();
	    }
	    catch(Exception ex) { }
	  }
	  */
	  
	  ByteArrayOutputStream out=new ByteArrayOutputStream();
	  while(in.available()>0) out.write(in.read());
	  byte[] data=out.toByteArray();
	  r=defineClass(_name,data,0,data.length);

	  if(only_==null) only_=r;
	  putLocal(r);
	  if(_resolve) resolveClass(r);
	  //System.err.println("  CL="+r.getClassLoader());

	  //System.err.println("Fu:loading "+_name);
	  //System.err.println("CLASSES: "+local_.size()+"/"+global_.size());
	  //list();
	}
	catch(Throwable th)
	{ r=null; }
      }
    }

    if(r==null)
    {
      /*
	ClassLoader cl=base_.getClassLoader();
	System.err.println("CL="+cl);
	if(cl!=null) r=cl.loadClass(_name);
	else
	*/
      r=Class.forName(_name);
      putGlobal(r);
    }

    return r;
  }

  public String toString()
  {
    return "FuClassLoaderDedicated("+(only_!=null ? only_.getName() : "null")+")";
  }

  public final static Class load(String _name,Class[] _exclude)
    throws ClassNotFoundException
  {
    FuClassLoaderDedicated cl=new FuClassLoaderDedicated();
    for(int i=0;i<_exclude.length;i++) cl.putLocal(_exclude[i]);
    return cl.loadClass(_name);
  }

  public final static Class load(String _name,Class _exclude)
    throws ClassNotFoundException
  {
    return load(_name,new Class[] { _exclude });
  }

  public final static Class load(String _name)
    throws ClassNotFoundException
  {
    return load(_name,new Class[] { });
  }

  /*
  public static void main(String[] _args)
  {
    AglCode.langage("Java");
    AglCode.langage("Lisp");
    AglCode.langage("UmlHierarchie");
    System.gc();
  }
  */
}
