/**
 * @modification $Date: 2001/12/03 16:28:08 $
 * @statut       unstable
 * @file         FuSort.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.fu;

import com.memoire.fu.*;


public class FuSort
{
  public static void sort(Object[] _a)
  {
    sort(_a,0,_a.length);
  }

  public static void sort(Object[] _a, int _from, int _to)
  {
    Object[] b=(Object[])_a.clone();
    merge(b,_a,_from,_to);
  }

  private final static void merge
  (Object[] _src, Object[] _dst, int _low, int _high)
  {
    int length=_high-_low;

    if(length<7)
    {
      for(int i=_low; i<_high; i++)
	for(int j=i; (j>_low)&&(compare(_dst[j-1],_dst[j])>0); j--)
	  swap(_dst,j,j-1);
      return;
    }

    int mid=(_low+_high)/2;
    merge(_dst,_src,_low,mid);
    merge(_dst,_src,mid,_high);
    
    if (compare(_src[mid-1],_src[mid])<=0)
    {
      System.arraycopy(_src,_low,_dst,_low,length);
      return;
    }
    
    int p=_low;
    int q=mid;
    for(int i=_low; i<_high; i++)
    {
      if((q>=_high)||(p<mid)&&(compare(_src[p],_src[q])<=0))
	_dst[i]=_src[p++];
      else
	_dst[i]=_src[q++];
    }
  }

  private final static int compare(Object _a, Object _b)
  {
    return _a.toString().compareTo(_b.toString());
  }

  private final static void swap(Object[] _x, int _a, int _b)
  {
    Object t=_x[_a];
    _x[_a]=_x[_b];
    _x[_b]=t;
  }
}


