/**
 * @modification $Date: 2001/12/03 16:28:08 $
 * @statut       unstable
 * @file         FuStreamTokenizer.java
 * @version      0.36
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.fu;

import com.memoire.fu.*;


import java.io.*;
import java.util.*;

public class FuStreamTokenizer
       extends StreamTokenizer
{
  private String origin_;

  private static class UFR extends FilterReader
  {
    private int p_=-1;

    UFR(Reader _reader)
    {
      super(_reader);
    }

    public int read() throws IOException
    {
      int i;
      if(p_!=-1)
      {
	i=p_;
	p_=-1;
      }
      else
      {  
	i=super.read();
        if(i=='\\')
        {
	  int j=super.read();
	  if(j!='u')
	  {
	    p_=j;
	  }
	  else
	  {
	    String h="";
	    for(int k=0;k<4;k++) h+=(char)super.read();
	    i=Integer.parseInt(h,16);
	    //System.err.println(i+" "+h);
	  }
        }
      }
      return i;
    }
  }

  public FuStreamTokenizer(InputStream _input,String _origin)
  {
    this(new InputStreamReader(_input),_origin);
  }

  public FuStreamTokenizer(Reader _reader,String _origin)
  {
    super(new UFR(_reader));
    origin_=_origin;
  }

  public String origin()
  { return origin_; }
}
