
package com.memoire.jedit;
import com.memoire.jedit.*;

/*
 * JEditJavaScriptTokenMarker.java - JavaScript token marker
 * Copyright (C) 1999 Slava Pestov
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 */


import javax.swing.text.Segment;

/**
 * JavaScript token marker.
 *
 * @author Slava Pestov
 * @version $Id: JEditJavaScriptTokenMarker.java,v 1.3 2001/07/25 17:39:05 desnoix Exp $
 */
public class JEditJavaScriptTokenMarker extends JEditCTokenMarker
{
	public JEditJavaScriptTokenMarker()
	{
		super(false,getKeywords());
	}

	public static JEditKeywordMap getKeywords()
	{
		if(javaScriptKeywords == null)
		{
			javaScriptKeywords = new JEditKeywordMap(false);
			javaScriptKeywords.add("function",JEditToken.KEYWORD3);
			javaScriptKeywords.add("var",JEditToken.KEYWORD3);
			javaScriptKeywords.add("else",JEditToken.KEYWORD1);
			javaScriptKeywords.add("for",JEditToken.KEYWORD1);
			javaScriptKeywords.add("if",JEditToken.KEYWORD1);
			javaScriptKeywords.add("in",JEditToken.KEYWORD1);
			javaScriptKeywords.add("new",JEditToken.KEYWORD1);
			javaScriptKeywords.add("return",JEditToken.KEYWORD1);
			javaScriptKeywords.add("while",JEditToken.KEYWORD1);
			javaScriptKeywords.add("with",JEditToken.KEYWORD1);
			javaScriptKeywords.add("break",JEditToken.KEYWORD1);
			javaScriptKeywords.add("case",JEditToken.KEYWORD1);
			javaScriptKeywords.add("continue",JEditToken.KEYWORD1);
			javaScriptKeywords.add("default",JEditToken.KEYWORD1);
			javaScriptKeywords.add("false",JEditToken.LABEL);
			javaScriptKeywords.add("this",JEditToken.LABEL);
			javaScriptKeywords.add("true",JEditToken.LABEL);
		}
		return javaScriptKeywords;
	}

	// private members
	private static JEditKeywordMap javaScriptKeywords;
}

/*
 * ChangeLog:
 * $Log: JEditJavaScriptTokenMarker.java,v $
 * Revision 1.3  2001/07/25 17:39:05  desnoix
 * *** empty log message ***
 *
 * Revision 1.2  2001/06/21 18:50:04  desnoix
 * *** empty log message ***
 *
 * Revision 1.1  2001/06/13 19:48:18  desnoix
 * *** empty log message ***
 *
 * Revision 1.2  1999/06/05 00:22:58  sp
 * LGPL'd syntax package
 *
 * Revision 1.1  1999/03/13 09:11:46  sp
 * Syntax code updates, code cleanups
 *
 */
