
package com.memoire.jedit;
import com.memoire.jedit.*;

/*
 * JEditPatchTokenMarker.java - DIFF patch token marker
 * Copyright (C) 1999 Slava Pestov
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 */


import javax.swing.text.Segment;

/**
 * Patch/diff token marker.
 *
 * @author Slava Pestov
 * @version $Id: JEditPatchTokenMarker.java,v 1.3 2001/07/25 17:39:05 desnoix Exp $
 */
public class JEditPatchTokenMarker extends JEditTokenMarker
{
	public byte markJEditTokensImpl(byte token, Segment line, int lineIndex)
	{
		if(line.count == 0)
			return JEditToken.NULL;
		switch(line.array[line.offset])
		{
		case '+': case '>':
			addJEditToken(line.count,JEditToken.KEYWORD1);
			break;
		case '-': case '<':
			addJEditToken(line.count,JEditToken.KEYWORD2);
			break;
		case '@': case '*':
			addJEditToken(line.count,JEditToken.KEYWORD3);
			break;
	        default:
			addJEditToken(line.count,JEditToken.NULL);
			break;
		}
		return JEditToken.NULL;
	}

	public boolean supportsMultilineJEditTokens()
	{
		return false;
	}
}

/*
 * ChangeLog:
 * $Log: JEditPatchTokenMarker.java,v $
 * Revision 1.3  2001/07/25 17:39:05  desnoix
 * *** empty log message ***
 *
 * Revision 1.2  2001/06/21 18:50:04  desnoix
 * *** empty log message ***
 *
 * Revision 1.1  2001/06/13 19:48:18  desnoix
 * *** empty log message ***
 *
 * Revision 1.6  1999/07/05 04:38:39  sp
 * Massive batch of changes... bug fixes, also new text component is in place.
 * Have fun
 *
 * Revision 1.5  1999/06/05 00:22:58  sp
 * LGPL'd syntax package
 *
 * Revision 1.4  1999/05/22 08:33:53  sp
 * FAQ updates, mode selection tweak, patch mode update, javadoc updates, JDK 1.1.8 fix
 *
 * Revision 1.3  1999/04/19 05:38:20  sp
 * Syntax API changes
 *
 * Revision 1.2  1999/03/12 23:51:00  sp
 * Console updates, uncomment removed cos it's too buggy, cvs log tags added
 *
 */
