/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         PbcLib.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:08 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.pbc;
import com.memoire.pbc.*;

public class PbcLib
{
  public final static int IGNORED  =0;
  public final static int DISPLAYED=1;
  public final static int TRACED   =2;
  public final static int THROWN   =4;
  public final static int EXITED   =8;

  public static int mode_=THROWN;

  public final static void invariant
    (boolean _test,String _msg,String _file,int _line)
  {
    if(!_test) fail("invariant",_msg,_file,_line);
  }

  public final static void require
    (boolean _test,String _msg,String _file,int _line)
  {
    if(!_test) fail("require",_msg,_file,_line);
  }

  public final static void ensure
    (boolean _test,String _msg,String _file,int _line)
  {
    if(!_test) fail("ensure",_msg,_file,_line);
  }

  public final static void check
    (boolean _test,String _msg,String _file,int _line)
  {
    if(!_test) fail("check",_msg,_file,_line);
  }

  private final static void fail
    (String _type,String _msg,String _file,int _line)
  {
    String s="PBC-FAIL: "+_type+" "+_msg+"[file "+_file+" line "+_line+"]";
    if((mode_&DISPLAYED)!=0) System.err.println(s);
    if((mode_&TRACED)   !=0) new RuntimeException(s).printStackTrace();
    if((mode_&THROWN)   !=0) throw new RuntimeException(s);
    if((mode_&EXITED)   !=0) System.exit(-127);
  }
}

