/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         ScriptInterpreter.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:08 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.script;
import com.memoire.script.*;

import java.util.*;

public abstract class ScriptInterpreter
{
  /*
  public final String langage()
  {
    String r=getClass().getName();
    int    i=r.indexOf("ScriptInterpreter");
    r=r.substring(i+17);
    return r;
  }
  */

  public static final ScriptInterpreterInterface language(String n)
  {
    ScriptInterpreterInterface r=null;

    try
    {
      String p=ScriptInterpreter.class.getName();
      int    i=p.indexOf("ScriptInterpreter");
      p=p.substring(0,i+17);

      Class c=Class.forName(p+n);
      //Class c=FuClassLoaderDedicated.load
      //  (p+n,ScriptInterpreterInterface.class);
      r=(ScriptInterpreterInterface)c.newInstance();
    }
    catch(Throwable ex) { }

    return r;
  }

  public static final String[] shortcuts(String n)
  {
    String[] r=new String[11];

    ScriptInterpreterInterface si=language(n);

    if(si!=null)
    {
      try
      {
	Properties p=new Properties();
	p.load(si.getClass().getResourceAsStream(n+"Shortcuts.txt"));
	for(int i=0;i<11;i++)
	  r[i]=p.getProperty("F"+(i+2));
      }
      catch (Exception ex) { }
    }

    return r;
  }

  public static final ScriptInterpreterInterface guess(String _file)
  {
    int i=_file.lastIndexOf('.');
    if(i<0) return null;

    String extension=_file.substring(i+1);

    String ls=ScriptPreferences.SCRIPT.getStringProperty
      ("script.interpreters",ScriptPreferences.INTERPRETERS);

    while(!"".equals(ls))
    {
      String  s="";

      i=ls.indexOf(',');
      if(i<0) { s=ls; ls=""; }
      else    { s=ls.substring(0,i); ls=ls.substring(i+1); }

      if("-".equals(s)) continue;

      ScriptInterpreterInterface si=ScriptInterpreter.language(s);
      if(si==null) continue;

      String[] extensions=si.getExtensions();
      for(int j=0; j<extensions.length; j++)
	if(extension.equals(extensions[j]))
	  return si;
    }

    return null;
  }
}
