/**
 * @modification $Date: 2001/12/03 16:28:08 $
 * @statut       unstable
 * @file         ScriptInterpreterFoo.java
 * @version      0.29
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.script;

import com.memoire.script.*;
import com.memoire.foo.*;

import java.io.*;
import java.lang.reflect.*;
import java.util.*;

import com.memoire.foo.*;

public class ScriptInterpreterFoo
       implements ScriptInterpreterInterface
{
  FooParser parser=null;

  public ScriptInterpreterFoo()
  {
  }

  public String getName()
  {
    return "Foo";
  }

  public String getShortDescription()
  {
    return "A foo interpreter";
  } 

  public String getLongDescription()
  {
    return "Foo is a foo interpreter.";
  }

  public Object getIcon()
  {
    return null;
  }

  public String getExtension()
  {
    return "foo";
  }

  public String[] getExtensions()
  {
    return new String[] { "foo", "FOO" };
  }

  public Object getGUI()
  {
    return null;
  }

  public String toString()
  {
    return "interpreter "+getName();
  }

  private InputStream  in_;
  private OutputStream out_,err_;

  private InputStream  input;
  private PrintStream  output,error;

  public void setInputStream(InputStream _in)
  {
    in_=_in;
    input=_in;
  }

  public InputStream getInputStream()
  {
    return in_;
  }

  public void setOutputStream(OutputStream _out)
  {
    out_=_out;
    output=new PrintStream(_out,true);
  }

  public OutputStream getOutputStream()
  {
    return out_;
  }

  public void setErrorStream(OutputStream _err)
  {
    err_=_err;
    error=new PrintStream(_err,true);
  }

  public OutputStream getErrorStream()
  {
    return err_;
  }

  public void start()
  {
    if(in_ ==null) setInputStream (System.in);
    if(out_==null) setOutputStream(System.out);
    if(err_==null) setErrorStream (System.err);

    parser=new FooParser();
    parser.setInput (input);
    parser.setOutput(output);
    parser.setError (error);
  }

  public void run()
  {
    parser.parseStdin();
  }

  public void exit()
  {
    parser.exit();
  }

  public void eval(String _script)
  {
    parser.parseString(_script);
  }

  public void addVariable(String _nom, Object _objet)
  {
    //interp.set(_nom,_objet);
  }

  public void removeVariable(String _nom)
  {
    //interp.set(_nom,null);
  }

  public void addFunction(String _name, Method _method)
  {
    /*
      String d="(define "+_name+" (method \""+
      _method.getName()+"\" \""+
      _method.getDeclaringClass().getName()+"\"";

    Class[] p=_method.getParameterTypes();
    for(int i=0;i<p.length;i++)
      d+=" \""+p[i].getName()+"\"";

    d+="))";
    System.err.println("method: "+d);
    silent_eval(d);
    */
  }

  public void removeFunction(String _name)
  {
    // silent_eval("(define "+_name+")");
  }

  //////////////// Main Loop

  public static void main(String[] files)
  {
    ScriptInterpreterFoo foo=new ScriptInterpreterFoo();
    foo.start();

    /*
    try
    {
      for(int i=0; i<files.length;i++) foo.load(files[i]);
    }
    catch (RuntimeException ex) { }
    */

    foo.run();
  }
}
