/**
 * @product      Alma (Atelier logiciel de modelistion et d'analyse)
 * @file         ScriptMenuInterpreters.java
 * @version      0.36
 * @www          http://www.memoire.com/guillaume-desnoix/alma/
 * @modification $Date: 2001/12/03 16:28:08 $
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.script;
import com.memoire.bu.*;
import com.memoire.script.*;

import javax.swing.*;

public class ScriptMenuInterpreters
       extends BuMenu
{
  public ScriptMenuInterpreters()
  {
    super(BuResource.BU.getString("Interpreters"),
	  "MENU_INTERPRETEURS",
	  BuResource.BU.getMenuIcon("terminal"));

    String ls=ScriptPreferences.SCRIPT.getStringProperty
      ("script.interpreters",ScriptPreferences.INTERPRETERS);

    while(!"".equals(ls))
    {
      int     i=ls.indexOf(',');
      String  s="";

      if(i<0) { s=ls; ls=""; }
      else    { s=ls.substring(0,i); ls=ls.substring(i+1); }

      if("-".equals(s))
	addSeparator();
      else
      {
	ScriptInterpreterInterface si=ScriptInterpreter.language(s);
	Icon icon=null;
	if(si!=null  ) icon=(Icon)si.getIcon();
	if(icon==null) icon=BuResource.BU.getMenuIcon("terminal");

	BuMenuItem mi=addMenuItem(s,"TERMINAL("+s.toUpperCase()+")",(si!=null));
	if(icon instanceof BuIcon) mi.setIcon((BuIcon)icon);
	else                       mi.setIcon(icon);
      }
    }

    computeMnemonics();
  }
}
