

package com.memoire.silk;
import com.memoire.silk.*;



/** @author Peter Norvig, peter@norvig.com http://www.norvig.com 
 * Copyright 1998 Peter Norvig, see http://www.norvig.com/license.html **/

public class SilkMacro extends SilkClosure {

    /** Make a macro from a parameter list, body, and environment. **/
    public SilkMacro (Object parms, Object body, SilkEnvironment env) {
      super(parms, body, env);
    }

  /** Replace the old cons cell with the macro expansion, and return it. **/
  public SilkPair expand(SilkScheme interpreter, SilkPair oldSilkPair, Object args) {
    Object expansion = apply(interpreter, args);
    if (expansion instanceof SilkPair) {
      oldSilkPair.first = ((SilkPair)expansion).first;
      oldSilkPair.rest  = ((SilkPair)expansion).rest;
    } else {
      oldSilkPair.first = "begin";
      oldSilkPair.rest = cons(expansion, null);
    }
    return oldSilkPair;
  }

  /** SilkMacro expand an expression **/
  public static Object macroExpand(SilkScheme interpreter, Object x) {
    if (!(x instanceof SilkPair)) return x;
    Object fn = interpreter.eval(first(x), interpreter.globalSilkEnvironment);
    if (!(fn instanceof SilkMacro)) return x;
    return ((SilkMacro)fn).expand(interpreter, (SilkPair)x, rest(x));
  }
}
