/**
 * @modification 2001-10-25
 * @statut       unstable
 * @file         Ontology.java
 * @version      0.04
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.xml;
import  com.memoire.xml.*;

import  com.memoire.fu.*;

import java.io.*;
import java.util.*;

public class Ontology
       implements XmlListener
{
  Hashtable words   =new Hashtable();
  int       maxrate =0;
  boolean   raw     =false;
  boolean   prec    =false;
  Hashtable article =new Hashtable();

  public Ontology()
  {
    loadArticle();
  }

  public void location(String _origin, int _lineno, int _charno)
  { }

  public void startElement(String _tag)
  { }

  public void endElement(String _tag)
  { }

  public void attribute(String _name,String _value)
  { }

    private int cpt=0;

  public void text(String _data)
  {
    cpt++;
    if(cpt%  16==0) System.err.print('.');
    if(cpt%1248==0) System.err.println();

    String s;

    s=_data;

    // TMP (a voir)
    s=s.toLowerCase();

    s=XmlParser.replace(s,"&lt;"  ,"<" );
    s=XmlParser.replace(s,"&gt;"  ,">" );
    s=XmlParser.replace(s,"&quot;","\"");
    s=XmlParser.replace(s,"&amp;" ,"&" );
    s=XmlParser.replace(s,"&nbsp;",""  );

    s=XmlParser.replace(s,"&agrave;","");
    s=XmlParser.replace(s,"&egrave;","");
    //s=XmlParser.replace(s,"&ograve;","\u00f2");
    s=XmlParser.replace(s,"&ugrave;","");

    s=XmlParser.replace(s,"&eacute;","");
    //s=XmlParser.replace(s,"&oacute;","\u00f3");

    s=XmlParser.replace(s,"&acirc;" ,"");
    s=XmlParser.replace(s,"&ecirc;" ,"");
    s=XmlParser.replace(s,"&icirc;" ,"");
    s=XmlParser.replace(s,"&ocirc;" ,"");
    s=XmlParser.replace(s,"&ucirc;" ,"");

    s=XmlParser.replace(s,"&euml;"  ,"");
    s=XmlParser.replace(s,"&iuml;"  ,"");
    s=XmlParser.replace(s,"&ouml;"  ,"");
    s=XmlParser.replace(s,"&uuml;"  ,"");

    s=XmlParser.replace(s,"&ccedil;","");

    //s=XmlParser.replace(s,"&otilde;","\u00f5");

    _data=s;

    s="";
    for(int i=0;i<_data.length();i++)
    {
      char c=_data.charAt(i);
      if(Character.isLetterOrDigit(c))
	  s+=c;
      else
	  s+=' ';
    }
    _data=s;

    StringTokenizer st=new StringTokenizer(_data);
    while(st.hasMoreTokens())
    {
      String t=st.nextToken();
      if(!t.equals(t.toUpperCase())) t=t.toLowerCase();

      if(Character.isLetter(t.charAt(0)))
      {
	  prec=prec||(article.get(t)!=null);

	  if(prec&&(t.length()>2))
          {
	    if(words.get(t)==null)
	    {
	      words.put(t,new Integer(1));
	      //System.err.println("NOM: "+t);
	    }
	    else
	      words.put(t,new Integer(((Integer)words.get(t)).intValue()+1));
	  }
      }
      else prec=false;
    }
  }

  public void error(String _message)
  {
    System.err.println("ERROR     : "+_message);
  }

  public void loadArticle()
  {
    try
    {
      LineNumberReader in=new LineNumberReader
	  (new FileReader("onto_article.txt"));
      while(true)
      {
        String l=in.readLine();
        if(l==null) break;
	if(l.equals("")) continue;

        article.put(l,Boolean.TRUE);
      }
    }
    catch(IOException ex)
      { System.err.println("onto_article.txt can not be found"); }
  }

  private String desaccentue(String _s)
  {
    _s=_s.replace('','a');
    _s=_s.replace('','e');
    //_s=_s.replace('\u00f2','o');
    _s=_s.replace('','u');

    _s=_s.replace('','e');
    //_s=_s.replace('\u00f3','o');

    _s=_s.replace('','a');
    _s=_s.replace('','e');
    _s=_s.replace('','i');
    _s=_s.replace('','o');
    _s=_s.replace('','u');
    
    _s=_s.replace('','e');
    _s=_s.replace('','i');
    _s=_s.replace('','o');
    _s=_s.replace('','u');

    _s=_s.replace('','c');

    //_s=_s.replace('\u00f5','o');

    return _s;  
  }

  public void applyAccent()
  {
    Enumeration e=words.keys();
    while(e.hasMoreElements())
    {
      String t=(String)e.nextElement();
      String u=desaccentue(t);
      if(t.equals(u)) continue;

      if(words.get(u)!=null)
      {
	int v=((Integer)words.get(t)).intValue();
	int w=((Integer)words.get(u)).intValue();
	words.remove(u);
	words.put(t,new Integer(v+w));
	System.err.println("ACCENT  "+u);
      }

      u=u.toUpperCase();
      if(words.get(u)!=null)
      {
	int v=((Integer)words.get(t)).intValue();
	int w=((Integer)words.get(u)).intValue();
	words.remove(u);
	words.put(t,new Integer(v+w));
	System.err.println("ACCENT  "+u);
      }
    }
  }

  public void removeJunk()
  {
    Hashtable junk=new Hashtable();

    try
    {
      LineNumberReader in=new LineNumberReader
	  (new FileReader("onto_junk.txt"));
      while(true)
      {
        String l=in.readLine();
        if(l==null) break;
	if(l.equals("")) continue;

        junk.put(l,Boolean.TRUE);
      }
    }
    catch(IOException ex)
      { System.err.println("onto_junk.txt can not be found"); }
    
    Enumeration e=junk.keys();
    while(e.hasMoreElements())
    {
      String t=(String)e.nextElement();
      if(words.get(t)!=null)
      {
        words.remove(t);
	System.err.println("JUNK    "+t);
      }
    }
  }

  public void removeCommon()
  {
    Hashtable common=new Hashtable();

    try
    {
      LineNumberReader in=new LineNumberReader
	  (new FileReader("onto_common.txt"));
      while(true)
      {
        String l=in.readLine();
        if(l==null) break;
	if(l.equals("")) continue;

        common.put(l,Boolean.TRUE);
      }
    }
    catch(IOException ex)
      { System.err.println("onto_common.txt can not be found"); }
    
    Enumeration e=common.keys();
    while(e.hasMoreElements())
    {
      String t=(String)e.nextElement();
      if(words.get(t)!=null)
      {
        words.remove(t);
	System.err.println("COMMON  "+t);
      }
    }
  }

  public void removeForeign()
  {
    Enumeration e=words.keys();
    while(e.hasMoreElements())
    {
      String t=(String)e.nextElement();
      String u=desaccentue(t).toLowerCase();

      boolean r=false;

      for(int i=u.length()-1; i>=0; i--)
      {
	char c=u.charAt(i);
	if((c<'a')||(c>'z'))
	    { r=true; break; }
      }

      if(r)
      {
	words.remove(t);
	System.err.println("FOREIGN "+t);
      }
    }
  }

  public void removePlural()
  {
    Hashtable plural=new Hashtable();

    try
    {
      LineNumberReader in=new LineNumberReader
	  (new FileReader("onto_plural.txt"));
      while(true)
      {
        String l=in.readLine();
        if(l==null) break;
	if(l.equals("")) continue;

	int i=l.indexOf(' ');
	String p,s;
	if(i>0)
	{
	  p=l.substring(0,i);
	  s=l.substring(i+1);
	}
	else
	{
	  p=l;
	  s="";
	}
	plural.put(p,s);
      }
    }
    catch(IOException ex)
      { System.err.println("onto_plural.txt can not be found"); }
    
    Enumeration e=words.keys();
    while(e.hasMoreElements())
    {
      String t=(String)e.nextElement();

      Enumeration f=plural.keys();
      while(f.hasMoreElements())
      {
	String p=(String)f.nextElement();
	if(t.endsWith(p))
	{
	  String s=(String)plural.get(p);
	  String u=t.substring(0,t.length()-p.length())+s;
	  if(words.get(u)!=null)
	  {
	    int v=((Integer)words.get(t)).intValue();
	    int w=((Integer)words.get(u)).intValue();
	    words.remove(t);
	    words.put(u,new Integer(v+w));
	    System.err.println("PLURAL  "+t);
	  }
	}
      }
    }
  }

  public void applyFactor()
  {
    Hashtable factor=new Hashtable();

    try
    {
      LineNumberReader in=new LineNumberReader
	  (new FileReader("onto_factor.txt"));
      while(true)
      {
        String l=in.readLine();
        if(l==null) break;
	if(l.equals("")) continue;

	int i=l.indexOf(' ');
	String p,s;
	p=l.substring(0,i);
	s=l.substring(i+1);
	factor.put(p,new Double(s));
      }
    }
    catch(IOException ex)
      { System.err.println("onto_factor.txt can not be found"); }
    
    Enumeration e=words.keys();
    while(e.hasMoreElements())
    {
      String t=(String)e.nextElement();

      Double f=(Double)factor.get(t);
      if(f==null) f=new Double(0.01);
	  
      int v=((Integer)words.get(t)).intValue();
      v=(int)((double)v/f.doubleValue());
      words.put(t,new Integer(v));
    }
  }

  public String[] sort()
  {
    int      l=words.size();
    String[] r=new String[l];

    maxrate=0;

    Enumeration e;
    int         i;

    // fill
    i=0;
    e=words.keys();
    while(e.hasMoreElements())
    {
      String  t=(String)e.nextElement();
      int     v=((Integer)words.get(t)).intValue();
      if(v>maxrate) maxrate=v;
      r[i]=t;
      i++;
    }

    // sort
    for(i=0;i<l-1;i++)
    {
      int     v0=((Integer)words.get(r[i  ])).intValue();
      int     v1=((Integer)words.get(r[i+1])).intValue();
      if((v1>v0)||((v1==v0)&&(r[i].compareTo(r[i+1])>0)))
      {
	String t=r[i];
	r[i]  =r[i+1];
	r[i+1]=t;
	i--;
	if(i>=0) i--;
      }
    }

    return r;
  }

  public void output(String[] _keys,int _nbmax)
  {
    int l=Math.min(_nbmax,_keys.length);

    for(int i=0;i<l;i++)
    {
      double rate=((Integer)words.get(_keys[i])).doubleValue()/(double)maxrate;
      rate=Math.round(10000.*rate)/100.;

      if(raw)
      {
	System.out.println(_keys[i]+" "+rate);
      }
      else
      //if(rate>=0.01)
      {
	String t=_keys[i]+"                   ";
        String v="          "+rate;
        t=t.substring(0,20);
        v=v.substring(v.length()-10);
	System.out.println(t+v);
      }
    }
  }

  public static void main(String[] _args)
  {
    int      n=Integer.MAX_VALUE;
    Ontology o=new Ontology();

    for(int i=0;i<_args.length;i++)
    {
      if("-n".equals(_args[i]))
      {
	i++;
	n=Integer.parseInt(_args[i]);
      }
      else
      if("-r".equals(_args[i]))
      {
	o.raw=true;
      }
      else
      {
        try
        {
          String f=_args[i];
	  int    m=XmlParser.XML;
	  if(f.endsWith(".html")) m=XmlParser.HTML;
	  if(f.endsWith(".htm" )) m=XmlParser.HTML;
	  if(f.endsWith(".txt" )) m=XmlParser.TXT;
	  if(f.endsWith(".java")) m=XmlParser.TXT;
	  //System.err.println("FILE: "+f+" MODE: "+m);
	  System.err.println(f);
	  XmlParser p=new XmlParser(f,m);
	  p.setXmlListener(o);
	  p.parse();
	}
	catch(Exception ex)
        {
	  ex.printStackTrace();
	  //System.err.println(ex);
	}
      }
    }

    o.removeJunk();
    o.applyAccent();
    o.removeCommon();
    o.removePlural();
    o.removeForeign();

    if(!o.raw) o.applyFactor();
    o.output(o.sort(),n);
  }
}
