/**
 * @modification $Date: 2001/12/03 16:28:08 $
 * @statut       unstable
 * @file         XmlBorder.java
 * @version      0.34
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.xml;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;

/**
 * A simple bevel border of thickness 1.
 */

public class XmlBorder extends AbstractBorder
{
  public static final int RAISED  = 0;
  public static final int LOWERED = 1;

  protected int type_;
  protected int thick_;
  protected int margin_;

  public XmlBorder()
  {
    this(RAISED,2,2);
  }

  public XmlBorder(int _type, int _thick, int _margin)
  {
    type_  =_type;
    thick_ =_thick;
    margin_=_margin;
  }

  public void paintBorder(Component _c, Graphics _g,
			  int _x, int _y, int _w, int _h)
  {
         if(type_==RAISED ) paintRaisedBevel (_c,_g,_x,_y,_w,_h);
    else if(type_==LOWERED) paintLoweredBevel(_c,_g,_x,_y,_w,_h);
  }

  public Insets getBorderInsets(Component _c)
  {
    return new Insets(margin_,margin_,margin_,margin_);
  }

  public boolean isBorderOpaque() { return true; }

  protected void paintRaisedBevel
    (Component _c, Graphics _g, int _x, int _y, int _w, int _h)
  {
    Color old=_g.getColor();
    _g.translate(_x,_y);
    _g.setColor(_c.getBackground());

    for(int i=0;i<thick_;i++)
      _g.draw3DRect(i,i,_w-1-2*i,_h-1-2*i,true);

    /*
    if(!((JComponent)_c).isOpaque())
      for(int i=thick_;i<thick_+margin_;i++)
	_g.drawRect(i,i,_w-1-2*i,_h-1-2*i);
    */

    _g.translate(-_x,-_y);
    _g.setColor(old);
  }

  protected void paintLoweredBevel
    (Component _c, Graphics _g, int _x, int _y, int _w, int _h)
  {
    Color old=_g.getColor();
    _g.translate(_x,_y);
    _g.setColor(_c.getBackground());

    for(int i=0;i<thick_;i++)
      _g.draw3DRect(i,i,_w-1-2*i,_h-1-2*i,false);

    /*
    if(!((JComponent)_c).isOpaque())
      for(int i=thick_;i<thick_+margin_;i++)
	_g.drawRect(i,i,_w-1-2*i,_h-1-2*i);
    */

    _g.translate(-_x,-_y);
    _g.setColor(old);
  }
}
