/**
 * @modification 2001-10-25
 * @statut       unstable
 * @file         XmlElement.java
 * @version      0.04
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1998-2001 Guillaume Desnoix
 */

package com.memoire.xml;
import  com.memoire.xml.*;

import java.util.*;

public final class XmlNode
{
  public String    tag_;
  public Hashtable attributes_=new Hashtable(11);
  public Vector    children_  =new Vector(11);

  public String getText()
  {
    String r="";
    Enumeration e=children_.elements();
    while(e.hasMoreElements())
    {
      Object o=e.nextElement();
      if(!(o instanceof XmlNode)) r+=o.toString().trim();
    }
    return r;
  }

  public XmlNode[] getNodes()
  {
    Vector v=new Vector();
    Enumeration e=children_.elements();
    while(e.hasMoreElements())
    {
      Object o=e.nextElement();
      if(o instanceof XmlNode) v.addElement(o);
    }
    int       l=v.size();
    XmlNode[] r=new XmlNode[l];
    for(int i=0;i<l;i++) r[i]=(XmlNode)v.elementAt(i);
    return r;
  }

  private final static String indent(int _n)
  {
    String r="";
    for(int i=0;i<_n;i++) r+="  ";
    return r;
  }

  public String str(int _n)
  {
    String r="";

    r+=indent(_n)+"<"+tag_;

    Enumeration e;

    e=attributes_.keys();
    while(e.hasMoreElements())
    {
      String k=(String)e.nextElement();
      String v=(String)attributes_.get(k);
      r+=" "+k+"=\""+v+"\"";
    }

    if(children_.size()>0)
    {
      r+=">\n";

      _n++;
      e=children_.elements();
      while(e.hasMoreElements())
      {
	Object o=e.nextElement();
	if(o instanceof XmlNode)
        {
	  r+=((XmlNode)o).str(_n);
        }
        else
        {
	  StringTokenizer st=new StringTokenizer(o.toString().trim(),"\n");
	  while(st.hasMoreTokens())
	  {
	    r+=indent(_n);
	    r+=st.nextToken().toString().trim();
	    r+="\n";
	  }
        }
      }
      _n--;

      for(int i=0;i<_n;i++) r+="  ";
      r+="</"+tag_+">\n";
    }
    else r+=" />\n";

    return r;
  }

  public String toString()
  {
    return str(0);
  }
}
