/**
 * @modification $Date: 2001/12/03 16:28:09 $
 * @statut       unstable
 * @file         YapodAbstractQuery.java
 * @version      0.17
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.yapod;
import  com.memoire.yapod.*;


import java.util.*;

public abstract class YapodAbstractQuery
                implements YapodQuery
{
  private YapodQuery previous_;

  public YapodAbstractQuery(YapodQuery _query)
  {
    setPrevious(_query);
  }

  protected abstract Enumeration query(Enumeration e);

  public final YapodQuery getPrevious()
    { return previous_; }

  public final synchronized void setPrevious(YapodQuery _query)
  {
    if(_query==null)
      throw new IllegalArgumentException("_query is null");

    previous_=_query;
  }

  public final Enumeration getResult()
    { return query(previous_.getResult()); }

  public String toString()
    { return "query("+previous_+")"; }
}

