/**
 * @modification $Date: 2001/12/03 16:28:09 $
 * @statut       unstable
 * @file         YapodCategoriesQuery.java
 * @version      0.17
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.yapod;
import  com.memoire.yapod.*;


import java.lang.reflect.*;
import java.util.*;

public class YapodCategoriesQuery
       extends YapodAbstractQuery
{
  private String field_;

  public YapodCategoriesQuery
    (String _field, YapodQuery _previous)
  {
    super(_previous);

    if(_field==null)
      throw new IllegalArgumentException
	("_field is null");

    field_=_field;
  }

  protected Enumeration query(Enumeration e)
  {
    Hashtable table=new Hashtable();

    while(e.hasMoreElements())
    {
      Object o=e.nextElement();

      try
      {
	Object v=field_;
	if(field_ instanceof String) v=YapodLib.getValue(o,(String)field_);
	if(v==FAKE) v=field_;
	if(v==null) v="";

	Integer n=(Integer)table.get(v);
	if(n==null) n=new Integer(1);
	else        n=new Integer(n.intValue()+1);
	table.put(v,n);
      }
      catch(Exception ex) { }
    }

    Vector r=new Vector(table.size());
    for(Enumeration f=table.keys(); f.hasMoreElements(); )
    {
      Object k=f.nextElement();
      r.addElement(new YapodPair(k,table.get(k)));
    }
    return r.elements();
  }

  public String toString()
    { return "categories(\""+field_+"\","+getPrevious()+")"; }
}
