/**
 * @modification $Date: 2001/12/03 16:28:09 $
 * @statut       unstable
 * @file         YapodDistinctQuery.java
 * @version      0.17
 * @author       Nicolas Chevalier
 * @email        nicolas.chavalier@etu.utc.fr
 * @license      GNU General Public License 2 (GPL2)
 * (c)1999-2001 Nicolas Chevalier
 * nicolas.chavalier@etu.utc.fr
 */

package com.memoire.yapod;
import  com.memoire.yapod.*;


import java.util.*;

/**
 * Remove multiple values.
 * Equivalent to the unix command uniq.
 * @author Nicolas Chevalier
 * @email  nicolas.chavalier@etu.utc.fr
 */

public class YapodDistinctQuery extends YapodAbstractQuery
{
  public YapodDistinctQuery(YapodQuery _previous)
  {
    super(_previous);
  }
  
  public Enumeration query(Enumeration _enum)
  {
    Hashtable table = new Hashtable();

    while(_enum.hasMoreElements())
    { 
      Object elt=_enum.nextElement();
      table.put(elt,elt);
    }
    
    return table.elements();
  }
  
  public static void main(String[] args)
  {
    Integer i1 = new Integer(1);
    Integer i2 = new Integer(2);
    Integer i3 = new Integer(3);
    Integer i4 = new Integer(1);
    
    Integer[] tab1 = {i1,i2,i3,i2,i1,i4};
    YapodQuery q0 = new YapodStaticArrayQuery(tab1);
    YapodDistinctQuery q1 = new YapodDistinctQuery(q0);
    System.out.println("\nq0");
    YapodLib.print(q0.getResult());
    System.out.println("\nq1");
    YapodLib.print(q1.getResult());
  }
}
