/**
 * @modification $Date: 2001/12/03 16:28:09 $
 * @statut       unstable
 * @file         YapodMapQuery.java
 * @version      0.17
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.yapod;
import  com.memoire.yapod.*;


import java.util.*;

public class YapodMapQuery
       extends YapodAbstractComputeQuery
{
  private YapodAbstractQuery query_;

  public YapodMapQuery
    (YapodAbstractQuery _query, YapodQuery _previous)
  {
    super(_previous);

    if(_query==null)
      throw new IllegalArgumentException("_query is null");

    query_=_query;
  }

  protected Object compute(Object _o)
  {
    Object r=FAKE;

    if(_o instanceof Enumeration)
      _o=new YapodStaticVectorQuery(YapodLib.toVector((Enumeration)_o));
    if(_o instanceof Vector)
      _o=new YapodStaticVectorQuery((Vector)_o);
    if(_o instanceof Object[])
      _o=new YapodStaticArrayQuery((Object[])_o);
    if(_o instanceof double[])
      _o=new YapodStaticDoubleArrayQuery((double[])_o);

    if(_o instanceof YapodQuery)
    {
      query_.setPrevious((YapodQuery)_o);
      r=YapodLib.toVector(query_.getResult());
    }

    return r;
  }

  public String toString()
  {
    return "map("+query_+","+getPrevious()+")";
  }
}
