/**
 * @modification $Date: 2001/12/03 16:28:09 $
 * @statut       unstable
 * @file         YapodReference.java
 * @version      0.17
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.yapod;
import  com.memoire.yapod.*;


import java.io.*;
import java.lang.reflect.*;
import java.util.*;

public class YapodReference
       // implements Serializable
{
  protected YapodDatabase db_;   // database
  protected String        id_;   // object id

  // not public
  YapodReference(YapodDatabase _db, String _id)
  {
    if(_db==null)
      throw new IllegalArgumentException("_db is null");

    if(_id==null)
      throw new IllegalArgumentException("_id is null");

    db_=_db;
    id_=_id;
  }

  public synchronized boolean isValid()
  {
    return db_.isOpened()&&(db_.guess(id_)!=null);
  }

  public synchronized String getId()
  {
    return id_;
  }

  public synchronized Object getObject()
  {
    if(!isValid())
      throw new RuntimeException
	("invalid reference");

    return db_.find(id_);
  }

  public synchronized String getType()
  {
    if(!isValid())
      throw new RuntimeException
	("invalid reference");

    return db_.guess(id_);
  }
}
