/**
 * @modification $Date: 2001/12/03 16:28:09 $
 * @statut       unstable
 * @file         YapodStaticArrayQuery.java
 * @version      0.17
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.yapod;
import  com.memoire.yapod.*;


import java.util.*;

public class YapodStaticArrayQuery
       implements YapodQuery
{
  private Object[] values_;

  public YapodStaticArrayQuery(Object[] _values)
  {
    if(_values==null)
      throw new IllegalArgumentException("_values is null");

    values_=_values;
  }

  public final Enumeration getResult()
    { return new Enumerator(values_); }

  public String toString()
    { return values_.toString(); }

  private final class Enumerator implements Enumeration
  {
    private Object[] values_;
    private int      index_;

    public Enumerator(Object[] _values)
    {
      values_=_values;
      index_=0;
    }

    public final boolean hasMoreElements()
      { return index_<values_.length; }

    public final Object nextElement()
    {
      if(index_>=values_.length)
	throw new NoSuchElementException();
      return values_[index_++];
    }
  }
}
