/**
 * @modification $Date: 2001/12/03 16:28:09 $
 * @statut       unstable
 * @file         YapodTestDatabase.java
 * @version      0.17
 * @author       Guillaume Desnoix
 * @email        guillaume@desnoix.com
 * @license      GNU General Public License 2 (GPL2)
 */

package com.memoire.yapod;
import  com.memoire.yapod.*;


import java.io.*;
import java.util.*;

public class YapodTestDatabase
{
  public static void main(String[] args)
  {
    // System.setSecurityManager(new YapodSecurityManager());

    String         nm="xml:DB_XML";
    YapodDatabase  db=null;
    
    if(!YapodDatabase.exists(nm))
    {
      System.err.println("Unable to open directory "+nm+", doesn't exist");
      System.err.println("Please type: mkdir "+new File(nm).getAbsolutePath());
    }
    else
    {
      db=YapodDatabase.open(nm);

      System.err.println("INDEX");
      System.err.println("-----");
      String[] r=db.index();
      for(int i=0;i<r.length;i++)
      {
	System.err.println(r[i]+" : "+db.guess(r[i]));
      }
      System.err.println();

      if(db.find("b")==null)
      {
	System.err.println("feeding...");

	/*
	String s="S";
	db.add(s);
	db.bind("S",s);
	*/

	for(int i=1;i<3;i++)
	{
	  YapodTestC3 h=new YapodTestC3(i,2*i);
	  db.add(h);
	  db.bind("h"+i,h);
	}

	YapodTestC2 b=new YapodTestC2();
	db.add(b);
	db.bind("b",b);

	YapodTestC1 a=new YapodTestC1();
	db.add(a);
	db.bind("a",a);

	Vector v=new Vector();
	v.addElement(b);
	v.addElement(new YapodTestC3(19,70));
	db.add(v);
      }
      else
      {
	System.err.println("OUTPUT");
	System.err.println("-----");
	System.err.println(db.find("b") );
	System.err.println(db.find("a") );
	System.err.println(db.find("h1"));
	System.err.println(db.find("h2"));
	System.err.println();
      }

      db.close();
      return;
    }
  }
}

